/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IShortPeriodLongPeriod_$type } from "./IShortPeriodLongPeriod";
import { AbsoluteVolumeOscillatorIndicatorStrategy } from "./AbsoluteVolumeOscillatorIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core/ES2015/type";
export class AbsoluteVolumeOscillatorIndicator extends StrategyBasedIndicator {
    get_pr() {
        return new AbsoluteVolumeOscillatorIndicatorStrategy();
    }
    get pr() {
        return this.get_pr();
    }
    get_p4() {
        return AbsoluteVolumeOscillatorIndicator.$;
    }
    get p4() {
        return this.get_p4();
    }
    get shortPeriod() {
        return typeGetValue(this.c(AbsoluteVolumeOscillatorIndicator.qd));
    }
    set shortPeriod(a) {
        this.h(AbsoluteVolumeOscillatorIndicator.qd, a);
    }
    pz() {
        return this.shortPeriod;
    }
    get longPeriod() {
        return typeGetValue(this.c(AbsoluteVolumeOscillatorIndicator.qc));
    }
    set longPeriod(a) {
        this.h(AbsoluteVolumeOscillatorIndicator.qc, a);
    }
    pw() {
        return this.longPeriod;
    }
}
AbsoluteVolumeOscillatorIndicator.qd = StrategyBasedIndicator.qb(10, AbsoluteVolumeOscillatorIndicator.$);
AbsoluteVolumeOscillatorIndicator.qc = StrategyBasedIndicator.p7(30, AbsoluteVolumeOscillatorIndicator.$);
AbsoluteVolumeOscillatorIndicator.$t = markType(AbsoluteVolumeOscillatorIndicator, 'AbsoluteVolumeOscillatorIndicator', StrategyBasedIndicator.$, [IShortPeriodLongPeriod_$type]);
/*<BeginStatics Name="Infragistics.Controls.Charts.AbsoluteVolumeOscillatorIndicator" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.AbsoluteVolumeOscillatorIndicator" />*/
//# sourceMappingURL=AbsoluteVolumeOscillatorIndicator.js.map