/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Series } from "./Series";
import { DependencyProperty } from "igniteui-angular-core/ES2015/DependencyProperty";
import { Type, Point_$type, Boolean_$type, runOn, delegateRemove, typeCast, delegateCombine, fromEnum, fromEn, markType } from "igniteui-angular-core/ES2015/type";
import { SeriesView } from "./SeriesView";
import { XamDataChart } from "./XamDataChart";
import { Tuple$2 } from "igniteui-angular-core/ES2015/Tuple$2";
import { PropertyMetadata } from "igniteui-angular-core/ES2015/PropertyMetadata";
import { isNaN_ } from "igniteui-angular-core/ES2015/number";
export class AnnotationLayer extends Series {
    constructor() {
        super();
        this.mi = null;
        this.lj = null;
        this.li = null;
        this.lk = null;
        this.mg = { $type: Point_$type, x: NaN, y: NaN };
        this.ll = false;
        this.mi = { $type: Point_$type, x: NaN, y: NaN };
    }
    bf() {
        return new AnnotationLayerView(this);
    }
    ib(a) {
        super.ib(a);
        this.lh = a;
    }
    ln(a) {
        if (a == null) {
            return false;
        }
        if (a.ci) {
            return false;
        }
        if (a == this) {
            return false;
        }
        return a.dt(a.bi.bp, a.bi.bq, a.bi);
    }
    get_cl() {
        return this.lm;
    }
    get cl() {
        return this.get_cl();
    }
    bd() {
        if (this.be == 0) {
            return 1;
        }
        else {
            return super.bd();
        }
    }
    get_cv() {
        return this.lp || this.lq;
    }
    get cv() {
        return this.get_cv();
    }
    get_isUsableInLegend() {
        return this.lq;
    }
    get isUsableInLegend() {
        return this.get_isUsableInLegend();
    }
    ih(a, b, c, d) {
        super.ih(a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                let e = c;
                let f = d;
                if (e != null) {
                    this.l9(e.series);
                    let g = e.series;
                    g.collectionChanged = delegateRemove(g.collectionChanged, runOn(this, this.l6));
                    if (typeCast(XamDataChart.$, e) !== null) {
                        let h = e;
                        this.l8(h.axes);
                        let i = h.axes;
                        i.collectionChanged = delegateRemove(i.collectionChanged, runOn(this, this.lw));
                    }
                }
                if (f != null) {
                    this.l4(f.series);
                    let j = f.series;
                    j.collectionChanged = delegateCombine(j.collectionChanged, runOn(this, this.l6));
                    if (typeCast(XamDataChart.$, f) !== null) {
                        let k = f;
                        this.l3(k.axes);
                        let l = k.axes;
                        l.collectionChanged = delegateCombine(l.collectionChanged, runOn(this, this.lw));
                    }
                }
                break;
            case AnnotationLayer.$$p[3]:
            case AnnotationLayer.$$p[2]:
                if (this.cv) {
                    if (this.e7 == -1) {
                        this.e7 = XamDataChart.n7(this);
                    }
                }
                else {
                    this.e7 = -1;
                    this.kk = null;
                    this.kl = null;
                }
                if (this.bs != null) {
                    this.bs.id();
                }
                this.iv(true);
                break;
            case "TransitionProgress":
                this.lk.c(this.ep, this.lj, this.li);
                if (this.cc(this.bi)) {
                    return;
                }
                if (this.ep == 1) {
                    this.l5(this.li, this.bi);
                }
                else {
                    this.l5(this.lk, this.bi);
                }
                break;
            case AnnotationLayer.$$p[1]:
                if (this.bs != null) {
                    this.bs.ib();
                }
                break;
            case AnnotationLayer.$$p[0]:
                this.mi = this.mh;
                this.h6(this.mh);
                break;
            case "ShouldRenderAsOverlay":
                if (this.bs != null) {
                    this.bi.ah(this.bs);
                    this.bi.ad(this.bs);
                }
                break;
        }
    }
    l9(a) {
        for (let b of fromEnum(a)) {
            if (!(b == this)) {
                b.renderRequested = delegateRemove(b.renderRequested, runOn(this, this.l7));
            }
        }
        this.iv(true);
    }
    l8(a) {
        for (let b of fromEnum(a)) {
            b.renderRequested = delegateRemove(b.renderRequested, runOn(this, this.lx));
        }
        this.iv(true);
    }
    l4(a) {
        for (let b of fromEnum(a)) {
            if (!(b == this)) {
                b.renderRequested = delegateCombine(b.renderRequested, runOn(this, this.l7));
            }
        }
        this.iv(true);
    }
    l3(a) {
        for (let b of fromEnum(a)) {
            b.renderRequested = delegateCombine(b.renderRequested, runOn(this, this.lx));
        }
        this.iv(true);
    }
    lx(a, b) {
        this.lz(a, b.animate);
    }
    l7(a, b) {
        this.l0(a, b.animate);
    }
    lz(a, b) {
    }
    l0(a, b) {
    }
    l6(a, b) {
        this.l1(b);
    }
    lw(a, b) {
        this.ly(b);
    }
    me() {
        if (this.kk != null) {
            return this.kk;
        }
        return this.km;
    }
    mf() {
        if (this.kl != null) {
            return this.kl;
        }
        return this.kp;
    }
    ly(a) {
        if (a.oldItems != null) {
            for (let b of fromEn(a.oldItems)) {
                b.renderRequested = delegateRemove(b.renderRequested, runOn(this, this.lx));
            }
        }
        if (a.newItems != null) {
            for (let c of fromEn(a.newItems)) {
                c.renderRequested = delegateCombine(c.renderRequested, runOn(this, this.lx));
            }
        }
        this.iv(true);
    }
    l1(a) {
        if (a.oldItems != null) {
            for (let b of fromEn(a.oldItems)) {
                b.renderRequested = delegateRemove(b.renderRequested, runOn(this, this.l7));
            }
        }
        if (a.newItems != null) {
            for (let c of fromEn(a.newItems)) {
                c.renderRequested = delegateCombine(c.renderRequested, runOn(this, this.l7));
            }
        }
        this.iv(true);
    }
    ja(a, b) {
        this.iv(false);
    }
    i9(a, b) {
        this.iv(true);
    }
    iw(a) {
        super.iw(a);
        if (this.cc(this.bi)) {
            return;
        }
        if (this.c7(a) && !this.db) {
            let b = this.lj;
            if (this.ca()) {
                if (this.bt.g) {
                    this.bt.t();
                }
                this.lj = this.lk;
                this.lk = b;
            }
            else {
                this.lj = this.li;
                this.li = b;
            }
            this.l2(this.li, this.bi);
            this.i3();
        }
        else {
            if (!this.db) {
                this.l2(this.li, this.bi);
            }
            this.l5(this.li, this.bi);
        }
    }
    get_ci() {
        return true;
    }
    get ci() {
        return this.get_ci();
    }
    l2(a, b) {
    }
    l5(a, b) {
        this.lh.bw();
    }
    lv(a) {
        let b = { $type: Point_$type, x: this.mg.x, y: this.mg.y };
        if (a.isVertical) {
            if (isNaN_(this.mg.y)) {
                return new Tuple$2(Boolean_$type, Point_$type, false, b);
            }
            if (isNaN_(this.mg.x)) {
                b.x = 0;
                return new Tuple$2(Boolean_$type, Point_$type, true, b);
            }
        }
        else {
            if (isNaN_(this.mg.x)) {
                return new Tuple$2(Boolean_$type, Point_$type, false, b);
            }
            if (isNaN_(this.mg.y)) {
                b.y = 0;
                return new Tuple$2(Boolean_$type, Point_$type, true, b);
            }
        }
        return new Tuple$2(Boolean_$type, Point_$type, true, b);
    }
    h6(a) {
        super.h6(a);
        if (isNaN_(this.mi.x) && isNaN_(this.mi.y)) {
            if (isNaN_(a.x) && isNaN_(a.y)) {
                this.lh.bv();
                return;
            }
            else {
                this.lh.bx();
                this.mg = a;
            }
        }
        else {
            this.lh.bx();
            this.mg = this.mi;
        }
        this.iv(true);
    }
    dt(a, b, c) {
        let d = super.dt(a, b, c);
        if (!this.bi.q()) {
            return d = false;
        }
        return d;
    }
    get_dp() {
        return this.lo;
    }
    get dp() {
        return this.get_dp();
    }
    get lo() {
        return this.ll;
    }
    set lo(a) {
        let b = this.ll;
        this.ll = a;
        this.raisePropertyChanged("ShouldRenderAsOverlay", b, this.ll);
    }
}
AnnotationLayer.$t = markType(AnnotationLayer, 'AnnotationLayer', Series.$);
Type.dep(DependencyProperty, PropertyMetadata, AnnotationLayer, 'raisePropertyChanged', ['CursorPosition:mh:ma', [Point_$type, { $type: Point_$type, x: NaN, y: NaN }], 'IsDefaultCrosshairDisabled:lm:mb', [0, true], 'UseIndex:lp:mc', [0, false], 'UseLegend:lq:md', [0, false]]);
export class AnnotationLayerView extends SeriesView {
    constructor(a) {
        super(a);
        this.bs = null;
        this.bt = false;
        this.bu = -1;
        this.bs = a;
    }
    by() {
        if (this.bt) {
            this.bt = false;
            this.bu = -1;
            this.bs.mg = { $type: Point_$type, x: NaN, y: NaN };
            this.bs.iv(true);
        }
    }
    bv() {
        this.bt = true;
        if (this.e.eu != null) {
            this.e.eu.setTimeout(runOn(this, this.by), 300);
        }
        else {
            this.bu = window.setTimeout(runOn(this, this.by), 300);
        }
    }
    bx() {
        if (this.bt == true) {
            this.bt = false;
            if (this.bu != -1) {
                window.clearTimeout(this.bu);
                this.bu = -1;
            }
        }
    }
    bw() {
        this.an();
    }
}
AnnotationLayerView.$t = markType(AnnotationLayerView, 'AnnotationLayerView', SeriesView.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.AnnotationLayer" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.AnnotationLayer" />*/
//# sourceMappingURL=AnnotationLayer_combined.js.map