import { FinancialOverlay } from "./FinancialOverlay";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { Type, Point } from "igniteui-angular-core/ES2015/type";
import { CategoryFrame } from "./CategoryFrame";
import { AxisRange } from "./AxisRange";
import { Axis } from "./Axis";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { SeriesView } from "./SeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { Polyline } from "igniteui-angular-core/ES2015/Polyline";
import { Polygon } from "igniteui-angular-core/ES2015/Polygon";
import { RenderingContext } from "igniteui-angular-core/ES2015/RenderingContext";
export declare class BollingerBandsOverlay extends FinancialOverlay {
    constructor();
    o8: number;
    o7: number;
    protected ih(a: any, b: string, c: any, d: any): void;
    private o5;
    private o6;
    protected oy(): boolean;
    an(a: Axis): AxisRange;
    o3: List$1<number>;
    o4: List$1<number>;
    od(a: CategoryFrame, b: FinancialSeriesView): void;
    hf(a: boolean, b: SeriesView): void;
    ee(a: Point, b: boolean, c: boolean): number;
    e4(a: Point, b: boolean): number;
    e2(a: Point, b: boolean): number;
    dt(a: Rect, b: Rect, c: SeriesView): boolean;
    of(a: CategoryFrame, b: FinancialSeriesView): void;
    protected bf(): SeriesView;
    ib(a: SeriesView): void;
    private o2;
    protected nm(): number;
    d9(): number;
    static $$p: string[];
    static $t: Type;
}
export declare class BollingerBandsBucketCalculator extends FinancialBucketCalculator {
    constructor(a: FinancialSeriesView);
    protected f: BollingerBandsOverlayView;
    getBucket(a: number): number[];
    static $t: Type;
}
export declare class BollingerBandsOverlayView extends FinancialSeriesView {
    by: BollingerBandsOverlay;
    constructor(a: BollingerBandsOverlay);
    ap(): void;
    protected bt(): FinancialBucketCalculator;
    b0(a: number, b: (arg1: number) => number, c: (arg1: number) => number, d: (arg1: number) => number, e: (arg1: number) => number, f: (arg1: number) => number): void;
    bz(): void;
    readonly b2: Polygon;
    readonly b7: Polyline;
    readonly b8: Polyline;
    readonly b9: Polyline;
    private b3;
    private ca;
    private cb;
    private cc;
    private b1;
    private b4;
    private b5;
    private b6;
    protected a9(): void;
    protected a3(a: RenderingContext, b: boolean): void;
    ai(a: any): void;
    static $t: Type;
}
