/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { ChaikinVolatilityIndicatorStrategy } from "./ChaikinVolatilityIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core/ES2015/type";
export class ChaikinVolatilityIndicator extends StrategyBasedIndicator {
    get_pr() {
        return new ChaikinVolatilityIndicatorStrategy();
    }
    get pr() {
        return this.get_pr();
    }
    get_p4() {
        return ChaikinVolatilityIndicator.$;
    }
    get p4() {
        return this.get_p4();
    }
    get qc() {
        return typeGetValue(this.c(ChaikinVolatilityIndicator.qd));
    }
    set qc(a) {
        this.h(ChaikinVolatilityIndicator.qd, a);
    }
    px() {
        return this.qc;
    }
    p6(a) {
        this.qc = a;
    }
}
ChaikinVolatilityIndicator.qd = StrategyBasedIndicator.p9(10, ChaikinVolatilityIndicator.$);
ChaikinVolatilityIndicator.$t = markType(ChaikinVolatilityIndicator, 'ChaikinVolatilityIndicator', StrategyBasedIndicator.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.ChaikinVolatilityIndicator" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.ChaikinVolatilityIndicator" />*/
//# sourceMappingURL=ChaikinVolatilityIndicator.js.map