/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { CustomIndicatorStrategy } from "./CustomIndicatorStrategy";
import { String_$type, fromEnum, markType } from "igniteui-angular-core/ES2015/type";
import { FinancialEventArgs } from "./FinancialEventArgs";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
export class CustomIndicator extends StrategyBasedIndicator {
    constructor() {
        super(...arguments);
        this.qd = null;
        this.qc = null;
    }
    get_pr() {
        return new CustomIndicatorStrategy();
    }
    get pr() {
        return this.get_pr();
    }
    get_p4() {
        return CustomIndicator.$;
    }
    get p4() {
        return this.get_p4();
    }
    o3(a, b) {
        let c = this.l1(a, b);
        let d = this.l2(c);
        let e = new List$1(String_$type, 0);
        if (this.qc != null) {
            let f = new FinancialEventArgs(c.calculateFrom, c.calculateCount, c, d, this);
            this.qc(this, f);
            if (f.basedOn != null) {
                for (let g of fromEnum(f.basedOn)) {
                    e.add(g);
                }
            }
        }
        return e;
    }
    get indicator() {
        return this.qd;
    }
    set indicator(a) {
        this.qd = a;
        this.pb();
    }
    get basedOnColumns() {
        return this.qc;
    }
    set basedOnColumns(a) {
        this.qc = a;
    }
    o0(a, b) {
        super.o0(a, b);
        if (this.qd != null) {
            let c = this.l1(a, b);
            if (b == 0) {
                return false;
            }
            if (!this.mw(this.o3(a, b))) {
                return false;
            }
            this.qd(this, new FinancialEventArgs(a, b, c, this.l2(c), this));
            if (this.pt(c) && this.l9 != null) {
                this.l9.ck();
            }
            return true;
        }
        return false;
    }
}
CustomIndicator.$t = markType(CustomIndicator, 'CustomIndicator', StrategyBasedIndicator.$);
//# sourceMappingURL=CustomIndicator.js.map