/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { FastStochasticOscillatorIndicatorStrategy } from "./FastStochasticOscillatorIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core/ES2015/type";
import { Brush } from "igniteui-angular-core/ES2015/Brush";
export class FastStochasticOscillatorIndicator extends StrategyBasedIndicator {
    constructor() {
        super();
        this.trendLineBrush = ((() => {
            let $ret = new Brush();
            $ret.fill = "#565656";
            return $ret;
        })());
        this.trendLineType = 10;
        this.trendLinePeriod = 3;
    }
    get_pr() {
        return new FastStochasticOscillatorIndicatorStrategy();
    }
    get pr() {
        return this.get_pr();
    }
    get_p4() {
        return FastStochasticOscillatorIndicator.$;
    }
    get p4() {
        return this.get_p4();
    }
    get qc() {
        return typeGetValue(this.c(FastStochasticOscillatorIndicator.qd));
    }
    set qc(a) {
        this.h(FastStochasticOscillatorIndicator.qd, a);
    }
    px() {
        return this.qc;
    }
    p6(a) {
        this.qc = a;
    }
}
FastStochasticOscillatorIndicator.qd = StrategyBasedIndicator.p9(14, FastStochasticOscillatorIndicator.$);
FastStochasticOscillatorIndicator.$t = markType(FastStochasticOscillatorIndicator, 'FastStochasticOscillatorIndicator', StrategyBasedIndicator.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.FastStochasticOscillatorIndicator" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.FastStochasticOscillatorIndicator" />*/
//# sourceMappingURL=FastStochasticOscillatorIndicator.js.map