import { Brush } from "igniteui-angular-core/ES2015/Brush";
import { XYChart } from "./XYChart";
import { DomWrapper, EventArgs, Type, IList } from "igniteui-angular-core/ES2015/type";
import { ZoomSliderWidget } from "./ZoomSliderWidget";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { DataSeriesType } from "igniteui-angular-core/ES2015/DataSeriesType";
import { IDataSeriesAdapterRule } from "igniteui-angular-core/ES2015/IDataSeriesAdapterRule";
import { XamDataChart } from "./XamDataChart";
import { FinancialChartVolumeType } from "./FinancialChartVolumeType";
import { FinancialChartXAxisMode } from "./FinancialChartXAxisMode";
import { FinancialChartYAxisMode } from "./FinancialChartYAxisMode";
import { FinancialChartType } from "./FinancialChartType";
import { HorizontalAlignment } from "igniteui-angular-core/ES2015/HorizontalAlignment";
import { FinancialIndicatorTypeCollection } from "./FinancialIndicatorTypeCollection";
import { FinancialOverlayTypeCollection } from "./FinancialOverlayTypeCollection";
import { AxisLabelsLocation } from "./AxisLabelsLocation";
import { FinancialChartZoomSliderType } from "./FinancialChartZoomSliderType";
import { BrushCollection } from "igniteui-angular-core/ES2015/BrushCollection";
import { IndicatorDisplayTypeCollection } from "./IndicatorDisplayTypeCollection";
import { FinancialChartRangeSelectorOptionCollection } from "./FinancialChartRangeSelectorOptionCollection";
import { CustomIndicatorNameCollection } from "./CustomIndicatorNameCollection";
import { TemplatedHtmlControl } from "./TemplatedHtmlControl";
import { FinancialChartContext } from "./FinancialChartContext";
import { FinancialChartToolbarContext } from "./FinancialChartToolbarContext";
import { FinancialChartToolbarViewModel } from "./FinancialChartToolbarViewModel";
import { Axis } from "./Axis";
import { DataSeries } from "igniteui-angular-core/ES2015/DataSeries";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { Series } from "./Series";
import { TitleSettings } from "./TitleSettings";
import { FinancialIndicatorType } from "./FinancialIndicatorType";
import { FinancialOverlayType } from "./FinancialOverlayType";
import { FinancialChartCustomIndicatorArgs } from "./FinancialChartCustomIndicatorArgs";
import { ObservableCollection$1 } from "igniteui-angular-core/ES2015/ObservableCollection$1";
import { FinancialChartEnumCollectionPickerToolViewModel } from "./FinancialChartEnumCollectionPickerToolViewModel";
import { FinancialChartEnumCollectionPickerToolView } from "./FinancialChartEnumCollectionPickerToolView";
import { FinancialChartEnumCollectionPickerVisualData } from "./FinancialChartEnumCollectionPickerVisualData";
import { FinancialChartTypePicker } from "./FinancialChartTypePicker";
import { FinancialChartTrendLinePicker } from "./FinancialChartTrendLinePicker";
import { FinancialChartVolumeTypePicker } from "./FinancialChartVolumeTypePicker";
import { TrendLineType } from "igniteui-angular-core/ES2015/TrendLineType";
import { FinancialChartToolbarVisualData } from "./FinancialChartToolbarVisualData";
import { FinancialChartRangeSelectorViewModel } from "./FinancialChartRangeSelectorViewModel";
import { FinancialChartRangeSelectorVisualData } from "./FinancialChartRangeSelectorVisualData";
export declare class FinancialChart extends XYChart {
    protected fl(a: string, b: any, c: any): void;
    private t5(a, b);
    private t4(a, b);
    private t1(a, b);
    private ud();
    private oo;
    provideGrid(a: DomWrapper): void;
    onDocumentClick(a: string[]): void;
    private qy;
    private qw;
    private qu;
    private qv;
    private qx;
    private po();
    getContext(): FinancialChartContext;
    provideContainer(a: any): void;
    private un(a, b, c);
    private u0(a, b);
    private tn();
    private uy(a, b);
    setGridRows(): void;
    protected e1(): void;
    private uj();
    private uk();
    private us();
    private ub();
    protected ey(a: XamDataChart): void;
    private u3(a);
    private u4(a);
    qh(): number;
    e9(source_: any, a: number, b: any): void;
    fa(source_: any, a: number, b: any): void;
    e8(source_: any): void;
    fc(source_: any, a: number, b: any, c: any): void;
    private nw;
    private nx;
    private rg;
    rn: any;
    private rh;
    ro: any;
    private rd;
    rk: any;
    private ri;
    rp: any;
    private rj;
    rq: any;
    private re;
    rl: any;
    private rf;
    rm: any;
    private pd;
    pe: ZoomSliderWidget;
    protected get_bw(): number;
    protected set_bw(a: number): void;
    bw: number;
    protected get_ay(): boolean;
    protected set_ay(a: boolean): void;
    ay: boolean;
    private qa;
    ql: number;
    constructor();
    private ng;
    private xAxis;
    private ot;
    private yAxis;
    private os;
    private volumeAxis;
    private nf;
    private volumeXAxis;
    private or;
    private indicatorAxis;
    private ne;
    private indicatorXAxis;
    private p1;
    private p4;
    private p3;
    private p6;
    protected gk(): Axis;
    protected gl(): Axis;
    protected r(a: DataSeries): DataSeriesType;
    protected get_ba(): List$1<DataSeriesType>;
    protected readonly ba: List$1<DataSeriesType>;
    protected get_a9(): List$1<IDataSeriesAdapterRule>;
    protected readonly a9: List$1<IDataSeriesAdapterRule>;
    private nj(a);
    private ov(a);
    private ni(a);
    protected em(): void;
    protected f2(a: Series): void;
    protected ek(a: Series, b: number): void;
    protected fx(a: DataSeries): void;
    protected f0(): void;
    private n1();
    private n0(a);
    private oa(a);
    private n3(a);
    private rx(a);
    private o7(seriesType_);
    private nk(axisType_);
    private ow(axisType_);
    private o2();
    private o3();
    private o1();
    private o4();
    private readonly pj;
    private oi;
    private readonly oj;
    private readonly pm;
    private og;
    private readonly oh;
    private readonly pk;
    private ok;
    private readonly ol;
    private readonly pl;
    private op;
    private readonly oq;
    protected ag(a: DataSeries, b: DataSeriesType): Series;
    protected fz(): void;
    protected lj(a: (arg1: Axis) => void, b: string): void;
    protected ln(a: (arg1: Axis) => void, b: boolean): void;
    protected ll(a: (arg1: TitleSettings) => void): void;
    protected lp(a: (arg1: TitleSettings) => void): void;
    protected lo(a: (arg1: AxisLabelSettings) => void): void;
    protected lk(a: (arg1: AxisLabelSettings) => void): void;
    protected ex(a: XamDataChart): void;
    private static rb;
    private rr;
    private sq();
    private tv(a, b);
    private tl();
    private to(a);
    private tq(a);
    private tp(a);
    private tr(a);
    private q5(a, b);
    protected er(a: (arg1: Series, arg2: number) => void): void;
    private o9;
    private volumeChart;
    private uf();
    private pn(a);
    private pr(a);
    private pp(a);
    private pq(a);
    private ue();
    private o5(indicatorName_);
    private o8(a);
    private uu(a);
    cn(): any;
    rw(): string;
    private o6(overlayName_);
    private ut();
    private pw;
    private ur();
    protected eu(): void;
    protected get_a2(): boolean;
    protected readonly a2: boolean;
    protected readonly p0: boolean;
    private uz(a, b);
    private ug();
    protected fg(a: (arg1: XamDataChart) => void, b: boolean, c: string): void;
    private tt(a, b);
    protected le(a: Axis): void;
    protected lg(a: Axis): void;
    private t9(a);
    protected e2(a: Series, b: number): void;
    protected fj(a: string, b: any, c: any): void;
    private uo(a, b, c);
    private readonly pz;
    private tu(a, b);
    private ps(a, b);
    private ui();
    private ty(a, b);
    private t3(a, b);
    private t2(a, b);
    private tw(a, b);
    private tx(a, b);
    private t7(a, b);
    private ua(a);
    private t8(a);
    private tm();
    private um(a, b);
    private ux(a, b);
    private tz(a, b);
    private uv();
    private pv;
    private t6(a, b);
    private ts(a, b);
    private uq(a, b, c, d);
    private up(a);
    private t0(a, b);
    private uw();
    private pi;
    py: boolean;
    private q4;
    rc: number;
    private qc;
    qp: number;
    private qe;
    qr: number;
    private qd;
    qq: number;
    private qf;
    qs: number;
    readonly qo: number;
    readonly qn: number;
    private n2;
    n4: FinancialChartVolumeType;
    private n5;
    n6: FinancialChartXAxisMode;
    private n7;
    n8: FinancialChartYAxisMode;
    private pf;
    pt: boolean;
    private ny;
    nz: FinancialChartType;
    protected get_lv(): HorizontalAlignment;
    protected set_lv(a: HorizontalAlignment): void;
    lv: HorizontalAlignment;
    private pg;
    pu: boolean;
    private oc;
    od: FinancialIndicatorTypeCollection;
    private oe;
    of: FinancialOverlayTypeCollection;
    private p2;
    private indicatorCharts;
    private ph;
    px: boolean;
    protected get_by(): number;
    protected set_by(a: number): void;
    by: number;
    protected get_gr(): AxisLabelsLocation;
    protected set_gr(a: AxisLabelsLocation): void;
    gr: AxisLabelsLocation;
    private pa;
    zoomSliderChart: XamDataChart;
    private ou;
    private zoomSliderAxis;
    private nh;
    private zoomSliderXAxis;
    private n9;
    ob: FinancialChartZoomSliderType;
    private m0;
    m8: BrushCollection;
    private m1;
    m9: BrushCollection;
    private m2;
    na: BrushCollection;
    private m3;
    nb: BrushCollection;
    private m5;
    nd: BrushCollection;
    private m4;
    nc: BrushCollection;
    private mz;
    m7: BrushCollection;
    private my;
    m6: BrushCollection;
    private qb;
    qm: number;
    private p9;
    qk: number;
    private p8;
    qj: number;
    private om;
    on: IndicatorDisplayTypeCollection;
    private q0;
    q7: number;
    private p7;
    qi: number;
    private q3;
    ra: number;
    private q1;
    q8: number;
    private qz;
    q6: number;
    private q2;
    q9: number;
    private nt;
    nv: FinancialChartRangeSelectorOptionCollection;
    nu: FinancialChartRangeSelectorOptionCollection;
    private np;
    customIndicatorNames: CustomIndicatorNameCollection;
    applyCustomIndicators: (sender: any, e: FinancialChartCustomIndicatorArgs) => void;
    protected get_a3(): boolean;
    protected set_a3(a: boolean): void;
    a3: boolean;
    private u1;
    u2: Brush;
    private qg;
    qt: number;
    static $t: Type;
}
export declare abstract class FinancialChartEnumCollectionPickerTool$2<TColl extends ObservableCollection$1<TEnum>, TEnum> extends TemplatedHtmlControl {
    protected $tColl: Type;
    protected $tEnum: Type;
    constructor($tColl: Type, $tEnum: Type, a: string, b: any, c: string);
    l(a: any): void;
    abstract s(): string;
    u(a: string[]): void;
    n: TColl;
    private w();
    protected o: FinancialChartEnumCollectionPickerToolView;
    p: FinancialChartEnumCollectionPickerToolViewModel;
    private v(a, b, c);
    changed: (sender: any, e: EventArgs) => void;
    q(): FinancialChartEnumCollectionPickerVisualData;
    static $t: Type;
}
export declare class FinancialChartIndicatorPicker extends FinancialChartEnumCollectionPickerTool$2<FinancialIndicatorTypeCollection, FinancialIndicatorType> {
    constructor(a: number);
    constructor(a: number, b: any);
    constructor(a: number, ..._rest: any[]);
    u(a: string[]): void;
    s(): string;
    static $t: Type;
}
export declare class FinancialChartOverlayPicker extends FinancialChartEnumCollectionPickerTool$2<FinancialOverlayTypeCollection, FinancialOverlayType> {
    constructor(a: number);
    constructor(a: number, b: any);
    constructor(a: number, ..._rest: any[]);
    u(a: string[]): void;
    s(): string;
    static $t: Type;
}
export declare class FinancialChartToolbar extends TemplatedHtmlControl {
    bp(a: DomWrapper): void;
    bx(a: string[]): void;
    private static a6;
    private n;
    constructor(a: FinancialChart, b: any);
    private s;
    t: FinancialChartRangeSelector;
    private ac;
    ad: FinancialChartTypePicker;
    private y;
    z: FinancialChartTrendLinePicker;
    private ag;
    ah: FinancialChartVolumeTypePicker;
    private o;
    p: FinancialChartIndicatorPicker;
    private q;
    r: FinancialChartOverlayPicker;
    private by(a, b, c);
    private br(a, b);
    private bq(a, b);
    private bs(a, b);
    private bu(a, b);
    private bv(a, b);
    private bt(a, b);
    x: FinancialChartToolbarViewModel;
    w(): FinancialChartToolbarContext;
    l(a: any): void;
    private bw();
    private av;
    az: Date;
    private au;
    ay: Date;
    private at;
    ax: Date;
    private as;
    aw: Date;
    rangeChanged: (sender: any, e: EventArgs) => void;
    chartTypeChanged: (sender: any, e: EventArgs) => void;
    trendLineTypeChanged: (sender: any, e: EventArgs) => void;
    volumeTypeChanged: (sender: any, e: EventArgs) => void;
    indicatorTypesChanged: (sender: any, e: EventArgs) => void;
    overlayTypesChanged: (sender: any, e: EventArgs) => void;
    bz(): void;
    private aa;
    ab: FinancialChartType;
    private am;
    an: TrendLineType;
    private ae;
    af: FinancialChartVolumeType;
    private ai;
    aj: FinancialIndicatorTypeCollection;
    private ak;
    al: FinancialOverlayTypeCollection;
    static ar(a: IList, b: IList): boolean;
    ao(): FinancialChartToolbarVisualData;
    private u;
    v: FinancialChartRangeSelectorOptionCollection;
    private ap;
    aq: boolean;
    static $t: Type;
}
export declare class FinancialChartRangeSelector extends TemplatedHtmlControl {
    private static w;
    p: FinancialChartRangeSelectorViewModel;
    u: Date;
    t: Date;
    s: Date;
    r: Date;
    z(): void;
    constructor(a: any);
    l(a: any): void;
    private y();
    rangeChanged: (sender: any, e: EventArgs) => void;
    q(): FinancialChartRangeSelectorVisualData;
    n: FinancialChartRangeSelectorOptionCollection;
    private o;
    static $t: Type;
}
