import { RangeCategorySeries } from "./RangeCategorySeries";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { Axis } from "./Axis";
import { Point, Type } from "igniteui-angular-core/ES2015/type";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { ScalerParams } from "./ScalerParams";
export declare abstract class HorizontalRangeCategorySeries extends RangeCategorySeries {
    xAxis: CategoryAxisBase;
    yAxis: NumericYAxis;
    fetchXAxis(): Axis;
    fetchYAxis(): Axis;
    hd(): void;
    ah(a: Point): Point[][];
    ai(a: Point): Point[][];
    protected get_c2(): boolean;
    readonly c2: boolean;
    protected bd(): SeriesHitTestMode;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    e2(a: Point, b: boolean): number;
    e4(a: Point, b: boolean): number;
    d1(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    ee(a: Point, b: boolean, c: boolean): number;
    ec(a: Point, b: boolean, c: boolean): number;
    ea(a: Point, b: boolean, c: boolean): number;
    ky(a: Point, b: boolean, c: boolean): Point;
    k0(a: Point, b: boolean, c: boolean): Point;
    k2(a: Point, b: boolean, c: boolean): Point;
    ni(): boolean;
    protected ih(a: any, b: string, c: any, d: any): void;
    ow(a: any): boolean;
    ov(a: any): boolean;
    readonly useHighMarkerFidelity: boolean;
    static $$p: string[];
    static $t: Type;
}
