/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { RangeCategorySeries } from "./RangeCategorySeries";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "igniteui-angular-core/ES2015/DependencyProperty";
import { NumericYAxis } from "./NumericYAxis";
import { Axis } from "./Axis";
import { Type, Point_$type, runOn, typeCast, markType } from "igniteui-angular-core/ES2015/type";
import { RangeValueList } from "./RangeValueList";
import { ScalerParams } from "./ScalerParams";
import { CategoryXAxis } from "./CategoryXAxis";
import { PropertyMetadata } from "igniteui-angular-core/ES2015/PropertyMetadata";
export class HorizontalRangeCategorySeries extends RangeCategorySeries {
    fetchXAxis() {
        return this.xAxis;
    }
    fetchYAxis() {
        return this.yAxis;
    }
    hd() {
        super.hd();
        this.xAxis = null;
        this.yAxis = null;
    }
    ah(a) {
        let b = this.aj(this.mn(), this.mo.f, this.no(this.bi), this.np(this.bi), this.k5(a), true);
        if (b == null) {
            return null;
        }
        let c = b[0];
        let d = b[1];
        let e = new Array(1);
        let f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[2] };
        f[1] = { $type: Point_$type, x: d[0], y: d[2] };
        e[0] = f;
        return e;
    }
    ai(a) {
        let b = this.aj(this.mn(), this.mo.f, this.no(this.bi), this.np(this.bi), this.k5(a), true);
        if (b == null) {
            return null;
        }
        let c = b[0];
        let d = b[1];
        let e = new Array(1);
        let f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[1] };
        f[1] = { $type: Point_$type, x: d[0], y: d[1] };
        e[0] = f;
        return e;
    }
    get_c2() {
        return true;
    }
    get c2() {
        return this.get_c2();
    }
    bd() {
        if (this.be == 0) {
            return 1;
        }
        else {
            return super.bd();
        }
    }
    getOffsetValue() {
        return this.RangeFramePreparer.r(this.xAxis, this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi));
    }
    getCategoryWidth() {
        return this.xAxis.getCategorySize(this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi));
    }
    e2(a, b) {
        return this.e3(a, b, this.xAxis, runOn(this, this.nm), new RangeValueList(this.highColumn, this.lowColumn));
    }
    e4(a, b) {
        return this.e5(a, b, this.xAxis, runOn(this, this.nm), new RangeValueList(this.highColumn, this.lowColumn));
    }
    d1(a, b, c, d, e) {
        if (c == null) {
            return Number.POSITIVE_INFINITY;
        }
        let f = this.xAxis.jq;
        return this.d2(a, b, this.xAxis, d, e, f, runOn(this, this.nm));
    }
    ee(a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        let d = this.getEffectiveViewport1(this.bi);
        let e = new ScalerParams(0, this.bs.mk, this.bi.bp, this.xAxis.b8, d);
        let f = this.RangeFramePreparer.r(this.xAxis, this.bs.mk, this.bi.bp, d);
        return this.eg(new RangeValueList(this.highColumn, this.lowColumn), a, this.xAxis, e, f, runOn(this, this.nm), b, c);
    }
    ec(a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        let d = this.getEffectiveViewport1(this.bi);
        let e = new ScalerParams(0, this.bs.mk, this.bi.bp, this.xAxis.b8, d);
        let f = this.RangeFramePreparer.r(this.xAxis, this.bs.mk, this.bi.bp, d);
        return this.eg(this.lowColumn, a, this.xAxis, e, f, runOn(this, this.nm), b, c);
    }
    ea(a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        let d = this.getEffectiveViewport1(this.bi);
        let e = new ScalerParams(0, this.bs.mk, this.bi.bp, this.xAxis.b8, d);
        let f = this.RangeFramePreparer.r(this.xAxis, this.bs.mk, this.bi.bp, d);
        return this.eg(this.highColumn, a, this.xAxis, e, f, runOn(this, this.nm), b, c);
    }
    ky(a, b, c) {
        return this.k4(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi)), this.yAxis, this.xAxis, runOn(this, this.ea), (d, e) => this.e5(d, e, this.xAxis, runOn(this, this.nm), this.highColumn), (d, e) => this.e3(d, e, this.xAxis, runOn(this, this.nm), this.highColumn));
    }
    k0(a, b, c) {
        return this.k4(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi)), this.yAxis, this.xAxis, runOn(this, this.ec), (d, e) => this.e5(d, e, this.xAxis, runOn(this, this.nm), this.lowColumn), (d, e) => this.e3(d, e, this.xAxis, runOn(this, this.nm), this.lowColumn));
    }
    k2(a, b, c) {
        return this.k4(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi)), this.yAxis, this.xAxis, null, null, null);
    }
    ni() {
        return this.yAxis != null && this.yAxis.ck();
    }
    ih(a, b, c, d) {
        super.ih(a, b, c, d);
        switch (b) {
            case HorizontalRangeCategorySeries.$$p[0]:
                this.hj(typeCast(Axis.$, c));
                this.im(typeCast(Axis.$, d));
                this.mw.cl.g(this.ek);
                this.iv(false);
                this.h2();
                break;
            case HorizontalRangeCategorySeries.$$p[1]:
                this.hj(typeCast(Axis.$, c));
                this.im(typeCast(Axis.$, d));
                this.mw.cl.g(this.ek);
                this.ni();
                this.iv(false);
                this.h2();
                break;
        }
    }
    ow(a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    ov(a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.b5) {
            return true;
        }
        return false;
    }
    get useHighMarkerFidelity() {
        return this.nj;
    }
}
HorizontalRangeCategorySeries.$t = markType(HorizontalRangeCategorySeries, 'HorizontalRangeCategorySeries', RangeCategorySeries.$);
Type.dep(DependencyProperty, PropertyMetadata, HorizontalRangeCategorySeries, 'raisePropertyChanged', ['XAxis::oz', [CategoryAxisBase.$, null], 'YAxis::o0', [NumericYAxis.$, null]]);
/*<BeginStatics Name="Infragistics.Controls.Charts.HorizontalRangeCategorySeries" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.HorizontalRangeCategorySeries" />*/
//# sourceMappingURL=HorizontalRangeCategorySeries.js.map