import { CategoryMode } from "./CategoryMode";
import { ICategoryScaler } from "./ICategoryScaler";
import { IScaler } from "./IScaler";
import { IBucketizer } from "./IBucketizer";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { Type } from "igniteui-angular-core/ES2015/type";
export interface IIsCategoryBased {
    readonly currentCategoryMode: CategoryMode;
    readonly scaler: ICategoryScaler;
    readonly yScaler: IScaler;
    readonly bucketizer: IBucketizer;
    readonly currentMode2Index: number;
    readonly useHighMarkerFidelity: boolean;
    readonly mayContainUnknowns: boolean;
    provideCollisionDetector(): IDetectsCollisions;
}
export declare let IIsCategoryBased_$type: Type;
