/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { ItemwiseStrategyCalculationStrategy } from "./ItemwiseStrategyCalculationStrategy";
import { markType } from "igniteui-angular-core/ES2015/type";
export class ItemwiseStrategyBasedIndicator extends StrategyBasedIndicator {
    constructor() {
        super();
    }
    get_pr() {
        return new ItemwiseStrategyCalculationStrategy();
    }
    get pr() {
        return this.get_pr();
    }
    p5() {
        super.p5();
        this.qc = this.qd;
        this.pq.c = this.qc;
    }
}
ItemwiseStrategyBasedIndicator.$t = markType(ItemwiseStrategyBasedIndicator, 'ItemwiseStrategyBasedIndicator', StrategyBasedIndicator.$);
//# sourceMappingURL=ItemwiseStrategyBasedIndicator.js.map