/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FinancialOverlay } from "./FinancialOverlay";
import { DependencyProperty } from "igniteui-angular-core/ES2015/DependencyProperty";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { Type, Number_$type, typeCast, runOn, markType, Point_$type, fromEnum } from "igniteui-angular-core/ES2015/type";
import { CategoryFrame } from "./CategoryFrame";
import { MathUtil } from "igniteui-angular-core/ES2015/MathUtil";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { Polyline } from "igniteui-angular-core/ES2015/Polyline";
import { Polygon } from "igniteui-angular-core/ES2015/Polygon";
import { RangeValueList } from "./RangeValueList";
import { PropertyMetadata } from "igniteui-angular-core/ES2015/PropertyMetadata";
import { truncate, isNaN_, isInfinity } from "igniteui-angular-core/ES2015/number";
import { Flattener } from "igniteui-angular-core/ES2015/Flattener";
export class PriceChannelOverlay extends FinancialOverlay {
    constructor() {
        super();
        this.o4 = new List$1(Number_$type, 0);
        this.o3 = new List$1(Number_$type, 0);
        this.ab = PriceChannelOverlay.$;
        this.ls = new CategoryFrame(3);
        this.lu = new CategoryFrame(3);
        this.lr = new CategoryFrame(3);
    }
    ih(a, b, c, d) {
        switch (b) {
            case "HighColumn":
            case "LowColumn":
                this.ox = false;
                break;
        }
        super.ih(a, b, c, d);
        switch (b) {
            case PriceChannelOverlay.$$p[0]:
                this.ox = false;
                this.iv(false);
                break;
        }
    }
    dt(a, b, c) {
        let d = super.dt(a, b, c);
        if (this.md == null || this.mf == null) {
            d = false;
        }
        return d;
    }
    oy() {
        this.o4.clear();
        this.o3.clear();
        let a = truncate(MathUtil.b(this.o5, 0, this.bz.count));
        let b = Math.min(this.md.count, this.mf.count);
        let c = this.m7(this.md);
        let d = this.m7(this.mf);
        for (let e = 0; e < b; e++) {
            let f = Math.min(a, e);
            let g = -1.7976931348623157E+308;
            let h = 1.7976931348623157E+308;
            for (let i = 0; i < f; i++) {
                if (!isNaN_(c.item(e - i))) {
                    g = Math.max(g, c.item(e - i));
                }
                if (!isNaN_(d.item(e - i))) {
                    h = Math.min(h, d.item(e - i));
                }
            }
            if (e == 0) {
                h = d.item(0);
                g = c.item(0);
            }
            this.o4.add(g);
            this.o3.add(h);
        }
        return true;
    }
    od(a, b) {
        super.od(a, b);
        let c = b.bq;
        let d = b.bp;
        let e = this.getEffectiveViewport1(b);
        let f = new ScalerParams(0, c, d, this.lp.b8, e);
        let g = new ScalerParams(0, c, d, this.l9.b8, e);
        let h = this.lp;
        let i = this.l9;
        a.f.clear();
        a.m.clear();
        a.p.clear();
        let j = 0;
        let k = typeCast(ISortingAxis_$type, this.lp);
        if (k != null && k.i$b.count != this.bz.count) {
            return;
        }
        j = this.ne(c, d, e);
        if (!this.ox) {
            this.ox = this.oy();
        }
        g.b = this.d9();
        let l = this.lp.dw(2, f) - this.lp.dw(1, f);
        for (let m = b.bs.c; m <= b.bs.d; ++m) {
            let n;
            if (k == null) {
                n = b.bs.getBucket(m);
            }
            else {
                let o = k.i$b._inner[m];
                let p = k.i$d(o);
                let q = this.o4._inner[m];
                let r = this.o3._inner[m];
                let s = q;
                let t = r;
                let u = p;
                while (m < b.bs.d) {
                    o = k.i$b._inner[m + 1];
                    u = k.i$d(o);
                    if (u - p > l) {
                        break;
                    }
                    m++;
                    s = Math.max(q, this.o4._inner[m]);
                    t = Math.min(r, this.o3._inner[m]);
                }
                if (!isInfinity(t) && !isInfinity(s)) {
                    let v = NaN;
                    if (!isNaN_(p)) {
                        v = this.lp.dt(p, f);
                    }
                    n = [v, t, s];
                }
                else {
                    n = [NaN, NaN, NaN];
                }
            }
            let w = Math.max(1, l);
            if (!isNaN_(n[0]) && m * w >= this.oz) {
                if (this.lp != null && typeCast(ISortingAxis_$type, this.lp) !== null) {
                    n[0] = n[0] + j;
                }
                else {
                    n[0] = h.dt(n[0], f) + j;
                }
                n[1] = i.dt(n[1], g);
                n[2] = i.dt(n[2], g);
                a.f.add(n);
            }
        }
    }
    hf(a, b) {
        super.hf(a, b);
        let c = b;
        if (c != null) {
            c.bz();
        }
    }
    of(a, b) {
        super.of(a, b);
        let c = typeCast(PriceChannelOverlayView.$, b);
        if (c == null) {
            return;
        }
        let d = this.getEffectiveViewport1(b);
        if (b.bv(a)) {
            c.bz();
            let e = a.f.count;
            let f = (g) => a.f._inner[g][0];
            let g = (h) => a.f._inner[e - 1 - h][0];
            let h = (i) => a.f._inner[i][1];
            let i = (j) => a.f._inner[e - 1 - j][2];
            c.b0(e, f, g, h, i);
            b.bx(a);
        }
        this.lx.x(this, this.mv(), this.lp, runOn(this, this.lh), this.nk(b), this.nl(b));
        let j = false;
        let k = this.lx.c;
        let l = a.f;
        let m = this.bz.count;
        if (k != null) {
            j = true;
        }
        if (j) {
            let n = new ScalerParams(0, b.bq, b.bp, this.lp.b8, d);
            this.oc(l, -1, m, this.lp, n, b.n);
        }
        let o = c.b6;
        let p = c.b7;
        let q = c.b2;
        this.lx.ae(o, true, false, true, true);
        this.lx.ae(p, true, false, true, true);
        this.lx.ae(q, false, true, false, false);
        q._opacity = this.lx.i * this.dz;
    }
    bf() {
        return new PriceChannelOverlayView(this);
    }
    ib(a) {
        super.ib(a);
        this.o2 = typeCast(PriceChannelOverlayView.$, a);
    }
    ee(a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        let d = this.getEffectiveViewport1(this.bi);
        let e = new ScalerParams(0, this.bs.mk, this.bi.bp, this.lp.b8, d);
        let f = this.ne(this.bs.mk, this.bi.bp, d);
        return this.eg(new RangeValueList(this.o4, this.o3), a, this.lp, e, f, runOn(this, this.nd), b, c);
    }
    e2(a, b) {
        if (this.o4 == null || this.o3 == null) {
            return super.e2(a, b);
        }
        return this.e3(a, b, this.lp, runOn(this, this.nd), new RangeValueList(this.o4, this.o3));
    }
    e4(a, b) {
        if (this.o4 == null || this.o3 == null) {
            return super.e4(a, b);
        }
        return this.e5(a, b, this.lp, runOn(this, this.nd), new RangeValueList(this.o4, this.o3));
    }
    d9() {
        return this.o3 == null || this.o3.count == 0 ? NaN : this.o3._inner[0];
    }
}
PriceChannelOverlay.$t = markType(PriceChannelOverlay, 'PriceChannelOverlay', FinancialOverlay.$);
Type.dep(DependencyProperty, PropertyMetadata, PriceChannelOverlay, 'raisePropertyChanged', ['Period:o5:o7', [1, 14]]);
export class PriceChannelBucketCalculator extends FinancialBucketCalculator {
    constructor(a) {
        super(a);
        this.f = null;
        this.f = a;
    }
    getBucket(a) {
        let b = a * this.b;
        let c = Math.min(b + this.b - 1, this.a.bu.bz.count - 1);
        if (b <= c) {
            let d = -1.7976931348623157E+308;
            let e = 1.7976931348623157E+308;
            let f = 0;
            for (let g = b; g <= c; ++g) {
                if (!isNaN_(this.f.by.o4._inner[g]) && !isNaN_(this.f.by.o3._inner[g])) {
                    d = Math.max(d, this.f.by.o4._inner[g]);
                    e = Math.min(e, this.f.by.o3._inner[g]);
                    ++f;
                }
            }
            if (f > 0 && e != 1.7976931348623157E+308 && d != -1.7976931348623157E+308) {
                return [0.5 * (b + c), e, d];
            }
        }
        return [NaN, NaN, NaN];
    }
}
PriceChannelBucketCalculator.$t = markType(PriceChannelBucketCalculator, 'PriceChannelBucketCalculator', FinancialBucketCalculator.$);
export class PriceChannelOverlayView extends FinancialSeriesView {
    constructor(a) {
        super(a);
        this.b3 = new Polygon();
        this.b8 = new Polyline();
        this.b9 = new Polyline();
        this.by = null;
        this.b1 = new Polygon();
        this.b4 = new Polyline();
        this.b5 = new Polyline();
        this.by = a;
    }
    get b2() {
        return this.b3;
    }
    get b6() {
        return this.b8;
    }
    get b7() {
        return this.b9;
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.e.bj = 1;
        }
    }
    bt() {
        return new PriceChannelBucketCalculator(this);
    }
    bz() {
        this.b3.aj.clear();
        this.b8.aj.clear();
        this.b9.aj.clear();
        this.an();
    }
    b0(a, b, c, d, e) {
        for (let f of fromEnum(Flattener.d(a, b, d, this.e.ek))) {
            this.b3.aj.add({ $type: Point_$type, x: b(f), y: d(f) });
            this.b8.aj.add({ $type: Point_$type, x: b(f), y: d(f) });
        }
        for (let g of fromEnum(Flattener.d(a, c, e, this.e.ek))) {
            this.b3.aj.add({ $type: Point_$type, x: c(g), y: e(g) });
            this.b9.aj.add({ $type: Point_$type, x: c(g), y: e(g) });
        }
        this.an();
    }
    a9() {
        super.a9();
        this.b1.aj = this.b3.aj;
        this.b4.aj = this.b8.aj;
        this.b5.aj = this.b9.aj;
        let a = this.bk();
        this.b1._fill = a;
        this.b1._opacity = 1;
        this.b4._stroke = a;
        this.b4.ac = this.e.eo + 3;
        this.b5._stroke = a;
        this.b5.ac = this.e.eo + 3;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            if (b) {
                a.t(this.b1);
                a.u(this.b4);
                a.u(this.b5);
            }
            else {
                a.t(this.b3);
                a.u(this.b8);
                a.u(this.b9);
            }
        }
    }
    ai(a) {
        super.ai(a);
        this.e.a2.exportPolygonData(a, this.b3, "fill", ["Fill"]);
        this.e.a2.exportPolylineData(a, this.b8, "bottom", ["Lower", "Main"]);
        this.e.a2.exportPolylineData(a, this.b9, "top", ["Upper"]);
    }
}
PriceChannelOverlayView.$t = markType(PriceChannelOverlayView, 'PriceChannelOverlayView', FinancialSeriesView.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.PriceChannelOverlay" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.PriceChannelOverlay" />*/
//# sourceMappingURL=PriceChannelOverlay_combined.js.map