import { RectData } from "igniteui-angular-core/ES2015/RectData";
import { PrimitiveVisualDataList } from "igniteui-angular-core/ES2015/PrimitiveVisualDataList";
import { PointerTooltipVisualDataList } from "./PointerTooltipVisualDataList";
import { MarkerVisualDataList } from "./MarkerVisualDataList";
import { Base, Type } from "igniteui-angular-core/ES2015/type";
export declare class SeriesVisualData extends Base {
    constructor();
    private _name;
    name: string;
    private _type;
    type: string;
    private _viewport;
    viewport: RectData;
    private _opacity;
    opacity: number;
    private _shapes;
    shapes: PrimitiveVisualDataList;
    private _pointerTooltips;
    pointerTooltips: PointerTooltipVisualDataList;
    private _markerShapes;
    markerShapes: MarkerVisualDataList;
    private _pixels;
    pixels: number[];
    private _pixelWidth;
    pixelWidth: number;
    private _pixelHeight;
    pixelHeight: number;
    l(): void;
    serialize(): string;
    static $t: Type;
}
