/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { SplineSeriesBase } from "./SplineSeriesBase";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { typeCast, runOn, markType } from "igniteui-angular-core/ES2015/type";
import { Path } from "igniteui-angular-core/ES2015/Path";
import { ScalerParams } from "./ScalerParams";
import { SplineSeriesBaseView } from "./SplineSeriesBaseView";
import { ISortingAxis_$type } from "./ISortingAxis";
import { Color } from "igniteui-angular-core/ES2015/Color";
export class SplineAreaSeries extends SplineSeriesBase {
    constructor() {
        super();
        this.p8 = null;
        this.p8 = new CategoryLineRasterizer();
        this.ab = SplineAreaSeries.$;
    }
    bf() {
        return new SplineAreaSeriesView(this);
    }
    mx() {
        return 1;
    }
    ib(a) {
        super.ib(a);
        this.p9 = a;
    }
    preferredCategoryMode(a) {
        return 0;
    }
    hf(a, b) {
        super.hf(a, b);
        let c = b;
        c.c6();
    }
    de(a, b) {
        let c = this.k2(this.k5(a), true, false);
        if (this.pp(a, c, b)) {
            return true;
        }
        if (this.dd(a, b)) {
            return true;
        }
        if (this.ll(a, b)) {
            return true;
        }
        return false;
    }
    n4(a, b) {
        super.n4(a, b);
        let c = this.mw.cl.d;
        let d = typeCast(SplineAreaSeriesView.$, b);
        let e = a.f;
        let f = this.getEffectiveViewport1(b);
        this.mv.x(this, this.ng(), this.pf, runOn(this, this.mh), this.no(b), this.np(b));
        let g = false;
        let h = this.mv.c;
        if (h != null) {
            g = true;
        }
        if (g) {
            let i = new ScalerParams(0, b.bq, b.bp, this.pf.b8, f);
            this.n0(e, -1, this.valueColumn.count, this.pf, i, b.n);
        }
        let j = d.dd;
        let k = d.de;
        let l = d.dg;
        let m = d.di;
        this.mv.ae(j, true, false, true, true);
        this.mv.ae(k, true, false, true, true);
        this.mv.ae(l, false, true, false, false);
        this.mv.ae(m, false, true, false, false);
        l._opacity = this.mv.i * this.dz;
        m._opacity = 0.5 * this.mv.i * this.dz;
        if (b.cp(a)) {
            d.c8(a.f.count, e, true, c, this.ek, (n, o, p, q, r) => this.o0(n, a.f.count, b), 1, a.f.count == 1 ? null : this.of(e, e.count - 1, b.bp, b.bq, true));
            b.cs(a);
        }
        let n = this.fetchYAxis();
    }
    get useHighMarkerFidelity() {
        return this.nj;
    }
}
SplineAreaSeries.$t = markType(SplineAreaSeries, 'SplineAreaSeries', SplineSeriesBase.$);
export class SplineAreaSeriesView extends SplineSeriesBaseView {
    constructor(a) {
        super(a);
        this.c5 = null;
        this.df = new Path();
        this.dj = new Path();
        this.dh = new Path();
        this.dk = new Path();
        this.c9 = new Path();
        this.db = new Path();
        this.da = new Path();
        this.dc = new Path();
        this.c5 = a;
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.e.bj = 1;
        }
    }
    get dd() {
        return this.dj;
    }
    get de() {
        return this.dk;
    }
    get dg() {
        return this.df;
    }
    get di() {
        return this.dh;
    }
    c6() {
        this.df.aj = null;
        this.dh.aj = null;
        this.dj.aj = null;
        this.dk.aj = null;
        this.an();
    }
    c7(a, b, c, d, e, f, g) {
        this.c8(a, b, c, d, e, f, g, null);
    }
    c8(a, b, c, d, e, f, g, h) {
        this.c5.p8.a = typeCast(ISortingAxis_$type, this.cn.fetchXAxis()) !== null ? true : false;
        this.c5.p8.j(this.df, this.dj, this.dh, this.dk, a, b, c, d, e, f, g, h);
        this.an();
    }
    a9() {
        super.a9();
        this.c9.aj = this.df.aj;
        this.db.aj = this.dj.aj;
        this.da.aj = this.dh.aj;
        this.dc.aj = this.dk.aj;
        let a = this.bk();
        this.c9._fill = a;
        this.c9._opacity = 1;
        this.da._fill = a;
        this.da._opacity = 1;
        this.db._stroke = a;
        this.db.ac = this.e.eo + 3;
        this.dc._stroke = a;
        this.dc.ac = this.e.eo + 3;
    }
    a3(a, b) {
        super.a3(a, b);
        if (b) {
            a.s(this.c9);
            a.s(this.da);
            a.s(this.db);
            a.s(this.dc);
        }
        else {
            a.s(this.df);
            a.s(this.dh);
            a.s(this.dj);
            a.s(this.dk);
        }
    }
    ai(a) {
        super.ai(a);
        this.e.a2.exportPathData(a, this.dj, "lowerShape", ["Lower"]);
        this.e.a2.exportPathData(a, this.dk, "upperShape", ["Upper", "Main"]);
        this.e.a2.exportPathData(a, this.dh, "translucentShape", ["Translucent"]);
        this.e.a2.exportPathData(a, this.df, "fillShape", ["Fill"]);
    }
    ac() {
        let a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.kr = a;
        this.e.el = 5;
        this.e.em = 1;
        this.e.en = -3;
    }
}
SplineAreaSeriesView.$t = markType(SplineAreaSeriesView, 'SplineAreaSeriesView', SplineSeriesBaseView.$);
//# sourceMappingURL=SplineAreaSeries_combined.js.map