import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { CategoryMode } from "./CategoryMode";
import { SeriesView } from "./SeriesView";
import { Type, IList$1 } from "igniteui-angular-core/ES2015/type";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { CategoryFrame } from "./CategoryFrame";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { CategorySeriesView } from "./CategorySeriesView";
import { Path } from "igniteui-angular-core/ES2015/Path";
import { PointCollection } from "igniteui-angular-core/ES2015/PointCollection";
import { UnknownValuePlotting } from "igniteui-angular-core/ES2015/UnknownValuePlotting";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { Clipper } from "igniteui-angular-core/ES2015/Clipper";
import { RenderingContext } from "igniteui-angular-core/ES2015/RenderingContext";
export declare class StepAreaSeries extends HorizontalAnchoredCategorySeries implements IIsCategoryBased {
    protected bf(): SeriesView;
    ib(a: SeriesView): void;
    pz: StepAreaSeriesView;
    protected get_cj(): boolean;
    readonly cj: boolean;
    constructor();
    py: CategoryLineRasterizer;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    hf(a: boolean, b: SeriesView): void;
    private p0(a, b, c, d, e);
    protected mx(): CategoryTransitionInMode;
    d7(a: number, b: IList$1<number>, c: number, d: number, e: number, f: number, g: number, h: boolean): number;
    protected bd(): SeriesHitTestMode;
    n4(a: CategoryFrame, b: CategorySeriesView): void;
    readonly currentCategoryMode: CategoryMode;
    readonly useHighMarkerFidelity: boolean;
    static $t: Type;
}
export declare class StepAreaSeriesView extends AnchoredCategorySeriesView {
    protected c4: StepAreaSeries;
    constructor(a: StepAreaSeries);
    ap(): void;
    private dc;
    private dg;
    private de;
    private di;
    readonly dd: Path;
    readonly dh: Path;
    readonly df: Path;
    readonly dj: Path;
    c5(): void;
    c6(a: number, b: List$1<number[]>, c: boolean, d: number, e: number, f: (arg1: PointCollection, arg2: PointCollection, arg3: PointCollection, arg4: PointCollection, arg5: boolean) => void, g: UnknownValuePlotting): void;
    c7(a: number, b: List$1<number[]>, c: boolean, d: number, e: number, f: (arg1: PointCollection, arg2: PointCollection, arg3: PointCollection, arg4: PointCollection, arg5: boolean) => void, g: UnknownValuePlotting, h: Clipper): void;
    private c8;
    private da;
    private c9;
    private db;
    protected a9(): void;
    protected a3(a: RenderingContext, b: boolean): void;
    ai(a: any): void;
    static $t: Type;
}
