/**
 * Provides data for the SelectedItemChanged event.
*/
export class SelectedItemChangedEventArgs {
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
         * The previously selected item.
        */
    get oldItem() {
        return this.i.oldItem;
    }
    /**
         * The newly selected item.
        */
    get newItem() {
        return this.i.newItem;
    }
}
//# sourceMappingURL=igx-selected-item-changed-event-args.js.map