/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased_$type } from "./IIsCategoryBased";
import { IHasSingleValueCategory_$type } from "./IHasSingleValueCategory";
import { IHasCategoryTrendline_$type } from "./IHasCategoryTrendline";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { IAnchoredCategorySeriesInteractionManager_$type } from "./IAnchoredCategorySeriesInteractionManager";
import { DVContainer } from "igniteui-angular-core/ES5/DVContainer";
import { Type, enumGetBox, typeCast, Point_$type, markType } from "igniteui-angular-core/ES5/type";
import { DependencyProperty } from "igniteui-angular-core/ES5/DependencyProperty";
import { TrendLineType_$type } from "igniteui-angular-core/ES5/TrendLineType";
import { Brush } from "igniteui-angular-core/ES5/Brush";
import { PenLineCap_$type } from "igniteui-angular-core/ES5/PenLineCap";
import { DoubleCollection } from "igniteui-angular-core/ES5/DoubleCollection";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ICategoryScaler_$type } from "./ICategoryScaler";
import { IScaler_$type } from "./IScaler";
import { CategorySeriesView } from "./CategorySeriesView";
import { CategorySeriesMarkerCollisionAvoidance_$type } from "./CategorySeriesMarkerCollisionAvoidance";
import { ConsolidatedItemHitTestBehavior_$type } from "./ConsolidatedItemHitTestBehavior";
import { CategoryFramePreparer } from "./CategoryFramePreparer";
import { Rect } from "igniteui-angular-core/ES5/Rect";
import { IFastItemsSource_$type } from "igniteui-angular-core/ES5/IFastItemsSource";
import { NumericAxisBase } from "./NumericAxisBase";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AxisRange } from "./AxisRange";
import { NumericYAxis } from "./NumericYAxis";
import { ScalerParams } from "./ScalerParams";
import { CategoryMarkerManager } from "./CategoryMarkerManager";
import { CollisionAvoider } from "./CollisionAvoider";
import { NonCollisionAvoider } from "./NonCollisionAvoider";
import { PropertyMetadata } from "igniteui-angular-core/ES5/PropertyMetadata";
import { truncate, isNaN_ } from "igniteui-angular-core/ES5/number";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
var AnchoredCategorySeries = /** @class */ (function (_super) {
    tslib_1.__extends(AnchoredCategorySeries, _super);
    function AnchoredCategorySeries() {
        var _this = _super.call(this) || this;
        _this.ok = null;
        _this.oo = false;
        _this.om = null;
        _this.oh = null;
        _this.or = null;
        _this.ms = new CategoryFramePreparer(1, _this, _this.mw, _this, _this, _this.mw.cl);
        return _this;
    }
    Object.defineProperty(AnchoredCategorySeries.prototype, "ol", {
        get: function () {
            var _this = this;
            if (this.ok == null) {
                this.ok = DVContainer.instance.createInstance(IAnchoredCategorySeriesInteractionManager_$type, function () { return _this.b2.n; });
            }
            return this.ok;
        },
        enumerable: true,
        configurable: true
    });
    AnchoredCategorySeries.prototype.bf = function () {
        var a = new AnchoredCategorySeriesView(this);
        return a;
    };
    AnchoredCategorySeries.prototype.ib = function (a) {
        _super.prototype.ib.call(this, a);
        this.og = a;
    };
    Object.defineProperty(AnchoredCategorySeries.prototype, "valueColumn", {
        get: function () {
            return this.om;
        },
        set: function (a) {
            if (this.om != a) {
                var b = this.om;
                this.om = a;
                if (!this.oo) {
                    this.raisePropertyChanged("ValueColumn", b, this.om);
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AnchoredCategorySeries.prototype, "pc", {
        get: function () {
            return this.c(AnchoredCategorySeries.o1);
        },
        set: function (a) {
            this.h(AnchoredCategorySeries.o1, a);
        },
        enumerable: true,
        configurable: true
    });
    AnchoredCategorySeries.prototype.c6 = function (a) {
        var b = new Rect(0, 0, 0, 1, 1);
        var c = this.fetchXAxis();
        var d = this.fetchYAxis();
        var e = this.k9(this.bi);
        var f = c != null ? this.ms.r(typeCast(ICategoryScaler_$type, c), b, b, e) : 0;
        return this.ol.c$a(this, this.valueColumn, c, d, f, a);
    };
    AnchoredCategorySeries.prototype.od = function (a, b, c) {
        if (b < a || a < 0 || a > this.valueColumn.count || b < 0 || b > this.valueColumn.count || c == null) {
            return null;
        }
        var d = new Array((b - a) + 1);
        var e = c.cc;
        var f = null;
        if (e) {
            f = c.i$b;
        }
        for (var g = a; g <= b; g++) {
            var h = g;
            if (e) {
                h = f._inner[h];
            }
            d[g - a] = this.bz.item(g);
        }
        return d;
    };
    AnchoredCategorySeries.prototype.ih = function (a, b, c, d) {
        _super.prototype.ih.call(this, a, b, c, d);
        if (this.og.cx && this.og.cw.g$b(a, b, c, d)) {
            this.iv(false);
            this.h2();
        }
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.valueColumn);
                    this.valueColumn = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.valueColumn = this.bw(this.ov);
                }
                var e = typeCast(NumericAxisBase.$, this.fetchYAxis());
                if (e != null && !e.ck()) {
                    this.og.cl.g(this.ek);
                    this.iv(false);
                }
                break;
            case AnchoredCategorySeries.$$p[2]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.valueColumn);
                    this.valueColumn = this.bw(this.ov);
                }
                this.or = this.ov;
                break;
            case "ValueColumn":
                if (this.og.cx) {
                    this.og.cw.g$i();
                }
                var f = typeCast(NumericAxisBase.$, this.fetchYAxis());
                if (f != null && !f.ck()) {
                    this.og.cl.g(this.ek);
                    this.iv(false);
                }
                break;
            case "TrendLineBrush":
                this.i6();
                break;
            case "ErrorBarSettings":
                this.iv(false);
                break;
            case "TrendLineType":
                this.h2();
                break;
            case AnchoredCategorySeries.$$p[1]:
                this.iv(false);
                break;
        }
    };
    AnchoredCategorySeries.prototype.an = function (a) {
        if (this.valueColumn == null || this.valueColumn.count == 0) {
            return null;
        }
        if (a == this.fetchXAxis()) {
            return new AxisRange(0, this.valueColumn.count - 1);
        }
        if (a == this.fetchYAxis()) {
            return new AxisRange(this.valueColumn.minimum, this.valueColumn.maximum);
        }
        return null;
    };
    AnchoredCategorySeries.prototype.hi = function (a, b, c, d) {
        switch (a) {
            case 4:
            case 1:
            case 0:
                this.og.cl.g(this.ek);
                break;
        }
        if (this.og.cx) {
            this.og.cw.g$e(a, b, c, d);
        }
    };
    AnchoredCategorySeries.prototype.nn = function () {
        return this.op(this.mw);
    };
    AnchoredCategorySeries.prototype.op = function (a) {
        var b = 0;
        var c = a.bq;
        var d = a.bp;
        var e = this.getEffectiveViewport1(a);
        var f = typeCast(NumericYAxis.$, this.fetchYAxis());
        if (!c.isEmpty && !d.isEmpty && f != null) {
            var g = new ScalerParams(0, c, d, f.b8, e);
            b = f.dt(f.j6, g);
        }
        return b;
    };
    AnchoredCategorySeries.prototype.o0 = function (a, b, c) {
        var d = this.op(c);
        if (a.count > 0) {
            var e = d;
            a.add({ $type: Point_$type, x: a._inner[a.count - 1].x, y: e });
            a.add({ $type: Point_$type, x: a._inner[0].x, y: e });
        }
    };
    AnchoredCategorySeries.prototype.oe = function (a, b, c, d) {
        return this.of(a, b, c, d, false);
    };
    AnchoredCategorySeries.prototype.of = function (a, b, c, d, e) {
        return CategorySeries.mi(a, b, c, d, e);
    };
    AnchoredCategorySeries.prototype.dt = function (a, b, c) {
        var d = _super.prototype.dt.call(this, a, b, c);
        var e = c;
        if (this.valueColumn == null || this.valueColumn.count == 0 || e.cl.d < 1) {
            d = false;
        }
        return d;
    };
    AnchoredCategorySeries.prototype.hf = function (a, b) {
        _super.prototype.hf.call(this, a, b);
        var c = b;
        c.cr();
        if (c.cx) {
            c.cw.g$d();
        }
    };
    AnchoredCategorySeries.prototype.n1 = function (a, b) {
        _super.prototype.n1.call(this, a, b);
        this.mt(b).d(a, b);
    };
    AnchoredCategorySeries.prototype.n4 = function (a, b) {
        _super.prototype.n4.call(this, a, b);
        var c = typeCast(AnchoredCategorySeriesView.$, b);
        c.by = true;
        if (c.cx) {
            c.cw.g$g(a.p);
        }
        if (this.lk()) {
            CategoryMarkerManager.b(this, a.m, b.co, this.lm);
            this.ny(b, a);
            b.ch();
        }
        this.ox(a, b);
    };
    AnchoredCategorySeries.prototype.iu = function (a, b, c, d, e) {
        _super.prototype.iu.call(this, a, b, c, d, e);
        var f = this.a0.a$h.item(d);
        var g = f;
        g.cl.g(this.ek);
        f.ay(c);
        if (this.cc(g)) {
            return;
        }
        if (this.oh == null) {
            this.oh = new CategoryFrame(3);
        }
        this.oh.u();
        this.n1(this.oh, g);
        this.n4(this.oh, g);
    };
    AnchoredCategorySeries.prototype.ox = function (a, b) {
    };
    AnchoredCategorySeries.prototype.i6 = function () {
        _super.prototype.i6.call(this);
        if (this.e7 < 0) {
            return;
        }
        this.og.c1();
        if (this.trendLineBrush != null) {
            this.og.cz();
        }
        else {
            this.og.cy();
        }
    };
    AnchoredCategorySeries.prototype.fi = function (a, b) {
        if (this.og.cx && a == this.og.cw.g$j) {
            return null;
        }
        return _super.prototype.fi.call(this, a, b);
    };
    Object.defineProperty(AnchoredCategorySeries.prototype, "currentCategoryMode", {
        get: function () {
            return this.preferredCategoryMode(typeCast(CategoryAxisBase.$, this.fetchXAxis()));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AnchoredCategorySeries.prototype, "scaler", {
        get: function () {
            return typeCast(ICategoryScaler_$type, this.fetchXAxis());
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AnchoredCategorySeries.prototype, "yScaler", {
        get: function () {
            return typeCast(IScaler_$type, this.fetchYAxis());
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AnchoredCategorySeries.prototype, "bucketizer", {
        get: function () {
            return this.og.cl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AnchoredCategorySeries.prototype, "currentMode2Index", {
        get: function () {
            return this.nq();
        },
        enumerable: true,
        configurable: true
    });
    AnchoredCategorySeries.prototype.provideCollisionDetector = function () {
        if (this.oi == 1) {
            return new CollisionAvoider();
        }
        return NonCollisionAvoider.a;
    };
    Object.defineProperty(AnchoredCategorySeries.prototype, "trendlinePreparer", {
        get: function () {
            return this.og.cx ? this.og.cw : null;
        },
        enumerable: true,
        configurable: true
    });
    AnchoredCategorySeries.prototype.ho = function (a) {
        _super.prototype.ho.call(this, a);
        if (this.og.cx) {
            this.a2.exportTrendlineData(this, a, this.og.cw.g$j);
        }
    };
    AnchoredCategorySeries.prototype.ff = function (a) {
        var _this = this;
        var b = this.fetchXAxis();
        var c = this.fetchYAxis();
        return this.ol.c$b(this, a, this.no(this.bi), this.valueColumn, b, c, this.oj == 1, function (d) { return _super.prototype.ff.call(_this, d); });
    };
    Object.defineProperty(AnchoredCategorySeries.prototype, "mayContainUnknowns", {
        get: function () {
            return this.valueColumn == null || this.valueColumn.mayContainUnknowns;
        },
        enumerable: true,
        configurable: true
    });
    AnchoredCategorySeries.prototype.d9 = function () {
        return this.valueColumn == null || this.valueColumn.count == 0 ? NaN : this.valueColumn.item(0);
    };
    AnchoredCategorySeries.prototype.ao = function () {
        if (this.valueColumn == null) {
            return null;
        }
        var a = this.mn();
        var b = new ScalerParams(0, this.bs.mk, this.bs.mx, a.b8, this.getEffectiveViewport());
        var c = (a.dw(this.bs.mx.left, b));
        var d = (a.dw(this.bs.mx.right, b));
        var e = null;
        if (a.cc) {
            e = a;
            c = e.i$f(c);
            d = e.i$f(d);
        }
        else {
            c = Math.floor(c);
            d = Math.ceil(d);
        }
        if (isNaN_(c) || isNaN_(d)) {
            return null;
        }
        c = Math.max(0, Math.min(this.valueColumn.count - 1, c));
        d = Math.max(0, Math.min(this.valueColumn.count - 1, d));
        var f = 1.7976931348623157E+308;
        var g = -1.7976931348623157E+308;
        for (var h = truncate(c); h <= truncate(d); h++) {
            var i = h;
            if (e != null) {
                i = e.i$b._inner[h];
            }
            f = Math.min(f, this.valueColumn.item(i));
            g = Math.max(g, this.valueColumn.item(i));
        }
        return new AxisRange(f, g);
    };
    Object.defineProperty(AnchoredCategorySeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.nj;
        },
        enumerable: true,
        configurable: true
    });
    AnchoredCategorySeries.o1 = DependencyProperty.i("ActualTrendLineBrush", Brush.$, AnchoredCategorySeries.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    AnchoredCategorySeries.$t = markType(AnchoredCategorySeries, 'AnchoredCategorySeries', CategorySeries.$, [IIsCategoryBased_$type, IHasSingleValueCategory_$type, IHasCategoryTrendline_$type, ITrendLineSeries_$type]);
    return AnchoredCategorySeries;
}(CategorySeries));
export { AnchoredCategorySeries };
Type.dep(DependencyProperty, PropertyMetadata, AnchoredCategorySeries, 'raisePropertyChanged', ['ConsolidatedItemHitTestBehavior:oj:o2', [ConsolidatedItemHitTestBehavior_$type, enumGetBox(ConsolidatedItemHitTestBehavior_$type, 0)], 'MarkerCollisionAvoidance:oi:o3', [CategorySeriesMarkerCollisionAvoidance_$type, enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, 1)], 'ValueMemberPath:ov:pb', [2, null], 'TrendLineType::o9', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::o8', [1, 1.5], 'TrendLinePeriod::o7', [1, 7], 'TrendLineBrush::o4', [Brush.$, null], 'TrendLineZIndex:oq:pa', [1, 1001], 'TrendLineDashArray:pd:o5', [DoubleCollection.$], 'TrendLineDashCap:pe:o6', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
var AnchoredCategoryBucketCalculator = /** @class */ (function (_super) {
    tslib_1.__extends(AnchoredCategoryBucketCalculator, _super);
    function AnchoredCategoryBucketCalculator(a) {
        var _this = _super.call(this, a) || this;
        _this.i = null;
        _this.h = null;
        _this.j = 0;
        _this.i = a;
        return _this;
    }
    AnchoredCategoryBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        var b = this.h;
        var c = this.j;
        var d = a * this.d;
        var e = d + this.d - 1;
        var f = c - 1;
        d = d < f ? d : f;
        e = e < f ? e : f;
        var g = 1.7976931348623157E+308;
        var h = -1.7976931348623157E+308;
        var i = true;
        for (var j = d; j <= e; ++j) {
            var k = b[j];
            g = g < k ? g : k;
            h = h > k ? h : k;
            i = false;
        }
        if (!i) {
            return [0.5 * (d + e), g, h];
        }
        return [0.5 * (d + e), NaN, NaN];
    };
    AnchoredCategoryBucketCalculator.prototype.getBucket = function (a) {
        var b = this.h;
        var c = this.j;
        var d = a * this.d;
        var e = d + this.d - 1;
        var f = c - 1;
        d = d < f ? d : f;
        e = e < f ? e : f;
        var g = 0;
        var h = 0;
        var i = true;
        for (var j = d; j <= e; ++j) {
            var k = b[j];
            if (!i) {
                if (!isNaN_(k)) {
                    g = g < k ? g : k;
                    h = h > k ? h : k;
                }
            }
            else {
                if (!isNaN_(k)) {
                    g = k;
                    h = k;
                    i = false;
                }
            }
        }
        if (!i) {
            return [0.5 * (d + e), g, h];
        }
        return [0.5 * (d + e), NaN, NaN];
    };
    AnchoredCategoryBucketCalculator.prototype.cacheValues = function () {
        this.j = this.i.cu.valueColumn.count;
        this.h = this.i.cu.valueColumn.asArray();
    };
    AnchoredCategoryBucketCalculator.prototype.unCacheValues = function () {
        this.h = null;
    };
    AnchoredCategoryBucketCalculator.$t = markType(AnchoredCategoryBucketCalculator, 'AnchoredCategoryBucketCalculator', CategoryBucketCalculator.$);
    return AnchoredCategoryBucketCalculator;
}(CategoryBucketCalculator));
export { AnchoredCategoryBucketCalculator };
var AnchoredCategorySeriesView = /** @class */ (function (_super) {
    tslib_1.__extends(AnchoredCategorySeriesView, _super);
    function AnchoredCategorySeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cu = null;
        _this.cv = null;
        _this.cu = a;
        return _this;
    }
    Object.defineProperty(AnchoredCategorySeriesView.prototype, "cw", {
        get: function () {
            if (this.cv == null) {
                this.cv = CategoryTrendLineManagerFactory.a(this.cv, this.e.ap(), this.e.je, this.e, this.e.b2);
            }
            return this.cv;
        },
        set: function (a) {
            this.cv = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AnchoredCategorySeriesView.prototype, "cx", {
        get: function () {
            return this.cv != null;
        },
        enumerable: true,
        configurable: true
    });
    AnchoredCategorySeriesView.prototype.c1 = function () {
        this.cu.pc = null;
    };
    AnchoredCategorySeriesView.prototype.cz = function () {
        this.cu.pc = this.cu.trendLineBrush;
    };
    AnchoredCategorySeriesView.prototype.cy = function () {
        this.cu.pc = this.cu.kk;
    };
    AnchoredCategorySeriesView.prototype.cm = function () {
        return new AnchoredCategoryBucketCalculator(this);
    };
    AnchoredCategorySeriesView.prototype.c0 = function () {
        this.cl.cacheValues();
    };
    AnchoredCategorySeriesView.prototype.c2 = function () {
        this.cl.unCacheValues();
    };
    AnchoredCategorySeriesView.prototype.c3 = function (a) {
        var b = this.co.item(a);
        return this.ck(b);
    };
    AnchoredCategorySeriesView.prototype.a2 = function (a, b) {
        if (a.d) {
            if (this.cu.trendLineType != 0 && !b) {
                var c = this.cw.g$j;
                c.ac = this.cu.trendLineThickness;
                c._stroke = this.cu.pc;
                c.ai = this.cu.pd;
                c.ad = this.cu.pe;
                a.u(c);
            }
        }
        _super.prototype.a2.call(this, a, b);
    };
    AnchoredCategorySeriesView.prototype.getDefaultTooltipTemplate = function () {
        return this.cu.ol.c$c(this.e, this.cu.ov);
    };
    AnchoredCategorySeriesView.$t = markType(AnchoredCategorySeriesView, 'AnchoredCategorySeriesView', CategorySeriesView.$);
    return AnchoredCategorySeriesView;
}(CategorySeriesView));
export { AnchoredCategorySeriesView };
/*<BeginStatics Name="Infragistics.Controls.Charts.AnchoredCategorySeries" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.AnchoredCategorySeries" />*/
//# sourceMappingURL=AnchoredCategorySeries_combined.js.map