/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { DVContainer } from "igniteui-angular-core/ES5/DVContainer";
import { IAnnotationInfoProvider_$type } from "./IAnnotationInfoProvider";
import { Base, markType } from "igniteui-angular-core/ES5/type";
import { AnnotationInfoProvider } from "./AnnotationInfoProvider";
import { IAxisAnnotationManager_$type } from "./IAxisAnnotationManager";
import { AxisAnnotationManager } from "./AxisAnnotationManager";
var AnnotationFactoryManager = /** @class */ (function (_super) {
    tslib_1.__extends(AnnotationFactoryManager, _super);
    function AnnotationFactoryManager() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AnnotationFactoryManager.register = function () {
        if (!AnnotationFactoryManager.a) {
            DVContainer.instance.registerFactory(IAnnotationInfoProvider_$type, function () { return new AnnotationInfoProvider(); });
            DVContainer.instance.registerFactory(IAxisAnnotationManager_$type, function () { return new AxisAnnotationManager(); });
            AnnotationFactoryManager.a = true;
        }
    };
    AnnotationFactoryManager.a = false;
    AnnotationFactoryManager.$t = markType(AnnotationFactoryManager, 'AnnotationFactoryManager');
    return AnnotationFactoryManager;
}(Base));
export { AnnotationFactoryManager };
/*<BeginStatics Name="Infragistics.Controls.Charts.AnnotationFactoryManager" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.AnnotationFactoryManager" />*/
//# sourceMappingURL=AnnotationFactoryManager.js.map