import { AnnotationLayer } from "./AnnotationLayer";
import { Series } from "./Series";
import { CategoryItemHighlightType } from "./CategoryItemHighlightType";
import { DataTemplate } from "igniteui-angular-core/ES5/DataTemplate";
import { CategoryItemHighlightLayerFrame } from "./CategoryItemHighlightLayerFrame";
import { Type, Point } from "igniteui-angular-core/ES5/type";
import { SeriesView } from "./SeriesView";
import { Frame } from "./Frame";
import { List$1 } from "igniteui-angular-core/ES5/List$1";
import { Rect } from "igniteui-angular-core/ES5/Rect";
import { ItemHighlightFrameRect } from "./ItemHighlightFrameRect";
import { Pool$1 } from "igniteui-angular-core/ES5/Pool$1";
import { ContentControl } from "igniteui-angular-core/ES5/ContentControl";
import { Rectangle } from "igniteui-angular-core/ES5/Rectangle";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { Brush } from "igniteui-angular-core/ES5/Brush";
import { RenderingContext } from "igniteui-angular-core/ES5/RenderingContext";
export declare class CategoryItemHighlightLayer extends AnnotationLayer {
    constructor();
    protected bf(): SeriesView;
    ib(a: SeriesView): void;
    protected mj: CategoryItemHighlightLayerView;
    mm: Series;
    mq: boolean;
    mk: CategoryItemHighlightType;
    m4: DataTemplate;
    ms: number;
    mp: boolean;
    protected l0(a: Series, b: boolean): void;
    protected ln(a: Series): boolean;
    protected l2(a: Frame, b: SeriesView): void;
    private mo;
    private mn;
    protected ih(a: any, b: string, c: any, d: any): void;
    private mr;
    private m1(a, b, c);
    mz(a: Point, b: CategoryItemHighlightLayerFrame, c: Series): void;
    private ml(a, b);
    m0(a: Rect, b: CategoryItemHighlightLayerFrame, c: Series): void;
    protected l5(a: Frame, b: SeriesView): void;
    m2(a: ItemHighlightFrameRect, b: ContentControl): void;
    m3(a: ItemHighlightFrameRect, b: Rectangle): void;
    protected c5(): boolean;
    static $$p: string[];
    static $t: Type;
}
export declare class CategoryItemHighlightLayerView extends AnnotationLayerView {
    constructor(a: CategoryItemHighlightLayer);
    protected bz: CategoryItemHighlightLayer;
    b1: Pool$1<Rectangle>;
    b0: Pool$1<ContentControl>;
    ap(): void;
    protected b2: List$1<ContentControl>;
    protected b3: List$1<Rectangle>;
    private cf();
    private b9(a);
    private cb(a);
    private ca(a);
    private cc();
    private b4(a);
    private b6(a);
    private b5(a);
    cd(a: Brush): Brush;
    ce(a: Brush): Brush;
    b8(a: Rectangle, b: number, c: number, d: number, e: number): void;
    b7(a: ContentControl, b: number, c: number): void;
    protected be(a: any, b: number): void;
    protected a3(a: RenderingContext, b: boolean): void;
    ai(a: any): void;
    static $t: Type;
}
