import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { ConsolidatedItemsPosition } from "./ConsolidatedItemsPosition";
import { SeriesView } from "./SeriesView";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { Type, Point } from "igniteui-angular-core/ES5/type";
import { CategoryMode } from "./CategoryMode";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { Rect } from "igniteui-angular-core/ES5/Rect";
import { CategoryFrame } from "./CategoryFrame";
import { Pool$1 } from "igniteui-angular-core/ES5/Pool$1";
import { CategorySeriesView } from "./CategorySeriesView";
import { List$1 } from "igniteui-angular-core/ES5/List$1";
import { Rectangle } from "igniteui-angular-core/ES5/Rectangle";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { RenderingContext } from "igniteui-angular-core/ES5/RenderingContext";
export declare class ColumnSeries extends HorizontalAnchoredCategorySeries {
    protected bf(): SeriesView;
    py: ColumnSeriesView;
    ib(a: SeriesView): void;
    protected mx(): CategoryTransitionInMode;
    constructor();
    p2: number;
    p3: number;
    protected get_nc(): boolean;
    protected readonly nc: boolean;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    private p4;
    lb(a: Point): Rect;
    de(a: Point, b: boolean): boolean;
    hf(a: boolean, b: SeriesView): void;
    d8(): number;
    n4(a: CategoryFrame, b: CategorySeriesView): void;
    private pz;
    p0: ConsolidatedItemsPosition;
    private p1(a);
    readonly useHighMarkerFidelity: boolean;
    static $$p: string[];
    static $t: Type;
}
export declare class ColumnSeriesView extends AnchoredCategorySeriesView {
    ap(): void;
    protected c4: ColumnSeries;
    constructor(a: ColumnSeries);
    dc(): Rectangle;
    protected c6: List$1<Rectangle>;
    c7(a: Rectangle): void;
    c9(a: Rectangle): void;
    c8(a: Rectangle): void;
    da(a: Rectangle, b: number, c: number): void;
    protected z(a: number): any;
    private db;
    protected y(a: number): any;
    protected a3(a: RenderingContext, b: boolean): void;
    c5: Pool$1<Rectangle>;
    ai(a: any): void;
    static $t: Type;
}
