/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { AnnotationLayer } from "./AnnotationLayer";
import { Brush } from "igniteui-angular-core/ES5/Brush";
import { DependencyProperty } from "igniteui-angular-core/ES5/DependencyProperty";
import { Series } from "./Series";
import { Visibility_$type } from "igniteui-angular-core/ES5/Visibility";
import { CrosshairLayerFrame } from "./CrosshairLayerFrame";
import { List$1 } from "igniteui-angular-core/ES5/List$1";
import { Axis } from "./Axis";
import { Dictionary$2 } from "igniteui-angular-core/ES5/Dictionary$2";
import { Pool$1 } from "igniteui-angular-core/ES5/Pool$1";
import { AxisAnnotation } from "./AxisAnnotation";
import { Type, Number_$type, enumGetBox, fromEnum, Point_$type, markType, runOn } from "igniteui-angular-core/ES5/type";
import { AxisAnnotationFrameManager } from "./AxisAnnotationFrameManager";
import { Tuple$2 } from "igniteui-angular-core/ES5/Tuple$2";
import { Path } from "igniteui-angular-core/ES5/Path";
import { PathGeometry } from "igniteui-angular-core/ES5/PathGeometry";
import { PathFigure } from "igniteui-angular-core/ES5/PathFigure";
import { LineSegment } from "igniteui-angular-core/ES5/LineSegment";
import { PropertyMetadata } from "igniteui-angular-core/ES5/PropertyMetadata";
import { isNaN_ } from "igniteui-angular-core/ES5/number";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { TranslateTransform } from "igniteui-angular-core/ES5/TranslateTransform";
import { LineGeometry } from "igniteui-angular-core/ES5/LineGeometry";
import { BrushUtil } from "igniteui-angular-core/ES5/BrushUtil";
var CrosshairLayer = /** @class */ (function (_super) {
    tslib_1.__extends(CrosshairLayer, _super);
    function CrosshairLayer() {
        var _this = _super.call(this) || this;
        _this.mp = null;
        _this.mo = null;
        var a = new CrosshairLayerFrame();
        var b = new CrosshairLayerFrame();
        var c = new CrosshairLayerFrame();
        var d = _this.e8 / 1000;
        _this.lj = a;
        _this.li = b;
        _this.lk = c;
        _this.ab = CrosshairLayer.$;
        return _this;
    }
    CrosshairLayer.prototype.bf = function () {
        return new CrosshairLayerView(this);
    };
    CrosshairLayer.prototype.ib = function (a) {
        _super.prototype.ib.call(this, a);
        this.mj = a;
    };
    CrosshairLayer.prototype.l0 = function (a, b) {
        if (this.mk == null || this.mk == a) {
            if (!this.aq.c) {
                this.iv(b);
            }
        }
    };
    CrosshairLayer.prototype.l2 = function (a, b) {
        _super.prototype.l2.call(this, a, b);
        var c = a;
        var d = this.mn;
        var e = this.mm;
        c.x.clear();
        c.y.clear();
        c.w.clear();
        c.z.clear();
        AxisAnnotationFrameManager.b(c);
        if (this.ln(this.mk)) {
            this.nh(this.mk, c, d, e);
        }
        else {
            try {
                for (var _a = tslib_1.__values(fromEnum(this.bs.series)), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var f = _b.value;
                    if (this.ln(f)) {
                        this.nh(f, c, d, e);
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        var e_1, _c;
    };
    CrosshairLayer.prototype.ln = function (a) {
        if (!_super.prototype.ln.call(this, a)) {
            return false;
        }
        var b = this.lv(a);
        if (!b.a) {
            return false;
        }
        return true;
    };
    CrosshairLayer.prototype.h5 = function () {
        _super.prototype.h5.call(this);
        if (!this.aq.c && !this.ca()) {
            return;
        }
        if (this.ca()) {
            this.ni(this.lk, false);
        }
        else {
            this.ni(this.li, false);
        }
    };
    CrosshairLayer.prototype.nh = function (a, b, c, d) {
        var e = this.lv(a);
        if (!e.a) {
            return;
        }
        var f = e.b;
        f = a.k2(f, c, d);
        var g = this.kk;
        if (g == null) {
            g = this.km;
        }
        if (g == null) {
            g = a.kk;
            if (g != null) {
                g = this.mj.b6(g);
            }
        }
        var h = g;
        var i = g;
        if (this.n3 != null) {
            h = this.n3;
        }
        if (this.n4 != null) {
            i = this.n4;
        }
        b.w.add(h);
        b.z.add(i);
        b.x.add(f.y);
        b.y.add(f.x);
        if (this.ml) {
            AxisAnnotationFrameManager.c(b, f, a, this.bs, this.getEffectiveViewport(), g, this.n5, this.n7, this.n6, this.mq, this.mr, this.n8, this.oa, this.n9, this.ms, this.mt, this.oc == 0, this.ob == 0);
        }
    };
    CrosshairLayer.prototype.ni = function (a, b) {
        var c = false;
        if (this.mo == null) {
            c = true;
            this.mp = new List$1(Axis.$, 0);
            this.mo = new Dictionary$2(Axis.$, Pool$1.$.specialize(AxisAnnotation.$), 0);
        }
        AxisAnnotationFrameManager.d(a, c, this.mo, this.mp, b, this.mu, this.mv);
    };
    CrosshairLayer.prototype.ng = function (a, b, c, d, e) {
        var f = a.item(b);
        b++;
        if (e) {
            f._stroke = d.z._inner[c];
            f._fill = d.z._inner[c];
        }
        else {
            f._stroke = d.w._inner[c];
            f._fill = d.w._inner[c];
        }
        f.ac = this.eo;
        f.ai = this.ks;
        f.ad = this.kt;
        return new Tuple$2(Path.$, Number_$type, f, b);
    };
    CrosshairLayer.prototype.l5 = function (a, b) {
        _super.prototype.l5.call(this, a, b);
        var c = this.mj.b0;
        var d = a;
        var e = d.x.count;
        var f = 0;
        var g = b.bp.left;
        var h = b.bp.right;
        var i = b.bp.top;
        var j = b.bp.bottom;
        var k = this.oc == 0;
        var l = this.ob == 0;
        for (var m = 0; m < e; m++) {
            var n = Math.floor(d.x._inner[m]);
            var o = Math.floor(d.y._inner[m]);
            var p = null;
            if (k) {
                if (isNaN_(n)) {
                    continue;
                }
                var q = this.ng(c, f, m, d, true);
                p = q.a;
                f = q.b;
                var r = new PathGeometry();
                var s = new PathFigure();
                s._startPoint = { $type: Point_$type, x: o, y: i };
                var t = new LineSegment(1);
                t.c = { $type: Point_$type, x: o, y: j };
                s._segments.add(t);
                r.b.add(s);
                p.aj = r;
            }
            if (l) {
                if (isNaN_(n)) {
                    continue;
                }
                var u = this.ng(c, f, m, d, false);
                p = u.a;
                f = u.b;
                var v = new PathGeometry();
                var w = new PathFigure();
                w._startPoint = { $type: Point_$type, x: g, y: n };
                var x = new LineSegment(1);
                x.c = { $type: Point_$type, x: h, y: n };
                w._segments.add(x);
                v.b.add(w);
                p.aj = v;
            }
        }
        c.count = f;
        if (this.ca()) {
            this.ni(this.lk, true);
        }
        else {
            this.ni(this.li, false);
        }
    };
    CrosshairLayer.prototype.c5 = function () {
        return true;
    };
    CrosshairLayer.prototype.ih = function (a, b, c, d) {
        _super.prototype.ih.call(this, a, b, c, d);
        switch (b) {
            case CrosshairLayer.$$p[1]:
                this.iv(true);
                break;
            case CrosshairLayer.$$p[7]:
                this.iv(true);
                break;
            case CrosshairLayer.$$p[4]:
                this.iv(true);
                break;
            case CrosshairLayer.$$p[2]:
            case CrosshairLayer.$$p[8]:
            case CrosshairLayer.$$p[10]:
            case CrosshairLayer.$$p[11]:
            case CrosshairLayer.$$p[12]:
            case CrosshairLayer.$$p[13]:
            case CrosshairLayer.$$p[14]:
            case CrosshairLayer.$$p[16]:
            case CrosshairLayer.$$p[17]:
            case CrosshairLayer.$$p[18]:
            case CrosshairLayer.$$p[19]:
            case CrosshairLayer.$$p[0]:
            case CrosshairLayer.$$p[6]:
            case CrosshairLayer.$$p[5]:
                this.iv(true);
                break;
        }
    };
    CrosshairLayer.$t = markType(CrosshairLayer, 'CrosshairLayer', AnnotationLayer.$);
    return CrosshairLayer;
}(AnnotationLayer));
export { CrosshairLayer };
Type.dep(DependencyProperty, PropertyMetadata, CrosshairLayer, 'raisePropertyChanged', ['HorizontalLineStroke:n3:nj', [Brush.$, null], 'HorizontalLineVisibility:ob:nk', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'IsAxisAnnotationEnabled:ml:nl', [0, false], 'SkipUnknownValues:mm:nm', [0, true], 'TargetSeries:mk:nn', [Series.$, null], 'UseInterpolation:mn:no', [0, true], 'VerticalLineStroke:n4:np', [Brush.$, null], 'VerticalLineVisibility:oc:nq', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'XAxisAnnotationBackground:n5:nr', [Brush.$, null], 'XAxisAnnotationInterpolatedValuePrecision:mu:ns', [1, -1], 'XAxisAnnotationOutline:n6:nt', [Brush.$, null], 'XAxisAnnotationPadding:mq:nu', [1, NaN], 'XAxisAnnotationStrokeThickness:mr:nv', [1, NaN], 'XAxisAnnotationTextColor:n7:nw', [Brush.$, null], 'YAxisAnnotationBackground:n8:nx', [Brush.$, null], 'YAxisAnnotationInterpolatedValuePrecision:mv:ny', [1, -1], 'YAxisAnnotationOutline:n9:nz', [Brush.$, null], 'YAxisAnnotationPadding:ms:n0', [1, NaN], 'YAxisAnnotationStrokeThickness:mt:n1', [1, NaN], 'YAxisAnnotationTextColor:oa:n2', [Brush.$, null]]);
var CrosshairLayerView = /** @class */ (function (_super) {
    tslib_1.__extends(CrosshairLayerView, _super);
    function CrosshairLayerView(a) {
        var _this = _super.call(this, a) || this;
        _this.bz = null;
        _this.b0 = null;
        _this.b1 = null;
        _this.bz = a;
        _this.b1 = new List$1(Path.$, 0);
        return _this;
    }
    CrosshairLayerView.prototype.ap = function () {
        var _this = this;
        _super.prototype.ap.call(this);
        this.b0 = ((function () {
            var $ret = new Pool$1(Path.$);
            $ret.create = runOn(_this, _this.b7);
            $ret.activate = runOn(_this, _this.b2);
            $ret.disactivate = runOn(_this, _this.b4);
            $ret.destroy = runOn(_this, _this.b3);
            return $ret;
        })());
    };
    CrosshairLayerView.prototype.b7 = function () {
        var a = new Path();
        a.j = new TranslateTransform();
        this.b1.add(a);
        return a;
    };
    CrosshairLayerView.prototype.b2 = function (a) {
        a._visibility = 0;
    };
    CrosshairLayerView.prototype.b4 = function (a) {
        a._visibility = 1;
    };
    CrosshairLayerView.prototype.b3 = function (a) {
        this.b1.remove(a);
    };
    CrosshairLayerView.prototype.b5 = function (a, b, c, d) {
        if (a.aj == null || a.aj.b.x != d || a.aj.c.x != c) {
            var e = ((function () {
                var $ret = new LineGeometry();
                $ret.c = { $type: Point_$type, x: c, y: b };
                $ret.b = { $type: Point_$type, x: d, y: b };
                return $ret;
            })());
            a.aj = e;
        }
    };
    CrosshairLayerView.prototype.b6 = function (a) {
        if (a == null) {
            return a;
        }
        return BrushUtil.h(a, 0.1);
    };
    CrosshairLayerView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d && !b) {
            for (var c = 0; c < this.b1.count; c++) {
                var d = this.b1._inner[c];
                if (d._visibility == 0) {
                    a.s(d);
                }
            }
        }
    };
    CrosshairLayerView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        for (var b = 0; b < this.b1.count; b++) {
            this.e.a2.exportPathData(a, this.b1._inner[b], "crosshairLine", ["Main", "Crosshair"]);
        }
    };
    CrosshairLayerView.$t = markType(CrosshairLayerView, 'CrosshairLayerView', AnnotationLayerView.$);
    return CrosshairLayerView;
}(AnnotationLayerView));
export { CrosshairLayerView };
/*<BeginStatics Name="Infragistics.Controls.Charts.CrosshairLayer" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.CrosshairLayer" />*/
//# sourceMappingURL=CrosshairLayer_combined.js.map