import { AnchoredCategorySeries } from "./AnchoredCategorySeries";
import { IHorizontalAnchoredCategorySeriesInteractionManager } from "./IHorizontalAnchoredCategorySeriesInteractionManager";
import { Type, Point } from "igniteui-angular-core/ES5/type";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { NumericAxisBase } from "./NumericAxisBase";
import { CategoryMode } from "./CategoryMode";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { Rect } from "igniteui-angular-core/ES5/Rect";
import { ScalerParams } from "./ScalerParams";
import { Axis } from "./Axis";
import { FastItemsSourceEventAction } from "igniteui-angular-core/ES5/FastItemsSourceEventAction";
export declare abstract class HorizontalAnchoredCategorySeries extends AnchoredCategorySeries {
    private pj;
    readonly pk: IHorizontalAnchoredCategorySeriesInteractionManager;
    hd(): void;
    xAxis: CategoryAxisBase;
    yAxis: NumericYAxis;
    protected bd(): SeriesHitTestMode;
    mn(): CategoryAxisBase;
    m7(): NumericAxisBase;
    ld(a: Point): Rect;
    private px(a);
    protected pp(a: Point, b: Point, c: boolean): boolean;
    ah(a: Point): Point[][];
    ai(a: Point): Point[][];
    de(a: Point, b: boolean): boolean;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    ee(a: Point, b: boolean, c: boolean): number;
    e4(a: Point, b: boolean): number;
    e2(a: Point, b: boolean): number;
    d1(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    k2(a: Point, b: boolean, c: boolean): Point;
    fetchXAxis(): Axis;
    fetchYAxis(): Axis;
    oy(a: Axis): void;
    oz(a: Axis): void;
    ni(): boolean;
    protected pf: CategoryAxisBase;
    protected pl: NumericAxisBase;
    pt(a: CategoryAxisBase): void;
    pu(a: NumericYAxis): void;
    mh(a: number, b: number): any[];
    protected ih(a: any, b: string, c: any, d: any): void;
    protected hi(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    pn(a: any): boolean;
    po(a: any): boolean;
    private ph;
    pi: CategoryMode;
    readonly useHighMarkerFidelity: boolean;
    static $$p: string[];
    static $t: Type;
}
