import { IHorizontalAnchoredCategorySeriesProxy } from "./IHorizontalAnchoredCategorySeriesProxy";
import { Series } from "./Series";
import { CategoryMode } from "./CategoryMode";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { Base, Type } from "igniteui-angular-core/ES5/type";
export declare class HorizontalAnchoredCategorySeriesProxy extends Base implements IHorizontalAnchoredCategorySeriesProxy {
    matchesType(a: Series): boolean;
    setCategoryMode(a: Series, b: CategoryMode): void;
    setValueMemberPath(a: Series, b: string): void;
    setXAxis(a: Series, b: CategoryAxisBase): void;
    setYAxis(a: Series, b: NumericYAxis): void;
    static $t: Type;
}
