/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { RangeCategorySeries } from "./RangeCategorySeries";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "igniteui-angular-core/ES5/DependencyProperty";
import { NumericYAxis } from "./NumericYAxis";
import { Axis } from "./Axis";
import { Type, Point_$type, runOn, typeCast, markType } from "igniteui-angular-core/ES5/type";
import { RangeValueList } from "./RangeValueList";
import { ScalerParams } from "./ScalerParams";
import { CategoryXAxis } from "./CategoryXAxis";
import { PropertyMetadata } from "igniteui-angular-core/ES5/PropertyMetadata";
var HorizontalRangeCategorySeries = /** @class */ (function (_super) {
    tslib_1.__extends(HorizontalRangeCategorySeries, _super);
    function HorizontalRangeCategorySeries() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HorizontalRangeCategorySeries.prototype.fetchXAxis = function () {
        return this.xAxis;
    };
    HorizontalRangeCategorySeries.prototype.fetchYAxis = function () {
        return this.yAxis;
    };
    HorizontalRangeCategorySeries.prototype.hd = function () {
        _super.prototype.hd.call(this);
        this.xAxis = null;
        this.yAxis = null;
    };
    HorizontalRangeCategorySeries.prototype.ah = function (a) {
        var b = this.aj(this.mn(), this.mo.f, this.no(this.bi), this.np(this.bi), this.k5(a), true);
        if (b == null) {
            return null;
        }
        var c = b[0];
        var d = b[1];
        var e = new Array(1);
        var f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[2] };
        f[1] = { $type: Point_$type, x: d[0], y: d[2] };
        e[0] = f;
        return e;
    };
    HorizontalRangeCategorySeries.prototype.ai = function (a) {
        var b = this.aj(this.mn(), this.mo.f, this.no(this.bi), this.np(this.bi), this.k5(a), true);
        if (b == null) {
            return null;
        }
        var c = b[0];
        var d = b[1];
        var e = new Array(1);
        var f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[1] };
        f[1] = { $type: Point_$type, x: d[0], y: d[1] };
        e[0] = f;
        return e;
    };
    HorizontalRangeCategorySeries.prototype.get_c2 = function () {
        return true;
    };
    Object.defineProperty(HorizontalRangeCategorySeries.prototype, "c2", {
        get: function () {
            return this.get_c2();
        },
        enumerable: true,
        configurable: true
    });
    HorizontalRangeCategorySeries.prototype.bd = function () {
        if (this.be == 0) {
            return 1;
        }
        else {
            return _super.prototype.bd.call(this);
        }
    };
    HorizontalRangeCategorySeries.prototype.getOffsetValue = function () {
        return this.RangeFramePreparer.r(this.xAxis, this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi));
    };
    HorizontalRangeCategorySeries.prototype.getCategoryWidth = function () {
        return this.xAxis.getCategorySize(this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi));
    };
    HorizontalRangeCategorySeries.prototype.e2 = function (a, b) {
        return this.e3(a, b, this.xAxis, runOn(this, this.nm), new RangeValueList(this.highColumn, this.lowColumn));
    };
    HorizontalRangeCategorySeries.prototype.e4 = function (a, b) {
        return this.e5(a, b, this.xAxis, runOn(this, this.nm), new RangeValueList(this.highColumn, this.lowColumn));
    };
    HorizontalRangeCategorySeries.prototype.d1 = function (a, b, c, d, e) {
        if (c == null) {
            return Number.POSITIVE_INFINITY;
        }
        var f = this.xAxis.jq;
        return this.d2(a, b, this.xAxis, d, e, f, runOn(this, this.nm));
    };
    HorizontalRangeCategorySeries.prototype.ee = function (a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.bi);
        var e = new ScalerParams(0, this.bs.mk, this.bi.bp, this.xAxis.b8, d);
        var f = this.RangeFramePreparer.r(this.xAxis, this.bs.mk, this.bi.bp, d);
        return this.eg(new RangeValueList(this.highColumn, this.lowColumn), a, this.xAxis, e, f, runOn(this, this.nm), b, c);
    };
    HorizontalRangeCategorySeries.prototype.ec = function (a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.bi);
        var e = new ScalerParams(0, this.bs.mk, this.bi.bp, this.xAxis.b8, d);
        var f = this.RangeFramePreparer.r(this.xAxis, this.bs.mk, this.bi.bp, d);
        return this.eg(this.lowColumn, a, this.xAxis, e, f, runOn(this, this.nm), b, c);
    };
    HorizontalRangeCategorySeries.prototype.ea = function (a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.bi);
        var e = new ScalerParams(0, this.bs.mk, this.bi.bp, this.xAxis.b8, d);
        var f = this.RangeFramePreparer.r(this.xAxis, this.bs.mk, this.bi.bp, d);
        return this.eg(this.highColumn, a, this.xAxis, e, f, runOn(this, this.nm), b, c);
    };
    HorizontalRangeCategorySeries.prototype.ky = function (a, b, c) {
        var _this = this;
        return this.k4(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi)), this.yAxis, this.xAxis, runOn(this, this.ea), function (d, e) { return _this.e5(d, e, _this.xAxis, runOn(_this, _this.nm), _this.highColumn); }, function (d, e) { return _this.e3(d, e, _this.xAxis, runOn(_this, _this.nm), _this.highColumn); });
    };
    HorizontalRangeCategorySeries.prototype.k0 = function (a, b, c) {
        var _this = this;
        return this.k4(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi)), this.yAxis, this.xAxis, runOn(this, this.ec), function (d, e) { return _this.e5(d, e, _this.xAxis, runOn(_this, _this.nm), _this.lowColumn); }, function (d, e) { return _this.e3(d, e, _this.xAxis, runOn(_this, _this.nm), _this.lowColumn); });
    };
    HorizontalRangeCategorySeries.prototype.k2 = function (a, b, c) {
        return this.k4(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi)), this.yAxis, this.xAxis, null, null, null);
    };
    HorizontalRangeCategorySeries.prototype.ni = function () {
        return this.yAxis != null && this.yAxis.ck();
    };
    HorizontalRangeCategorySeries.prototype.ih = function (a, b, c, d) {
        _super.prototype.ih.call(this, a, b, c, d);
        switch (b) {
            case HorizontalRangeCategorySeries.$$p[0]:
                this.hj(typeCast(Axis.$, c));
                this.im(typeCast(Axis.$, d));
                this.mw.cl.g(this.ek);
                this.iv(false);
                this.h2();
                break;
            case HorizontalRangeCategorySeries.$$p[1]:
                this.hj(typeCast(Axis.$, c));
                this.im(typeCast(Axis.$, d));
                this.mw.cl.g(this.ek);
                this.ni();
                this.iv(false);
                this.h2();
                break;
        }
    };
    HorizontalRangeCategorySeries.prototype.ow = function (a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    HorizontalRangeCategorySeries.prototype.ov = function (a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.b5) {
            return true;
        }
        return false;
    };
    Object.defineProperty(HorizontalRangeCategorySeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.nj;
        },
        enumerable: true,
        configurable: true
    });
    HorizontalRangeCategorySeries.$t = markType(HorizontalRangeCategorySeries, 'HorizontalRangeCategorySeries', RangeCategorySeries.$);
    return HorizontalRangeCategorySeries;
}(RangeCategorySeries));
export { HorizontalRangeCategorySeries };
Type.dep(DependencyProperty, PropertyMetadata, HorizontalRangeCategorySeries, 'raisePropertyChanged', ['XAxis::oz', [CategoryAxisBase.$, null], 'YAxis::o0', [NumericYAxis.$, null]]);
/*<BeginStatics Name="Infragistics.Controls.Charts.HorizontalRangeCategorySeries" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.HorizontalRangeCategorySeries" />*/
//# sourceMappingURL=HorizontalRangeCategorySeries.js.map