/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { RectData } from "igniteui-angular-core/ES5/RectData";
import { PrimitiveAppearanceData } from "igniteui-angular-core/ES5/PrimitiveAppearanceData";
import { StringBuilder } from "igniteui-angular-core/ES5/StringBuilder";
import { Base, markType } from "igniteui-angular-core/ES5/type";
var LegendItemVisualData = /** @class */ (function (_super) {
    tslib_1.__extends(LegendItemVisualData, _super);
    function LegendItemVisualData() {
        var _this = _super.call(this) || this;
        _this._label = null;
        _this._labelBounds = null;
        _this._appearance = null;
        _this._labelAppearance = null;
        _this.labelBounds = RectData.empty;
        _this.appearance = new PrimitiveAppearanceData();
        return _this;
    }
    Object.defineProperty(LegendItemVisualData.prototype, "label", {
        get: function () {
            return this._label;
        },
        set: function (a) {
            this._label = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendItemVisualData.prototype, "labelBounds", {
        get: function () {
            return this._labelBounds;
        },
        set: function (a) {
            this._labelBounds = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendItemVisualData.prototype, "appearance", {
        get: function () {
            return this._appearance;
        },
        set: function (a) {
            this._appearance = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendItemVisualData.prototype, "labelAppearance", {
        get: function () {
            return this._labelAppearance;
        },
        set: function (a) {
            this._labelAppearance = a;
        },
        enumerable: true,
        configurable: true
    });
    LegendItemVisualData.prototype.serialize = function () {
        var a = new StringBuilder(0);
        a.u("{");
        if (this.label != null) {
            a.u("label: \"" + this.label + "\", ");
        }
        if (this.appearance != null) {
            a.u("appearance: " + this.appearance.serialize() + ", ");
        }
        if (this.labelAppearance != null) {
            a.u("labelAppearance: " + this.labelAppearance.serialize() + ", ");
        }
        a.u("labelBounds: { left: " + this.labelBounds.left + ", top: " + this.labelBounds.top + ", width: " + this.labelBounds.width + ", height: " + this.labelBounds.height + "}");
        a.u("}");
        return a.toString();
    };
    LegendItemVisualData.$t = markType(LegendItemVisualData, 'LegendItemVisualData');
    return LegendItemVisualData;
}(Base));
export { LegendItemVisualData };
//# sourceMappingURL=LegendItemVisualData.js.map