import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IShortPeriodLongPeriod } from "./IShortPeriodLongPeriod";
import { IndicatorCalculationStrategy } from "./IndicatorCalculationStrategy";
import { Type } from "igniteui-angular-core/ES5/type";
import { DependencyProperty } from "igniteui-angular-core/ES5/DependencyProperty";
export declare class MovingAverageConvergenceDivergenceIndicator extends StrategyBasedIndicator implements IShortPeriodLongPeriod {
    constructor();
    protected get_pr(): IndicatorCalculationStrategy;
    protected readonly pr: IndicatorCalculationStrategy;
    protected get_p4(): Type;
    protected readonly p4: Type;
    shortPeriod: number;
    static readonly qf: DependencyProperty;
    protected pz(): number;
    longPeriod: number;
    static readonly qe: DependencyProperty;
    protected pw(): number;
    signalPeriod: number;
    static readonly qg: DependencyProperty;
    protected o7(): number;
    static $t: Type;
}
