/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IShortPeriodLongPeriod_$type } from "./IShortPeriodLongPeriod";
import { PercentagePriceOscillatorIndicatorStrategy } from "./PercentagePriceOscillatorIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core/ES5/type";
var PercentagePriceOscillatorIndicator = /** @class */ (function (_super) {
    tslib_1.__extends(PercentagePriceOscillatorIndicator, _super);
    function PercentagePriceOscillatorIndicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PercentagePriceOscillatorIndicator.prototype.get_pr = function () {
        return new PercentagePriceOscillatorIndicatorStrategy();
    };
    Object.defineProperty(PercentagePriceOscillatorIndicator.prototype, "pr", {
        get: function () {
            return this.get_pr();
        },
        enumerable: true,
        configurable: true
    });
    PercentagePriceOscillatorIndicator.prototype.get_p4 = function () {
        return PercentagePriceOscillatorIndicator.$;
    };
    Object.defineProperty(PercentagePriceOscillatorIndicator.prototype, "p4", {
        get: function () {
            return this.get_p4();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PercentagePriceOscillatorIndicator.prototype, "shortPeriod", {
        get: function () {
            return typeGetValue(this.c(PercentagePriceOscillatorIndicator.qd));
        },
        set: function (a) {
            this.h(PercentagePriceOscillatorIndicator.qd, a);
        },
        enumerable: true,
        configurable: true
    });
    PercentagePriceOscillatorIndicator.prototype.pz = function () {
        return this.shortPeriod;
    };
    Object.defineProperty(PercentagePriceOscillatorIndicator.prototype, "longPeriod", {
        get: function () {
            return typeGetValue(this.c(PercentagePriceOscillatorIndicator.qc));
        },
        set: function (a) {
            this.h(PercentagePriceOscillatorIndicator.qc, a);
        },
        enumerable: true,
        configurable: true
    });
    PercentagePriceOscillatorIndicator.prototype.pw = function () {
        return this.longPeriod;
    };
    PercentagePriceOscillatorIndicator.qd = StrategyBasedIndicator.qb(10, PercentagePriceOscillatorIndicator.$);
    PercentagePriceOscillatorIndicator.qc = StrategyBasedIndicator.p7(30, PercentagePriceOscillatorIndicator.$);
    PercentagePriceOscillatorIndicator.$t = markType(PercentagePriceOscillatorIndicator, 'PercentagePriceOscillatorIndicator', StrategyBasedIndicator.$, [IShortPeriodLongPeriod_$type]);
    return PercentagePriceOscillatorIndicator;
}(StrategyBasedIndicator));
export { PercentagePriceOscillatorIndicator };
/*<BeginStatics Name="Infragistics.Controls.Charts.PercentagePriceOscillatorIndicator" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.PercentagePriceOscillatorIndicator" />*/
//# sourceMappingURL=PercentagePriceOscillatorIndicator.js.map