import { LegendBase } from "./LegendBase";
import { IChartScaleLegend } from "igniteui-angular-core/ES5/IChartScaleLegend";
import { UIElement } from "igniteui-angular-core/ES5/UIElement";
import { TextBlock } from "igniteui-angular-core/ES5/TextBlock";
import { IScaleLegendSeries } from "igniteui-angular-core/ES5/IScaleLegendSeries";
import { LegendBaseView } from "./LegendBaseView";
import { Type } from "igniteui-angular-core/ES5/type";
import { Color } from "igniteui-angular-core/ES5/Color";
import { Brush } from "igniteui-angular-core/ES5/Brush";
import { Shape } from "igniteui-angular-core/ES5/Shape";
import { GradientData } from "./GradientData";
import { RenderingContext } from "igniteui-angular-core/ES5/RenderingContext";
import { Size } from "igniteui-angular-core/ES5/Size";
export declare class ScaleLegend extends LegendBase implements IChartScaleLegend {
    aj(): LegendBaseView;
    a5(a: LegendBaseView): void;
    bb: ScaleLegendView;
    readonly legendScaleElement: UIElement;
    readonly minText: TextBlock;
    readonly maxText: TextBlock;
    constructor();
    bd: number;
    bc: number;
    private a9;
    ba: IScaleLegendSeries;
    bg(): void;
    restoreOriginalState(): void;
    private bj(a);
    be(a: IScaleLegendSeries): void;
    initializeLegend(a: IScaleLegendSeries): void;
    protected get_isScale(): boolean;
    readonly isScale: boolean;
    bf(): void;
    static $t: Type;
}
export declare class ScaleLegendView extends LegendBaseView {
    constructor(a: ScaleLegend);
    ai: ScaleLegend;
    a3: Shape;
    az: TextBlock;
    ay: TextBlock;
    av(): void;
    u(): void;
    a2(): Color;
    ap(): any;
    ar(a: any, b: Color, c: number): void;
    aw(a: Shape, b: boolean, c: any): void;
    protected ah: GradientData;
    protected aj: RenderingContext;
    protected a4: Size;
    ac(a: any): void;
    protected ak: boolean;
    protected as(): void;
    ax(): void;
    private au();
    an(a: any): number;
    am(a: any): number;
    protected al: number;
    protected a1: Brush;
    private at();
    a0: Brush;
    ae(): void;
    static $t: Type;
}
