import { fromPoint } from "igniteui-angular-core/ES5/componentUtil";
/**
 * Provides data for IgxDataChartComponent mouse button related events.
*/
var /**
 * Provides data for IgxDataChartComponent mouse button related events.
*/
ChartMouseEventArgs = /** @class */ (function () {
    function ChartMouseEventArgs() {
    }
    Object.defineProperty(ChartMouseEventArgs.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    ChartMouseEventArgs.prototype.onImplementationCreated = function () {
    };
    ChartMouseEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(ChartMouseEventArgs.prototype, "originalSource", {
        /**
         * Gets a reference to the object that raised the event.
        */
        get: /**
             * Gets a reference to the object that raised the event.
            */
        function () {
            return this.i.originalSource;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartMouseEventArgs.prototype, "item", {
        /**
         * Gets the ItemsSource item associated with the current event.
        */
        get: /**
             * Gets the ItemsSource item associated with the current event.
            */
        function () {
            return this.i.item;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartMouseEventArgs.prototype, "series", {
        /**
         * Gets the series associated with the current event.
        */
        get: /**
             * Gets the series associated with the current event.
            */
        function () {
            if (this.i.series == null) {
                return null;
            }
            return this.i.series.externalObject;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChartMouseEventArgs.prototype, "chart", {
        /**
         * Gets the Chart associated with the current event.
        */
        get: /**
             * Gets the Chart associated with the current event.
            */
        function () {
            if (this.i.chart == null) {
                return null;
            }
            return this.i.chart.externalObject;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Provides a human readable description of the mouse button event.
    
    */
    /**
         * Provides a human readable description of the mouse button event.
        
        */
    ChartMouseEventArgs.prototype.toString = /**
         * Provides a human readable description of the mouse button event.
        
        */
    function () {
        var iv = this.i.toString();
        return (iv);
    };
    /**
     * Returns the x- and y- coordinates of the mouse pointer position, optionally evaluated
     * against the origin of a supplied UIElement.
    
    * @param relativeTo  * Any UIElement derived object that is contained by the the engine plug-in
     * and connected to the object tree. To specify the object relative to the overall the engine
     * coordinate system, use a relativeTo value of null.
    */
    /**
         * Returns the x- and y- coordinates of the mouse pointer position, optionally evaluated
         * against the origin of a supplied UIElement.
        
        * @param relativeTo  * Any UIElement derived object that is contained by the the engine plug-in
         * and connected to the object tree. To specify the object relative to the overall the engine
         * coordinate system, use a relativeTo value of null.
        */
    ChartMouseEventArgs.prototype.getPosition = /**
         * Returns the x- and y- coordinates of the mouse pointer position, optionally evaluated
         * against the origin of a supplied UIElement.
        
        * @param relativeTo  * Any UIElement derived object that is contained by the the engine plug-in
         * and connected to the object tree. To specify the object relative to the overall the engine
         * coordinate system, use a relativeTo value of null.
        */
    function (relativeTo) {
        var iv = this.i.getPosition(relativeTo);
        return fromPoint(iv);
    };
    return ChartMouseEventArgs;
}());
/**
 * Provides data for IgxDataChartComponent mouse button related events.
*/
export { ChartMouseEventArgs };
//# sourceMappingURL=igx-chart-mouse-event-args.js.map