import { OnDestroy, ViewContainerRef, NgZone, ComponentFactoryResolver, Renderer2, Injector } from '@angular/core';
import { IgxPieChartBaseComponent } from './igx-pie-chart-base-component';
import { XamPieChart } from './XamPieChart';
export declare const IgxPieChartComponent_PROVIDERS: any[];
/**
 * Represents Infragistics IgxPieChartComponent control.
*/
export declare class IgxPieChartComponent extends IgxPieChartBaseComponent implements OnDestroy {
    private renderer;
    private _elRef;
    private document;
    private ngZone;
    private injector;
    private componentFactoryResolver;
    container: Element;
    _dynamicContent: ViewContainerRef;
    private _height;
    private _width;
    height: string;
    width: string;
    constructor(renderer: Renderer2, _elRef: ViewContainerRef, document: any, ngZone: NgZone, injector: Injector, componentFactoryResolver: ComponentFactoryResolver);
    ngOnDestroy(): void;
    private _wrapper;
    protected createImplementation(): XamPieChart;
    readonly i: XamPieChart;
    protected createSeriesComponent(type: string): any;
    private _chart;
    private _dataSource;
    dataSource: Array<any>;
    bindData(): void;
}
