import { Type } from '@angular/core';
import { IgxHorizontalAnchoredCategorySeriesComponent } from "./igx-horizontal-anchored-category-series-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { PointSeries } from "./PointSeries";
/**
 * Represents a IgxDataChartComponent point series.
*/
export declare const IgxPointSeriesComponent_PROVIDERS: ({
    provide: typeof IgxMarkerSeriesComponent;
    useExisting: Type<any>;
} | {
    provide: typeof IgxSeriesComponent;
    useExisting: Type<any>;
})[];
export declare class IgxPointSeriesComponent extends IgxHorizontalAnchoredCategorySeriesComponent {
    protected createImplementation(): PointSeries;
    readonly i: PointSeries;
    constructor();
    readonly isMarkerlessDisplayPreferred: boolean;
}
