import * as tslib_1 from "tslib";
import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxStrategyBasedIndicatorComponent } from "./igx-strategy-based-indicator-component";
import { IgxFinancialIndicatorComponent } from "./igx-financial-indicator-component";
import { IgxFinancialSeriesComponent } from "./igx-financial-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { PositiveVolumeIndexIndicator } from "./PositiveVolumeIndexIndicator";
/**
 * Represents a IgxDataChartComponent Positive Volume Index (PVI) indicator series.
 * Default required members: Close, Volume
*/
export var IgxPositiveVolumeIndexIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxPositiveVolumeIndexIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxPositiveVolumeIndexIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxPositiveVolumeIndexIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxPositiveVolumeIndexIndicatorComponent; }) }];
var IgxPositiveVolumeIndexIndicatorComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxPositiveVolumeIndexIndicatorComponent, _super);
    function IgxPositiveVolumeIndexIndicatorComponent() {
        return _super.call(this) || this;
    }
    IgxPositiveVolumeIndexIndicatorComponent.prototype.createImplementation = function () {
        return new PositiveVolumeIndexIndicator();
    };
    Object.defineProperty(IgxPositiveVolumeIndexIndicatorComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxPositiveVolumeIndexIndicatorComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-positive-volume-index-indicator',
                    template: "",
                    providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxPositiveVolumeIndexIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxPositiveVolumeIndexIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxPositiveVolumeIndexIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxPositiveVolumeIndexIndicatorComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxPositiveVolumeIndexIndicatorComponent.ctorParameters = function () { return []; };
    return IgxPositiveVolumeIndexIndicatorComponent;
}(IgxStrategyBasedIndicatorComponent));
export { IgxPositiveVolumeIndexIndicatorComponent };
//# sourceMappingURL=igx-positive-volume-index-indicator-component.js.map