import * as tslib_1 from "tslib";
import { SelectedItemsChangedEventArgs } from "./igx-selected-items-changed-event-args";
import { ensureBool } from "igniteui-angular-core/ES5/componentUtil";
/**
 * Provides data for the SelectedItemsChanging event.
*/
var /**
 * Provides data for the SelectedItemsChanging event.
*/
SelectedItemsChangingEventArgs = /** @class */ (function (_super) {
    tslib_1.__extends(SelectedItemsChangingEventArgs, _super);
    function SelectedItemsChangingEventArgs() {
        return _super.call(this) || this;
    }
    Object.defineProperty(SelectedItemsChangingEventArgs.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SelectedItemsChangingEventArgs.prototype, "cancel", {
        /**
         * Set this to true in order to stop the SelectedItems collection from changing.
        */
        get: /**
             * Set this to true in order to stop the SelectedItems collection from changing.
            */
        function () {
            return this.i.cancel;
        },
        set: function (v) {
            this.i.cancel = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    return SelectedItemsChangingEventArgs;
}(SelectedItemsChangedEventArgs));
/**
 * Provides data for the SelectedItemsChanging event.
*/
export { SelectedItemsChangingEventArgs };
//# sourceMappingURL=igx-selected-items-changing-event-args.js.map