import { ensureBool } from "igniteui-angular-core/ES5/componentUtil";
/**
 * Contains PieChart click event data.
*/
var /**
 * Contains PieChart click event data.
*/
SliceClickEventArgs = /** @class */ (function () {
    function SliceClickEventArgs() {
    }
    Object.defineProperty(SliceClickEventArgs.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    SliceClickEventArgs.prototype.onImplementationCreated = function () {
    };
    SliceClickEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(SliceClickEventArgs.prototype, "isSelected", {
        /**
         * Gets or sets whether the slice is selected.
        */
        get: /**
             * Gets or sets whether the slice is selected.
            */
        function () {
            return this.i.isSelected;
        },
        set: function (v) {
            this.i.isSelected = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SliceClickEventArgs.prototype, "isExploded", {
        /**
         * Gets or sets whether the slice is exploded.
        */
        get: /**
             * Gets or sets whether the slice is exploded.
            */
        function () {
            return this.i.isExploded;
        },
        set: function (v) {
            this.i.isExploded = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SliceClickEventArgs.prototype, "isOthersSlice", {
        /**
         * Gets whether the current slice is part of the others slice.
        */
        get: /**
             * Gets whether the current slice is part of the others slice.
            */
        function () {
            return this.i.isOthersSlice;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SliceClickEventArgs.prototype, "dataContext", {
        /**
         * Gets the slice data context.
        */
        get: /**
             * Gets the slice data context.
            */
        function () {
            return this.i.dataContext;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SliceClickEventArgs.prototype, "originalEvent", {
        /**
         * Holds a reference to the original event that triggered slice click.
        */
        get: /**
             * Holds a reference to the original event that triggered slice click.
            */
        function () {
            return this.i.originalEvent;
        },
        enumerable: true,
        configurable: true
    });
    return SliceClickEventArgs;
}());
/**
 * Contains PieChart click event data.
*/
export { SliceClickEventArgs };
//# sourceMappingURL=igx-slice-click-event-args.js.map