import * as tslib_1 from "tslib";
import { forwardRef, Input } from '@angular/core';
import { NumericScaleMode, NumericScaleMode_$type } from "./NumericScaleMode";
import { IgxNumericAxisBaseComponent } from "./igx-numeric-axis-base-component";
import { IgxAxisComponent } from "./igx-axis-component";
import { ensureEnum } from "igniteui-angular-core/ES5/componentUtil";
/**
 * Defines a set of basic methods and properties used to create a StraightNumeric axis.
*/
export var IgxStraightNumericAxisBaseComponent_PROVIDERS = [{ provide: IgxNumericAxisBaseComponent, useExisting: forwardRef(function () { return IgxStraightNumericAxisBaseComponent; }) }, { provide: IgxAxisComponent, useExisting: forwardRef(function () { return IgxStraightNumericAxisBaseComponent; }) }];
var IgxStraightNumericAxisBaseComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxStraightNumericAxisBaseComponent, _super);
    function IgxStraightNumericAxisBaseComponent() {
        return _super.call(this) || this;
    }
    Object.defineProperty(IgxStraightNumericAxisBaseComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxStraightNumericAxisBaseComponent.prototype, "scaleMode", {
        /**
         * Gets or sets the axis scale mode.
        */
        get: /**
             * Gets or sets the axis scale mode.
            */
        function () {
            return this.i.k4;
        },
        set: function (v) {
            this.i.k4 = ensureEnum(NumericScaleMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    IgxStraightNumericAxisBaseComponent.propDecorators = {
        "scaleMode": [{ type: Input },],
    };
    return IgxStraightNumericAxisBaseComponent;
}(IgxNumericAxisBaseComponent));
export { IgxStraightNumericAxisBaseComponent };
//# sourceMappingURL=igx-straight-numeric-axis-base-component.js.map