import { AnnotationLayer } from "./AnnotationLayer";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "igniteui-angular-core/ES2015/DependencyProperty";
import { CategoryHighlightLayerFrame } from "./CategoryHighlightLayerFrame";
import { Type } from "igniteui-angular-core/ES2015/type";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { Frame } from "./Frame";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { CategoryHighlightFrameRect } from "./CategoryHighlightFrameRect";
import { Pool$1 } from "igniteui-angular-core/ES2015/Pool$1";
import { Rectangle } from "igniteui-angular-core/ES2015/Rectangle";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { Brush } from "igniteui-angular-core/ES2015/Brush";
import { RenderingContext } from "igniteui-angular-core/ES2015/RenderingContext";
export declare class CategoryHighlightLayer extends AnnotationLayer {
    constructor();
    protected bf(): SeriesView;
    ib(a: SeriesView): void;
    protected mk: CategoryHighlightLayerView;
    mj: CategoryAxisBase;
    mm: boolean;
    mn: number;
    static readonly mu: DependencyProperty;
    protected lz(a: Axis, b: boolean): void;
    private ml(a);
    protected l2(a: Frame, b: SeriesView): void;
    private ms(a, b, c);
    mr(a: Rect, b: CategoryHighlightLayerFrame, c: Axis): void;
    protected l5(a: Frame, b: SeriesView): void;
    protected c5(): boolean;
    mt(a: CategoryHighlightFrameRect, b: Rectangle): void;
    protected ih(a: any, b: string, c: any, d: any): void;
    static $$p: string[];
    static $t: Type;
}
export declare class CategoryHighlightLayerView extends AnnotationLayerView {
    constructor(a: CategoryHighlightLayer);
    protected bz: CategoryHighlightLayer;
    b0: Pool$1<Rectangle>;
    ap(): void;
    protected b1: List$1<Rectangle>;
    private b8();
    private b3(a);
    private b5(a);
    private b4(a);
    b6(a: Brush): Brush;
    b7(a: Brush): Brush;
    b2(a: Rectangle, b: number, c: number, d: number, e: number): void;
    protected a3(a: RenderingContext, b: boolean): void;
    ai(a: any): void;
    static $t: Type;
}
