/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Brush } from "igniteui-angular-core/ES2015/Brush";
import { XYChart } from "./XYChart";
import { IndicatorPane } from "./IndicatorPane";
import { BaseError, EventArgs, Base, runOn, delegateRemove, delegateCombine, typeCast, fromEnum, EnumUtil, Number_$type, String_$type, enumGetBox, Type, markType, TypeRegistrar, typeCastObjTo$t, fromEn } from "igniteui-angular-core/ES2015/type";
import { ZoomSliderWidget } from "./ZoomSliderWidget";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { DataSeriesType_$type } from "igniteui-angular-core/ES2015/DataSeriesType";
import { IDataSeriesAdapterRule_$type } from "igniteui-angular-core/ES2015/IDataSeriesAdapterRule";
import { SimpleFinancialPriceSeriesRule } from "igniteui-angular-core/ES2015/SimpleFinancialPriceSeriesRule";
import { SubCollectionsRule } from "igniteui-angular-core/ES2015/SubCollectionsRule";
import { XamDataChart } from "./XamDataChart";
import { FinancialChartVolumeType_$type } from "./FinancialChartVolumeType";
import { FinancialChartXAxisMode_$type } from "./FinancialChartXAxisMode";
import { FinancialChartYAxisMode_$type } from "./FinancialChartYAxisMode";
import { FinancialChartType_$type } from "./FinancialChartType";
import { FinancialIndicatorTypeCollection } from "./FinancialIndicatorTypeCollection";
import { FinancialOverlayTypeCollection } from "./FinancialOverlayTypeCollection";
import { FinancialChartZoomSliderType_$type } from "./FinancialChartZoomSliderType";
import { BrushCollection } from "igniteui-angular-core/ES2015/BrushCollection";
import { FinancialChartRangeSelectorOptionCollection } from "./FinancialChartRangeSelectorOptionCollection";
import { TemplatedHtmlControl } from "./TemplatedHtmlControl";
import { FinancialChartContext } from "./FinancialChartContext";
import { FinancialChartToolbarContext } from "./FinancialChartToolbarContext";
import { FinancialChartViewModel } from "./FinancialChartViewModel";
import { FinancialChartToolbarViewModel } from "./FinancialChartToolbarViewModel";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { Axis } from "./Axis";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { Series } from "./Series";
import { MarkerSeries } from "./MarkerSeries";
import { SyncSettings } from "./SyncSettings";
import { SyncManager } from "./SyncManager";
import { ArrayExtension } from "igniteui-angular-core/ES2015/ArrayExtension";
import { FinancialIndicatorType_$type } from "./FinancialIndicatorType";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { FinancialChartVisualData } from "./FinancialChartVisualData";
import { FinancialOverlayType_$type } from "./FinancialOverlayType";
import { FinancialChartCustomIndicatorArgs } from "./FinancialChartCustomIndicatorArgs";
import { ObservableCollection$1 } from "igniteui-angular-core/ES2015/ObservableCollection$1";
import { ScalerParams } from "./ScalerParams";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { stringReplace, stringJoin, stringIsNullOrEmpty, stringToString$1 } from "igniteui-angular-core/ES2015/string";
import { timeSpanFromDays } from "igniteui-angular-core/ES2015/timespan";
import { dateMaxValue, dateMinValue } from "igniteui-angular-core/ES2015/date";
import { isNaN_, isInfinity } from "igniteui-angular-core/ES2015/number";
import { FinancialChartEnumCollectionPickerToolViewModel } from "./FinancialChartEnumCollectionPickerToolViewModel";
import { FinancialChartEnumCollectionPickerToolView } from "./FinancialChartEnumCollectionPickerToolView";
import { SRProvider } from "igniteui-angular-core/ES2015/SRProvider";
import { FinancialChartTypePicker } from "./FinancialChartTypePicker";
import { FinancialChartTrendLinePicker } from "./FinancialChartTrendLinePicker";
import { FinancialChartVolumeTypePicker } from "./FinancialChartVolumeTypePicker";
import { TrendLineType_$type } from "igniteui-angular-core/ES2015/TrendLineType";
import { FinancialChartChartTypePickerContext } from "./FinancialChartChartTypePickerContext";
import { FinancialChartIndicatorPickerContext } from "./FinancialChartIndicatorPickerContext";
import { FinancialChartOverlayPickerContext } from "./FinancialChartOverlayPickerContext";
import { FinancialChartRangeSelectorContext } from "./FinancialChartRangeSelectorContext";
import { FinancialChartTrendLinePickerContext } from "./FinancialChartTrendLinePickerContext";
import { FinancialChartVolumeTypePickerContext } from "./FinancialChartVolumeTypePickerContext";
import { FinancialChartToolbarVisualData } from "./FinancialChartToolbarVisualData";
import { FinancialChartRangeSelectorViewModel } from "./FinancialChartRangeSelectorViewModel";
import { FinancialChartRangeSelectorView } from "./FinancialChartRangeSelectorView";
export class FinancialChart extends XYChart {
    constructor() {
        super();
        this.oo = null;
        this.qy = null;
        this.qw = null;
        this.qu = null;
        this.qv = null;
        this.qx = null;
        this.nw = null;
        this.rg = null;
        this.rh = null;
        this.rd = null;
        this.ri = null;
        this.rj = null;
        this.re = null;
        this.rf = null;
        this.pd = null;
        this.qa = 40;
        this.oi = null;
        this.og = null;
        this.ok = null;
        this.op = null;
        this.rr = null;
        this.o9 = null;
        this.pw = false;
        this.pv = false;
        this.pi = false;
        this.q4 = 10;
        this.qc = NaN;
        this.qe = NaN;
        this.qd = NaN;
        this.qf = 0;
        this.n2 = 0;
        this.n5 = 0;
        this.n7 = 0;
        this.pf = true;
        this.ny = 0;
        this.pg = false;
        this.oc = null;
        this.oe = null;
        this.p2 = null;
        this.ph = true;
        this.pa = null;
        this.n9 = 1;
        this.m0 = null;
        this.m1 = null;
        this.m2 = null;
        this.m3 = null;
        this.m5 = null;
        this.m4 = null;
        this.mz = null;
        this.my = null;
        this.qb = 1;
        this.p9 = 1;
        this.p8 = 1;
        this.om = null;
        this.q0 = -2147483648;
        this.p7 = 2;
        this.q3 = 3;
        this.q1 = 10;
        this.qz = 30;
        this.q2 = 9;
        this.nt = null;
        this.nu = null;
        this.np = null;
        this.applyCustomIndicators = null;
        this.u1 = null;
        this.qg = 1;
        this.eo();
        this.ud();
    }
    fl(a, b, c) {
        super.fl(a, b, c);
        switch (a) {
            case "ToolbarTemplate":
            case "RangeSelectorTemplate":
                this.nx = new FinancialChartToolbar(this, this.ro);
                break;
            case "Toolbar":
                let d = b;
                if (d != null) {
                    d.chartTypeChanged = delegateRemove(d.chartTypeChanged, runOn(this, this.t1));
                    d.trendLineTypeChanged = delegateRemove(d.trendLineTypeChanged, runOn(this, this.t4));
                    d.volumeTypeChanged = delegateRemove(d.volumeTypeChanged, runOn(this, this.t5));
                    d.l(null);
                }
                if (this.nx != null) {
                    this.nx.af = this.n4;
                    this.nx.an = this.ai;
                    this.nx.ab = this.nz;
                    this.nx.aq = this.pt;
                    if (this.qv != null) {
                        this.nx.l(this.qv);
                    }
                    let e = this.nx;
                    e.chartTypeChanged = delegateCombine(e.chartTypeChanged, runOn(this, this.t1));
                    ;
                    let f = this.nx;
                    f.trendLineTypeChanged = delegateCombine(f.trendLineTypeChanged, runOn(this, this.t4));
                    let g = this.nx;
                    g.volumeTypeChanged = delegateCombine(g.volumeTypeChanged, runOn(this, this.t5));
                }
                break;
            case "ChartType":
                if (this.nx != null) {
                    this.nx.ab = this.nz;
                }
                break;
            case "VolumeType":
                if (this.nx != null) {
                    this.nx.af = this.n4;
                }
                break;
            case "TrendLineType":
                if (this.nx != null) {
                    this.nx.an = this.ai;
                }
                break;
            case "IsToolbarVisible":
                if (this.nx == null) {
                    break;
                }
                this.nx.aq = this.pt;
                this.setGridRows();
                break;
        }
    }
    t5(a, b) {
        this.n4 = this.nx.af;
    }
    t4(a, b) {
        this.ai = this.nx.an;
    }
    t1(a, b) {
        this.nz = this.nx.ab;
    }
    ud() {
        this.oo = new IndicatorPane();
    }
    provideGrid(a) {
        this.qy = a;
        this.uw();
        this.setGridRows();
        if (this.nx != null) {
            this.nx.bp(a);
        }
    }
    onDocumentClick(a) {
        if (this.nx != null) {
            this.nx.bx(a);
        }
    }
    po() {
        return (navigator.userAgent.indexOf("Trident/7") >= 0);
    }
    getContext() {
        let a = this.nx.w();
        let b = new FinancialChartContext();
        b.vm = new FinancialChartViewModel();
        b.vm.toolbar = a;
        b.container = this.cm;
        b.toolbarContainer = this.qv;
        b.indicatorsContainer = this.qu;
        b.volumeContainer = this.qw;
        b.zoomContainer = this.qx;
        return b;
    }
    provideContainer(a) {
        let b = a;
        if (b != null) {
            let c = "financialChartMainGrid";
            let d = b.createElement("div");
            d.setStyleProperty("width", "100%");
            d.setStyleProperty("height", "100%");
            if (this.nx == null) {
                this.nx = new FinancialChartToolbar(this, this.ro);
            }
            this.nx.x.isIndicatorPickerVisible = this.pk;
            this.nx.x.isOverlayPickerVisible = this.pl;
            this.qv = b.getSubRenderer(d);
            this.nx.l(this.qv);
            let e = b.createElement("div");
            e.setStyleProperty("width", "100%");
            e.setStyleProperty("height", "100%");
            let f = b.createElement("div");
            f.setStyleProperty("width", "100%");
            f.setStyleProperty("height", "100%");
            this.qu = b.getSubRenderer(f);
            let g = b.createElement("div");
            g.setStyleProperty("width", "100%");
            g.setStyleProperty("height", "100%");
            this.qw = b.getSubRenderer(g);
            let h = b.createElement("div");
            h.setStyleProperty("width", "100%");
            h.setStyleProperty("height", "100%");
            this.qx = b.getSubRenderer(h);
            a = b.getSubRenderer(e);
        }
        else {
            this.qv = null;
            if (this.nx != null) {
                this.nx.l(null);
            }
        }
        super.provideContainer(a);
        if (this.volumeChart != null) {
            this.volumeChart.provideContainer(this.qw);
        }
        if (this.oo != null) {
            this.oo.h(this.qu);
        }
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.provideContainer(this.qx);
            if (a != null) {
                this.tn();
            }
            else {
                this.pe = null;
            }
        }
        this.setGridRows();
    }
    un(a, b, c) {
        if (a != null) {
            a.provideContainer(null);
        }
        if (b != null) {
            b.provideContainer(c);
        }
        this.setGridRows();
    }
    u0(a, b) {
        this.un(a, b, this.qx);
        if (b == null) {
            return;
        }
        this.tn();
    }
    tn() {
        if (this.qx == null) {
            return;
        }
        this.pe = ZoomSliderWidget.a(this.externalObject, this.qx.rootWrapper);
        let a = this.pe;
        a.windowRectChanged = delegateCombine(a.windowRectChanged, (a, b) => {
            if (this.dataChart != null) {
                this.dataChart.my = new Rect(0, this.pe.t.left, this.dataChart.mk.top, this.pe.t.width, this.dataChart.mk.height);
            }
        });
    }
    uy(a, b) {
        this.un(a, b, this.qw);
    }
    setGridRows() {
        if (this.qy == null) {
            return;
        }
        let a = new Array(5);
        a[0] = (this.pt ? this.ql : 0) + "px";
        a[1] = "auto";
        a[2] = this.indicatorCharts == null || this.indicatorCharts.count == 0 ? "0px" : this.indicatorCharts.count * 150 + "px";
        a[3] = this.volumeChart == null ? "0px" : "100px";
        a[4] = this.zoomSliderChart == null ? "0px" : "100px";
        if (this.pe != null) {
            let b = this.pe;
            if (a[4] == "0px") {
                b.hide();
            }
            else {
                b.show();
            }
        }
        this.qy.setStyleProperty("-ms-grid-rows", stringReplace(stringJoin(" ", ...a), "auto", "1fr"));
        this.qy.setStyleProperty("grid-template-rows", stringJoin(" ", ...a));
        if (this.cm == null) {
            return;
        }
        if (this.dataChart != null) {
            this.dataChart.notifyContainerResized();
        }
        if (this.oo != null) {
            this.oo.f();
        }
        if (this.volumeChart != null) {
            this.volumeChart.notifyContainerResized();
        }
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.notifyContainerResized();
        }
        if (this.pe != null) {
            this.pe.o();
        }
    }
    e1() {
        super.e1();
        this.gr = 3;
        this.lv = 0;
        this.by = NaN;
        this.bw = 30;
        this.ay = true;
        this.a3 = false;
        if (this.dataChart != null) {
            let a = this.dataChart.bk.i.e();
            this.m8 = a.d;
            this.m9 = a.e;
            this.m7 = a.d;
            this.u2 = this.dataChart.pg;
        }
        let b = new BrushCollection();
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "rgba(116, 70, 185, .3)";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "rgba(159, 179, 40, .3)";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "rgba(46, 156, 166, .3)";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "rgba(63, 81, 181, .3)";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "rgba(154, 154, 154, .3)";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "rgba(67, 156, 71, .3)";
            return $ret;
        })()));
        this.na = b;
        let c = new BrushCollection();
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "#7446B9";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "#9FB328";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "#2E9CA6";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "#3F51B5";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "#9A9A9A";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "#439C47";
            return $ret;
        })()));
        this.nb = c;
    }
    uj() {
        if (this.oo != null) {
            this.oo.b = null;
            this.oo.b = this.indicatorCharts;
        }
        this.setGridRows();
    }
    uk() {
        this.setGridRows();
    }
    us() {
        this.uj();
    }
    ub() {
        if (this.pe == null || this.zoomSliderChart == null || this.dataChart == null || this.dataChart.series.count == 0) {
            return;
        }
        let a = this.cm.rootWrapper.width();
        let b = this.dataChart.mx.left + this.dataChart.mx.width;
        let c = this.dataChart.mx.left;
        let d = a - b;
        this.pe.e = c - this.pe.g;
        this.pe.d = d - this.pe.f;
        if (this.pe.d < 0) {
            let e = this.pe.d;
            this.pe.d = 0;
            this.dataChart.ei += (e * -1);
        }
        if (this.pe.e < 0) {
            let f = this.pe.e;
            this.pe.e = 0;
            this.dataChart.eg += (f * -1);
        }
        this.zoomSliderChart.eg = c;
        this.zoomSliderChart.ei = d;
        this.zoomSliderChart.ec = this.pe.c;
    }
    ey(a) {
        super.ey(a);
        if (a != null) {
            a.eb = 0;
        }
    }
    u3(a) {
        return a.md();
    }
    u4(a) {
        if (a == null || a.d == null || a.d.rootWrapper == null) {
            return null;
        }
        let b = a.d.rootWrapper.getOffset();
        return new Rect(0, b.left, b.top, a.d.rootWrapper.width(), a.d.rootWrapper.height());
    }
    qh() {
        if (this.qy == null) {
            return NaN;
        }
        let a = this.qy.getOffset();
        return this.qy.width() + (a == null ? 0 : a.left);
    }
    e9(source_, a, b) {
        super.e9(source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.hu(source_, a, b);
        }
    }
    fa(source_, a, b) {
        super.fa(source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.hv(source_, a, b);
        }
    }
    e8(source_) {
        super.e8(source_);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.hr(source_);
        }
    }
    fc(source_, a, b, c) {
        super.fc(source_, a, b, c);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.hw(source_, a, b, c);
        }
    }
    get nx() {
        return this.nw;
    }
    set nx(a) {
        let b = this.nx;
        if (a != b) {
            this.nw = a;
            this.fj("Toolbar", b, this.nx);
        }
    }
    get rn() {
        return this.rg;
    }
    set rn(a) {
        let b = this.rn;
        if (a != b) {
            this.rg = a;
            this.fj("RangeSelectorTemplate", b, this.rn);
        }
    }
    get ro() {
        return this.rh;
    }
    set ro(a) {
        let b = this.ro;
        if (a != b) {
            this.rh = a;
            this.fj("ToolbarTemplate", b, this.ro);
        }
    }
    get rk() {
        return this.rd;
    }
    set rk(a) {
        let b = this.rk;
        if (a != b) {
            this.rd = a;
            this.fj("ChartTypePickerTemplate", b, this.rk);
        }
    }
    get rp() {
        return this.ri;
    }
    set rp(a) {
        let b = this.rp;
        if (a != b) {
            this.ri = a;
            this.fj("TrendLineTypePickerTemplate", b, this.rp);
        }
    }
    get rq() {
        return this.rj;
    }
    set rq(a) {
        let b = this.rq;
        if (a != b) {
            this.rj = a;
            this.fj("VolumeTypePickerTemplate", b, this.rq);
        }
    }
    get rl() {
        return this.re;
    }
    set rl(a) {
        let b = this.rl;
        if (a != b) {
            this.re = a;
            this.fj("IndicatorPickerTemplate", b, this.rl);
        }
    }
    get rm() {
        return this.rf;
    }
    set rm(a) {
        let b = this.rm;
        if (a != b) {
            this.rf = a;
            this.fj("OverlayPickerTemplate", b, this.rm);
        }
    }
    get pe() {
        return this.pd;
    }
    set pe(a) {
        let b = this.pe;
        if (a != b) {
            this.pd = a;
            this.fj("ZoomSlider", b, this.pe);
        }
    }
    get_bw() {
        return super.get_bw();
    }
    set_bw(a) {
        super.set_bw(a);
    }
    get bw() {
        return this.get_bw();
    }
    set bw(a) {
        this.set_bw(a);
    }
    get_ay() {
        return super.get_ay();
    }
    set_ay(a) {
        super.set_ay(a);
    }
    get ay() {
        return this.get_ay();
    }
    set ay(a) {
        this.set_ay(a);
    }
    get ql() {
        return this.qa;
    }
    set ql(a) {
        let b = this.ql;
        if (a != b) {
            this.qa = a;
            this.fj("ToolbarHeight", b, this.ql);
        }
    }
    get xAxis() {
        return this.ng;
    }
    set xAxis(a) {
        let b = this.xAxis;
        if (a != b) {
            this.ng = a;
            this.fj("XAxis", b, this.xAxis);
        }
    }
    get yAxis() {
        return this.ot;
    }
    set yAxis(a) {
        let b = this.yAxis;
        if (a != b) {
            this.ot = a;
            this.fj("YAxis", b, this.yAxis);
        }
    }
    get volumeAxis() {
        return this.os;
    }
    set volumeAxis(a) {
        let b = this.volumeAxis;
        if (a != b) {
            this.os = a;
            this.fj("VolumeAxis", b, this.volumeAxis);
        }
    }
    get volumeXAxis() {
        return this.nf;
    }
    set volumeXAxis(a) {
        let b = this.volumeXAxis;
        if (a != b) {
            this.nf = a;
            this.fj("VolumeXAxis", b, this.volumeXAxis);
        }
    }
    get indicatorAxis() {
        return this.or;
    }
    set indicatorAxis(a) {
        let b = this.indicatorAxis;
        if (a != b) {
            this.or = a;
            this.fj("IndicatorAxis", b, this.indicatorAxis);
        }
    }
    get indicatorXAxis() {
        return this.ne;
    }
    set indicatorXAxis(a) {
        let b = this.indicatorXAxis;
        if (a != b) {
            this.ne = a;
            this.fj("IndicatorXAxis", b, this.indicatorXAxis);
        }
    }
    get p4() {
        return this.p1;
    }
    set p4(a) {
        let b = this.p4;
        if (a != b) {
            this.p1 = a;
            this.fj("IndicatorAxes", b, this.p4);
        }
    }
    get p6() {
        return this.p3;
    }
    set p6(a) {
        let b = this.p6;
        if (a != b) {
            this.p3 = a;
            this.fj("IndicatorXAxes", b, this.p6);
        }
    }
    gk() {
        return this.xAxis;
    }
    gl() {
        return this.yAxis;
    }
    r(a) {
        return 20;
    }
    get_ba() {
        return ((() => {
            let $ret = new List$1(DataSeriesType_$type, 0);
            $ret.add(20);
            return $ret;
        })());
    }
    get ba() {
        return this.get_ba();
    }
    get_a9() {
        return ((() => {
            let $ret = new List$1(IDataSeriesAdapterRule_$type, 0);
            $ret.add(new SimpleFinancialPriceSeriesRule());
            $ret.add(new SubCollectionsRule());
            return $ret;
        })());
    }
    get a9() {
        return this.get_a9();
    }
    nj(a) {
        return this.nk(a);
    }
    ov(a) {
        return this.ow(a);
    }
    ni(a) {
        let b = this.nj(0);
        b.name = a;
        return b;
    }
    em() {
        this.xAxis = this.ni("xAxis");
        this.yAxis = this.ov(0);
        this.yAxis.name = "yAxis";
        this.volumeAxis = this.ov(0);
        this.volumeAxis.name = "volumeAxis";
        this.volumeXAxis = this.ni("volumeXAxis");
        this.indicatorAxis = this.ov(0);
        this.indicatorAxis.name = "indicatorAxis";
        this.indicatorXAxis = this.ni("indicatorXAxis_0");
        this.p4 = new List$1(NumericYAxis.$, 0);
        this.p6 = new List$1(CategoryAxisBase.$, 0);
        this.p4.add(this.indicatorAxis);
        this.p6.add(this.indicatorXAxis);
        if (this.xAxis.aw == null) {
            this.xAxis.aw = new AxisLabelSettings();
        }
        if (this.yAxis.aw == null) {
            this.yAxis.aw = new AxisLabelSettings();
        }
        if (this.volumeAxis.aw == null) {
            this.volumeAxis.aw = new AxisLabelSettings();
        }
        if (this.volumeXAxis.aw == null) {
            this.volumeAxis.aw = new AxisLabelSettings();
        }
        if (this.indicatorAxis.aw == null) {
            this.indicatorAxis.aw = new AxisLabelSettings();
        }
        if (this.indicatorXAxis.aw == null) {
            this.indicatorXAxis.aw = new AxisLabelSettings();
        }
        this.zoomSliderAxis = this.ov(0);
        this.zoomSliderAxis.name = "zoomSliderAxis";
        this.zoomSliderXAxis = this.ni("zoomSliderXAxis");
        if (this.zoomSliderAxis.aw == null) {
            this.zoomSliderAxis.aw = new AxisLabelSettings();
        }
        if (this.zoomSliderXAxis.aw == null) {
            this.zoomSliderXAxis.aw = new AxisLabelSettings();
        }
    }
    f2(a) {
        super.f2(a);
        a.hd();
    }
    ek(a, b) {
        let c = typeCast(MarkerSeries.$, a);
        if (c != null) {
            c.li = this.ad(a, b);
        }
    }
    fx(a) {
        if (a.suggestedSecondaryAxis == 2) {
            this.yAxis.jl = true;
            this.yAxis.j8 = 10;
        }
    }
    f0() {
        this.yAxis.jl = this.py;
        this.yAxis.j8 = this.rc;
    }
    n1() {
        let a;
        if (this.nz == 0) {
            if (this.s == null || this.s.dataSeries == null || this.s.dataSeries.count == 0 || stringIsNullOrEmpty(this.s.dataSeries._inner[0].getMemberPathFor(12))) {
                a = 4;
            }
            else {
                a = 1;
            }
        }
        else {
            a = this.nz;
        }
        a = this.n0(a);
        return a;
    }
    n0(a) {
        if ((a == 1 || a == 2)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    }
    oa(a) {
        if ((a == 2 || a == 3)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 5;
        }
        if (a == 5) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 6;
        }
        if (a == 6) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    }
    n3(a) {
        if (a == 2) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 1;
        }
        if (a == 1) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    }
    rx(a) {
        let b = a.getMemberPathFor(14);
        if (stringIsNullOrEmpty(b)) {
            b = a.getMemberPathFor(11);
        }
        return b;
    }
    o7(seriesType_) {
        return (this.externalObject.createSeries(seriesType_).i);
    }
    nk(axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createXAxis(axisType_).i);
        }
        else {
            let a;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    }
    ow(axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createYAxis(axisType_).i);
        }
        else {
            let a;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    }
    o2() {
        return this.o7(1);
    }
    o3() {
        return this.o7(0);
    }
    o1() {
        return this.o7(2);
    }
    o4() {
        return this.o7(20);
    }
    get pj() {
        return (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy"));
    }
    get oj() {
        if (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy")) {
            return TypeRegistrar.create("HorizontalAnchoredCategorySeriesProxy");
        }
        else {
            throw new BaseError(1, "horizontal series module is not loaded, but is required.");
        }
    }
    get pm() {
        return (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy"));
    }
    get oh() {
        if (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy")) {
            return TypeRegistrar.create("FinancialPriceSeriesProxy");
        }
        else {
            throw new BaseError(1, "financial series module is not loaded, but is required.");
        }
    }
    get pk() {
        return (TypeRegistrar.isRegistered("IndicatorProxy"));
    }
    get ol() {
        if (TypeRegistrar.isRegistered("IndicatorProxy")) {
            return TypeRegistrar.create("IndicatorProxy");
        }
        else {
            throw new BaseError(1, "financial series module is not loaded, but is required.");
        }
    }
    get pl() {
        return (TypeRegistrar.isRegistered("OverlayProxy"));
    }
    get oq() {
        if (TypeRegistrar.isRegistered("OverlayProxy")) {
            return TypeRegistrar.create("OverlayProxy");
        }
        else {
            throw new BaseError(1, "overlay series module is not loaded, but is required.");
        }
    }
    ag(a, b) {
        let c = this.rx(a);
        switch (this.n1()) {
            case 3:
                let d = this.o2();
                this.oj.setValueMemberPath(d, c);
                this.oj.setXAxis(d, this.xAxis);
                this.oj.setYAxis(d, this.yAxis);
                this.oj.setCategoryMode(d, 1);
                return d;
            case 4:
                let e = this.o3();
                this.oj.setValueMemberPath(e, c);
                this.oj.setXAxis(e, this.xAxis);
                this.oj.setYAxis(e, this.yAxis);
                this.oj.setCategoryMode(e, 1);
                return e;
            default:
            case 1:
            case 2:
                let f = this.o4();
                this.oh.setOpenMemberPath(f, a.getMemberPathFor(11));
                this.oh.setHighMemberPath(f, a.getMemberPathFor(12));
                this.oh.setLowMemberPath(f, a.getMemberPathFor(13));
                this.oh.setCloseMemberPath(f, a.getMemberPathFor(14));
                this.oh.setVolumeMemberPath(f, a.getMemberPathFor(15));
                this.oh.setXAxis(f, this.xAxis);
                this.oh.setYAxis(f, this.yAxis);
                this.oh.setDisplayType(f, this.nz == 2 ? 0 : 1);
                this.oh.setCategoryMode(f, 1);
                return f;
        }
    }
    fz() {
        super.fz();
        this.t9(this.xAxis);
        this.uu(false);
        if (this.n4 != 0 && this.volumeChart != null) {
            this.uf();
        }
        this.t9(this.volumeXAxis);
        this.t9(this.indicatorXAxis);
        this.ur();
        this.ut();
        if (this.ob != 0) {
            this.ug();
            this.t9(this.zoomSliderXAxis);
        }
    }
    lj(a, b) {
        super.lj(a, b);
        a(this.volumeXAxis);
        if (this.p6 != null) {
            for (let c of fromEnum(this.p6)) {
                a(c);
            }
        }
        let d = true;
        switch (b) {
            case "XAxisMajorStroke":
            case "XAxisMajorStrokeThickness":
                d = false;
                break;
        }
        if (d) {
            a(this.zoomSliderXAxis);
        }
    }
    ln(a, b) {
        super.ln(a, b);
        if (b) {
            a(this.volumeAxis);
            if (this.p4 != null) {
                for (let c of fromEnum(this.p4)) {
                    a(c);
                }
            }
            a(this.zoomSliderAxis);
        }
    }
    ll(a) {
        super.ll(a);
        this.ld(this.volumeXAxis, a);
        this.ld(this.indicatorXAxis, a);
        this.ld(this.zoomSliderXAxis, a);
    }
    lp(a) {
        super.lp(a);
        this.ld(this.volumeAxis, a);
        this.ld(this.indicatorAxis, a);
        this.ld(this.zoomSliderAxis, a);
    }
    lo(a) {
        super.lo(a);
        this.lc(this.volumeAxis, a);
        this.lc(this.indicatorAxis, a);
        this.lc(this.zoomSliderAxis, a);
    }
    lk(a) {
        super.lk(a);
        this.lc(this.volumeXAxis, a);
        this.lc(this.indicatorXAxis, a);
        this.lc(this.zoomSliderXAxis, a);
    }
    ex(a) {
        super.ex(a);
        if (a == null) {
            return;
        }
        if (a == this.zoomSliderChart) {
            a.nl = a.nn = false;
            a.ay = null;
            if (this.dataChart != null) {
                a.m3 = this.dataChart.m3;
                a.m6 = this.dataChart.m6;
            }
        }
        else {
            SyncManager.d(a, ((() => {
                let $ret = new SyncSettings();
                $ret.ae = this.sq();
                $ret.ac = true;
                $ret.ad = false;
                return $ret;
            })()));
            SyncManager.c(a);
        }
        a.bc = 2;
    }
    sq() {
        if (this.rr == null) {
            FinancialChart.rb++;
            this.rr = FinancialChart.rb.toString();
        }
        return this.rr;
    }
    tv(a, b) {
        this.tl();
        this.ub();
    }
    tl() {
        if (this.yAxis.bz()) {
            return;
        }
        let a = this.yAxis.at.a5;
        if (this.n4 != 0) {
            a = Math.max(a, this.volumeAxis.at.a5);
        }
        for (let b of fromEnum(this.p4)) {
            a = Math.max(a, b.at.a5);
        }
        this.yAxis.d1 = this.volumeAxis.d1 = a;
        for (let c of fromEnum(this.p4)) {
            c.d1 = a;
        }
        this.zoomSliderAxis.d1 = this.yAxis.d1;
    }
    to(a) {
        if (this.indicatorCharts == null) {
            return;
        }
        for (let b = 0; b < this.indicatorCharts.count; b++) {
            let c = this.indicatorCharts._inner[b];
            for (let d = 0; d < c.series.count; d++) {
                a(c.series._inner[d], b);
            }
        }
    }
    tq(a) {
        if (this.volumeChart == null) {
            return;
        }
        for (let b = 0; b < this.volumeChart.series.count; b++) {
            a(this.volumeChart.series._inner[b], b);
        }
    }
    tp(a) {
        if (this.dataChart == null) {
            return;
        }
        let b = this.s == null || this.s.dataSeries == null ? 0 : this.s.dataSeries.count;
        let c = this.of == null ? 0 : this.of.count;
        for (let d = 0; d < this.dataChart.series.count; d++) {
            if (this.pq(this.dataChart.series._inner[d])) {
                continue;
            }
            let e = d - (b * c);
            a(this.dataChart.series._inner[d], e);
        }
        this.tr(a);
    }
    tr(a) {
        if (this.zoomSliderChart == null) {
            return;
        }
        for (let b = 0; b < this.zoomSliderChart.series.count; b++) {
            a(this.zoomSliderChart.series._inner[b], b);
        }
    }
    q5(a, b) {
        if (a.bq != this.dataChart) {
            return b;
        }
        let c = this.s == null || this.s.dataSeries == null ? 0 : this.s.dataSeries.count;
        let d = this.of == null ? 0 : this.of.count;
        return b - (c * d);
    }
    er(a) {
        super.er(a);
        this.tq(a);
        this.to(a);
        this.tr(a);
    }
    get volumeChart() {
        return this.o9;
    }
    set volumeChart(a) {
        let b = this.volumeChart;
        if (a != b) {
            this.o9 = a;
            this.fj("VolumeChart", b, this.volumeChart);
        }
    }
    uf() {
        if (this.dataChart == null) {
            return;
        }
        this.volumeChart.series.clear();
        let a = new List$1(Series.$, 0);
        let b = -1;
        for (let c = 0; c < this.dataChart.series.count; c++) {
            let d = this.dataChart.series._inner[c];
            if (this.pq(d)) {
                continue;
            }
            b++;
            let e;
            let f = this.n4;
            f = this.n3(f);
            switch (f) {
                case 2:
                    e = this.o3();
                    break;
                case 3:
                    e = this.o1();
                    break;
                default:
                case 1:
                    e = this.o2();
                    break;
            }
            this.oj.setCategoryMode(e, 1);
            e.name = "volumeSeries_" + b;
            e.itemsSource = d.itemsSource;
            this.oj.setXAxis(e, this.volumeXAxis);
            this.oj.setYAxis(e, this.volumeAxis);
            this.oj.setValueMemberPath(e, this.s != null && this.s.dataSeries != null && this.s.dataSeries.count > b ? this.s.dataSeries._inner[b].getMemberPathFor(15) : null);
            e.fk = d.fk + " Volume";
            e.km = ArrayExtension.getModulus$1(Brush.$, this.nc, b);
            e.kp = ArrayExtension.getModulus$1(Brush.$, this.nd, b);
            e.eo = this.qm;
            a.add(e);
        }
        for (let g = 0; g < a.count; g++) {
            let h = a._inner[g];
            this.volumeChart.series.add(h);
            this.e2(h, g);
        }
    }
    pn(a) {
        if (!this.pj) {
            return false;
        }
        return this.oj.matchesType(a);
    }
    pr(a) {
        if (!this.pm) {
            return false;
        }
        return this.oh.matchesType(a);
    }
    pp(a) {
        if (!this.pk) {
            return false;
        }
        return this.ol.matchesType(a);
    }
    pq(a) {
        if (!this.pl) {
            return false;
        }
        return this.oq.matchesType(a);
    }
    ue() {
        if (this.dataChart == null) {
            return;
        }
        let a = 0;
        let b = this.od == null ? 0 : this.od.count;
        let c = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        let d = b + c;
        for (let e = 0; e < d; e++) {
            let f = new List$1(Series.$, 0);
            let g = this.indicatorCharts._inner[e];
            let h = e >= b;
            let i = h ? this.customIndicatorNames._inner[e - b] : EnumUtil.getName(FinancialIndicatorType_$type, this.od._inner[e]);
            let j = -1;
            for (let k = 0; k < this.dataChart.series.count; k++) {
                let l = this.dataChart.series._inner[k];
                if (this.pq(l)) {
                    continue;
                }
                j++;
                let m;
                if (h) {
                    let n = this.o5("Custom");
                    this.ol.handleCustomIndicatorEvent(n, runOn(this, this.tt));
                    m = n;
                }
                else {
                    m = this.o8(this.od._inner[e]);
                }
                if (m == null) {
                    continue;
                }
                m.name = "indicator_" + a++;
                this.ol.setXAxis(m, this.p6._inner[e]);
                this.ol.setYAxis(m, this.p4._inner[e]);
                m.itemsSource = l.itemsSource;
                this.ol.setOpenMemberPath(m, this.s.dataSeries._inner[j].getMemberPathFor(11));
                this.ol.setHighMemberPath(m, this.s.dataSeries._inner[j].getMemberPathFor(12));
                this.ol.setLowMemberPath(m, this.s.dataSeries._inner[j].getMemberPathFor(13));
                this.ol.setCloseMemberPath(m, this.s.dataSeries._inner[j].getMemberPathFor(14));
                this.ol.setVolumeMemberPath(m, this.s.dataSeries._inner[j].getMemberPathFor(15));
                m.fk = l.fk + " " + i;
                m.km = ArrayExtension.getModulus$1(Brush.$, this.m6, e);
                m.eo = this.qj;
                if (this.pp(m)) {
                    this.ol.setNegativeBrush(m, ArrayExtension.getModulus$1(Brush.$, this.m7, e));
                    this.ol.setDisplayType(m, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.on, e));
                }
                if (this.q7 != -2147483648 && this.pp(m)) {
                    this.ol.setPeriodOverride(m, this.q7);
                }
                if (this.pp(m)) {
                    this.ol.setSmoothingPeriod(m, this.ra);
                }
                if (this.pp(m)) {
                    this.ol.setSignalPeriod(m, this.q9);
                }
                if (this.pp(m)) {
                    this.ol.setShortPeriod(m, this.q8);
                    this.ol.setLongPeriod(m, this.q6);
                }
                this.e2(m, e);
                f.add(m);
            }
            for (let o of fromEnum(f)) {
                g.series.add(o);
            }
        }
    }
    o5(indicatorName_) {
        return (this.externalObject.createIndicator(indicatorName_ + 'Indicator').i);
    }
    o8(a) {
        return this.o5(EnumUtil.getName(FinancialIndicatorType_$type, a));
    }
    uu(a) {
        if (this.nx == null) {
            return;
        }
        let b = this.xAxis;
        if (b.actualMinimumValue > b.actualMaximumValue) {
            return;
        }
        this.nx.ax = b.actualMinimumValue;
        this.nx.aw = b.actualMaximumValue;
        if (a) {
            this.nx.az = b.visibleMinimum;
            this.nx.ay = b.visibleMaximum;
        }
        this.nx.bz();
    }
    cn() {
        let a = ((() => {
            let $ret = new FinancialChartVisualData();
            $ret.mainChart = super.cn();
            $ret.volumeChart = this.volumeChart == null ? null : this.volumeChart.n8();
            $ret.toolbar = this.nx == null ? null : this.nx.ao();
            $ret.zoomChart = this.zoomSliderChart == null ? null : this.zoomSliderChart.n8();
            return $ret;
        })());
        if (this.indicatorCharts != null) {
            a.indicatorCharts = new List$1(Base.$, 0);
            for (let b of fromEnum(this.indicatorCharts)) {
                a.indicatorCharts.add1(b.n8());
            }
        }
        if (this.dataChart != null) {
            a.mainChartLeft = this.u3(this.dataChart).x;
            a.mainChartTop = this.u3(this.dataChart).y;
        }
        if (this.volumeChart != null) {
            a.volumeChartLeft = this.u3(this.volumeChart).x;
            a.volumeChartTop = this.u3(this.volumeChart).y;
        }
        if (this.zoomSliderChart != null) {
            a.zoomChartLeft = this.u3(this.zoomSliderChart).x;
            a.zoomChartTop = this.u3(this.zoomSliderChart).y;
        }
        if (this.nx != null) {
            let c = this.u4(this.nx);
            a.toolbarLeft = c.left;
            a.toolbarTop = c.top;
            a.toolbarWidth = c.width;
            a.toolbarHeight = c.height;
        }
        if (this.indicatorCharts != null) {
            a.indicatorChartLefts = new List$1(Number_$type, 0);
            a.indicatorChartTops = new List$1(Number_$type, 0);
            for (let d of fromEnum(this.indicatorCharts)) {
                a.indicatorChartLefts.add(this.u3(d).x);
                a.indicatorChartTops.add(this.u3(d).y);
            }
        }
        return a;
    }
    rw() {
        let a = this.cn();
        a.scaleByViewport();
        return a.serialize();
    }
    o6(overlayName_) {
        return (this.externalObject.createOverlay(overlayName_ + 'Overlay').i);
    }
    ut() {
        if (this.dataChart == null) {
            return;
        }
        let a = new List$1(Series.$, 0);
        for (let b of fromEnum(this.dataChart.series)) {
            if (this.pq(b)) {
                a.add(b);
            }
        }
        for (let c of fromEnum(a)) {
            this.dataChart.series.remove(c);
        }
        if (this.of == null) {
            return;
        }
        let d = new List$1(Series.$, 0);
        for (let e = 0; e < this.dataChart.series.count; e++) {
            let f = this.dataChart.series._inner[e];
            for (let g = 0; g < this.of.count; g++) {
                let h = this.of._inner[g];
                let i;
                switch (h) {
                    case 1:
                        i = this.o6(EnumUtil.getName(FinancialOverlayType_$type, h));
                        break;
                    default:
                    case 0:
                        i = this.o6(EnumUtil.getName(FinancialOverlayType_$type, h));
                        break;
                }
                i.name = f.name + "_" + EnumUtil.getName(FinancialOverlayType_$type, h);
                this.oq.setXAxis(i, this.xAxis);
                this.oq.setYAxis(i, this.yAxis);
                i.itemsSource = f.itemsSource;
                let j = e * this.of.count + g;
                i.km = ArrayExtension.getModulus$1(Brush.$, this.na, j);
                i.kp = ArrayExtension.getModulus$1(Brush.$, this.nb, j);
                i.eo = this.qk;
                i.fk = f.fk + " " + EnumUtil.getName(FinancialOverlayType_$type, h);
                let k = f;
                if (k == null) {
                    continue;
                }
                this.oq.setOpenMemberPath(i, this.s.dataSeries._inner[e].getMemberPathFor(11));
                this.oq.setHighMemberPath(i, this.s.dataSeries._inner[e].getMemberPathFor(12));
                this.oq.setLowMemberPath(i, this.s.dataSeries._inner[e].getMemberPathFor(13));
                this.oq.setCloseMemberPath(i, this.s.dataSeries._inner[e].getMemberPathFor(14));
                this.oq.setVolumeMemberPath(i, this.s.dataSeries._inner[e].getMemberPathFor(15));
                d.add(i);
            }
        }
        let l = new Array(this.dataChart.series.count);
        this.dataChart.series.copyTo(l, 0);
        this.dataChart.skipDataCleanup = true;
        this.dataChart.series.clear();
        this.dataChart.skipDataCleanup = false;
        for (let m = 0; m < l.length; m++) {
            l[m].e7 = -1;
        }
        d.o(l);
        for (let n of fromEnum(d)) {
            this.dataChart.series.add(n);
        }
    }
    ur() {
        if (this.pw) {
            return;
        }
        this.pw = true;
        if (this.indicatorCharts != null) {
            let a = this.indicatorCharts;
            this.indicatorCharts = null;
            for (let b of fromEnum(a)) {
                this.ua(b);
            }
        }
        if ((this.od == null || this.od.count == 0) && (this.customIndicatorNames == null || this.customIndicatorNames.count == 0)) {
            this.indicatorCharts = null;
            this.uj();
            this.us();
            this.pw = false;
            return;
        }
        if (this.indicatorCharts == null) {
            this.indicatorCharts = new List$1(XamDataChart.$, 0);
        }
        this.indicatorCharts.clear();
        this.p4.clear();
        this.p6.clear();
        let c = this.od == null ? 0 : this.od.count;
        let d = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        let e = c + d;
        for (let f = 0; f < e; f++) {
            let g = new XamDataChart();
            this.indicatorCharts.add(g);
            this.t8(g);
            let h = f >= c;
            g.gm = h ? this.customIndicatorNames._inner[f - c] : EnumUtil.getName(FinancialIndicatorType_$type, this.od._inner[f]);
            if (this.indicatorAxis != null) {
                let i;
                let j;
                if (f == 0) {
                    i = this.indicatorAxis;
                    j = this.indicatorXAxis;
                }
                else {
                    i = new NumericYAxis();
                    if (!this.indicatorXAxis.b5) {
                        j = this.nj(0);
                    }
                    else {
                        j = this.nj(1);
                    }
                }
                j.name = "indicatorXAxis_" + f;
                i.name = "indicatorAxis_" + f;
                g.axes.add(i);
                g.axes.add(j);
                this.p4.add(i);
                this.p6.add(j);
                if (this.aw) {
                    this.lg(i);
                }
                if (this.aw) {
                    this.le(j);
                }
            }
        }
        this.ue();
        this.uj();
        if (this.nx != null) {
            this.nx.aj = this.od;
        }
        this.tm();
        this.us();
        this.pw = false;
    }
    eu() {
        super.eu();
        this.le(this.xAxis);
        this.le(this.volumeXAxis);
        if (this.p6 != null) {
            for (let a of fromEnum(this.p6)) {
                this.le(a);
            }
        }
        this.lg(this.yAxis);
        this.lg(this.volumeAxis);
        if (this.p4 != null) {
            for (let b of fromEnum(this.p4)) {
                this.lg(b);
            }
        }
        this.le(this.zoomSliderXAxis);
        this.lg(this.zoomSliderAxis);
    }
    get_a2() {
        return !this.pu;
    }
    get a2() {
        return this.get_a2();
    }
    get p0() {
        return (this.externalObject._dynamicContent);
    }
    uz(a, b) {
        this.um(a, b);
        this.tm();
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.axes.add(this.zoomSliderAxis);
            this.zoomSliderChart.axes.add(this.zoomSliderXAxis);
        }
        this.ug();
        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
        this.uk();
        this.u0(a, b);
    }
    ug() {
        if (this.dataChart == null || this.zoomSliderChart == null) {
            return;
        }
        this.zoomSliderChart.series.clear();
        let a = new List$1(Series.$, 0);
        for (let b = 0; b < this.dataChart.series.count; b++) {
            let c = this.dataChart.series._inner[b];
            let d;
            let e = this.ob;
            e = this.oa(e);
            if (e == 1) {
                switch (this.n1()) {
                    case 1:
                        e = 2;
                        break;
                    case 2:
                        e = 3;
                        break;
                    case 3:
                        e = 4;
                        break;
                    case 4:
                        e = 5;
                        break;
                }
            }
            switch (e) {
                case 2:
                    d = this.o4();
                    this.oh.setDisplayType(d, 1);
                    break;
                case 3:
                    d = this.o4();
                    this.oh.setDisplayType(d, 0);
                    break;
                case 5:
                    d = this.o3();
                    break;
                case 6:
                    d = this.o1();
                    break;
                default:
                case 4:
                    d = this.o2();
                    break;
            }
            if (d.ck && !d.cq) {
                this.oj.setCategoryMode(d, 1);
                this.oj.setXAxis(d, this.zoomSliderXAxis);
                this.oj.setYAxis(d, this.zoomSliderAxis);
                this.oj.setValueMemberPath(d, this.s != null && this.s.dataSeries != null && this.s.dataSeries.count > b ? this.rx(this.s.dataSeries._inner[b]) : null);
            }
            else if (d.cq) {
                this.oh.setCategoryMode(d, 1);
                this.oh.setXAxis(d, this.zoomSliderXAxis);
                this.oh.setYAxis(d, this.zoomSliderAxis);
                if (this.s != null && this.s.dataSeries != null && this.s.dataSeries.count > b) {
                    this.oh.setOpenMemberPath(d, this.s.dataSeries._inner[b].getMemberPathFor(11));
                    this.oh.setHighMemberPath(d, this.s.dataSeries._inner[b].getMemberPathFor(12));
                    this.oh.setLowMemberPath(d, this.s.dataSeries._inner[b].getMemberPathFor(13));
                    this.oh.setCloseMemberPath(d, this.s.dataSeries._inner[b].getMemberPathFor(14));
                    this.oh.setVolumeMemberPath(d, this.s.dataSeries._inner[b].getMemberPathFor(15));
                }
            }
            d.name = "zoomSliderSeries_" + b;
            d.itemsSource = c.itemsSource;
            d.fk = c.fk;
            a.add(d);
        }
        for (let f = 0; f < a.count; f++) {
            let g = a._inner[f];
            this.zoomSliderChart.series.add(g);
            this.e2(g, f);
        }
    }
    fg(a, b, c) {
        super.fg(a, b, c);
        if (a == null || !b) {
            return;
        }
        let d = true;
        let e = true;
        let f = true;
        switch (c) {
            case "Brushes":
            case "Outlines":
                d = e = false;
                break;
        }
        if (this.indicatorCharts != null && d) {
            for (let g of fromEnum(this.indicatorCharts)) {
                a(g);
            }
        }
        if (this.volumeChart != null && e) {
            a(this.volumeChart);
        }
        if (this.zoomSliderChart != null && f) {
            a(this.zoomSliderChart);
        }
    }
    tt(a, b) {
        let c = b;
        let d = a;
        let e = -1;
        if (this.indicatorCharts != null) {
            e = this.indicatorCharts.indexOf(d.bq);
        }
        e -= this.od == null ? 0 : this.od.count;
        if (this.applyCustomIndicators != null) {
            this.applyCustomIndicators(this, new FinancialChartCustomIndicatorArgs(c, d, e));
        }
    }
    le(a) {
        super.le(a);
        let b = a;
        this.t9(b);
        if (a.bd != null) {
            for (let c of fromEnum(a.bd.series)) {
                if (this.pn(c)) {
                    this.oj.setXAxis(c, b);
                }
                else if (this.pr(c)) {
                    this.oh.setXAxis(c, b);
                }
                else if (this.pp(c)) {
                    this.ol.setXAxis(c, b);
                }
                else if (this.pq(c)) {
                    this.oq.setXAxis(c, b);
                }
            }
        }
        let d = a == this.zoomSliderXAxis;
        if (d) {
            a.ib = this.u2;
            a.d0 = this.qt;
            this.lc(a, (e) => e.visibility = 1);
        }
    }
    lg(a) {
        super.lg(a);
        if (a.bd != null) {
            for (let b of fromEnum(a.bd.series)) {
                if (this.pn(b)) {
                    this.oj.setYAxis(b, this.yAxis);
                }
                else if (this.pr(b)) {
                    this.oh.setYAxis(b, this.yAxis);
                }
                else if (this.pp(b)) {
                    this.ol.setYAxis(b, this.yAxis);
                }
                else if (this.pq(b)) {
                    this.oq.setYAxis(b, this.yAxis);
                }
            }
        }
        a.jg = this.px;
        a.j4 = this.qr;
        a.j3 = this.qq;
        a.j0 = this.qp;
        let c = a == this.zoomSliderAxis;
        if (c) {
            this.lc(a, (d) => d.visibility = 1);
        }
    }
    t9(a) {
        a.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
        a.e1 = XYChart.i8(a, this.s.dataSeries);
        if (this.s.dataSeries.count > 0) {
            let b = this.s.dataSeries._inner[0].getMemberPathFor(17);
            a.gp(b);
        }
    }
    e2(a, b) {
        super.e2(a, b);
        if (a == null) {
            return;
        }
        let c = this.dataChart != null && this.dataChart.series.contains(a);
        if (c && a.cy) {
            a.i0(this.m8 != null ? ArrayExtension.getModulus$1(Brush.$, this.m8, b) : null, this.m9 != null ? ArrayExtension.getModulus$1(Brush.$, this.m9, b) : null);
        }
        if (this.pq(a)) {
            a.km = this.na != null ? ArrayExtension.getModulus$1(Brush.$, this.na, b) : null;
            a.kp = this.nb != null ? ArrayExtension.getModulus$1(Brush.$, this.nb, b) : null;
            a.eo = this.qk;
        }
        else if (this.pp(a)) {
            a.km = this.m6 != null ? ArrayExtension.getModulus$1(Brush.$, this.m6, b) : null;
            a.eo = this.qj;
        }
        else if (c) {
            a.km = this.j != null ? ArrayExtension.getModulus$1(Brush.$, this.j, b) : null;
            a.kp = this.n != null ? ArrayExtension.getModulus$1(Brush.$, this.n, b) : null;
        }
        let d = this.volumeChart != null && this.volumeChart.series.count > b && this.volumeChart.series._inner[b] == a;
        if (d) {
            a.eo = this.qm;
        }
    }
    fj(a, b, c) {
        super.fj(a, b, c);
        switch (a) {
            case "YAxisIsLogarithmic":
                this.yAxis.jl = this.py;
                break;
            case "YAxisLogarithmBase":
                this.yAxis.j8 = this.rc;
                break;
            case "VolumeType":
                let d = EnumUtil.getEnumValue(FinancialChartVolumeType_$type, b);
                if (this.n4 == 0) {
                    this.volumeChart = null;
                }
                else if (this.volumeChart == null) {
                    this.volumeChart = ((() => {
                        let $ret = new XamDataChart();
                        $ret.name = "VolumeChart";
                        return $ret;
                    })());
                }
                else {
                    this.uf();
                }
                break;
            case "VolumeChart":
                this.ux(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "DataChart":
                if (typeCast(XamDataChart.$, b) !== null) {
                    let e = b;
                    e.gridAreaRectChanged = delegateRemove(e.gridAreaRectChanged, runOn(this, this.tv));
                    e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, runOn(this, this.ts));
                    e.seriesDataUpdated = delegateRemove(e.seriesDataUpdated, runOn(this, this.t0));
                }
                if (this.dataChart != null) {
                    let f = this.dataChart;
                    f.gridAreaRectChanged = delegateCombine(f.gridAreaRectChanged, runOn(this, this.tv));
                    let g = this.dataChart;
                    g.actualWindowRectChanged = delegateCombine(g.actualWindowRectChanged, runOn(this, this.ts));
                    let h = this.dataChart;
                    h.seriesDataUpdated = delegateCombine(h.seriesDataUpdated, runOn(this, this.t0));
                }
                this.uw();
                break;
            case "XAxisMode":
                this.xAxis = this.nj(this.n6);
                this.xAxis.name = "xAxis";
                this.volumeXAxis = this.nj(this.n6);
                this.volumeXAxis.name = "volumeXAxis";
                this.indicatorXAxis = this.nj(this.n6);
                this.indicatorXAxis.name = "indicatorXAxis_0";
                this.zoomSliderXAxis = this.nj(this.n6);
                this.zoomSliderXAxis.name = "zoomSliderXAxis";
                this.lc(this.zoomSliderXAxis, (i) => i.visibility = 1);
                this.tm();
                break;
            case "YAxisMode":
                this.yAxis = this.ov(this.n8);
                this.yAxis.name = "yAxis";
                break;
            case "Toolbar":
                let i = typeCast(FinancialChartToolbar.$, b);
                if (i != null) {
                    i.rangeChanged = delegateRemove(i.rangeChanged, runOn(this, this.tz));
                    i.indicatorTypesChanged = delegateRemove(i.indicatorTypesChanged, runOn(this, this.t2));
                    i.overlayTypesChanged = delegateRemove(i.overlayTypesChanged, runOn(this, this.t3));
                }
                if (this.nx != null) {
                    this.nx.aj = this.od;
                    this.nx.al = this.of;
                    this.nx.v = this.nu;
                    this.uu(true);
                    let j = this.nx;
                    j.rangeChanged = delegateCombine(j.rangeChanged, runOn(this, this.tz));
                    let k = this.nx;
                    k.indicatorTypesChanged = delegateCombine(k.indicatorTypesChanged, runOn(this, this.t2));
                    let l = this.nx;
                    l.overlayTypesChanged = delegateCombine(l.overlayTypesChanged, runOn(this, this.t3));
                }
                break;
            case "XAxis":
                let m = typeCast(CategoryAxisBase.$, b);
                if (m != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(m);
                    }
                }
                let n = typeCast(ITimeRangeSelectorAxis_$type, b);
                if (n != null) {
                    n.actualRangeChanged = delegateRemove(n.actualRangeChanged, runOn(this, this.t6));
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.xAxis);
                }
                if (this.aw) {
                    this.le(this.xAxis);
                    this.ep();
                }
                this.uu(false);
                this.uv();
                if (typeCast(ITimeRangeSelectorAxis_$type, this.xAxis) !== null) {
                    let o = this.xAxis;
                    o.actualRangeChanged = delegateCombine(o.actualRangeChanged, runOn(this, this.t6));
                }
                break;
            case "ChartType":
                this.fz();
                break;
            case "VolumeXAxis":
                this.uo(this.volumeChart, typeCast(Axis.$, b), this.volumeXAxis);
                break;
            case "ZoomSliderXAxis":
                this.uo(this.zoomSliderChart, typeCast(Axis.$, b), this.zoomSliderXAxis);
                break;
            case "IndicatorXAxis":
                this.ur();
                break;
            case "YAxis":
                let p = typeCast(NumericYAxis.$, b);
                if (p != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(p);
                    }
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.yAxis);
                }
                if (this.aw) {
                    this.lg(this.yAxis);
                    this.lg(this.yAxis);
                }
                let q = this.yAxis;
                q.rangeChanged = delegateCombine(q.rangeChanged, runOn(this, this.t7));
                break;
            case "VolumeAxis":
                let r = typeCast(Axis.$, b);
                if (this.volumeChart != null && r != null) {
                    this.volumeChart.axes.remove(r);
                }
                if (this.aw) {
                    this.lg(this.volumeAxis);
                }
                let s = this.volumeAxis;
                s.rangeChanged = delegateCombine(s.rangeChanged, runOn(this, this.t7));
                break;
            case "IndicatorAxis":
                if (this.indicatorCharts != null) {
                    for (let t = 0; t < this.indicatorCharts.count; t++) {
                        let u = this.indicatorCharts._inner[t];
                        let v = new List$1(Axis.$, 0);
                        for (let w of fromEnum(u.axes)) {
                            if (typeCast(NumericYAxis.$, w) !== null) {
                                v.add(w);
                            }
                        }
                        for (let x of fromEnum(v)) {
                            u.axes.remove(x);
                        }
                        let y = null;
                        if (t == 0) {
                            y = this.indicatorAxis;
                        }
                        else if (this.n8 == 1) {
                            y = this.ov(this.n8);
                        }
                        else if (typeCast(NumericYAxis.$, this.indicatorAxis) !== null) {
                            y = new NumericYAxis();
                        }
                        if (y != null) {
                            u.axes.add(y);
                        }
                        if (this.aw) {
                            this.lg(y);
                        }
                    }
                }
                break;
            case "IsWindowSyncedToVisibleRange":
                if (this.dataChart != null) {
                    this.dataChart.nn = this.a3 && this.a2;
                }
                if (this.volumeChart != null) {
                    this.volumeChart.nn = this.a3 && this.a2;
                }
                if (this.pu) {
                    this.up(this.dataChart);
                }
                break;
            case "IndicatorTypes":
                let z = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), b);
                if (z != null) {
                    z.collectionChanged = delegateRemove(z.collectionChanged, runOn(this, this.tw));
                }
                let aa = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), c);
                if (aa != null) {
                    aa.collectionChanged = delegateCombine(aa.collectionChanged, runOn(this, this.tw));
                }
                this.ur();
                break;
            case "OverlayTypes":
                let ab = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), b);
                if (ab != null) {
                    ab.collectionChanged = delegateRemove(ab.collectionChanged, runOn(this, this.tx));
                }
                let ac = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), c);
                if (ac != null) {
                    ac.collectionChanged = delegateCombine(ac.collectionChanged, runOn(this, this.tx));
                }
                this.ut();
                break;
            case "YAxisAbbreviateLargeNumbers":
                this.lm((ad) => ad.jg = this.px);
                break;
            case "YAxisMinimumValue":
                this.ln((ad) => ad.j4 = this.qr, false);
                break;
            case "YAxisMaximumValue":
                this.ln((ad) => ad.j3 = this.qq, false);
                break;
            case "YAxisInterval":
                this.ln((ad) => ad.j0 = this.qp, false);
                break;
            case "ZoomSliderType":
                this.uw();
                break;
            case "ZoomSliderChart":
                if (!this.pz) {
                    return;
                }
                this.uz(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "NegativeBrushes":
            case "NegativeOutlines":
                this.tp((ad, ae) => {
                    if (ad.cy) {
                        ad.i0(this.m8 != null ? ArrayExtension.getModulus$1(Brush.$, this.m8, ae) : null, this.m9 != null ? ArrayExtension.getModulus$1(Brush.$, this.m9, ae) : null);
                    }
                });
                break;
            case "OverlayBrushes":
                this.er((ad, ae) => {
                    if (!(this.pq(ad))) {
                        return;
                    }
                    ad.km = this.na != null ? ArrayExtension.getModulus$1(Brush.$, this.na, ae) : null;
                });
                break;
            case "OverlayOutlines":
                this.er((ad, ae) => {
                    if (!(this.pq(ad))) {
                        return;
                    }
                    ad.kp = this.nb != null ? ArrayExtension.getModulus$1(Brush.$, this.nb, ae) : null;
                });
                break;
            case "OverlayThickness":
                this.er((ad, ae) => {
                    if (!(this.pq(ad))) {
                        return;
                    }
                    ad.eo = this.qk;
                });
                break;
            case "VolumeBrushes":
                this.tq((ad, ae) => ad.km = ArrayExtension.getModulus$1(Brush.$, this.nc, ae));
                break;
            case "VolumeOutlines":
                this.tq((ad, ae) => ad.kp = ArrayExtension.getModulus$1(Brush.$, this.nd, ae));
                break;
            case "VolumeThickness":
                this.tq((ad, ae) => ad.eo = this.qm);
                break;
            case "IndicatorNegativeBrushes":
                this.to((ad, ae) => this.ol.setNegativeBrush(ad, ArrayExtension.getModulus$1(Brush.$, this.m7, ae)));
                break;
            case "IndicatorBrushes":
                this.to((ad, ae) => ad.km = ArrayExtension.getModulus$1(Brush.$, this.m6, ae));
                break;
            case "IndicatorThickness":
                this.to((ad, ae) => ad.eo = this.qj);
                break;
            case "IndicatorDisplayTypes":
                this.to((ad, ae) => this.ol.setDisplayType(ad, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.on, ae)));
                break;
            case "IndicatorPeriod":
                this.to((ad, ae) => {
                    if (this.q7 == -2147483648 || !(this.pp(ad))) {
                        return;
                    }
                    this.ol.setPeriodOverride(ad, this.q7);
                });
                break;
            case "IndicatorMultiplier":
                this.to((ad, ae) => {
                    if (!(this.pq(ad))) {
                        return;
                    }
                    this.oq.setMultiplier(ad, this.qi);
                });
                break;
            case "IndicatorSmoothingPeriod":
                this.to((ad, ae) => {
                    if (!(this.pp(ad))) {
                        return;
                    }
                    this.ol.setSmoothingPeriod(ad, this.ra);
                });
                break;
            case "IndicatorShortPeriod":
                this.to((ad, ae) => {
                    if (!(this.pp(ad))) {
                        return;
                    }
                    this.ol.setShortPeriod(ad, this.q8);
                });
                break;
            case "IndicatorLongPeriod":
                this.to((ad, ae) => {
                    if (!(this.pp(ad))) {
                        return;
                    }
                    this.ol.setLongPeriod(ad, this.q6);
                });
                break;
            case "IndicatorSignalPeriod":
                this.to((ad, ae) => {
                    if (!(this.pp(ad))) {
                        return;
                    }
                    this.ol.setSignalPeriod(ad, this.q9);
                });
                break;
            case "RangeSelectorOptions":
                let ad = typeCast(FinancialChartRangeSelectorOptionCollection.$, b);
                if (ad != null) {
                    ad.collectionChanged = delegateRemove(ad.collectionChanged, runOn(this, this.ty));
                }
                if (this.nv != null) {
                    let ae = this.nv;
                    ae.collectionChanged = delegateCombine(ae.collectionChanged, runOn(this, this.ty));
                }
                this.ui();
                break;
            case "CustomIndicatorNames":
                let af = typeCast(ObservableCollection$1.$.specialize(String_$type), b);
                if (af != null) {
                    af.collectionChanged = delegateRemove(af.collectionChanged, runOn(this, this.tu));
                }
                if (this.customIndicatorNames != null) {
                    let ag = this.customIndicatorNames;
                    ag.collectionChanged = delegateCombine(ag.collectionChanged, runOn(this, this.tu));
                }
                this.ur();
                break;
            case "Legend":
                if (this.zoomSliderChart != null) {
                    this.zoomSliderChart.ay = null;
                }
                break;
            case "Brushes":
                this.tp((ah, ai) => {
                    if (this.pq(ah)) {
                        return;
                    }
                    ah.km = this.j != null ? ArrayExtension.getModulus$1(Brush.$, this.j, ai) : null;
                });
                break;
            case "Outlines":
                this.tp((ah, ai) => {
                    if (this.pq(ah)) {
                        return;
                    }
                    ah.kp = this.n != null ? ArrayExtension.getModulus$1(Brush.$, this.n, ai) : null;
                });
                break;
            case "XAxisLabelVisibility":
                if (this.mw == 0 && this.zoomSliderXAxis != null) {
                    this.lc(this.zoomSliderXAxis, (ah) => ah.visibility = 1);
                }
                this.tm();
                break;
            case "YAxisLabelVisibility":
                if (this.mx != 0 || this.zoomSliderAxis == null) {
                    break;
                }
                this.lc(this.zoomSliderAxis, (ah) => ah.visibility = 1);
                break;
            case "ZoomSliderXAxisMajorStroke":
                this.zoomSliderXAxis.ib = this.u2;
                break;
            case "ZoomSliderXAxisMajorStrokeThickness":
                this.zoomSliderXAxis.d0 = this.qt;
                break;
        }
    }
    uo(a, b, c) {
        if (a != null) {
            if (b != null) {
                a.axes.remove(b);
            }
            a.axes.add(c);
        }
        if (this.aw) {
            this.le(c);
        }
    }
    get pz() {
        return TypeRegistrar.isRegistered("IgxZoomSliderComponent");
    }
    tu(a, b) {
        this.ur();
    }
    ps(a, b) {
        if (b <= (0)) {
            return false;
        }
        switch (a) {
            case 5: return true;
            case 4:
            case 3: return b >= timeSpanFromDays(365);
            case 2: return b >= timeSpanFromDays(180);
            case 1: return b >= timeSpanFromDays(90);
            case 0: return b >= timeSpanFromDays(30);
        }
        return false;
    }
    ui() {
        let a = this.nv != null ? this.nv : new FinancialChartRangeSelectorOptionCollection(1, [5, 4, 3, 2, 1, 0]);
        let b = new FinancialChartRangeSelectorOptionCollection(0);
        let c = this.xAxis;
        let d = +(c.actualMaximumValue) - +(c.actualMinimumValue);
        for (let e of fromEnum(a)) {
            if (this.ps(e, d)) {
                b.add(e);
            }
        }
        this.nu = b;
        if (this.nx != null) {
            this.nx.v = this.nu;
        }
    }
    ty(a, b) {
        this.ui();
    }
    t3(a, b) {
        this.of = this.nx.al;
    }
    t2(a, b) {
        this.od = this.nx.aj;
    }
    tw(a, b) {
        this.ur();
    }
    tx(a, b) {
        this.ut();
    }
    t7(a, b) {
        let c = a;
        if (c.bd == null) {
            return;
        }
        if (this.pu) {
            this.up(c.bd);
        }
    }
    ua(a) {
        a.axes.clear();
        a.series.clear();
        a.gridAreaRectChanged = delegateRemove(a.gridAreaRectChanged, runOn(this, this.tv));
        if (this.volumeChart == null && this.indicatorCharts == null) {
            this.yAxis.d1 = this.volumeAxis.d1 = this.indicatorAxis.d1 = 0;
            this.xAxis.aw.visibility = this.mw;
        }
    }
    t8(a) {
        let b = a != this.zoomSliderChart;
        if (b) {
            if (this.dataChart != null) {
                a.my = new Rect(0, this.dataChart.mk.x, a.my.y, this.dataChart.mk.width, a.my.height);
            }
            let c = ((() => {
                let $ret = new SyncSettings();
                $ret.ae = "one";
                $ret.ac = true;
                $ret.ad = false;
                return $ret;
            })());
            SyncManager.d(a, c);
            SyncManager.c(a);
        }
        a.gridAreaRectChanged = delegateCombine(a.gridAreaRectChanged, runOn(this, this.tv));
        this.ew(a);
    }
    tm() {
        if (this.indicatorCharts != null || this.volumeChart != null) {
            this.lc(this.xAxis, (a) => a.visibility = 1);
        }
        for (let a = 0; a < this.p6.count; a++) {
            let b = this.p6._inner[a];
            let c = a < this.p6.count - 1 || this.volumeChart != null;
            this.lc(b, (d) => d.visibility = c ? 1 : 0);
        }
    }
    um(a, b) {
        if (a != null) {
            this.ua(a);
        }
        if (b != null) {
            this.t8(b);
        }
    }
    ux(a, b) {
        this.um(a, b);
        this.tm();
        if (this.volumeChart != null) {
            if (this.volumeAxis != null) {
                this.volumeChart.axes.add(this.volumeAxis);
                this.volumeChart.axes.add(this.volumeXAxis);
            }
            this.uf();
            this.volumeXAxis.itemsSource = this.xAxis.itemsSource;
        }
        this.uy(a, b);
    }
    tz(a, b) {
        this.uv();
    }
    uv() {
        if (this.nx == null || +(this.nx.az) == +(dateMaxValue()) || +(this.nx.ay) == +(dateMinValue()) || this.dataChart == null) {
            return;
        }
        let a = this.xAxis;
        let b = a.getWindowRectForSelection(this.nx.az, this.nx.ay);
        if (b.width == 0 || isNaN_(b.width) || isInfinity(b.width)) {
            return;
        }
        this.pv = true;
        this.dataChart.my = new Rect(0, b.left, this.dataChart.my.top, b.width, this.dataChart.my.height);
        if (this.pe != null) {
            this.pe.t = this.dataChart.mk;
        }
        if (this.pu) {
            this.up(this.dataChart);
        }
        this.pv = false;
    }
    t6(a, b) {
        this.ui();
        this.uu(true);
    }
    ts(a, b) {
        if (!this.pv) {
            if (this.pu) {
                this.up(a);
            }
            let c = false;
            let d = this.fn(() => this.uu(true), c);
            c = d.p1;
            if (this.pe != null) {
                this.pe.t = this.dataChart.mk;
            }
        }
    }
    uq(a, b, c, d) {
        if (a == null || b == null) {
            return;
        }
        if (c != -1) {
            this.pv = true;
            a.my = new Rect(0, d, a.mk.top, c, a.mk.height);
            this.pv = false;
        }
        let e = 1.7976931348623157E+308;
        let f = -1.7976931348623157E+308;
        let g = new Rect(0, 0, 0, 1, 1);
        let h = new ScalerParams(0, g, g, this.yAxis.b8, a.mo);
        for (let i of fromEnum(a.series)) {
            h.b = i.d9();
            let j = i.ao();
            let k = j == null || j.c == 1.7976931348623157E+308 || isNaN_(j.c);
            if (k) {
                continue;
            }
            let l = b.dt(j.c, h);
            let m = b.dt(j.b, h);
            f = Math.max(f, l);
            e = Math.min(e, m);
        }
        let n = a.mk.width;
        if (c != -1) {
            n = c;
        }
        let o = a.mk.left;
        if (d != -1) {
            o = d;
        }
        if (e == 1.7976931348623157E+308 || f == -1.7976931348623157E+308 || isNaN_(e) || isNaN_(f)) {
            return;
        }
        this.pv = true;
        let p = new Rect(0, o, e, n, f - e);
        a.my = p;
        this.pv = false;
    }
    up(a) {
        if (a == null) {
            return;
        }
        if (a == this.dataChart) {
            this.uq(this.dataChart, this.yAxis, -1, -1);
            if (this.volumeChart != null) {
                this.uq(this.volumeChart, this.volumeAxis, this.dataChart.mk.width, this.dataChart.mk.left);
            }
        }
        else if (a == this.volumeChart) {
            this.uq(this.volumeChart, this.volumeAxis, -1, -1);
            this.uq(this.dataChart, this.yAxis, this.volumeChart.mk.width, this.volumeChart.mk.left);
        }
    }
    t0(a, b) {
        if (this.pu) {
            this.up(a);
        }
    }
    uw() {
        if (!this.p0) {
            return;
        }
        if (this.pe != null) {
            this.pe.m();
        }
        if (this.ob == 0) {
            this.zoomSliderChart = null;
        }
        else if (this.zoomSliderChart == null) {
            this.zoomSliderChart = ((() => {
                let $ret = new XamDataChart();
                $ret.name = "ZoomSliderChart";
                return $ret;
            })());
        }
        else {
            this.ug();
        }
    }
    get py() {
        return this.pi;
    }
    set py(a) {
        let b = this.py;
        if (a != b) {
            this.pi = a;
            this.fj("YAxisIsLogarithmic", b, this.py);
        }
    }
    get rc() {
        return this.q4;
    }
    set rc(a) {
        let b = this.rc;
        if (a != b) {
            this.q4 = a;
            this.fj("YAxisLogarithmBase", b, this.rc);
        }
    }
    get qp() {
        return this.qc;
    }
    set qp(a) {
        let b = this.qp;
        if (a != b) {
            this.qc = a;
            this.fj("YAxisInterval", b, this.qp);
        }
    }
    get qr() {
        return this.qe;
    }
    set qr(a) {
        let b = this.qr;
        if (a != b) {
            this.qe = a;
            this.fj("YAxisMinimumValue", b, this.qr);
        }
    }
    get qq() {
        return this.qd;
    }
    set qq(a) {
        let b = this.qq;
        if (a != b) {
            this.qd = a;
            this.fj("YAxisMaximumValue", b, this.qq);
        }
    }
    get qs() {
        return this.qf;
    }
    set qs(a) {
        let b = this.qs;
        if (a != b) {
            this.qf = a;
            this.fj("YAxisMinorInterval", b, this.qs);
        }
    }
    get qo() {
        return this.yAxis.jw;
    }
    get qn() {
        return this.yAxis.jv;
    }
    get n4() {
        return this.n2;
    }
    set n4(a) {
        let b = this.n4;
        if (a != b) {
            this.n2 = a;
            this.fj("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.n4));
        }
    }
    get n6() {
        return this.n5;
    }
    set n6(a) {
        let b = this.n6;
        if (a != b) {
            this.n5 = a;
            this.fj("XAxisMode", enumGetBox(FinancialChartXAxisMode_$type, b), enumGetBox(FinancialChartXAxisMode_$type, this.n6));
        }
    }
    get n8() {
        return this.n7;
    }
    set n8(a) {
        let b = this.n8;
        if (a != b) {
            this.n7 = a;
            this.fj("YAxisMode", enumGetBox(FinancialChartYAxisMode_$type, b), enumGetBox(FinancialChartYAxisMode_$type, this.n8));
        }
    }
    get pt() {
        return this.pf;
    }
    set pt(a) {
        let b = this.pt;
        if (a != b) {
            this.pf = a;
            this.fj("IsToolbarVisible", b, this.pt);
        }
    }
    get nz() {
        return this.ny;
    }
    set nz(a) {
        let b = this.nz;
        if (a != b) {
            this.ny = a;
            this.fj("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.nz));
        }
    }
    get_lv() {
        return super.get_lv();
    }
    set_lv(a) {
        super.set_lv(a);
    }
    get lv() {
        return this.get_lv();
    }
    set lv(a) {
        this.set_lv(a);
    }
    get pu() {
        return this.pg;
    }
    set pu(a) {
        let b = this.pu;
        if (a != b) {
            this.pg = a;
            this.fj("IsWindowSyncedToVisibleRange", b, this.pu);
        }
    }
    get od() {
        return this.oc;
    }
    set od(a) {
        let b = this.od;
        if (a != b) {
            this.oc = a;
            this.fj("IndicatorTypes", b, this.od);
        }
    }
    get of() {
        return this.oe;
    }
    set of(a) {
        let b = this.of;
        if (a != b) {
            this.oe = a;
            this.fj("OverlayTypes", b, this.of);
        }
    }
    get indicatorCharts() {
        return this.p2;
    }
    set indicatorCharts(a) {
        let b = this.indicatorCharts;
        if (a != b) {
            this.p2 = a;
            this.fj("IndicatorCharts", b, this.indicatorCharts);
        }
    }
    get px() {
        return this.ph;
    }
    set px(a) {
        let b = this.px;
        if (a != b) {
            this.ph = a;
            this.fj("YAxisAbbreviateLargeNumbers", b, this.px);
        }
    }
    get_by() {
        return super.get_by();
    }
    set_by(a) {
        super.set_by(a);
    }
    get by() {
        return this.get_by();
    }
    set by(a) {
        this.set_by(a);
    }
    get_gr() {
        return super.get_gr();
    }
    set_gr(a) {
        super.set_gr(a);
    }
    get gr() {
        return this.get_gr();
    }
    set gr(a) {
        this.set_gr(a);
    }
    get zoomSliderChart() {
        return this.pa;
    }
    set zoomSliderChart(a) {
        let b = this.zoomSliderChart;
        if (a != b) {
            this.pa = a;
            this.fj("ZoomSliderChart", b, this.zoomSliderChart);
        }
    }
    get zoomSliderAxis() {
        return this.ou;
    }
    set zoomSliderAxis(a) {
        let b = this.zoomSliderAxis;
        if (a != b) {
            this.ou = a;
            this.fj("ZoomSliderAxis", b, this.zoomSliderAxis);
        }
    }
    get zoomSliderXAxis() {
        return this.nh;
    }
    set zoomSliderXAxis(a) {
        let b = this.zoomSliderXAxis;
        if (a != b) {
            this.nh = a;
            this.fj("ZoomSliderXAxis", b, this.zoomSliderXAxis);
        }
    }
    get ob() {
        return this.n9;
    }
    set ob(a) {
        let b = this.ob;
        if (a != b) {
            this.n9 = a;
            this.fj("ZoomSliderType", enumGetBox(FinancialChartZoomSliderType_$type, b), enumGetBox(FinancialChartZoomSliderType_$type, this.ob));
        }
    }
    get m8() {
        return this.m0;
    }
    set m8(a) {
        let b = this.m8;
        if (a != b) {
            this.m0 = a;
            this.fj("NegativeBrushes", b, this.m8);
        }
    }
    get m9() {
        return this.m1;
    }
    set m9(a) {
        let b = this.m9;
        if (a != b) {
            this.m1 = a;
            this.fj("NegativeOutlines", b, this.m9);
        }
    }
    get na() {
        return this.m2;
    }
    set na(a) {
        let b = this.na;
        if (a != b) {
            this.m2 = a;
            this.fj("OverlayBrushes", b, this.na);
        }
    }
    get nb() {
        return this.m3;
    }
    set nb(a) {
        let b = this.nb;
        if (a != b) {
            this.m3 = a;
            this.fj("OverlayOutlines", b, this.nb);
        }
    }
    get nd() {
        return this.m5;
    }
    set nd(a) {
        let b = this.nd;
        if (a != b) {
            this.m5 = a;
            this.fj("VolumeOutlines", b, this.nd);
        }
    }
    get nc() {
        return this.m4;
    }
    set nc(a) {
        let b = this.nc;
        if (a != b) {
            this.m4 = a;
            this.fj("VolumeBrushes", b, this.nc);
        }
    }
    get m7() {
        return this.mz;
    }
    set m7(a) {
        let b = this.m7;
        if (a != b) {
            this.mz = a;
            this.fj("IndicatorNegativeBrushes", b, this.m7);
        }
    }
    get m6() {
        return this.my;
    }
    set m6(a) {
        let b = this.m6;
        if (a != b) {
            this.my = a;
            this.fj("IndicatorBrushes", b, this.m6);
        }
    }
    get qm() {
        return this.qb;
    }
    set qm(a) {
        let b = this.qm;
        if (a != b) {
            this.qb = a;
            this.fj("VolumeThickness", b, this.qm);
        }
    }
    get qk() {
        return this.p9;
    }
    set qk(a) {
        let b = this.qk;
        if (a != b) {
            this.p9 = a;
            this.fj("OverlayThickness", b, this.qk);
        }
    }
    get qj() {
        return this.p8;
    }
    set qj(a) {
        let b = this.qj;
        if (a != b) {
            this.p8 = a;
            this.fj("IndicatorThickness", b, this.qj);
        }
    }
    get on() {
        return this.om;
    }
    set on(a) {
        let b = this.on;
        if (a != b) {
            this.om = a;
            this.fj("IndicatorDisplayTypes", b, this.on);
        }
    }
    get q7() {
        return this.q0;
    }
    set q7(a) {
        let b = this.q7;
        if (a != b) {
            this.q0 = a;
            this.fj("IndicatorPeriod", b, this.q7);
        }
    }
    get qi() {
        return this.p7;
    }
    set qi(a) {
        let b = this.qi;
        if (a != b) {
            this.p7 = a;
            this.fj("IndicatorMultiplier", b, this.qi);
        }
    }
    get ra() {
        return this.q3;
    }
    set ra(a) {
        let b = this.ra;
        if (a != b) {
            this.q3 = a;
            this.fj("IndicatorSmoothingPeriod", b, this.ra);
        }
    }
    get q8() {
        return this.q1;
    }
    set q8(a) {
        let b = this.q8;
        if (a != b) {
            this.q1 = a;
            this.fj("IndicatorShortPeriod", b, this.q8);
        }
    }
    get q6() {
        return this.qz;
    }
    set q6(a) {
        let b = this.q6;
        if (a != b) {
            this.qz = a;
            this.fj("IndicatorLongPeriod", b, this.q6);
        }
    }
    get q9() {
        return this.q2;
    }
    set q9(a) {
        let b = this.q9;
        if (a != b) {
            this.q2 = a;
            this.fj("IndicatorSignalPeriod", b, this.q9);
        }
    }
    get nv() {
        return this.nt;
    }
    set nv(a) {
        let b = this.nv;
        if (a != b) {
            this.nt = a;
            this.fj("RangeSelectorOptions", b, this.nv);
        }
    }
    get customIndicatorNames() {
        return this.np;
    }
    set customIndicatorNames(a) {
        let b = this.np;
        if (a != b) {
            this.np = a;
            this.fj("CustomIndicatorNames", b, this.customIndicatorNames);
        }
    }
    get_a3() {
        return super.get_a3();
    }
    set_a3(a) {
        super.set_a3(a);
    }
    get a3() {
        return this.get_a3();
    }
    set a3(a) {
        this.set_a3(a);
    }
    get u2() {
        return this.u1;
    }
    set u2(a) {
        let b = this.u2;
        if (a != b) {
            this.u1 = a;
            this.fj("ZoomSliderXAxisMajorStroke", b, this.u2);
        }
    }
    get qt() {
        return this.qg;
    }
    set qt(a) {
        let b = this.qt;
        if (a != b) {
            this.qg = a;
            this.fj("ZoomSliderXAxisMajorStrokeThickness", b, this.qt);
        }
    }
}
FinancialChart.rb = 0;
FinancialChart.$t = markType(FinancialChart, 'FinancialChart', XYChart.$);
export class FinancialChartEnumCollectionPickerTool$2 extends TemplatedHtmlControl {
    constructor($tColl, $tEnum, a, b, c) {
        super(a, b, c);
        this.$tColl = null;
        this.$tEnum = null;
        this.o = null;
        this.p = null;
        this.changed = null;
        this.$tColl = $tColl;
        this.$tEnum = $tEnum;
        this.$type = this.$type.specialize(this.$tColl, this.$tEnum);
        this.o = new FinancialChartEnumCollectionPickerToolView();
        this.p = new FinancialChartEnumCollectionPickerToolViewModel();
        this.p.onSelectionChanged = runOn(this, this.w);
    }
    l(a) {
        super.l(a);
        this.o.d(this.j, this.d, this.p, this.s());
    }
    u(a) {
    }
    get n() {
        let a = Type.createInstance(this.$tColl);
        let d = this.p.selection;
        for (let c = 0; c < d.length; c++) {
            let b = d[c];
            a.add(typeCastObjTo$t(this.$tEnum, EnumUtil.parse(this.$tEnum, b, true)));
        }
        return a;
    }
    set n(a) {
        let b = this.n;
        if (!FinancialChartToolbar.ar(b, a)) {
            let c = new List$1(String_$type, 0);
            if (a != null) {
                for (let d = 0; d < a.count; d++) {
                    let e = a._inner[d];
                    c.add(stringToString$1(this.$tEnum, e));
                }
            }
            this.p.selection = c.toArray();
            this.v("Selection", b, a);
        }
    }
    w() {
        if (this.changed != null) {
            this.changed(this, EventArgs.empty);
        }
    }
    v(a, b, c) {
        switch (a) {
            case "Selection":
                this.p.updateUI();
                this.o.g(this.p);
                break;
        }
    }
    q() {
        return this.o.b(this.g);
    }
}
FinancialChartEnumCollectionPickerTool$2.$t = markType(FinancialChartEnumCollectionPickerTool$2, 'FinancialChartEnumCollectionPickerTool$2', TemplatedHtmlControl.$);
export class FinancialChartIndicatorPicker extends FinancialChartEnumCollectionPickerTool$2 {
    constructor(a, ..._rest) {
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = [null];
                    {
                        let e = c[0];
                        super(FinancialIndicatorTypeCollection.$, FinancialIndicatorType_$type, "financialChartIndicatorPicker", e, "");
                    }
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    super(FinancialIndicatorTypeCollection.$, FinancialIndicatorType_$type, "financialChartIndicatorPicker", c, "");
                }
                break;
        }
    }
    u(a) {
        super.u(a);
        if (this.p.isOpen) {
            for (let b = 0; b < a.length; b++) {
                if (a[b] == "financialChartIndicatorPickerDropDownButton") {
                    return;
                }
            }
            this.p.isOpen = false;
            this.p.updateUI();
        }
    }
    s() {
        return this.d != null ? new SRProvider(this.d).ac : null;
    }
}
FinancialChartIndicatorPicker.$t = markType(FinancialChartIndicatorPicker, 'FinancialChartIndicatorPicker', FinancialChartEnumCollectionPickerTool$2.$.specialize(FinancialIndicatorTypeCollection.$, FinancialIndicatorType_$type));
export class FinancialChartOverlayPicker extends FinancialChartEnumCollectionPickerTool$2 {
    constructor(a, ..._rest) {
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = [null];
                    {
                        let e = c[0];
                        super(FinancialOverlayTypeCollection.$, FinancialOverlayType_$type, "financialChartOverlayPicker", e, "");
                    }
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    super(FinancialOverlayTypeCollection.$, FinancialOverlayType_$type, "financialChartOverlayPicker", c, "");
                }
                break;
        }
    }
    u(a) {
        super.u(a);
        if (this.p.isOpen) {
            for (let b = 0; b < a.length; b++) {
                if (a[b] == "financialChartOverlayPickerDropDownButton") {
                    return;
                }
            }
            this.p.isOpen = false;
            this.p.updateUI();
        }
    }
    s() {
        return this.d != null ? new SRProvider(this.d).ad : null;
    }
}
FinancialChartOverlayPicker.$t = markType(FinancialChartOverlayPicker, 'FinancialChartOverlayPicker', FinancialChartEnumCollectionPickerTool$2.$.specialize(FinancialOverlayTypeCollection.$, FinancialOverlayType_$type));
export class FinancialChartToolbar extends TemplatedHtmlControl {
    constructor(a, b) {
        super("financialChartToolbar", b, "");
        this.n = null;
        this.s = null;
        this.ac = null;
        this.y = null;
        this.ag = null;
        this.o = null;
        this.q = null;
        this.x = null;
        this.av = dateMaxValue();
        this.au = dateMinValue();
        this.at = dateMaxValue();
        this.as = dateMinValue();
        this.rangeChanged = null;
        this.chartTypeChanged = null;
        this.trendLineTypeChanged = null;
        this.volumeTypeChanged = null;
        this.indicatorTypesChanged = null;
        this.overlayTypesChanged = null;
        this.aa = 0;
        this.am = 0;
        this.ae = 0;
        this.ai = null;
        this.ak = null;
        this.u = null;
        this.ap = false;
        this.n = a;
        this.x = new FinancialChartToolbarViewModel();
        this.t = new FinancialChartRangeSelector(a != null ? a.rn : null);
        this.ad = new FinancialChartTypePicker(a != null ? a.rk : null);
        this.z = new FinancialChartTrendLinePicker(1, a != null ? a.rp : null);
        this.ah = new FinancialChartVolumeTypePicker(a != null ? a.rq : null);
        this.p = new FinancialChartIndicatorPicker(1, a != null ? a.rl : null);
        this.r = new FinancialChartOverlayPicker(1, a != null ? a.rm : null);
    }
    bp(a) {
        let b = this.d.querySelector(".financialChartRangeSelector");
        this.t.g = b;
        let c = this.d.querySelector(".financialChartChartTypePicker");
        this.ad.g = c;
        let d = this.d.querySelector(".financialChartIndicatorPicker");
        this.p.g = d;
        let e = this.d.querySelector(".financialChartOverlayPicker");
        this.r.g = e;
        let f = this.d.querySelector(".financialChartTrendLineTypePicker");
        this.z.g = f;
        let g = this.d.querySelector(".financialChartVolumeTypePicker");
        this.ah.g = g;
    }
    bx(a) {
        this.p.u(a);
        this.r.u(a);
    }
    get t() {
        return this.s;
    }
    set t(a) {
        let b = this.t;
        if (a != b) {
            this.s = a;
            this.by("RangeSelector", b, this.t);
        }
    }
    get ad() {
        return this.ac;
    }
    set ad(a) {
        let b = this.ad;
        if (a != b) {
            this.ac = a;
            this.by("ChartTypePicker", b, this.ad);
        }
    }
    get z() {
        return this.y;
    }
    set z(a) {
        let b = this.z;
        if (a != b) {
            this.y = a;
            this.by("TrendLineTypePicker", b, this.z);
        }
    }
    get ah() {
        return this.ag;
    }
    set ah(a) {
        let b = this.ah;
        if (a != b) {
            this.ag = a;
            this.by("VolumeTypePicker", b, this.ah);
        }
    }
    get p() {
        return this.o;
    }
    set p(a) {
        let b = this.p;
        if (a != b) {
            this.o = a;
            this.by("IndicatorPicker", b, this.p);
        }
    }
    get r() {
        return this.q;
    }
    set r(a) {
        let b = this.r;
        if (a != b) {
            this.q = a;
            this.by("OverlayPicker", b, this.r);
        }
    }
    by(a, b, c) {
        switch (a) {
            case "RangeStart":
                if (this.t != null) {
                    this.t.s = this.ax;
                }
                break;
            case "RangeEnd":
                if (this.t != null) {
                    this.t.r = this.aw;
                }
                break;
            case "SelectionStart":
                if (this.t != null) {
                    this.t.u = this.az;
                }
                break;
            case "SelectionEnd":
                if (this.t != null) {
                    this.t.t = this.ay;
                }
                break;
            case "RangeSelector":
                let d = b;
                if (d != null) {
                    d.rangeChanged = delegateRemove(d.rangeChanged, runOn(this, this.bt));
                }
                if (this.t != null) {
                    this.t.s = this.ax;
                    this.t.r = this.aw;
                    this.t.n = this.v;
                    this.t.u = this.az;
                    this.t.t = this.ay;
                    let e = this.t;
                    e.rangeChanged = delegateCombine(e.rangeChanged, runOn(this, this.bt));
                }
                break;
            case "ChartTypePicker":
                let f = b;
                if (f != null) {
                    f.changed = delegateRemove(f.changed, runOn(this, this.bs));
                }
                if (this.ad != null) {
                    this.ad.n = this.ab;
                    let g = this.ad;
                    g.changed = delegateCombine(g.changed, runOn(this, this.bs));
                }
                break;
            case "ChartType":
                if (this.ad != null) {
                    this.ad.n = this.ab;
                }
                break;
            case "TrendLineTypePicker":
                let h = b;
                if (h != null) {
                    h.changed = delegateRemove(h.changed, runOn(this, this.bu));
                }
                if (this.z != null) {
                    this.z.n = this.an;
                    let i = this.z;
                    i.changed = delegateCombine(i.changed, runOn(this, this.bu));
                }
                break;
            case "VolumeType":
                if (this.ah != null) {
                    this.ah.n = this.af;
                }
                break;
            case "VolumeTypePicker":
                let j = b;
                if (j != null) {
                    j.changed = delegateRemove(j.changed, runOn(this, this.bv));
                }
                if (this.ah != null) {
                    this.ah.n = this.af;
                    let k = this.ah;
                    k.changed = delegateCombine(k.changed, runOn(this, this.bv));
                }
                break;
            case "TrendLineType":
                if (this.z != null) {
                    this.z.n = this.an;
                }
                break;
            case "IndicatorPicker":
                let l = b;
                if (l != null) {
                    l.changed = delegateRemove(l.changed, runOn(this, this.bq));
                }
                if (this.p != null) {
                    this.p.n = this.aj;
                    let m = this.p;
                    m.changed = delegateCombine(m.changed, runOn(this, this.bq));
                }
                break;
            case "IndicatorTypes":
                if (this.p != null) {
                    this.p.n = this.aj;
                }
                break;
            case "OverlayPicker":
                let n = b;
                if (n != null) {
                    n.changed = delegateRemove(n.changed, runOn(this, this.br));
                }
                if (this.r != null) {
                    this.r.n = this.al;
                    let o = this.r;
                    o.changed = delegateCombine(o.changed, runOn(this, this.br));
                }
                break;
            case "OverlayTypes":
                if (this.r != null) {
                    this.r.n = this.al;
                }
                break;
            case "RangeSelectorOptions":
                if (this.t != null) {
                    this.t.n = this.v;
                }
                break;
            case "IsToolbarVisible":
                if (this.g == null) {
                    break;
                }
                if (this.aq) {
                    this.g.show();
                }
                else {
                    this.g.hide();
                }
                break;
        }
    }
    br(a, b) {
        this.al = this.r.n;
        if (this.overlayTypesChanged != null) {
            this.overlayTypesChanged(this, b);
        }
    }
    bq(a, b) {
        this.aj = this.p.n;
        if (this.indicatorTypesChanged != null) {
            this.indicatorTypesChanged(this, b);
        }
    }
    bs(a, b) {
        this.ab = this.ad.n;
        if (this.chartTypeChanged != null) {
            this.chartTypeChanged(this, b);
        }
    }
    bu(a, b) {
        this.an = this.z.n;
        if (this.trendLineTypeChanged != null) {
            this.trendLineTypeChanged(this, b);
        }
    }
    bv(a, b) {
        this.af = this.ah.n;
        if (this.volumeTypeChanged != null) {
            this.volumeTypeChanged(this, b);
        }
    }
    bt(a, b) {
        this.az = this.t.u;
        this.ay = this.t.t;
        if (this.rangeChanged != null) {
            this.rangeChanged(this, b);
        }
    }
    w() {
        let a = new FinancialChartToolbarContext();
        a.container = this.d;
        a.vm = this.x;
        a.vm.financialChartChartTypePicker = ((() => {
            let $ret = new FinancialChartChartTypePickerContext();
            $ret.vm = this.ad.p;
            return $ret;
        })());
        a.vm.financialChartIndicatorPicker = ((() => {
            let $ret = new FinancialChartIndicatorPickerContext();
            $ret.vm = this.p.p;
            return $ret;
        })());
        a.vm.financialChartOverlayPicker = ((() => {
            let $ret = new FinancialChartOverlayPickerContext();
            $ret.vm = this.r.p;
            return $ret;
        })());
        a.vm.financialChartRangeSelector = ((() => {
            let $ret = new FinancialChartRangeSelectorContext();
            $ret.vm = this.t.p;
            return $ret;
        })());
        a.vm.financialChartTrendLineTypePicker = ((() => {
            let $ret = new FinancialChartTrendLinePickerContext();
            $ret.vm = this.z.p;
            return $ret;
        })());
        a.vm.financialChartVolumeTypePicker = ((() => {
            let $ret = new FinancialChartVolumeTypePickerContext();
            $ret.vm = this.ah.p;
            return $ret;
        })());
        return a;
    }
    l(a) {
        super.l(a);
        if (a == null) {
            return;
        }
        this.bw();
    }
    bw() {
    }
    get az() {
        return this.av;
    }
    set az(a) {
        let b = this.az;
        if (+a != +b) {
            this.av = a;
            this.by("SelectionStart", b, this.az);
        }
    }
    get ay() {
        return this.au;
    }
    set ay(a) {
        let b = this.ay;
        if (+a != +b) {
            this.au = a;
            this.by("SelectionEnd", b, this.ay);
        }
    }
    get ax() {
        return this.at;
    }
    set ax(a) {
        let b = this.ax;
        if (+a != +b) {
            this.at = a;
            this.by("RangeStart", b, this.ax);
        }
    }
    get aw() {
        return this.as;
    }
    set aw(a) {
        let b = this.aw;
        if (+a != +b) {
            this.as = a;
            this.by("RangeEnd", b, this.aw);
        }
    }
    bz() {
        if (this.t != null) {
            this.t.z();
        }
    }
    get ab() {
        return this.aa;
    }
    set ab(a) {
        let b = this.ab;
        if (a != b) {
            this.aa = a;
            this.by("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.ab));
        }
    }
    get an() {
        return this.am;
    }
    set an(a) {
        let b = this.an;
        if (a != b) {
            this.am = a;
            this.by("TrendLineType", enumGetBox(TrendLineType_$type, b), enumGetBox(TrendLineType_$type, this.an));
        }
    }
    get af() {
        return this.ae;
    }
    set af(a) {
        let b = this.af;
        if (a != b) {
            this.ae = a;
            this.by("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.af));
        }
    }
    get aj() {
        return this.ai;
    }
    set aj(a) {
        let b = this.aj;
        if (!FinancialChartToolbar.ar(b, a)) {
            this.ai = a;
            this.by("IndicatorTypes", b, this.aj);
        }
    }
    get al() {
        return this.ak;
    }
    set al(a) {
        let b = this.al;
        if (!FinancialChartToolbar.ar(b, a)) {
            this.ak = a;
            this.by("OverlayTypes", b, this.al);
        }
    }
    static ar(a, b) {
        if (a == b) {
            return true;
        }
        if ((a == null && b != null) || (a != null && b == null)) {
            return false;
        }
        if (a.count != b.count) {
            return false;
        }
        for (let c of fromEn(a)) {
            if (!b.contains(c)) {
                return false;
            }
        }
        return true;
    }
    ao() {
        return ((() => {
            let $ret = new FinancialChartToolbarVisualData();
            $ret.indicatorPicker = this.p == null ? null : this.p.q();
            $ret.overlayPicker = this.r == null ? null : this.r.q();
            $ret.trendLineTypePicker = this.z == null ? null : this.z.q();
            $ret.chartTypePicker = this.ad == null ? null : this.ad.q();
            $ret.volumeTypePicker = this.ah == null ? null : this.ah.q();
            $ret.rangeSelector = this.t == null ? null : this.t.q();
            return $ret;
        })());
    }
    get v() {
        return this.u;
    }
    set v(a) {
        let b = this.v;
        if (a != b) {
            this.u = a;
            this.by("RangeSelectorOptions", b, this.v);
        }
    }
    get aq() {
        return this.ap;
    }
    set aq(a) {
        let b = this.aq;
        if (a != b) {
            this.ap = a;
            this.by("IsToolbarVisible", b, this.aq);
        }
    }
}
FinancialChartToolbar.a6 = 0;
FinancialChartToolbar.$t = markType(FinancialChartToolbar, 'FinancialChartToolbar', TemplatedHtmlControl.$);
export class FinancialChartRangeSelector extends TemplatedHtmlControl {
    constructor(a) {
        super("financialChartRangeSelector", a, "");
        this.p = null;
        this.rangeChanged = null;
        this.o = null;
        this.o = new FinancialChartRangeSelectorView();
        this.p = new FinancialChartRangeSelectorViewModel();
        this.p.onRangeChanged = runOn(this, this.y);
    }
    get u() {
        return this.p.selectionStart;
    }
    set u(a) {
        this.p.selectionStart = a;
    }
    get t() {
        return this.p.selectionEnd;
    }
    set t(a) {
        this.p.selectionEnd = a;
    }
    get s() {
        return this.p.rangeStart;
    }
    set s(a) {
        this.p.rangeStart = a;
    }
    get r() {
        return this.p.rangeEnd;
    }
    set r(a) {
        this.p.rangeEnd = a;
    }
    z() {
        if (this.p.onPropertiesChanged()) {
            this.o.e(this.p);
        }
    }
    l(a) {
        super.l(a);
        this.o.d(this.d, this.p);
    }
    y() {
        if (this.rangeChanged != null) {
            this.rangeChanged(this, EventArgs.empty);
        }
    }
    q() {
        return this.o.c(this.g);
    }
    get n() {
        return this.p.options;
    }
    set n(a) {
        let b = !FinancialChartToolbar.ar(this.p.options, a);
        if (b) {
            this.p.options = a;
            if (this.o != null) {
                this.o.g(this.n);
            }
        }
    }
}
FinancialChartRangeSelector.w = 0;
FinancialChartRangeSelector.$t = markType(FinancialChartRangeSelector, 'FinancialChartRangeSelector', TemplatedHtmlControl.$);
//# sourceMappingURL=FinancialChart_combined.js.map