import { FinancialSeries } from "./FinancialSeries";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { TrendLineType } from "igniteui-angular-core/ES2015/TrendLineType";
import { DependencyProperty } from "igniteui-angular-core/ES2015/DependencyProperty";
import { Brush } from "igniteui-angular-core/ES2015/Brush";
import { PenLineCap } from "igniteui-angular-core/ES2015/PenLineCap";
import { DoubleCollection } from "igniteui-angular-core/ES2015/DoubleCollection";
import { PriceDisplayType } from "./PriceDisplayType";
import { SeriesView } from "./SeriesView";
import { Type, Point } from "igniteui-angular-core/ES2015/type";
import { CategoryFrame } from "./CategoryFrame";
import { FastItemsSourceEventAction } from "igniteui-angular-core/ES2015/FastItemsSourceEventAction";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { ITrendLineManager } from "./ITrendLineManager";
import { Axis } from "./Axis";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { AxisRange } from "./AxisRange";
import { Pool$1 } from "igniteui-angular-core/ES2015/Pool$1";
import { Path } from "igniteui-angular-core/ES2015/Path";
import { GeometryGroup } from "igniteui-angular-core/ES2015/GeometryGroup";
import { RenderingContext } from "igniteui-angular-core/ES2015/RenderingContext";
export declare class FinancialPriceSeries extends FinancialSeries implements ITrendLineSeries {
    protected bf(): SeriesView;
    ib(a: SeriesView): void;
    oy: FinancialPriceSeriesView;
    constructor();
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    pi: Brush;
    static readonly o8: DependencyProperty;
    trendLineThickness: number;
    pl: PenLineCap;
    pk: DoubleCollection;
    trendLinePeriod: number;
    o2: number;
    protected hi(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    oz: PriceDisplayType;
    protected bd(): SeriesHitTestMode;
    lb(a: Point): Rect;
    private ox(a, b);
    ak(a: Point): Rect[];
    de(a: Point, b: boolean): boolean;
    protected dh(a: Point, b: boolean): boolean;
    protected ih(a: any, b: string, c: any, d: any): void;
    private o7();
    an(a: Axis): AxisRange;
    ao(): AxisRange;
    d9(): number;
    c6(a: any): boolean;
    dt(a: Rect, b: Rect, c: SeriesView): boolean;
    od(a: CategoryFrame, b: FinancialSeriesView): void;
    hf(a: boolean, b: SeriesView): void;
    protected get_mr(): boolean;
    protected readonly mr: boolean;
    of(a: CategoryFrame, b: FinancialSeriesView): void;
    d8(): number;
    private o6(a, b, c);
    private o0(a, b);
    private o5(a, b);
    fi(a: any, b: Point): any;
    protected i6(): void;
    protected ho(a: any): void;
    pj: Brush;
    i0(a: Brush, b: Brush): void;
    static $$p: string[];
    static $t: Type;
}
export declare class FinancialPriceSeriesView extends FinancialSeriesView {
    protected by: FinancialPriceSeries;
    constructor(a: FinancialPriceSeries);
    b1: Pool$1<Path>;
    cj(): Path;
    protected b4: List$1<Path>;
    b9(a: Path): void;
    cb(a: Path): void;
    ca(a: Path): void;
    protected bt(): FinancialBucketCalculator;
    ap(): void;
    private ci;
    private ch;
    private bz;
    b0: ITrendLineManager;
    readonly b2: boolean;
    cc(): void;
    b6(): void;
    b5(): void;
    cf(): GeometryGroup;
    ce(): GeometryGroup;
    cd(): void;
    protected a8(): void;
    protected a9(): void;
    protected z(a: number): any;
    private cg;
    protected y(a: number): any;
    protected a3(a: RenderingContext, b: boolean): void;
    protected a2(a: RenderingContext, b: boolean): void;
    ai(a: any): void;
    b7(): void;
    b3: boolean;
    b8(): void;
    static $t: Type;
}
