/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { RectData } from "igniteui-angular-core/ES2015/RectData";
import { PrimitiveAppearanceData } from "igniteui-angular-core/ES2015/PrimitiveAppearanceData";
import { StringBuilder } from "igniteui-angular-core/ES2015/StringBuilder";
import { Base, markType } from "igniteui-angular-core/ES2015/type";
export class LegendItemVisualData extends Base {
    constructor() {
        super();
        this._label = null;
        this._labelBounds = null;
        this._appearance = null;
        this._labelAppearance = null;
        this.labelBounds = RectData.empty;
        this.appearance = new PrimitiveAppearanceData();
    }
    get label() {
        return this._label;
    }
    set label(a) {
        this._label = a;
    }
    get labelBounds() {
        return this._labelBounds;
    }
    set labelBounds(a) {
        this._labelBounds = a;
    }
    get appearance() {
        return this._appearance;
    }
    set appearance(a) {
        this._appearance = a;
    }
    get labelAppearance() {
        return this._labelAppearance;
    }
    set labelAppearance(a) {
        this._labelAppearance = a;
    }
    serialize() {
        let a = new StringBuilder(0);
        a.u("{");
        if (this.label != null) {
            a.u("label: \"" + this.label + "\", ");
        }
        if (this.appearance != null) {
            a.u("appearance: " + this.appearance.serialize() + ", ");
        }
        if (this.labelAppearance != null) {
            a.u("labelAppearance: " + this.labelAppearance.serialize() + ", ");
        }
        a.u("labelBounds: { left: " + this.labelBounds.left + ", top: " + this.labelBounds.top + ", width: " + this.labelBounds.width + ", height: " + this.labelBounds.height + "}");
        a.u("}");
        return a.toString();
    }
}
LegendItemVisualData.$t = markType(LegendItemVisualData, 'LegendItemVisualData');
//# sourceMappingURL=LegendItemVisualData.js.map