/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IShortPeriodLongPeriod_$type } from "./IShortPeriodLongPeriod";
import { PercentagePriceOscillatorIndicatorStrategy } from "./PercentagePriceOscillatorIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core/ES2015/type";
export class PercentagePriceOscillatorIndicator extends StrategyBasedIndicator {
    get_pr() {
        return new PercentagePriceOscillatorIndicatorStrategy();
    }
    get pr() {
        return this.get_pr();
    }
    get_p4() {
        return PercentagePriceOscillatorIndicator.$;
    }
    get p4() {
        return this.get_p4();
    }
    get shortPeriod() {
        return typeGetValue(this.c(PercentagePriceOscillatorIndicator.qd));
    }
    set shortPeriod(a) {
        this.h(PercentagePriceOscillatorIndicator.qd, a);
    }
    pz() {
        return this.shortPeriod;
    }
    get longPeriod() {
        return typeGetValue(this.c(PercentagePriceOscillatorIndicator.qc));
    }
    set longPeriod(a) {
        this.h(PercentagePriceOscillatorIndicator.qc, a);
    }
    pw() {
        return this.longPeriod;
    }
}
PercentagePriceOscillatorIndicator.qd = StrategyBasedIndicator.qb(10, PercentagePriceOscillatorIndicator.$);
PercentagePriceOscillatorIndicator.qc = StrategyBasedIndicator.p7(30, PercentagePriceOscillatorIndicator.$);
PercentagePriceOscillatorIndicator.$t = markType(PercentagePriceOscillatorIndicator, 'PercentagePriceOscillatorIndicator', StrategyBasedIndicator.$, [IShortPeriodLongPeriod_$type]);
/*<BeginStatics Name="Infragistics.Controls.Charts.PercentagePriceOscillatorIndicator" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.PercentagePriceOscillatorIndicator" />*/
//# sourceMappingURL=PercentagePriceOscillatorIndicator.js.map