import { NumericAxisRenderingParameters } from "./NumericAxisRenderingParameters";
import { IPolarRadialRenderingParameters } from "./IPolarRadialRenderingParameters";
import { Point, Type } from "igniteui-angular-core/ES2015/type";
export declare class PolarAxisRenderingParameters extends NumericAxisRenderingParameters implements IPolarRadialRenderingParameters {
    private _minLength;
    minLength: number;
    private _maxLength;
    maxLength: number;
    private _center;
    center: Point;
    private _minAngle;
    minAngle: number;
    private _maxAngle;
    maxAngle: number;
    private _crossingAngleRadians;
    crossingAngleRadians: number;
    private _effectiveMaximum;
    effectiveMaximum: number;
    static $t: Type;
}
