/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { CategoryAxisRenderingParameters } from "./CategoryAxisRenderingParameters";
import { IPolarRadialRenderingParameters_$type } from "./IPolarRadialRenderingParameters";
import { markType } from "igniteui-angular-core/ES2015/type";
export class RadialAxisRenderingParameters extends CategoryAxisRenderingParameters {
    constructor() {
        super(...arguments);
        this._minLength = 0;
        this._maxLength = 0;
        this._center = null;
        this._crossingAngleRadians = 0;
        this._minAngle = 0;
        this._maxAngle = 0;
        this._effectiveMaximum = 0;
    }
    get minLength() {
        return this._minLength;
    }
    set minLength(a) {
        this._minLength = a;
    }
    get maxLength() {
        return this._maxLength;
    }
    set maxLength(a) {
        this._maxLength = a;
    }
    get center() {
        return this._center;
    }
    set center(a) {
        this._center = a;
    }
    get crossingAngleRadians() {
        return this._crossingAngleRadians;
    }
    set crossingAngleRadians(a) {
        this._crossingAngleRadians = a;
    }
    get minAngle() {
        return this._minAngle;
    }
    set minAngle(a) {
        this._minAngle = a;
    }
    get maxAngle() {
        return this._maxAngle;
    }
    set maxAngle(a) {
        this._maxAngle = a;
    }
    get effectiveMaximum() {
        return this._effectiveMaximum;
    }
    set effectiveMaximum(a) {
        this._effectiveMaximum = a;
    }
}
RadialAxisRenderingParameters.$t = markType(RadialAxisRenderingParameters, 'RadialAxisRenderingParameters', CategoryAxisRenderingParameters.$, [IPolarRadialRenderingParameters_$type]);
//# sourceMappingURL=RadialAxisRenderingParameters.js.map