import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { SplineType } from "./SplineType";
import { SeriesView } from "./SeriesView";
import { CategoryFrame } from "./CategoryFrame";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericAxisBase } from "./NumericAxisBase";
import { CategorySeriesView } from "./CategorySeriesView";
import { CollisionAvoider } from "./CollisionAvoider";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { Point, IList$1, Type } from "igniteui-angular-core/ES2015/type";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { FastItemsSourceEventAction } from "igniteui-angular-core/ES2015/FastItemsSourceEventAction";
export declare abstract class SplineSeriesBase extends HorizontalAnchoredCategorySeries {
    protected bf(): SeriesView;
    ib(a: SeriesView): void;
    pz: SplineSeriesBaseView;
    protected get_cj(): boolean;
    readonly cj: boolean;
    protected py: number[];
    p5(a: CategoryFrame, b: Rect, c: Rect, d: CategoryAxisBase, e: NumericAxisBase, f: CategorySeriesView): void;
    p1(a: CategoryFrame, b: number[], c: CollisionAvoider, d: number, e: number, f: CategorySeriesView, g: number): boolean;
    aj(a: CategoryAxisBase, b: List$1<number[]>, c: number, d: number, e: Point, f: boolean): number[][];
    n1(a: CategoryFrame, b: CategorySeriesView): void;
    private p2(a, b, c, d, e, f, g);
    d7(a: number, b: IList$1<number>, c: number, d: number, e: number, f: number, g: number, h: boolean): number;
    p3(a: CategoryAxisBase, b: Rect, c: Rect, d: Rect): number;
    p0: SplineType;
    protected p6(): void;
    protected ih(a: any, b: string, c: any, d: any): void;
    protected hi(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    readonly useHighMarkerFidelity: boolean;
    static $$p: string[];
    static $t: Type;
}
export declare class SplineSeriesBaseView extends AnchoredCategorySeriesView {
    protected c4: SplineSeriesBase;
    constructor(a: SplineSeriesBase);
    protected ac(): void;
    static $t: Type;
}
