/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { StochRSIIndicatorStrategy } from "./StochRSIIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core/ES2015/type";
export class StochRSIIndicator extends StrategyBasedIndicator {
    get_pr() {
        return new StochRSIIndicatorStrategy();
    }
    get pr() {
        return this.get_pr();
    }
    get_p4() {
        return StochRSIIndicator.$;
    }
    get p4() {
        return this.get_p4();
    }
    get qc() {
        return typeGetValue(this.c(StochRSIIndicator.qd));
    }
    set qc(a) {
        this.h(StochRSIIndicator.qd, a);
    }
    px() {
        return this.qc;
    }
    p6(a) {
        this.qc = a;
    }
}
StochRSIIndicator.qd = StrategyBasedIndicator.p9(14, StochRSIIndicator.$);
StochRSIIndicator.$t = markType(StochRSIIndicator, 'StochRSIIndicator', StrategyBasedIndicator.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.StochRSIIndicator" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.StochRSIIndicator" />*/
//# sourceMappingURL=StochRSIIndicator.js.map