/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FinancialIndicator } from "./FinancialIndicator";
import { String_$type, Number_$type, typeCast, fromEnum, markType } from "igniteui-angular-core/ES2015/type";
import { DependencyProperty } from "igniteui-angular-core/ES2015/DependencyProperty";
import { PropertyMetadata } from "igniteui-angular-core/ES2015/PropertyMetadata";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { AxisRange } from "./AxisRange";
import { isNaN_ } from "igniteui-angular-core/ES2015/number";
export class StrategyBasedIndicator extends FinancialIndicator {
    constructor() {
        super();
        this.p5();
    }
    p5() {
        this.pq = this.pr;
        this.ab = this.p4;
    }
    px() {
        return -2147483648;
    }
    p6(a) {
    }
    pz() {
        return -2147483648;
    }
    pw() {
        return -2147483648;
    }
    static qa(a, b, c) {
        let d = DependencyProperty.i(c, Number_$type, b, new PropertyMetadata(2, a, (e, f) => (typeCast(StrategyBasedIndicator.$, e)).raisePropertyChanged(c, f.oldValue, f.newValue)));
        StrategyBasedIndicator.pu.add(c);
        return d;
    }
    static p9(a, b) {
        return StrategyBasedIndicator.qa(a, b, "Period");
    }
    static p7(a, b) {
        return StrategyBasedIndicator.qa(a, b, "LongPeriod");
    }
    static qb(a, b) {
        return StrategyBasedIndicator.qa(a, b, "ShortPeriod");
    }
    o3(a, b) {
        let c = this.l1(a, b);
        let d = this.l2(c);
        return this.pq.b(c, d);
    }
    o0(a, b) {
        let c = this.l1(a, b);
        if (b == 0) {
            return false;
        }
        if (!this.mw(this.o3(a, b))) {
            return false;
        }
        let d = this.l2(c);
        if (this.ox != null) {
            c.minimumValue = this.ox.c;
            c.maximumValue = this.ox.b;
        }
        let e = this.pq.a(c, d);
        for (let f = 0; f < this.o5 && f < c.indicatorColumn.count; f++) {
            c.indicatorColumn.item(f, NaN);
        }
        if (this.l9 != null && this.pt(c)) {
            this.l9.ck();
        }
        return e;
    }
    pt(a) {
        if (!isNaN_(a.minimumValue) && !isNaN_(a.maximumValue) && a.specifiesRange) {
            let b = this.ox;
            this.ox = new AxisRange(a.minimumValue, a.maximumValue);
            return this.ps(b, this.ox);
        }
        let c = 1.7976931348623157E+308;
        let d = -1.7976931348623157E+308;
        for (let e of fromEnum(a.indicatorColumn)) {
            if (!isNaN_(e)) {
                c = Math.min(c, e);
                d = Math.max(d, e);
            }
        }
        let f = this.ox;
        this.ox = new AxisRange(c, d);
        return this.ps(f, this.ox);
    }
    ps(a, b) {
        if (a == null || b == null) {
            return true;
        }
        if (a.c != b.c) {
            return true;
        }
        if (a.b != b.b) {
            return true;
        }
        return false;
    }
    py(a) {
        if (a == -2147483648) {
            return 0;
        }
        if (a > this.indicatorColumn.count && this.indicatorColumn.count > 0) {
            a = this.indicatorColumn.count - 1;
        }
        if (a < 1) {
            return 1;
        }
        return a;
    }
    l1(a, b) {
        let c = super.l1(a, b);
        c.indicatorColumn = this.indicatorColumn;
        c.period = this.py(this.px());
        c.shortPeriod = this.py(this.pz());
        c.longPeriod = this.py(this.pw());
        c.multiplier = this.pv();
        return c;
    }
    pv() {
        return 1;
    }
    static p8(a, b) {
        let c = DependencyProperty.i("Multiplier", Number_$type, b, new PropertyMetadata(2, a, (d, e) => (typeCast(StrategyBasedIndicator.$, d)).raisePropertyChanged("Multiplier", e.oldValue, e.newValue)));
        StrategyBasedIndicator.pu.add("Multiplier");
        return c;
    }
    ih(a, b, c, d) {
        super.ih(a, b, c, d);
        if (StrategyBasedIndicator.pu.contains(b)) {
            if (this.l9 != null && !this.l9.ck()) {
                this.l5.bs.e(this.ek);
                this.o0(0, this.indicatorColumn.count);
                if (this.oy.b2) {
                    this.oy.b0.g$i();
                }
                this.iv(false);
            }
        }
    }
}
StrategyBasedIndicator.pu = new List$1(String_$type, 0);
StrategyBasedIndicator.$t = markType(StrategyBasedIndicator, 'StrategyBasedIndicator', FinancialIndicator.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.StrategyBasedIndicator" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.StrategyBasedIndicator" />*/
//# sourceMappingURL=StrategyBasedIndicator.js.map