/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { TRIXIndicatorStrategy } from "./TRIXIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core/ES2015/type";
import { Brush } from "igniteui-angular-core/ES2015/Brush";
export class TRIXIndicator extends StrategyBasedIndicator {
    constructor() {
        super();
        this.oz = 0;
        this.trendLineBrush = ((() => {
            let $ret = new Brush();
            $ret.fill = "#565656";
            return $ret;
        })());
        this.trendLineType = 9;
        this.trendLinePeriod = 9;
    }
    get_pr() {
        return new TRIXIndicatorStrategy();
    }
    get pr() {
        return this.get_pr();
    }
    get_p4() {
        return TRIXIndicator.$;
    }
    get p4() {
        return this.get_p4();
    }
    get qc() {
        return typeGetValue(this.c(TRIXIndicator.qd));
    }
    set qc(a) {
        this.h(TRIXIndicator.qd, a);
    }
    px() {
        return this.qc;
    }
    p6(a) {
        this.qc = a;
    }
}
TRIXIndicator.qd = StrategyBasedIndicator.p9(15, TRIXIndicator.$);
TRIXIndicator.$t = markType(TRIXIndicator, 'TRIXIndicator', StrategyBasedIndicator.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.TRIXIndicator" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.TRIXIndicator" />*/
//# sourceMappingURL=TRIXIndicator.js.map