/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { Brush } from "igniteui-angular-core/ES2015/Brush";
import { DependencyProperty } from "igniteui-angular-core/ES2015/DependencyProperty";
import { Type, runOn, markType, fromEnum } from "igniteui-angular-core/ES2015/type";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { Pool$1 } from "igniteui-angular-core/ES2015/Pool$1";
import { ArrayExtension } from "igniteui-angular-core/ES2015/ArrayExtension";
import { Rectangle } from "igniteui-angular-core/ES2015/Rectangle";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { ScalerParams } from "./ScalerParams";
import { PropertyMetadata } from "igniteui-angular-core/ES2015/PropertyMetadata";
import { isNaN_ } from "igniteui-angular-core/ES2015/number";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
export class WaterfallSeries extends HorizontalAnchoredCategorySeries {
    constructor() {
        super();
        this.ab = WaterfallSeries.$;
    }
    bf() {
        return new WaterfallSeriesView(this);
    }
    ib(a) {
        super.ib(a);
        this.py = a;
    }
    preferredCategoryMode(a) {
        return 2;
    }
    get_cy() {
        return true;
    }
    get cy() {
        return this.get_cy();
    }
    i0(a, b) {
        super.i0(a, b);
        this.p9 = a;
        this.qa = b;
    }
    kq() {
        return this.p9;
    }
    get_nc() {
        return true;
    }
    get nc() {
        return this.get_nc();
    }
    ih(a, b, c, d) {
        super.ih(a, b, c, d);
        switch (b) {
            case WaterfallSeries.$$p[3]:
            case WaterfallSeries.$$p[2]:
            case WaterfallSeries.$$p[0]:
            case WaterfallSeries.$$p[1]:
                this.iv(false);
                break;
        }
    }
    de(a, b) {
        if (this.dh(a, b)) {
            return true;
        }
        if (this.ll(a, b)) {
            return true;
        }
        return false;
    }
    lb(a) {
        if (this.py == null || this.py.c5 == null || this.py.c5.count == 0 || this.xAxis == null) {
            return Rect.empty;
        }
        let b = this.py.c5;
        let c = this.kx(a);
        let d = -1;
        let e = this.xAxis.b8;
        let f = this.lf.right * 2;
        if (e) {
            d = ArrayExtension.binarySearch$1(Rectangle.$, b, (g) => {
                let h = this.py.dc(g);
                return (f - c.x) < (f - (h.left + h.width / 2)) ? -1 : ((f - c.x) > (f - (h.left + h.width / 2)) ? 1 : 0);
            });
        }
        else {
            d = ArrayExtension.binarySearch$1(Rectangle.$, b, (g) => {
                let h = this.py.dc(g);
                return c.x < (h.left + h.width / 2) ? -1 : (c.x > (h.left + h.width / 2) ? 1 : 0);
            });
        }
        if (d < 0) {
            d = ~d;
            d--;
        }
        if (d < 0) {
            d = 0;
        }
        if (d > b.count - 1) {
            d = b.count - 1;
        }
        let g = d;
        let h = d;
        if (g < 0) {
            g--;
        }
        if (h < b.count - 1) {
            h++;
        }
        let i = this.qb(g);
        let j = this.qb(d);
        let k = this.qb(h);
        let l = i.left + i.width / 2;
        let m = j.left + j.width / 2;
        let n = k.left + k.width / 2;
        let o = Math.abs(l - c.x);
        let p = Math.abs(m - c.x);
        let q = Math.abs(n - c.x);
        let r = i.containsPoint(c);
        let s = j.containsPoint(c);
        let t = k.containsPoint(c);
        if (p <= o && p <= q) {
            if (!e && t) {
                return k;
            }
            if (e && r) {
                return i;
            }
            return j;
        }
        if (o <= p && o <= q) {
            if (!e && s) {
                return j;
            }
            return i;
        }
        if (q <= p && q <= o) {
            if (e && s) {
                return j;
            }
            return k;
        }
        return Rect.empty;
    }
    qb(a) {
        return this.py.db(a);
    }
    mx() {
        return 1;
    }
    hf(a, b) {
        super.hf(a, b);
        this.py.c5.count = 0;
    }
    d8() {
        return this.pf.jj(this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi));
    }
    n4(a, b) {
        let c = b;
        super.n4(a, b);
        let d = b.bq;
        let e = b.bp;
        let f = this.getEffectiveViewport1(b);
        let g = this.pf.jj(d, e, f);
        let h = this.pz;
        let i = this.p0;
        let j;
        let k = this.op(b);
        let l = NaN;
        let m = c.c5;
        let n;
        let o = 0;
        this.mv.x(this, this.ng(), this.pf, runOn(this, this.mh), this.no(b), this.np(b));
        this.mv.p = this.pz;
        this.mv.q = this.p0;
        this.mv.j = this.pz;
        this.mv.k = this.p0;
        let p = false;
        let q = this.mv.c;
        if (q != null) {
            p = true;
        }
        let r = this.pf.cc;
        let s = this.valueColumn.count;
        let t = a.f;
        let u = this.pf;
        let v = new ScalerParams(0, d, e, this.pf.b8, f);
        let w = this.kk;
        let x = this.p9;
        let y = this.kl;
        let z = this.qa || y;
        if (a.f.count > 0) {
            j = a.f._inner[0][0] - 0.5 * g;
            let aa = a.f._inner[0][1];
            if (!isNaN_(aa)) {
                if (aa > k) {
                    n = m.item(o);
                    o++;
                    c.da(n, j, k);
                    n.width = g;
                    n.height = Math.abs(k - aa);
                    this.mv.al = x;
                    this.mv.ah = x;
                    this.mv.am = z;
                    this.mv.ai = z;
                    this.mv.f = true;
                    if (p) {
                        this.n0(t, 0, s, u, v, b.n);
                    }
                    this.mv.ae(n, false, false, false, false);
                    n.al = this.mv.j;
                    n.am = this.mv.k;
                }
                else {
                    n = m.item(o);
                    o++;
                    c.da(n, j, aa);
                    n.width = g;
                    n.height = Math.abs(aa - k);
                    this.mv.al = w;
                    this.mv.ah = w;
                    this.mv.am = y;
                    this.mv.ai = y;
                    this.mv.f = false;
                    if (p) {
                        this.n0(t, 0, s, u, v, b.n);
                    }
                    this.mv.ae(n, false, false, false, false);
                    n.al = this.mv.j;
                    n.am = this.mv.k;
                }
                l = aa;
            }
            else {
                l = k;
            }
        }
        for (let ab = 1; ab < a.f.count; ++ab) {
            let ac = a.f._inner[ab];
            j = a.f._inner[ab][0] - 0.5 * g;
            let ad = ac[1];
            if (!isNaN_(ad)) {
                n = m.item(o);
                o++;
                c.da(n, j, Math.min(l, ad));
                n.width = g;
                n.height = Math.abs(l - ad);
                this.mv.al = w;
                this.mv.ah = w;
                this.mv.am = y;
                this.mv.ai = y;
                this.mv.f = false;
                if (l > ad) {
                    if (p) {
                        this.n0(t, ab, s, u, v, b.n);
                    }
                }
                else {
                    this.mv.al = x;
                    this.mv.ah = x;
                    this.mv.am = z;
                    this.mv.ai = z;
                    this.mv.f = true;
                    if (p) {
                        this.n0(t, ab, s, u, v, b.n);
                    }
                }
                this.mv.ae(n, false, false, false, false);
                n.al = this.mv.j;
                n.am = this.mv.k;
                l = ad;
            }
        }
        m.count = o;
        b.cs(a);
    }
    get useHighMarkerFidelity() {
        return this.nj;
    }
}
WaterfallSeries.$t = markType(WaterfallSeries, 'WaterfallSeries', HorizontalAnchoredCategorySeries.$);
Type.dep(DependencyProperty, PropertyMetadata, WaterfallSeries, 'raisePropertyChanged', ['NegativeBrush:p9:p5', [Brush.$, null], 'NegativeOutline:qa:p6', [Brush.$, null], 'RadiusX:pz:p7', [1, 2], 'RadiusY:p0:p8', [1, 2]]);
export class WaterfallSeriesView extends AnchoredCategorySeriesView {
    constructor(a) {
        super(a);
        this.c4 = null;
        this.c6 = null;
        this.dd = new Rectangle();
        this.c5 = null;
        this.c4 = a;
        this.c5 = ((() => {
            let $ret = new Pool$1(Rectangle.$);
            $ret.create = runOn(this, this.de);
            $ret.activate = runOn(this, this.c7);
            $ret.disactivate = runOn(this, this.c9);
            $ret.destroy = runOn(this, this.c8);
            return $ret;
        })());
    }
    ap() {
        super.ap();
        this.c6 = new List$1(Rectangle.$, 0);
        if (!this.n) {
            this.e.ek = 4;
            this.c4.p9 = ((() => {
                let $ret = new Brush();
                $ret.fill = "#C62828";
                return $ret;
            })());
            this.c4.qa = ((() => {
                let $ret = new Brush();
                $ret.fill = "#C62828";
                return $ret;
            })());
            this.e.bj = 5;
        }
    }
    de() {
        let a = new Rectangle();
        this.c6.add(a);
        a._visibility = 1;
        return a;
    }
    c7(a) {
        a._visibility = 0;
    }
    c9(a) {
        a._visibility = 1;
    }
    c8(a) {
        this.c6.remove(a);
    }
    da(a, b, c) {
        let d = false;
        if (a.o != c) {
            d = true;
            a.o = c;
        }
        if (a.n != b) {
            d = true;
            a.n = b;
        }
        if (d) {
            this.an();
        }
    }
    z(a) {
        return this.c6._inner[a];
    }
    y(a) {
        let b = this.c6._inner[a];
        this.dd._visibility = b._visibility;
        this.dd.n = b.n;
        this.dd.o = b.o;
        this.dd.width = b.width;
        this.dd.height = b.height;
        let c = this.bl(a);
        this.dd._fill = c;
        this.dd._stroke = c;
        this.dd.ac = this.e.eo + 3;
        return this.dd;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            for (let c = 0; c < this.c6.count; c++) {
                let d = this.x(c, b);
                this.ba(d, c, b);
                a.v(d);
            }
        }
    }
    ai(a) {
        super.ai(a);
        let b = 0;
        let c = new List$1(Rectangle.$, 0);
        for (let d of fromEnum(this.c5.a)) {
            c.add(d);
        }
        c.aa((e, f) => {
            if (e.n < f.n) {
                return -1;
            }
            else if (e.n > f.n) {
                return 1;
            }
            else {
                return 0;
            }
        });
        for (let e of fromEnum(c)) {
            let f = "Negative";
            if (e._fill == this.e.kk) {
                f = "Positive";
            }
            this.e.a2.exportRectangleData(a, e, "column" + b, ["Main", f]);
        }
        b++;
    }
    db(a) {
        let b = this.c5.item(a);
        return new Rect(0, b.n, b.o, b.width, b.height);
    }
    dc(a) {
        return new Rect(0, a.n, a.o, a.width, a.height);
    }
}
WaterfallSeriesView.$t = markType(WaterfallSeriesView, 'WaterfallSeriesView', AnchoredCategorySeriesView.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.WaterfallSeries" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.WaterfallSeries" />*/
//# sourceMappingURL=WaterfallSeries_combined.js.map