/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { AnnotationFactoryManager } from './AnnotationFactoryManager';
import { TypeRegistrar } from "igniteui-angular-core/ES2015/type";
import { IgxCrosshairLayerModule } from "igniteui-angular-charts/ES2015/igx-crosshair-layer-module";
import { IgxCategoryToolTipLayerModule } from "igniteui-angular-charts/ES2015/igx-category-tool-tip-layer-module";
import { IgxItemToolTipLayerModule } from "igniteui-angular-charts/ES2015/igx-item-tool-tip-layer-module";
import { IgxCategoryItemHighlightLayerModule } from "igniteui-angular-charts/ES2015/igx-category-item-highlight-layer-module";
import { IgxCategoryHighlightLayerModule } from "igniteui-angular-charts/ES2015/igx-category-highlight-layer-module";
import { IgxFinalValueLayerModule } from "igniteui-angular-charts/ES2015/igx-final-value-layer-module";
export class IgxDataChartAnnotationModule {
    constructor() {
        TypeRegistrar.register("AnnotationFactoryManager", AnnotationFactoryManager.$type);
    }
}
IgxDataChartAnnotationModule.decorators = [
    { type: NgModule, args: [{
                declarations: [],
                exports: [IgxCrosshairLayerModule,
                    IgxCategoryToolTipLayerModule,
                    IgxItemToolTipLayerModule,
                    IgxCategoryItemHighlightLayerModule,
                    IgxCategoryHighlightLayerModule,
                    IgxFinalValueLayerModule],
                imports: [CommonModule,
                    IgxCrosshairLayerModule,
                    IgxCategoryToolTipLayerModule,
                    IgxItemToolTipLayerModule,
                    IgxCategoryItemHighlightLayerModule,
                    IgxCategoryHighlightLayerModule,
                    IgxFinalValueLayerModule]
            },] },
];
/** @nocollapse */
IgxDataChartAnnotationModule.ctorParameters = () => [];
//# sourceMappingURL=igx-data-chart-annotation-module.js.map