import { IgxSeriesComponent } from "./igx-series-component";
import { DomainChartSeriesPointerEventArgs as DomainChartSeriesPointerEventArgs_internal } from "./DomainChartSeriesPointerEventArgs";
/**
 * Represents event arguments for chart's SeriesAdded and SeriesRemoved events
*/
export declare class DomainChartSeriesPointerEventArgs {
    protected _implementation: any;
    readonly i: DomainChartSeriesPointerEventArgs_internal;
    private onImplementationCreated();
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets the series hit by the pointer.
    */
    readonly series: IgxSeriesComponent;
    /**
     * Gets the item hit by the pointer.
    */
    readonly item: any;
}
