import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { IgxItemLegendComponent } from './igx-item-legend-component';
import { TypeRegistrar } from "igniteui-angular-core/ES2015/type";
import { LegendTemplates } from './LegendTemplates';
export class IgxItemLegendModule {
    constructor() {
        TypeRegistrar.register("LegendTemplates", LegendTemplates.$type);
    }
}
IgxItemLegendModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                ],
                declarations: [
                    IgxItemLegendComponent
                ],
                exports: [
                    IgxItemLegendComponent
                ]
            },] },
];
/** @nocollapse */
IgxItemLegendModule.ctorParameters = () => [];
//# sourceMappingURL=igx-item-legend-module.js.map