import { Type } from '@angular/core';
import { IgxNumericYAxisComponent } from "./igx-numeric-y-axis-component";
import { IgxAxisComponent } from "./igx-axis-component";
import { PercentChangeYAxis } from "./PercentChangeYAxis";
/**
 * A horizontal axis that uses a DateTime scale.
*/
export declare const IgxPercentChangeYAxisComponent_PROVIDERS: {
    provide: typeof IgxAxisComponent;
    useExisting: Type<any>;
}[];
export declare class IgxPercentChangeYAxisComponent extends IgxNumericYAxisComponent {
    protected createImplementation(): PercentChangeYAxis;
    readonly i: PercentChangeYAxis;
    constructor();
}
