import { IgCollection } from "igniteui-angular-core/ES2015/IgCollection";
import { markType } from "igniteui-angular-core/ES2015/type";
import { SyncableObservableCollection$2 } from "igniteui-angular-core/ES2015/SyncableObservableCollection$2";
import { TimeAxisLabelFormat as TimeAxisLabelFormat_internal } from './TimeAxisLabelFormat';
import { TimeAxisLabelFormat as TimeAxisLabelFormat } from './igx-time-axis-label-format';
export class TimeAxisLabelFormatCollection extends IgCollection {
    constructor(list) {
        super();
        if (!TimeAxisLabelFormat.$type) {
            TimeAxisLabelFormat.$type = markType(TimeAxisLabelFormat, "TimeAxisLabelFormat");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!TimeAxisLabelFormat.$type) {
            TimeAxisLabelFormat.$type = markType(TimeAxisLabelFormat, "TimeAxisLabelFormat");
        }
        let coll = new SyncableObservableCollection$2(TimeAxisLabelFormat.$type, TimeAxisLabelFormat_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new TimeAxisLabelFormat();
                ext._implementation = int;
            }
            return ext;
        };
        return coll;
    }
}
//# sourceMappingURL=igx-time-axis-label-format-collection.js.map