import { AxisLabelPanelBase } from "./AxisLabelPanelBase";
import { Point, Type, IList$1 } from "igniteui-angular-core/ES5/type";
import { AxisLabelPanelBaseView } from "./AxisLabelPanelBaseView";
import { Rect } from "igniteui-angular-core/ES5/Rect";
import { Axis } from "./Axis";
import { List$1 } from "igniteui-angular-core/ES5/List$1";
import { AxisLabelsLocation } from "./AxisLabelsLocation";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { IAngleScaler } from "./IAngleScaler";
import { CategoryAxisRenderer } from "./CategoryAxisRenderer";
import { DependencyProperty } from "igniteui-angular-core/ES5/DependencyProperty";
import { AxisOrientation } from "./AxisOrientation";
import { AxisView } from "./AxisView";
import { PolarAxisRenderingManager } from "./PolarAxisRenderingManager";
import { ScalerParams } from "./ScalerParams";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { NumericAxisBase } from "./NumericAxisBase";
import { NumericAxisRenderer } from "./NumericAxisRenderer";
import { NumericAxisRenderingParameters } from "./NumericAxisRenderingParameters";
import { GeometryGroup } from "igniteui-angular-core/ES5/GeometryGroup";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
import { NumericAxisBaseView } from "./NumericAxisBaseView";
export declare class AngleAxisLabelPanel extends AxisLabelPanelBase {
    ad(): AxisLabelPanelBaseView;
    b8(a: AxisLabelPanelBaseView): void;
    cs: AngleAxisLabelPanelView;
    constructor();
    ct: boolean;
    cz: (arg1: number) => Point;
    ao(a: number, b: Rect): boolean;
    cx: number;
    cu: number;
    cw: number;
    cv: number;
    ay(): List$1<Rect>;
    private cy();
    ah(): AxisLabelsLocation;
    as(a: AxisLabelsLocation): boolean;
    static $t: Type;
}
export declare class CategoryAngleAxis extends CategoryAxisBase implements IAngleScaler {
    a1(): AxisView;
    gl(a: AxisView): void;
    kp: CategoryAngleAxisView;
    protected get_b0(): boolean;
    readonly b0: boolean;
    private ku;
    constructor();
    as(): AxisLabelPanelBase;
    kr: CategoryAxisRenderer;
    private kv;
    private k9(a);
    private kz;
    private kq();
    private lo(a, b, c, d, e);
    private k3();
    private ko(a, b, c, d);
    getMinMaxAngle(a: Rect, b: number, c: number): {
        p1: number;
        p2: number;
    };
    ac(): void;
    private ks;
    kt: NumericRadiusAxis;
    ah(): Axis;
    la: number;
    private k0;
    getCategorySize(a: Rect, b: Rect, c: Rect): number;
    jj(a: Rect, b: Rect, c: Rect): number;
    getGroupCenter(a: number, b: Rect, c: Rect, d: Rect): number;
    k6(a: number): number;
    protected g0(a: boolean): void;
    k5(a: Rect, b: Rect): number;
    k4(a: Rect, b: Rect): number;
    getScaledAngle(a: number): number;
    getUnscaledAngle(a: number): number;
    dt(a: number, b: ScalerParams): number;
    dw(a: number, b: ScalerParams): number;
    protected gn(a: any, b: string, c: any, d: any): void;
    private li();
    lk(a: NumericRadiusAxis): void;
    static readonly ll: DependencyProperty;
    k7: number;
    private kx;
    k1: number;
    d4(): number;
    static readonly lm: DependencyProperty;
    k8: number;
    private ky;
    k2: number;
    protected kw(): boolean;
    protected get_az(): AxisOrientation;
    readonly az: AxisOrientation;
    cm(): boolean;
    private lb;
    lc: number;
    readonly isVertical: boolean;
    j$c(a: number, b: ScalerParams): number;
    j$b(a: number, b: ScalerParams): number;
    j$d(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$e(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    readonly j$a: boolean;
    static $$p: string[];
    static $t: Type;
}
export declare class NumericAngleAxis extends NumericAxisBase implements IAngleScaler {
    a1(): AxisView;
    gl(a: AxisView): void;
    k4: NumericAngleAxisView;
    k7: PolarAxisRenderingManager;
    protected get_b0(): boolean;
    readonly b0: boolean;
    constructor();
    as(): AxisLabelPanelBase;
    private lb();
    private ld(a);
    private k8;
    private k9;
    i5(): NumericAxisRenderer;
    private lk(a, b, c, d, e);
    dt(a: number, b: ScalerParams): number;
    getScaledAngle1(a: number, b: boolean, c: boolean): number;
    getScaledAngle(a: number): number;
    dw(a: number, b: ScalerParams): number;
    getUnscaledAngle(a: number): number;
    le: number;
    private la;
    protected gn(a: any, b: string, c: any, d: any): void;
    private lg();
    i9(): NumericAxisRenderingParameters;
    i8(a: Rect, b: Rect, c: Rect, d: Rect): NumericAxisRenderingParameters;
    getMinMaxAngle(a: Rect, b: number, c: number): {
        p1: number;
        p2: number;
    };
    protected g0(a: boolean): void;
    private k5;
    k6: NumericRadiusAxis;
    ah(): Axis;
    li(a: NumericRadiusAxis): void;
    protected ha(a: Rect, b: Rect): void;
    protected get_az(): AxisOrientation;
    readonly az: AxisOrientation;
    static $$p: string[];
    static $t: Type;
}
export declare class NumericRadiusAxis extends NumericAxisBase {
    a1(): AxisView;
    gl(a: AxisView): void;
    k6: NumericRadiusAxisView;
    protected get_cb(): boolean;
    readonly cb: boolean;
    ds(): number;
    private lf();
    private le();
    private k7;
    constructor();
    as(): AxisLabelPanelBase;
    k8: boolean;
    private lc(a);
    private k9;
    i5(): NumericAxisRenderer;
    dt(a: number, b: ScalerParams): number;
    li(a: number, b: boolean, c: boolean, d: number, e: number): number;
    lh(a: number): number;
    lj(a: number): number;
    dw(a: number, b: ScalerParams): number;
    ll: number;
    lb: number;
    lk: number;
    la: number;
    protected gn(a: any, b: string, c: any, d: any): void;
    protected ld: number;
    lq(a: Axis): void;
    private k4;
    k5: Axis;
    ah(): Axis;
    i9(): NumericAxisRenderingParameters;
    i8(a: Rect, b: Rect, c: Rect, d: Rect): NumericAxisRenderingParameters;
    private lr(a, b, c, d);
    private lm(a, b, c, d, e);
    lg(): number;
    ku(a: AxisRangeChangedEventArgs): void;
    protected g0(a: boolean): void;
    protected ha(a: Rect, b: Rect): void;
    lp(a: GeometryGroup, b: Rect, c: Rect, d: Rect, e: Rect): void;
    protected get_az(): AxisOrientation;
    readonly az: AxisOrientation;
    static $$p: string[];
    static $t: Type;
}
export declare class AngleAxisLabelPanelView extends AxisLabelPanelBaseView {
    protected ax: AngleAxisLabelPanel;
    constructor(a: AngleAxisLabelPanel);
    am(): void;
    ay(a: List$1<Rect>, b: List$1<boolean>): void;
    o(): number;
    p(): number;
    q(): number;
    r(): number;
    static $t: Type;
}
export declare class CategoryAngleAxisView extends CategoryAxisBaseView {
    protected bf: CategoryAngleAxis;
    constructor(a: CategoryAngleAxis);
    static $t: Type;
}
export declare class NumericAngleAxisView extends NumericAxisBaseView {
    protected bf: NumericAngleAxis;
    constructor(a: NumericAngleAxis);
    static $t: Type;
}
export declare class NumericRadiusAxisView extends NumericAxisBaseView {
    protected bf: NumericRadiusAxis;
    constructor(a: NumericRadiusAxis);
    static $t: Type;
}
