import { Series } from "./Series";
import { Point, Type } from "igniteui-angular-core/ES5/type";
import { Frame } from "./Frame";
import { SeriesView } from "./SeriesView";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { NotifyCollectionChangedEventArgs } from "igniteui-angular-core/ES5/NotifyCollectionChangedEventArgs";
import { Axis } from "./Axis";
import { Brush } from "igniteui-angular-core/ES5/Brush";
import { Rect } from "igniteui-angular-core/ES5/Rect";
import { Tuple$2 } from "igniteui-angular-core/ES5/Tuple$2";
export declare abstract class AnnotationLayer extends Series {
    constructor();
    protected bf(): SeriesView;
    ib(a: SeriesView): void;
    protected ln(a: Series): boolean;
    protected lh: AnnotationLayerView;
    lp: boolean;
    lq: boolean;
    mh: Point;
    lm: boolean;
    protected get_cl(): boolean;
    readonly cl: boolean;
    protected bd(): SeriesHitTestMode;
    protected get_cv(): boolean;
    readonly cv: boolean;
    protected get_isUsableInLegend(): boolean;
    readonly isUsableInLegend: boolean;
    protected ih(a: any, b: string, c: any, d: any): void;
    protected mi: Point;
    private l9(a);
    private l8(a);
    private l4(a);
    private l3(a);
    private lx(a, b);
    private l7(a, b);
    protected lz(a: Axis, b: boolean): void;
    protected l0(a: Series, b: boolean): void;
    private l6(a, b);
    private lw(a, b);
    protected me(): Brush;
    protected mf(): Brush;
    protected ly(a: NotifyCollectionChangedEventArgs): void;
    protected l1(a: NotifyCollectionChangedEventArgs): void;
    protected lj: Frame;
    protected li: Frame;
    protected lk: Frame;
    protected ja(a: Rect, b: Rect): void;
    protected i9(a: Rect, b: Rect): void;
    iw(a: boolean): void;
    protected get_ci(): boolean;
    readonly ci: boolean;
    protected l2(a: Frame, b: SeriesView): void;
    protected l5(a: Frame, b: SeriesView): void;
    protected lv(a: Series): Tuple$2<boolean, Point>;
    protected h6(a: Point): void;
    mg: Point;
    dt(a: Rect, b: Rect, c: SeriesView): boolean;
    protected get_dp(): boolean;
    readonly dp: boolean;
    private ll;
    lo: boolean;
    static $$p: string[];
    static $t: Type;
}
export declare class AnnotationLayerView extends SeriesView {
    constructor(a: AnnotationLayer);
    protected bs: AnnotationLayer;
    private bt;
    private bu;
    private by();
    bv(): void;
    bx(): void;
    bw(): void;
    static $t: Type;
}
