/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { Brush } from "igniteui-angular-core/ES5/Brush";
import { XYChart } from "./XYChart";
import { IndicatorPane } from "./IndicatorPane";
import { BaseError, EventArgs, Base, runOn, delegateRemove, delegateCombine, typeCast, fromEnum, EnumUtil, Number_$type, String_$type, enumGetBox, Type, markType, TypeRegistrar, typeCastObjTo$t, fromEn } from "igniteui-angular-core/ES5/type";
import { ZoomSliderWidget } from "./ZoomSliderWidget";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { List$1 } from "igniteui-angular-core/ES5/List$1";
import { DataSeriesType_$type } from "igniteui-angular-core/ES5/DataSeriesType";
import { IDataSeriesAdapterRule_$type } from "igniteui-angular-core/ES5/IDataSeriesAdapterRule";
import { SimpleFinancialPriceSeriesRule } from "igniteui-angular-core/ES5/SimpleFinancialPriceSeriesRule";
import { SubCollectionsRule } from "igniteui-angular-core/ES5/SubCollectionsRule";
import { XamDataChart } from "./XamDataChart";
import { FinancialChartVolumeType_$type } from "./FinancialChartVolumeType";
import { FinancialChartXAxisMode_$type } from "./FinancialChartXAxisMode";
import { FinancialChartYAxisMode_$type } from "./FinancialChartYAxisMode";
import { FinancialChartType_$type } from "./FinancialChartType";
import { FinancialIndicatorTypeCollection } from "./FinancialIndicatorTypeCollection";
import { FinancialOverlayTypeCollection } from "./FinancialOverlayTypeCollection";
import { FinancialChartZoomSliderType_$type } from "./FinancialChartZoomSliderType";
import { BrushCollection } from "igniteui-angular-core/ES5/BrushCollection";
import { FinancialChartRangeSelectorOptionCollection } from "./FinancialChartRangeSelectorOptionCollection";
import { TemplatedHtmlControl } from "./TemplatedHtmlControl";
import { FinancialChartContext } from "./FinancialChartContext";
import { FinancialChartToolbarContext } from "./FinancialChartToolbarContext";
import { FinancialChartViewModel } from "./FinancialChartViewModel";
import { FinancialChartToolbarViewModel } from "./FinancialChartToolbarViewModel";
import { Rect } from "igniteui-angular-core/ES5/Rect";
import { Axis } from "./Axis";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { Series } from "./Series";
import { MarkerSeries } from "./MarkerSeries";
import { SyncSettings } from "./SyncSettings";
import { SyncManager } from "./SyncManager";
import { ArrayExtension } from "igniteui-angular-core/ES5/ArrayExtension";
import { FinancialIndicatorType_$type } from "./FinancialIndicatorType";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { FinancialChartVisualData } from "./FinancialChartVisualData";
import { FinancialOverlayType_$type } from "./FinancialOverlayType";
import { FinancialChartCustomIndicatorArgs } from "./FinancialChartCustomIndicatorArgs";
import { ObservableCollection$1 } from "igniteui-angular-core/ES5/ObservableCollection$1";
import { ScalerParams } from "./ScalerParams";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { stringReplace, stringJoin, stringIsNullOrEmpty, stringToString$1 } from "igniteui-angular-core/ES5/string";
import { timeSpanFromDays } from "igniteui-angular-core/ES5/timespan";
import { dateMaxValue, dateMinValue } from "igniteui-angular-core/ES5/date";
import { isNaN_, isInfinity } from "igniteui-angular-core/ES5/number";
import { FinancialChartEnumCollectionPickerToolViewModel } from "./FinancialChartEnumCollectionPickerToolViewModel";
import { FinancialChartEnumCollectionPickerToolView } from "./FinancialChartEnumCollectionPickerToolView";
import { SRProvider } from "igniteui-angular-core/ES5/SRProvider";
import { FinancialChartTypePicker } from "./FinancialChartTypePicker";
import { FinancialChartTrendLinePicker } from "./FinancialChartTrendLinePicker";
import { FinancialChartVolumeTypePicker } from "./FinancialChartVolumeTypePicker";
import { TrendLineType_$type } from "igniteui-angular-core/ES5/TrendLineType";
import { FinancialChartChartTypePickerContext } from "./FinancialChartChartTypePickerContext";
import { FinancialChartIndicatorPickerContext } from "./FinancialChartIndicatorPickerContext";
import { FinancialChartOverlayPickerContext } from "./FinancialChartOverlayPickerContext";
import { FinancialChartRangeSelectorContext } from "./FinancialChartRangeSelectorContext";
import { FinancialChartTrendLinePickerContext } from "./FinancialChartTrendLinePickerContext";
import { FinancialChartVolumeTypePickerContext } from "./FinancialChartVolumeTypePickerContext";
import { FinancialChartToolbarVisualData } from "./FinancialChartToolbarVisualData";
import { FinancialChartRangeSelectorViewModel } from "./FinancialChartRangeSelectorViewModel";
import { FinancialChartRangeSelectorView } from "./FinancialChartRangeSelectorView";
var FinancialChart = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialChart, _super);
    function FinancialChart() {
        var _this = _super.call(this) || this;
        _this.oo = null;
        _this.qy = null;
        _this.qw = null;
        _this.qu = null;
        _this.qv = null;
        _this.qx = null;
        _this.nw = null;
        _this.rg = null;
        _this.rh = null;
        _this.rd = null;
        _this.ri = null;
        _this.rj = null;
        _this.re = null;
        _this.rf = null;
        _this.pd = null;
        _this.qa = 40;
        _this.oi = null;
        _this.og = null;
        _this.ok = null;
        _this.op = null;
        _this.rr = null;
        _this.o9 = null;
        _this.pw = false;
        _this.pv = false;
        _this.pi = false;
        _this.q4 = 10;
        _this.qc = NaN;
        _this.qe = NaN;
        _this.qd = NaN;
        _this.qf = 0;
        _this.n2 = 0;
        _this.n5 = 0;
        _this.n7 = 0;
        _this.pf = true;
        _this.ny = 0;
        _this.pg = false;
        _this.oc = null;
        _this.oe = null;
        _this.p2 = null;
        _this.ph = true;
        _this.pa = null;
        _this.n9 = 1;
        _this.m0 = null;
        _this.m1 = null;
        _this.m2 = null;
        _this.m3 = null;
        _this.m5 = null;
        _this.m4 = null;
        _this.mz = null;
        _this.my = null;
        _this.qb = 1;
        _this.p9 = 1;
        _this.p8 = 1;
        _this.om = null;
        _this.q0 = -2147483648;
        _this.p7 = 2;
        _this.q3 = 3;
        _this.q1 = 10;
        _this.qz = 30;
        _this.q2 = 9;
        _this.nt = null;
        _this.nu = null;
        _this.np = null;
        _this.applyCustomIndicators = null;
        _this.u1 = null;
        _this.qg = 1;
        _this.eo();
        _this.ud();
        return _this;
    }
    FinancialChart.prototype.fl = function (a, b, c) {
        _super.prototype.fl.call(this, a, b, c);
        switch (a) {
            case "ToolbarTemplate":
            case "RangeSelectorTemplate":
                this.nx = new FinancialChartToolbar(this, this.ro);
                break;
            case "Toolbar":
                var d = b;
                if (d != null) {
                    d.chartTypeChanged = delegateRemove(d.chartTypeChanged, runOn(this, this.t1));
                    d.trendLineTypeChanged = delegateRemove(d.trendLineTypeChanged, runOn(this, this.t4));
                    d.volumeTypeChanged = delegateRemove(d.volumeTypeChanged, runOn(this, this.t5));
                    d.l(null);
                }
                if (this.nx != null) {
                    this.nx.af = this.n4;
                    this.nx.an = this.ai;
                    this.nx.ab = this.nz;
                    this.nx.aq = this.pt;
                    if (this.qv != null) {
                        this.nx.l(this.qv);
                    }
                    var e = this.nx;
                    e.chartTypeChanged = delegateCombine(e.chartTypeChanged, runOn(this, this.t1));
                    ;
                    var f = this.nx;
                    f.trendLineTypeChanged = delegateCombine(f.trendLineTypeChanged, runOn(this, this.t4));
                    var g = this.nx;
                    g.volumeTypeChanged = delegateCombine(g.volumeTypeChanged, runOn(this, this.t5));
                }
                break;
            case "ChartType":
                if (this.nx != null) {
                    this.nx.ab = this.nz;
                }
                break;
            case "VolumeType":
                if (this.nx != null) {
                    this.nx.af = this.n4;
                }
                break;
            case "TrendLineType":
                if (this.nx != null) {
                    this.nx.an = this.ai;
                }
                break;
            case "IsToolbarVisible":
                if (this.nx == null) {
                    break;
                }
                this.nx.aq = this.pt;
                this.setGridRows();
                break;
        }
    };
    FinancialChart.prototype.t5 = function (a, b) {
        this.n4 = this.nx.af;
    };
    FinancialChart.prototype.t4 = function (a, b) {
        this.ai = this.nx.an;
    };
    FinancialChart.prototype.t1 = function (a, b) {
        this.nz = this.nx.ab;
    };
    FinancialChart.prototype.ud = function () {
        this.oo = new IndicatorPane();
    };
    FinancialChart.prototype.provideGrid = function (a) {
        this.qy = a;
        this.uw();
        this.setGridRows();
        if (this.nx != null) {
            this.nx.bp(a);
        }
    };
    FinancialChart.prototype.onDocumentClick = function (a) {
        if (this.nx != null) {
            this.nx.bx(a);
        }
    };
    FinancialChart.prototype.po = function () {
        return (navigator.userAgent.indexOf("Trident/7") >= 0);
    };
    FinancialChart.prototype.getContext = function () {
        var a = this.nx.w();
        var b = new FinancialChartContext();
        b.vm = new FinancialChartViewModel();
        b.vm.toolbar = a;
        b.container = this.cm;
        b.toolbarContainer = this.qv;
        b.indicatorsContainer = this.qu;
        b.volumeContainer = this.qw;
        b.zoomContainer = this.qx;
        return b;
    };
    FinancialChart.prototype.provideContainer = function (a) {
        var b = a;
        if (b != null) {
            var c = "financialChartMainGrid";
            var d = b.createElement("div");
            d.setStyleProperty("width", "100%");
            d.setStyleProperty("height", "100%");
            if (this.nx == null) {
                this.nx = new FinancialChartToolbar(this, this.ro);
            }
            this.nx.x.isIndicatorPickerVisible = this.pk;
            this.nx.x.isOverlayPickerVisible = this.pl;
            this.qv = b.getSubRenderer(d);
            this.nx.l(this.qv);
            var e = b.createElement("div");
            e.setStyleProperty("width", "100%");
            e.setStyleProperty("height", "100%");
            var f = b.createElement("div");
            f.setStyleProperty("width", "100%");
            f.setStyleProperty("height", "100%");
            this.qu = b.getSubRenderer(f);
            var g = b.createElement("div");
            g.setStyleProperty("width", "100%");
            g.setStyleProperty("height", "100%");
            this.qw = b.getSubRenderer(g);
            var h = b.createElement("div");
            h.setStyleProperty("width", "100%");
            h.setStyleProperty("height", "100%");
            this.qx = b.getSubRenderer(h);
            a = b.getSubRenderer(e);
        }
        else {
            this.qv = null;
            if (this.nx != null) {
                this.nx.l(null);
            }
        }
        _super.prototype.provideContainer.call(this, a);
        if (this.volumeChart != null) {
            this.volumeChart.provideContainer(this.qw);
        }
        if (this.oo != null) {
            this.oo.h(this.qu);
        }
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.provideContainer(this.qx);
            if (a != null) {
                this.tn();
            }
            else {
                this.pe = null;
            }
        }
        this.setGridRows();
    };
    FinancialChart.prototype.un = function (a, b, c) {
        if (a != null) {
            a.provideContainer(null);
        }
        if (b != null) {
            b.provideContainer(c);
        }
        this.setGridRows();
    };
    FinancialChart.prototype.u0 = function (a, b) {
        this.un(a, b, this.qx);
        if (b == null) {
            return;
        }
        this.tn();
    };
    FinancialChart.prototype.tn = function () {
        var _this = this;
        if (this.qx == null) {
            return;
        }
        this.pe = ZoomSliderWidget.a(this.externalObject, this.qx.rootWrapper);
        var a = this.pe;
        a.windowRectChanged = delegateCombine(a.windowRectChanged, function (a, b) {
            if (_this.dataChart != null) {
                _this.dataChart.my = new Rect(0, _this.pe.t.left, _this.dataChart.mk.top, _this.pe.t.width, _this.dataChart.mk.height);
            }
        });
    };
    FinancialChart.prototype.uy = function (a, b) {
        this.un(a, b, this.qw);
    };
    FinancialChart.prototype.setGridRows = function () {
        if (this.qy == null) {
            return;
        }
        var a = new Array(5);
        a[0] = (this.pt ? this.ql : 0) + "px";
        a[1] = "auto";
        a[2] = this.indicatorCharts == null || this.indicatorCharts.count == 0 ? "0px" : this.indicatorCharts.count * 150 + "px";
        a[3] = this.volumeChart == null ? "0px" : "100px";
        a[4] = this.zoomSliderChart == null ? "0px" : "100px";
        if (this.pe != null) {
            var b = this.pe;
            if (a[4] == "0px") {
                b.hide();
            }
            else {
                b.show();
            }
        }
        this.qy.setStyleProperty("-ms-grid-rows", stringReplace(stringJoin.apply(void 0, tslib_1.__spread([" "], a)), "auto", "1fr"));
        this.qy.setStyleProperty("grid-template-rows", stringJoin.apply(void 0, tslib_1.__spread([" "], a)));
        if (this.cm == null) {
            return;
        }
        if (this.dataChart != null) {
            this.dataChart.notifyContainerResized();
        }
        if (this.oo != null) {
            this.oo.f();
        }
        if (this.volumeChart != null) {
            this.volumeChart.notifyContainerResized();
        }
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.notifyContainerResized();
        }
        if (this.pe != null) {
            this.pe.o();
        }
    };
    FinancialChart.prototype.e1 = function () {
        _super.prototype.e1.call(this);
        this.gr = 3;
        this.lv = 0;
        this.by = NaN;
        this.bw = 30;
        this.ay = true;
        this.a3 = false;
        if (this.dataChart != null) {
            var a = this.dataChart.bk.i.e();
            this.m8 = a.d;
            this.m9 = a.e;
            this.m7 = a.d;
            this.u2 = this.dataChart.pg;
        }
        var b = new BrushCollection();
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(116, 70, 185, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(159, 179, 40, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(46, 156, 166, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(63, 81, 181, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(154, 154, 154, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(67, 156, 71, .3)";
            return $ret;
        })()));
        this.na = b;
        var c = new BrushCollection();
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#7446B9";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#9FB328";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#2E9CA6";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#3F51B5";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#9A9A9A";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#439C47";
            return $ret;
        })()));
        this.nb = c;
    };
    FinancialChart.prototype.uj = function () {
        if (this.oo != null) {
            this.oo.b = null;
            this.oo.b = this.indicatorCharts;
        }
        this.setGridRows();
    };
    FinancialChart.prototype.uk = function () {
        this.setGridRows();
    };
    FinancialChart.prototype.us = function () {
        this.uj();
    };
    FinancialChart.prototype.ub = function () {
        if (this.pe == null || this.zoomSliderChart == null || this.dataChart == null || this.dataChart.series.count == 0) {
            return;
        }
        var a = this.cm.rootWrapper.width();
        var b = this.dataChart.mx.left + this.dataChart.mx.width;
        var c = this.dataChart.mx.left;
        var d = a - b;
        this.pe.e = c - this.pe.g;
        this.pe.d = d - this.pe.f;
        if (this.pe.d < 0) {
            var e = this.pe.d;
            this.pe.d = 0;
            this.dataChart.ei += (e * -1);
        }
        if (this.pe.e < 0) {
            var f = this.pe.e;
            this.pe.e = 0;
            this.dataChart.eg += (f * -1);
        }
        this.zoomSliderChart.eg = c;
        this.zoomSliderChart.ei = d;
        this.zoomSliderChart.ec = this.pe.c;
    };
    FinancialChart.prototype.ey = function (a) {
        _super.prototype.ey.call(this, a);
        if (a != null) {
            a.eb = 0;
        }
    };
    FinancialChart.prototype.u3 = function (a) {
        return a.md();
    };
    FinancialChart.prototype.u4 = function (a) {
        if (a == null || a.d == null || a.d.rootWrapper == null) {
            return null;
        }
        var b = a.d.rootWrapper.getOffset();
        return new Rect(0, b.left, b.top, a.d.rootWrapper.width(), a.d.rootWrapper.height());
    };
    FinancialChart.prototype.qh = function () {
        if (this.qy == null) {
            return NaN;
        }
        var a = this.qy.getOffset();
        return this.qy.width() + (a == null ? 0 : a.left);
    };
    FinancialChart.prototype.e9 = function (source_, a, b) {
        _super.prototype.e9.call(this, source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.hu(source_, a, b);
        }
    };
    FinancialChart.prototype.fa = function (source_, a, b) {
        _super.prototype.fa.call(this, source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.hv(source_, a, b);
        }
    };
    FinancialChart.prototype.e8 = function (source_) {
        _super.prototype.e8.call(this, source_);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.hr(source_);
        }
    };
    FinancialChart.prototype.fc = function (source_, a, b, c) {
        _super.prototype.fc.call(this, source_, a, b, c);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.hw(source_, a, b, c);
        }
    };
    Object.defineProperty(FinancialChart.prototype, "nx", {
        get: function () {
            return this.nw;
        },
        set: function (a) {
            var b = this.nx;
            if (a != b) {
                this.nw = a;
                this.fj("Toolbar", b, this.nx);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rn", {
        get: function () {
            return this.rg;
        },
        set: function (a) {
            var b = this.rn;
            if (a != b) {
                this.rg = a;
                this.fj("RangeSelectorTemplate", b, this.rn);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ro", {
        get: function () {
            return this.rh;
        },
        set: function (a) {
            var b = this.ro;
            if (a != b) {
                this.rh = a;
                this.fj("ToolbarTemplate", b, this.ro);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rk", {
        get: function () {
            return this.rd;
        },
        set: function (a) {
            var b = this.rk;
            if (a != b) {
                this.rd = a;
                this.fj("ChartTypePickerTemplate", b, this.rk);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rp", {
        get: function () {
            return this.ri;
        },
        set: function (a) {
            var b = this.rp;
            if (a != b) {
                this.ri = a;
                this.fj("TrendLineTypePickerTemplate", b, this.rp);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rq", {
        get: function () {
            return this.rj;
        },
        set: function (a) {
            var b = this.rq;
            if (a != b) {
                this.rj = a;
                this.fj("VolumeTypePickerTemplate", b, this.rq);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rl", {
        get: function () {
            return this.re;
        },
        set: function (a) {
            var b = this.rl;
            if (a != b) {
                this.re = a;
                this.fj("IndicatorPickerTemplate", b, this.rl);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rm", {
        get: function () {
            return this.rf;
        },
        set: function (a) {
            var b = this.rm;
            if (a != b) {
                this.rf = a;
                this.fj("OverlayPickerTemplate", b, this.rm);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "pe", {
        get: function () {
            return this.pd;
        },
        set: function (a) {
            var b = this.pe;
            if (a != b) {
                this.pd = a;
                this.fj("ZoomSlider", b, this.pe);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_bw = function () {
        return _super.prototype.get_bw.call(this);
    };
    FinancialChart.prototype.set_bw = function (a) {
        _super.prototype.set_bw.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "bw", {
        get: function () {
            return this.get_bw();
        },
        set: function (a) {
            this.set_bw(a);
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_ay = function () {
        return _super.prototype.get_ay.call(this);
    };
    FinancialChart.prototype.set_ay = function (a) {
        _super.prototype.set_ay.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "ay", {
        get: function () {
            return this.get_ay();
        },
        set: function (a) {
            this.set_ay(a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ql", {
        get: function () {
            return this.qa;
        },
        set: function (a) {
            var b = this.ql;
            if (a != b) {
                this.qa = a;
                this.fj("ToolbarHeight", b, this.ql);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "xAxis", {
        get: function () {
            return this.ng;
        },
        set: function (a) {
            var b = this.xAxis;
            if (a != b) {
                this.ng = a;
                this.fj("XAxis", b, this.xAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "yAxis", {
        get: function () {
            return this.ot;
        },
        set: function (a) {
            var b = this.yAxis;
            if (a != b) {
                this.ot = a;
                this.fj("YAxis", b, this.yAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "volumeAxis", {
        get: function () {
            return this.os;
        },
        set: function (a) {
            var b = this.volumeAxis;
            if (a != b) {
                this.os = a;
                this.fj("VolumeAxis", b, this.volumeAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "volumeXAxis", {
        get: function () {
            return this.nf;
        },
        set: function (a) {
            var b = this.volumeXAxis;
            if (a != b) {
                this.nf = a;
                this.fj("VolumeXAxis", b, this.volumeXAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorAxis", {
        get: function () {
            return this.or;
        },
        set: function (a) {
            var b = this.indicatorAxis;
            if (a != b) {
                this.or = a;
                this.fj("IndicatorAxis", b, this.indicatorAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorXAxis", {
        get: function () {
            return this.ne;
        },
        set: function (a) {
            var b = this.indicatorXAxis;
            if (a != b) {
                this.ne = a;
                this.fj("IndicatorXAxis", b, this.indicatorXAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "p4", {
        get: function () {
            return this.p1;
        },
        set: function (a) {
            var b = this.p4;
            if (a != b) {
                this.p1 = a;
                this.fj("IndicatorAxes", b, this.p4);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "p6", {
        get: function () {
            return this.p3;
        },
        set: function (a) {
            var b = this.p6;
            if (a != b) {
                this.p3 = a;
                this.fj("IndicatorXAxes", b, this.p6);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.gk = function () {
        return this.xAxis;
    };
    FinancialChart.prototype.gl = function () {
        return this.yAxis;
    };
    FinancialChart.prototype.r = function (a) {
        return 20;
    };
    FinancialChart.prototype.get_ba = function () {
        return ((function () {
            var $ret = new List$1(DataSeriesType_$type, 0);
            $ret.add(20);
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChart.prototype, "ba", {
        get: function () {
            return this.get_ba();
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_a9 = function () {
        return ((function () {
            var $ret = new List$1(IDataSeriesAdapterRule_$type, 0);
            $ret.add(new SimpleFinancialPriceSeriesRule());
            $ret.add(new SubCollectionsRule());
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChart.prototype, "a9", {
        get: function () {
            return this.get_a9();
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.nj = function (a) {
        return this.nk(a);
    };
    FinancialChart.prototype.ov = function (a) {
        return this.ow(a);
    };
    FinancialChart.prototype.ni = function (a) {
        var b = this.nj(0);
        b.name = a;
        return b;
    };
    FinancialChart.prototype.em = function () {
        this.xAxis = this.ni("xAxis");
        this.yAxis = this.ov(0);
        this.yAxis.name = "yAxis";
        this.volumeAxis = this.ov(0);
        this.volumeAxis.name = "volumeAxis";
        this.volumeXAxis = this.ni("volumeXAxis");
        this.indicatorAxis = this.ov(0);
        this.indicatorAxis.name = "indicatorAxis";
        this.indicatorXAxis = this.ni("indicatorXAxis_0");
        this.p4 = new List$1(NumericYAxis.$, 0);
        this.p6 = new List$1(CategoryAxisBase.$, 0);
        this.p4.add(this.indicatorAxis);
        this.p6.add(this.indicatorXAxis);
        if (this.xAxis.aw == null) {
            this.xAxis.aw = new AxisLabelSettings();
        }
        if (this.yAxis.aw == null) {
            this.yAxis.aw = new AxisLabelSettings();
        }
        if (this.volumeAxis.aw == null) {
            this.volumeAxis.aw = new AxisLabelSettings();
        }
        if (this.volumeXAxis.aw == null) {
            this.volumeAxis.aw = new AxisLabelSettings();
        }
        if (this.indicatorAxis.aw == null) {
            this.indicatorAxis.aw = new AxisLabelSettings();
        }
        if (this.indicatorXAxis.aw == null) {
            this.indicatorXAxis.aw = new AxisLabelSettings();
        }
        this.zoomSliderAxis = this.ov(0);
        this.zoomSliderAxis.name = "zoomSliderAxis";
        this.zoomSliderXAxis = this.ni("zoomSliderXAxis");
        if (this.zoomSliderAxis.aw == null) {
            this.zoomSliderAxis.aw = new AxisLabelSettings();
        }
        if (this.zoomSliderXAxis.aw == null) {
            this.zoomSliderXAxis.aw = new AxisLabelSettings();
        }
    };
    FinancialChart.prototype.f2 = function (a) {
        _super.prototype.f2.call(this, a);
        a.hd();
    };
    FinancialChart.prototype.ek = function (a, b) {
        var c = typeCast(MarkerSeries.$, a);
        if (c != null) {
            c.li = this.ad(a, b);
        }
    };
    FinancialChart.prototype.fx = function (a) {
        if (a.suggestedSecondaryAxis == 2) {
            this.yAxis.jl = true;
            this.yAxis.j8 = 10;
        }
    };
    FinancialChart.prototype.f0 = function () {
        this.yAxis.jl = this.py;
        this.yAxis.j8 = this.rc;
    };
    FinancialChart.prototype.n1 = function () {
        var a;
        if (this.nz == 0) {
            if (this.s == null || this.s.dataSeries == null || this.s.dataSeries.count == 0 || stringIsNullOrEmpty(this.s.dataSeries._inner[0].getMemberPathFor(12))) {
                a = 4;
            }
            else {
                a = 1;
            }
        }
        else {
            a = this.nz;
        }
        a = this.n0(a);
        return a;
    };
    FinancialChart.prototype.n0 = function (a) {
        if ((a == 1 || a == 2)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.oa = function (a) {
        if ((a == 2 || a == 3)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 5;
        }
        if (a == 5) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 6;
        }
        if (a == 6) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.n3 = function (a) {
        if (a == 2) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 1;
        }
        if (a == 1) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.rx = function (a) {
        var b = a.getMemberPathFor(14);
        if (stringIsNullOrEmpty(b)) {
            b = a.getMemberPathFor(11);
        }
        return b;
    };
    FinancialChart.prototype.o7 = function (seriesType_) {
        return (this.externalObject.createSeries(seriesType_).i);
    };
    FinancialChart.prototype.nk = function (axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createXAxis(axisType_).i);
        }
        else {
            var a = void 0;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    };
    FinancialChart.prototype.ow = function (axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createYAxis(axisType_).i);
        }
        else {
            var a = void 0;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    };
    FinancialChart.prototype.o2 = function () {
        return this.o7(1);
    };
    FinancialChart.prototype.o3 = function () {
        return this.o7(0);
    };
    FinancialChart.prototype.o1 = function () {
        return this.o7(2);
    };
    FinancialChart.prototype.o4 = function () {
        return this.o7(20);
    };
    Object.defineProperty(FinancialChart.prototype, "pj", {
        get: function () {
            return (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy"));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "oj", {
        get: function () {
            if (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy")) {
                return TypeRegistrar.create("HorizontalAnchoredCategorySeriesProxy");
            }
            else {
                throw new BaseError(1, "horizontal series module is not loaded, but is required.");
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "pm", {
        get: function () {
            return (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy"));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "oh", {
        get: function () {
            if (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy")) {
                return TypeRegistrar.create("FinancialPriceSeriesProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "pk", {
        get: function () {
            return (TypeRegistrar.isRegistered("IndicatorProxy"));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ol", {
        get: function () {
            if (TypeRegistrar.isRegistered("IndicatorProxy")) {
                return TypeRegistrar.create("IndicatorProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "pl", {
        get: function () {
            return (TypeRegistrar.isRegistered("OverlayProxy"));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "oq", {
        get: function () {
            if (TypeRegistrar.isRegistered("OverlayProxy")) {
                return TypeRegistrar.create("OverlayProxy");
            }
            else {
                throw new BaseError(1, "overlay series module is not loaded, but is required.");
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.ag = function (a, b) {
        var c = this.rx(a);
        switch (this.n1()) {
            case 3:
                var d = this.o2();
                this.oj.setValueMemberPath(d, c);
                this.oj.setXAxis(d, this.xAxis);
                this.oj.setYAxis(d, this.yAxis);
                this.oj.setCategoryMode(d, 1);
                return d;
            case 4:
                var e = this.o3();
                this.oj.setValueMemberPath(e, c);
                this.oj.setXAxis(e, this.xAxis);
                this.oj.setYAxis(e, this.yAxis);
                this.oj.setCategoryMode(e, 1);
                return e;
            default:
            case 1:
            case 2:
                var f = this.o4();
                this.oh.setOpenMemberPath(f, a.getMemberPathFor(11));
                this.oh.setHighMemberPath(f, a.getMemberPathFor(12));
                this.oh.setLowMemberPath(f, a.getMemberPathFor(13));
                this.oh.setCloseMemberPath(f, a.getMemberPathFor(14));
                this.oh.setVolumeMemberPath(f, a.getMemberPathFor(15));
                this.oh.setXAxis(f, this.xAxis);
                this.oh.setYAxis(f, this.yAxis);
                this.oh.setDisplayType(f, this.nz == 2 ? 0 : 1);
                this.oh.setCategoryMode(f, 1);
                return f;
        }
    };
    FinancialChart.prototype.fz = function () {
        _super.prototype.fz.call(this);
        this.t9(this.xAxis);
        this.uu(false);
        if (this.n4 != 0 && this.volumeChart != null) {
            this.uf();
        }
        this.t9(this.volumeXAxis);
        this.t9(this.indicatorXAxis);
        this.ur();
        this.ut();
        if (this.ob != 0) {
            this.ug();
            this.t9(this.zoomSliderXAxis);
        }
    };
    FinancialChart.prototype.lj = function (a, b) {
        _super.prototype.lj.call(this, a, b);
        a(this.volumeXAxis);
        if (this.p6 != null) {
            try {
                for (var _a = tslib_1.__values(fromEnum(this.p6)), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var c = _b.value;
                    a(c);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        var d = true;
        switch (b) {
            case "XAxisMajorStroke":
            case "XAxisMajorStrokeThickness":
                d = false;
                break;
        }
        if (d) {
            a(this.zoomSliderXAxis);
        }
        var e_1, _c;
    };
    FinancialChart.prototype.ln = function (a, b) {
        _super.prototype.ln.call(this, a, b);
        if (b) {
            a(this.volumeAxis);
            if (this.p4 != null) {
                try {
                    for (var _a = tslib_1.__values(fromEnum(this.p4)), _b = _a.next(); !_b.done; _b = _a.next()) {
                        var c = _b.value;
                        a(c);
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            }
            a(this.zoomSliderAxis);
        }
        var e_2, _c;
    };
    FinancialChart.prototype.ll = function (a) {
        _super.prototype.ll.call(this, a);
        this.ld(this.volumeXAxis, a);
        this.ld(this.indicatorXAxis, a);
        this.ld(this.zoomSliderXAxis, a);
    };
    FinancialChart.prototype.lp = function (a) {
        _super.prototype.lp.call(this, a);
        this.ld(this.volumeAxis, a);
        this.ld(this.indicatorAxis, a);
        this.ld(this.zoomSliderAxis, a);
    };
    FinancialChart.prototype.lo = function (a) {
        _super.prototype.lo.call(this, a);
        this.lc(this.volumeAxis, a);
        this.lc(this.indicatorAxis, a);
        this.lc(this.zoomSliderAxis, a);
    };
    FinancialChart.prototype.lk = function (a) {
        _super.prototype.lk.call(this, a);
        this.lc(this.volumeXAxis, a);
        this.lc(this.indicatorXAxis, a);
        this.lc(this.zoomSliderXAxis, a);
    };
    FinancialChart.prototype.ex = function (a) {
        var _this = this;
        _super.prototype.ex.call(this, a);
        if (a == null) {
            return;
        }
        if (a == this.zoomSliderChart) {
            a.nl = a.nn = false;
            a.ay = null;
            if (this.dataChart != null) {
                a.m3 = this.dataChart.m3;
                a.m6 = this.dataChart.m6;
            }
        }
        else {
            SyncManager.d(a, ((function () {
                var $ret = new SyncSettings();
                $ret.ae = _this.sq();
                $ret.ac = true;
                $ret.ad = false;
                return $ret;
            })()));
            SyncManager.c(a);
        }
        a.bc = 2;
    };
    FinancialChart.prototype.sq = function () {
        if (this.rr == null) {
            FinancialChart.rb++;
            this.rr = FinancialChart.rb.toString();
        }
        return this.rr;
    };
    FinancialChart.prototype.tv = function (a, b) {
        this.tl();
        this.ub();
    };
    FinancialChart.prototype.tl = function () {
        if (this.yAxis.bz()) {
            return;
        }
        var a = this.yAxis.at.a5;
        if (this.n4 != 0) {
            a = Math.max(a, this.volumeAxis.at.a5);
        }
        try {
            for (var _a = tslib_1.__values(fromEnum(this.p4)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var b = _b.value;
                a = Math.max(a, b.at.a5);
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_3) throw e_3.error; }
        }
        this.yAxis.d1 = this.volumeAxis.d1 = a;
        try {
            for (var _d = tslib_1.__values(fromEnum(this.p4)), _e = _d.next(); !_e.done; _e = _d.next()) {
                var c = _e.value;
                c.d1 = a;
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (_e && !_e.done && (_f = _d.return)) _f.call(_d);
            }
            finally { if (e_4) throw e_4.error; }
        }
        this.zoomSliderAxis.d1 = this.yAxis.d1;
        var e_3, _c, e_4, _f;
    };
    FinancialChart.prototype.to = function (a) {
        if (this.indicatorCharts == null) {
            return;
        }
        for (var b = 0; b < this.indicatorCharts.count; b++) {
            var c = this.indicatorCharts._inner[b];
            for (var d = 0; d < c.series.count; d++) {
                a(c.series._inner[d], b);
            }
        }
    };
    FinancialChart.prototype.tq = function (a) {
        if (this.volumeChart == null) {
            return;
        }
        for (var b = 0; b < this.volumeChart.series.count; b++) {
            a(this.volumeChart.series._inner[b], b);
        }
    };
    FinancialChart.prototype.tp = function (a) {
        if (this.dataChart == null) {
            return;
        }
        var b = this.s == null || this.s.dataSeries == null ? 0 : this.s.dataSeries.count;
        var c = this.of == null ? 0 : this.of.count;
        for (var d = 0; d < this.dataChart.series.count; d++) {
            if (this.pq(this.dataChart.series._inner[d])) {
                continue;
            }
            var e = d - (b * c);
            a(this.dataChart.series._inner[d], e);
        }
        this.tr(a);
    };
    FinancialChart.prototype.tr = function (a) {
        if (this.zoomSliderChart == null) {
            return;
        }
        for (var b = 0; b < this.zoomSliderChart.series.count; b++) {
            a(this.zoomSliderChart.series._inner[b], b);
        }
    };
    FinancialChart.prototype.q5 = function (a, b) {
        if (a.bq != this.dataChart) {
            return b;
        }
        var c = this.s == null || this.s.dataSeries == null ? 0 : this.s.dataSeries.count;
        var d = this.of == null ? 0 : this.of.count;
        return b - (c * d);
    };
    FinancialChart.prototype.er = function (a) {
        _super.prototype.er.call(this, a);
        this.tq(a);
        this.to(a);
        this.tr(a);
    };
    Object.defineProperty(FinancialChart.prototype, "volumeChart", {
        get: function () {
            return this.o9;
        },
        set: function (a) {
            var b = this.volumeChart;
            if (a != b) {
                this.o9 = a;
                this.fj("VolumeChart", b, this.volumeChart);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.uf = function () {
        if (this.dataChart == null) {
            return;
        }
        this.volumeChart.series.clear();
        var a = new List$1(Series.$, 0);
        var b = -1;
        for (var c = 0; c < this.dataChart.series.count; c++) {
            var d = this.dataChart.series._inner[c];
            if (this.pq(d)) {
                continue;
            }
            b++;
            var e = void 0;
            var f = this.n4;
            f = this.n3(f);
            switch (f) {
                case 2:
                    e = this.o3();
                    break;
                case 3:
                    e = this.o1();
                    break;
                default:
                case 1:
                    e = this.o2();
                    break;
            }
            this.oj.setCategoryMode(e, 1);
            e.name = "volumeSeries_" + b;
            e.itemsSource = d.itemsSource;
            this.oj.setXAxis(e, this.volumeXAxis);
            this.oj.setYAxis(e, this.volumeAxis);
            this.oj.setValueMemberPath(e, this.s != null && this.s.dataSeries != null && this.s.dataSeries.count > b ? this.s.dataSeries._inner[b].getMemberPathFor(15) : null);
            e.fk = d.fk + " Volume";
            e.km = ArrayExtension.getModulus$1(Brush.$, this.nc, b);
            e.kp = ArrayExtension.getModulus$1(Brush.$, this.nd, b);
            e.eo = this.qm;
            a.add(e);
        }
        for (var g = 0; g < a.count; g++) {
            var h = a._inner[g];
            this.volumeChart.series.add(h);
            this.e2(h, g);
        }
    };
    FinancialChart.prototype.pn = function (a) {
        if (!this.pj) {
            return false;
        }
        return this.oj.matchesType(a);
    };
    FinancialChart.prototype.pr = function (a) {
        if (!this.pm) {
            return false;
        }
        return this.oh.matchesType(a);
    };
    FinancialChart.prototype.pp = function (a) {
        if (!this.pk) {
            return false;
        }
        return this.ol.matchesType(a);
    };
    FinancialChart.prototype.pq = function (a) {
        if (!this.pl) {
            return false;
        }
        return this.oq.matchesType(a);
    };
    FinancialChart.prototype.ue = function () {
        if (this.dataChart == null) {
            return;
        }
        var a = 0;
        var b = this.od == null ? 0 : this.od.count;
        var c = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        var d = b + c;
        for (var e = 0; e < d; e++) {
            var f = new List$1(Series.$, 0);
            var g = this.indicatorCharts._inner[e];
            var h = e >= b;
            var i = h ? this.customIndicatorNames._inner[e - b] : EnumUtil.getName(FinancialIndicatorType_$type, this.od._inner[e]);
            var j = -1;
            for (var k = 0; k < this.dataChart.series.count; k++) {
                var l = this.dataChart.series._inner[k];
                if (this.pq(l)) {
                    continue;
                }
                j++;
                var m = void 0;
                if (h) {
                    var n = this.o5("Custom");
                    this.ol.handleCustomIndicatorEvent(n, runOn(this, this.tt));
                    m = n;
                }
                else {
                    m = this.o8(this.od._inner[e]);
                }
                if (m == null) {
                    continue;
                }
                m.name = "indicator_" + a++;
                this.ol.setXAxis(m, this.p6._inner[e]);
                this.ol.setYAxis(m, this.p4._inner[e]);
                m.itemsSource = l.itemsSource;
                this.ol.setOpenMemberPath(m, this.s.dataSeries._inner[j].getMemberPathFor(11));
                this.ol.setHighMemberPath(m, this.s.dataSeries._inner[j].getMemberPathFor(12));
                this.ol.setLowMemberPath(m, this.s.dataSeries._inner[j].getMemberPathFor(13));
                this.ol.setCloseMemberPath(m, this.s.dataSeries._inner[j].getMemberPathFor(14));
                this.ol.setVolumeMemberPath(m, this.s.dataSeries._inner[j].getMemberPathFor(15));
                m.fk = l.fk + " " + i;
                m.km = ArrayExtension.getModulus$1(Brush.$, this.m6, e);
                m.eo = this.qj;
                if (this.pp(m)) {
                    this.ol.setNegativeBrush(m, ArrayExtension.getModulus$1(Brush.$, this.m7, e));
                    this.ol.setDisplayType(m, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.on, e));
                }
                if (this.q7 != -2147483648 && this.pp(m)) {
                    this.ol.setPeriodOverride(m, this.q7);
                }
                if (this.pp(m)) {
                    this.ol.setSmoothingPeriod(m, this.ra);
                }
                if (this.pp(m)) {
                    this.ol.setSignalPeriod(m, this.q9);
                }
                if (this.pp(m)) {
                    this.ol.setShortPeriod(m, this.q8);
                    this.ol.setLongPeriod(m, this.q6);
                }
                this.e2(m, e);
                f.add(m);
            }
            try {
                for (var _a = tslib_1.__values(fromEnum(f)), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var o = _b.value;
                    g.series.add(o);
                }
            }
            catch (e_5_1) { e_5 = { error: e_5_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_5) throw e_5.error; }
            }
        }
        var e_5, _c;
    };
    FinancialChart.prototype.o5 = function (indicatorName_) {
        return (this.externalObject.createIndicator(indicatorName_ + 'Indicator').i);
    };
    FinancialChart.prototype.o8 = function (a) {
        return this.o5(EnumUtil.getName(FinancialIndicatorType_$type, a));
    };
    FinancialChart.prototype.uu = function (a) {
        if (this.nx == null) {
            return;
        }
        var b = this.xAxis;
        if (b.actualMinimumValue > b.actualMaximumValue) {
            return;
        }
        this.nx.ax = b.actualMinimumValue;
        this.nx.aw = b.actualMaximumValue;
        if (a) {
            this.nx.az = b.visibleMinimum;
            this.nx.ay = b.visibleMaximum;
        }
        this.nx.bz();
    };
    FinancialChart.prototype.cn = function () {
        var _this = this;
        var a = ((function () {
            var $ret = new FinancialChartVisualData();
            $ret.mainChart = _super.prototype.cn.call(_this);
            $ret.volumeChart = _this.volumeChart == null ? null : _this.volumeChart.n8();
            $ret.toolbar = _this.nx == null ? null : _this.nx.ao();
            $ret.zoomChart = _this.zoomSliderChart == null ? null : _this.zoomSliderChart.n8();
            return $ret;
        })());
        if (this.indicatorCharts != null) {
            a.indicatorCharts = new List$1(Base.$, 0);
            try {
                for (var _a = tslib_1.__values(fromEnum(this.indicatorCharts)), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var b = _b.value;
                    a.indicatorCharts.add1(b.n8());
                }
            }
            catch (e_6_1) { e_6 = { error: e_6_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_6) throw e_6.error; }
            }
        }
        if (this.dataChart != null) {
            a.mainChartLeft = this.u3(this.dataChart).x;
            a.mainChartTop = this.u3(this.dataChart).y;
        }
        if (this.volumeChart != null) {
            a.volumeChartLeft = this.u3(this.volumeChart).x;
            a.volumeChartTop = this.u3(this.volumeChart).y;
        }
        if (this.zoomSliderChart != null) {
            a.zoomChartLeft = this.u3(this.zoomSliderChart).x;
            a.zoomChartTop = this.u3(this.zoomSliderChart).y;
        }
        if (this.nx != null) {
            var c = this.u4(this.nx);
            a.toolbarLeft = c.left;
            a.toolbarTop = c.top;
            a.toolbarWidth = c.width;
            a.toolbarHeight = c.height;
        }
        if (this.indicatorCharts != null) {
            a.indicatorChartLefts = new List$1(Number_$type, 0);
            a.indicatorChartTops = new List$1(Number_$type, 0);
            try {
                for (var _d = tslib_1.__values(fromEnum(this.indicatorCharts)), _e = _d.next(); !_e.done; _e = _d.next()) {
                    var d = _e.value;
                    a.indicatorChartLefts.add(this.u3(d).x);
                    a.indicatorChartTops.add(this.u3(d).y);
                }
            }
            catch (e_7_1) { e_7 = { error: e_7_1 }; }
            finally {
                try {
                    if (_e && !_e.done && (_f = _d.return)) _f.call(_d);
                }
                finally { if (e_7) throw e_7.error; }
            }
        }
        return a;
        var e_6, _c, e_7, _f;
    };
    FinancialChart.prototype.rw = function () {
        var a = this.cn();
        a.scaleByViewport();
        return a.serialize();
    };
    FinancialChart.prototype.o6 = function (overlayName_) {
        return (this.externalObject.createOverlay(overlayName_ + 'Overlay').i);
    };
    FinancialChart.prototype.ut = function () {
        if (this.dataChart == null) {
            return;
        }
        var a = new List$1(Series.$, 0);
        try {
            for (var _a = tslib_1.__values(fromEnum(this.dataChart.series)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var b = _b.value;
                if (this.pq(b)) {
                    a.add(b);
                }
            }
        }
        catch (e_8_1) { e_8 = { error: e_8_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_8) throw e_8.error; }
        }
        try {
            for (var _d = tslib_1.__values(fromEnum(a)), _e = _d.next(); !_e.done; _e = _d.next()) {
                var c = _e.value;
                this.dataChart.series.remove(c);
            }
        }
        catch (e_9_1) { e_9 = { error: e_9_1 }; }
        finally {
            try {
                if (_e && !_e.done && (_f = _d.return)) _f.call(_d);
            }
            finally { if (e_9) throw e_9.error; }
        }
        if (this.of == null) {
            return;
        }
        var d = new List$1(Series.$, 0);
        for (var e = 0; e < this.dataChart.series.count; e++) {
            var f = this.dataChart.series._inner[e];
            for (var g = 0; g < this.of.count; g++) {
                var h = this.of._inner[g];
                var i = void 0;
                switch (h) {
                    case 1:
                        i = this.o6(EnumUtil.getName(FinancialOverlayType_$type, h));
                        break;
                    default:
                    case 0:
                        i = this.o6(EnumUtil.getName(FinancialOverlayType_$type, h));
                        break;
                }
                i.name = f.name + "_" + EnumUtil.getName(FinancialOverlayType_$type, h);
                this.oq.setXAxis(i, this.xAxis);
                this.oq.setYAxis(i, this.yAxis);
                i.itemsSource = f.itemsSource;
                var j = e * this.of.count + g;
                i.km = ArrayExtension.getModulus$1(Brush.$, this.na, j);
                i.kp = ArrayExtension.getModulus$1(Brush.$, this.nb, j);
                i.eo = this.qk;
                i.fk = f.fk + " " + EnumUtil.getName(FinancialOverlayType_$type, h);
                var k = f;
                if (k == null) {
                    continue;
                }
                this.oq.setOpenMemberPath(i, this.s.dataSeries._inner[e].getMemberPathFor(11));
                this.oq.setHighMemberPath(i, this.s.dataSeries._inner[e].getMemberPathFor(12));
                this.oq.setLowMemberPath(i, this.s.dataSeries._inner[e].getMemberPathFor(13));
                this.oq.setCloseMemberPath(i, this.s.dataSeries._inner[e].getMemberPathFor(14));
                this.oq.setVolumeMemberPath(i, this.s.dataSeries._inner[e].getMemberPathFor(15));
                d.add(i);
            }
        }
        var l = new Array(this.dataChart.series.count);
        this.dataChart.series.copyTo(l, 0);
        this.dataChart.skipDataCleanup = true;
        this.dataChart.series.clear();
        this.dataChart.skipDataCleanup = false;
        for (var m = 0; m < l.length; m++) {
            l[m].e7 = -1;
        }
        d.o(l);
        try {
            for (var _g = tslib_1.__values(fromEnum(d)), _h = _g.next(); !_h.done; _h = _g.next()) {
                var n = _h.value;
                this.dataChart.series.add(n);
            }
        }
        catch (e_10_1) { e_10 = { error: e_10_1 }; }
        finally {
            try {
                if (_h && !_h.done && (_j = _g.return)) _j.call(_g);
            }
            finally { if (e_10) throw e_10.error; }
        }
        var e_8, _c, e_9, _f, e_10, _j;
    };
    FinancialChart.prototype.ur = function () {
        if (this.pw) {
            return;
        }
        this.pw = true;
        if (this.indicatorCharts != null) {
            var a = this.indicatorCharts;
            this.indicatorCharts = null;
            try {
                for (var _a = tslib_1.__values(fromEnum(a)), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var b = _b.value;
                    this.ua(b);
                }
            }
            catch (e_11_1) { e_11 = { error: e_11_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_11) throw e_11.error; }
            }
        }
        if ((this.od == null || this.od.count == 0) && (this.customIndicatorNames == null || this.customIndicatorNames.count == 0)) {
            this.indicatorCharts = null;
            this.uj();
            this.us();
            this.pw = false;
            return;
        }
        if (this.indicatorCharts == null) {
            this.indicatorCharts = new List$1(XamDataChart.$, 0);
        }
        this.indicatorCharts.clear();
        this.p4.clear();
        this.p6.clear();
        var c = this.od == null ? 0 : this.od.count;
        var d = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        var e = c + d;
        for (var f = 0; f < e; f++) {
            var g = new XamDataChart();
            this.indicatorCharts.add(g);
            this.t8(g);
            var h = f >= c;
            g.gm = h ? this.customIndicatorNames._inner[f - c] : EnumUtil.getName(FinancialIndicatorType_$type, this.od._inner[f]);
            if (this.indicatorAxis != null) {
                var i = void 0;
                var j = void 0;
                if (f == 0) {
                    i = this.indicatorAxis;
                    j = this.indicatorXAxis;
                }
                else {
                    i = new NumericYAxis();
                    if (!this.indicatorXAxis.b5) {
                        j = this.nj(0);
                    }
                    else {
                        j = this.nj(1);
                    }
                }
                j.name = "indicatorXAxis_" + f;
                i.name = "indicatorAxis_" + f;
                g.axes.add(i);
                g.axes.add(j);
                this.p4.add(i);
                this.p6.add(j);
                if (this.aw) {
                    this.lg(i);
                }
                if (this.aw) {
                    this.le(j);
                }
            }
        }
        this.ue();
        this.uj();
        if (this.nx != null) {
            this.nx.aj = this.od;
        }
        this.tm();
        this.us();
        this.pw = false;
        var e_11, _c;
    };
    FinancialChart.prototype.eu = function () {
        _super.prototype.eu.call(this);
        this.le(this.xAxis);
        this.le(this.volumeXAxis);
        if (this.p6 != null) {
            try {
                for (var _a = tslib_1.__values(fromEnum(this.p6)), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var a = _b.value;
                    this.le(a);
                }
            }
            catch (e_12_1) { e_12 = { error: e_12_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_12) throw e_12.error; }
            }
        }
        this.lg(this.yAxis);
        this.lg(this.volumeAxis);
        if (this.p4 != null) {
            try {
                for (var _d = tslib_1.__values(fromEnum(this.p4)), _e = _d.next(); !_e.done; _e = _d.next()) {
                    var b = _e.value;
                    this.lg(b);
                }
            }
            catch (e_13_1) { e_13 = { error: e_13_1 }; }
            finally {
                try {
                    if (_e && !_e.done && (_f = _d.return)) _f.call(_d);
                }
                finally { if (e_13) throw e_13.error; }
            }
        }
        this.le(this.zoomSliderXAxis);
        this.lg(this.zoomSliderAxis);
        var e_12, _c, e_13, _f;
    };
    FinancialChart.prototype.get_a2 = function () {
        return !this.pu;
    };
    Object.defineProperty(FinancialChart.prototype, "a2", {
        get: function () {
            return this.get_a2();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "p0", {
        get: function () {
            return (this.externalObject._dynamicContent);
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.uz = function (a, b) {
        this.um(a, b);
        this.tm();
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.axes.add(this.zoomSliderAxis);
            this.zoomSliderChart.axes.add(this.zoomSliderXAxis);
        }
        this.ug();
        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
        this.uk();
        this.u0(a, b);
    };
    FinancialChart.prototype.ug = function () {
        if (this.dataChart == null || this.zoomSliderChart == null) {
            return;
        }
        this.zoomSliderChart.series.clear();
        var a = new List$1(Series.$, 0);
        for (var b = 0; b < this.dataChart.series.count; b++) {
            var c = this.dataChart.series._inner[b];
            var d = void 0;
            var e = this.ob;
            e = this.oa(e);
            if (e == 1) {
                switch (this.n1()) {
                    case 1:
                        e = 2;
                        break;
                    case 2:
                        e = 3;
                        break;
                    case 3:
                        e = 4;
                        break;
                    case 4:
                        e = 5;
                        break;
                }
            }
            switch (e) {
                case 2:
                    d = this.o4();
                    this.oh.setDisplayType(d, 1);
                    break;
                case 3:
                    d = this.o4();
                    this.oh.setDisplayType(d, 0);
                    break;
                case 5:
                    d = this.o3();
                    break;
                case 6:
                    d = this.o1();
                    break;
                default:
                case 4:
                    d = this.o2();
                    break;
            }
            if (d.ck && !d.cq) {
                this.oj.setCategoryMode(d, 1);
                this.oj.setXAxis(d, this.zoomSliderXAxis);
                this.oj.setYAxis(d, this.zoomSliderAxis);
                this.oj.setValueMemberPath(d, this.s != null && this.s.dataSeries != null && this.s.dataSeries.count > b ? this.rx(this.s.dataSeries._inner[b]) : null);
            }
            else if (d.cq) {
                this.oh.setCategoryMode(d, 1);
                this.oh.setXAxis(d, this.zoomSliderXAxis);
                this.oh.setYAxis(d, this.zoomSliderAxis);
                if (this.s != null && this.s.dataSeries != null && this.s.dataSeries.count > b) {
                    this.oh.setOpenMemberPath(d, this.s.dataSeries._inner[b].getMemberPathFor(11));
                    this.oh.setHighMemberPath(d, this.s.dataSeries._inner[b].getMemberPathFor(12));
                    this.oh.setLowMemberPath(d, this.s.dataSeries._inner[b].getMemberPathFor(13));
                    this.oh.setCloseMemberPath(d, this.s.dataSeries._inner[b].getMemberPathFor(14));
                    this.oh.setVolumeMemberPath(d, this.s.dataSeries._inner[b].getMemberPathFor(15));
                }
            }
            d.name = "zoomSliderSeries_" + b;
            d.itemsSource = c.itemsSource;
            d.fk = c.fk;
            a.add(d);
        }
        for (var f = 0; f < a.count; f++) {
            var g = a._inner[f];
            this.zoomSliderChart.series.add(g);
            this.e2(g, f);
        }
    };
    FinancialChart.prototype.fg = function (a, b, c) {
        _super.prototype.fg.call(this, a, b, c);
        if (a == null || !b) {
            return;
        }
        var d = true;
        var e = true;
        var f = true;
        switch (c) {
            case "Brushes":
            case "Outlines":
                d = e = false;
                break;
        }
        if (this.indicatorCharts != null && d) {
            try {
                for (var _a = tslib_1.__values(fromEnum(this.indicatorCharts)), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var g = _b.value;
                    a(g);
                }
            }
            catch (e_14_1) { e_14 = { error: e_14_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_14) throw e_14.error; }
            }
        }
        if (this.volumeChart != null && e) {
            a(this.volumeChart);
        }
        if (this.zoomSliderChart != null && f) {
            a(this.zoomSliderChart);
        }
        var e_14, _c;
    };
    FinancialChart.prototype.tt = function (a, b) {
        var c = b;
        var d = a;
        var e = -1;
        if (this.indicatorCharts != null) {
            e = this.indicatorCharts.indexOf(d.bq);
        }
        e -= this.od == null ? 0 : this.od.count;
        if (this.applyCustomIndicators != null) {
            this.applyCustomIndicators(this, new FinancialChartCustomIndicatorArgs(c, d, e));
        }
    };
    FinancialChart.prototype.le = function (a) {
        _super.prototype.le.call(this, a);
        var b = a;
        this.t9(b);
        if (a.bd != null) {
            try {
                for (var _a = tslib_1.__values(fromEnum(a.bd.series)), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var c = _b.value;
                    if (this.pn(c)) {
                        this.oj.setXAxis(c, b);
                    }
                    else if (this.pr(c)) {
                        this.oh.setXAxis(c, b);
                    }
                    else if (this.pp(c)) {
                        this.ol.setXAxis(c, b);
                    }
                    else if (this.pq(c)) {
                        this.oq.setXAxis(c, b);
                    }
                }
            }
            catch (e_15_1) { e_15 = { error: e_15_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_15) throw e_15.error; }
            }
        }
        var d = a == this.zoomSliderXAxis;
        if (d) {
            a.ib = this.u2;
            a.d0 = this.qt;
            this.lc(a, function (e) { return e.visibility = 1; });
        }
        var e_15, _c;
    };
    FinancialChart.prototype.lg = function (a) {
        _super.prototype.lg.call(this, a);
        if (a.bd != null) {
            try {
                for (var _a = tslib_1.__values(fromEnum(a.bd.series)), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var b = _b.value;
                    if (this.pn(b)) {
                        this.oj.setYAxis(b, this.yAxis);
                    }
                    else if (this.pr(b)) {
                        this.oh.setYAxis(b, this.yAxis);
                    }
                    else if (this.pp(b)) {
                        this.ol.setYAxis(b, this.yAxis);
                    }
                    else if (this.pq(b)) {
                        this.oq.setYAxis(b, this.yAxis);
                    }
                }
            }
            catch (e_16_1) { e_16 = { error: e_16_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_16) throw e_16.error; }
            }
        }
        a.jg = this.px;
        a.j4 = this.qr;
        a.j3 = this.qq;
        a.j0 = this.qp;
        var c = a == this.zoomSliderAxis;
        if (c) {
            this.lc(a, function (d) { return d.visibility = 1; });
        }
        var e_16, _c;
    };
    FinancialChart.prototype.t9 = function (a) {
        a.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
        a.e1 = XYChart.i8(a, this.s.dataSeries);
        if (this.s.dataSeries.count > 0) {
            var b = this.s.dataSeries._inner[0].getMemberPathFor(17);
            a.gp(b);
        }
    };
    FinancialChart.prototype.e2 = function (a, b) {
        _super.prototype.e2.call(this, a, b);
        if (a == null) {
            return;
        }
        var c = this.dataChart != null && this.dataChart.series.contains(a);
        if (c && a.cy) {
            a.i0(this.m8 != null ? ArrayExtension.getModulus$1(Brush.$, this.m8, b) : null, this.m9 != null ? ArrayExtension.getModulus$1(Brush.$, this.m9, b) : null);
        }
        if (this.pq(a)) {
            a.km = this.na != null ? ArrayExtension.getModulus$1(Brush.$, this.na, b) : null;
            a.kp = this.nb != null ? ArrayExtension.getModulus$1(Brush.$, this.nb, b) : null;
            a.eo = this.qk;
        }
        else if (this.pp(a)) {
            a.km = this.m6 != null ? ArrayExtension.getModulus$1(Brush.$, this.m6, b) : null;
            a.eo = this.qj;
        }
        else if (c) {
            a.km = this.j != null ? ArrayExtension.getModulus$1(Brush.$, this.j, b) : null;
            a.kp = this.n != null ? ArrayExtension.getModulus$1(Brush.$, this.n, b) : null;
        }
        var d = this.volumeChart != null && this.volumeChart.series.count > b && this.volumeChart.series._inner[b] == a;
        if (d) {
            a.eo = this.qm;
        }
    };
    FinancialChart.prototype.fj = function (a, b, c) {
        var _this = this;
        _super.prototype.fj.call(this, a, b, c);
        switch (a) {
            case "YAxisIsLogarithmic":
                this.yAxis.jl = this.py;
                break;
            case "YAxisLogarithmBase":
                this.yAxis.j8 = this.rc;
                break;
            case "VolumeType":
                var d = EnumUtil.getEnumValue(FinancialChartVolumeType_$type, b);
                if (this.n4 == 0) {
                    this.volumeChart = null;
                }
                else if (this.volumeChart == null) {
                    this.volumeChart = ((function () {
                        var $ret = new XamDataChart();
                        $ret.name = "VolumeChart";
                        return $ret;
                    })());
                }
                else {
                    this.uf();
                }
                break;
            case "VolumeChart":
                this.ux(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "DataChart":
                if (typeCast(XamDataChart.$, b) !== null) {
                    var e = b;
                    e.gridAreaRectChanged = delegateRemove(e.gridAreaRectChanged, runOn(this, this.tv));
                    e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, runOn(this, this.ts));
                    e.seriesDataUpdated = delegateRemove(e.seriesDataUpdated, runOn(this, this.t0));
                }
                if (this.dataChart != null) {
                    var f = this.dataChart;
                    f.gridAreaRectChanged = delegateCombine(f.gridAreaRectChanged, runOn(this, this.tv));
                    var g = this.dataChart;
                    g.actualWindowRectChanged = delegateCombine(g.actualWindowRectChanged, runOn(this, this.ts));
                    var h = this.dataChart;
                    h.seriesDataUpdated = delegateCombine(h.seriesDataUpdated, runOn(this, this.t0));
                }
                this.uw();
                break;
            case "XAxisMode":
                this.xAxis = this.nj(this.n6);
                this.xAxis.name = "xAxis";
                this.volumeXAxis = this.nj(this.n6);
                this.volumeXAxis.name = "volumeXAxis";
                this.indicatorXAxis = this.nj(this.n6);
                this.indicatorXAxis.name = "indicatorXAxis_0";
                this.zoomSliderXAxis = this.nj(this.n6);
                this.zoomSliderXAxis.name = "zoomSliderXAxis";
                this.lc(this.zoomSliderXAxis, function (i) { return i.visibility = 1; });
                this.tm();
                break;
            case "YAxisMode":
                this.yAxis = this.ov(this.n8);
                this.yAxis.name = "yAxis";
                break;
            case "Toolbar":
                var i = typeCast(FinancialChartToolbar.$, b);
                if (i != null) {
                    i.rangeChanged = delegateRemove(i.rangeChanged, runOn(this, this.tz));
                    i.indicatorTypesChanged = delegateRemove(i.indicatorTypesChanged, runOn(this, this.t2));
                    i.overlayTypesChanged = delegateRemove(i.overlayTypesChanged, runOn(this, this.t3));
                }
                if (this.nx != null) {
                    this.nx.aj = this.od;
                    this.nx.al = this.of;
                    this.nx.v = this.nu;
                    this.uu(true);
                    var j = this.nx;
                    j.rangeChanged = delegateCombine(j.rangeChanged, runOn(this, this.tz));
                    var k = this.nx;
                    k.indicatorTypesChanged = delegateCombine(k.indicatorTypesChanged, runOn(this, this.t2));
                    var l = this.nx;
                    l.overlayTypesChanged = delegateCombine(l.overlayTypesChanged, runOn(this, this.t3));
                }
                break;
            case "XAxis":
                var m = typeCast(CategoryAxisBase.$, b);
                if (m != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(m);
                    }
                }
                var n = typeCast(ITimeRangeSelectorAxis_$type, b);
                if (n != null) {
                    n.actualRangeChanged = delegateRemove(n.actualRangeChanged, runOn(this, this.t6));
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.xAxis);
                }
                if (this.aw) {
                    this.le(this.xAxis);
                    this.ep();
                }
                this.uu(false);
                this.uv();
                if (typeCast(ITimeRangeSelectorAxis_$type, this.xAxis) !== null) {
                    var o = this.xAxis;
                    o.actualRangeChanged = delegateCombine(o.actualRangeChanged, runOn(this, this.t6));
                }
                break;
            case "ChartType":
                this.fz();
                break;
            case "VolumeXAxis":
                this.uo(this.volumeChart, typeCast(Axis.$, b), this.volumeXAxis);
                break;
            case "ZoomSliderXAxis":
                this.uo(this.zoomSliderChart, typeCast(Axis.$, b), this.zoomSliderXAxis);
                break;
            case "IndicatorXAxis":
                this.ur();
                break;
            case "YAxis":
                var p = typeCast(NumericYAxis.$, b);
                if (p != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(p);
                    }
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.yAxis);
                }
                if (this.aw) {
                    this.lg(this.yAxis);
                    this.lg(this.yAxis);
                }
                var q = this.yAxis;
                q.rangeChanged = delegateCombine(q.rangeChanged, runOn(this, this.t7));
                break;
            case "VolumeAxis":
                var r = typeCast(Axis.$, b);
                if (this.volumeChart != null && r != null) {
                    this.volumeChart.axes.remove(r);
                }
                if (this.aw) {
                    this.lg(this.volumeAxis);
                }
                var s = this.volumeAxis;
                s.rangeChanged = delegateCombine(s.rangeChanged, runOn(this, this.t7));
                break;
            case "IndicatorAxis":
                if (this.indicatorCharts != null) {
                    for (var t = 0; t < this.indicatorCharts.count; t++) {
                        var u = this.indicatorCharts._inner[t];
                        var v = new List$1(Axis.$, 0);
                        try {
                            for (var _a = tslib_1.__values(fromEnum(u.axes)), _b = _a.next(); !_b.done; _b = _a.next()) {
                                var w = _b.value;
                                if (typeCast(NumericYAxis.$, w) !== null) {
                                    v.add(w);
                                }
                            }
                        }
                        catch (e_17_1) { e_17 = { error: e_17_1 }; }
                        finally {
                            try {
                                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                            }
                            finally { if (e_17) throw e_17.error; }
                        }
                        try {
                            for (var _d = tslib_1.__values(fromEnum(v)), _e = _d.next(); !_e.done; _e = _d.next()) {
                                var x = _e.value;
                                u.axes.remove(x);
                            }
                        }
                        catch (e_18_1) { e_18 = { error: e_18_1 }; }
                        finally {
                            try {
                                if (_e && !_e.done && (_f = _d.return)) _f.call(_d);
                            }
                            finally { if (e_18) throw e_18.error; }
                        }
                        var y = null;
                        if (t == 0) {
                            y = this.indicatorAxis;
                        }
                        else if (this.n8 == 1) {
                            y = this.ov(this.n8);
                        }
                        else if (typeCast(NumericYAxis.$, this.indicatorAxis) !== null) {
                            y = new NumericYAxis();
                        }
                        if (y != null) {
                            u.axes.add(y);
                        }
                        if (this.aw) {
                            this.lg(y);
                        }
                    }
                }
                break;
            case "IsWindowSyncedToVisibleRange":
                if (this.dataChart != null) {
                    this.dataChart.nn = this.a3 && this.a2;
                }
                if (this.volumeChart != null) {
                    this.volumeChart.nn = this.a3 && this.a2;
                }
                if (this.pu) {
                    this.up(this.dataChart);
                }
                break;
            case "IndicatorTypes":
                var z = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), b);
                if (z != null) {
                    z.collectionChanged = delegateRemove(z.collectionChanged, runOn(this, this.tw));
                }
                var aa = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), c);
                if (aa != null) {
                    aa.collectionChanged = delegateCombine(aa.collectionChanged, runOn(this, this.tw));
                }
                this.ur();
                break;
            case "OverlayTypes":
                var ab = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), b);
                if (ab != null) {
                    ab.collectionChanged = delegateRemove(ab.collectionChanged, runOn(this, this.tx));
                }
                var ac = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), c);
                if (ac != null) {
                    ac.collectionChanged = delegateCombine(ac.collectionChanged, runOn(this, this.tx));
                }
                this.ut();
                break;
            case "YAxisAbbreviateLargeNumbers":
                this.lm(function (ad) { return ad.jg = _this.px; });
                break;
            case "YAxisMinimumValue":
                this.ln(function (ad) { return ad.j4 = _this.qr; }, false);
                break;
            case "YAxisMaximumValue":
                this.ln(function (ad) { return ad.j3 = _this.qq; }, false);
                break;
            case "YAxisInterval":
                this.ln(function (ad) { return ad.j0 = _this.qp; }, false);
                break;
            case "ZoomSliderType":
                this.uw();
                break;
            case "ZoomSliderChart":
                if (!this.pz) {
                    return;
                }
                this.uz(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "NegativeBrushes":
            case "NegativeOutlines":
                this.tp(function (ad, ae) {
                    if (ad.cy) {
                        ad.i0(_this.m8 != null ? ArrayExtension.getModulus$1(Brush.$, _this.m8, ae) : null, _this.m9 != null ? ArrayExtension.getModulus$1(Brush.$, _this.m9, ae) : null);
                    }
                });
                break;
            case "OverlayBrushes":
                this.er(function (ad, ae) {
                    if (!(_this.pq(ad))) {
                        return;
                    }
                    ad.km = _this.na != null ? ArrayExtension.getModulus$1(Brush.$, _this.na, ae) : null;
                });
                break;
            case "OverlayOutlines":
                this.er(function (ad, ae) {
                    if (!(_this.pq(ad))) {
                        return;
                    }
                    ad.kp = _this.nb != null ? ArrayExtension.getModulus$1(Brush.$, _this.nb, ae) : null;
                });
                break;
            case "OverlayThickness":
                this.er(function (ad, ae) {
                    if (!(_this.pq(ad))) {
                        return;
                    }
                    ad.eo = _this.qk;
                });
                break;
            case "VolumeBrushes":
                this.tq(function (ad, ae) { return ad.km = ArrayExtension.getModulus$1(Brush.$, _this.nc, ae); });
                break;
            case "VolumeOutlines":
                this.tq(function (ad, ae) { return ad.kp = ArrayExtension.getModulus$1(Brush.$, _this.nd, ae); });
                break;
            case "VolumeThickness":
                this.tq(function (ad, ae) { return ad.eo = _this.qm; });
                break;
            case "IndicatorNegativeBrushes":
                this.to(function (ad, ae) { return _this.ol.setNegativeBrush(ad, ArrayExtension.getModulus$1(Brush.$, _this.m7, ae)); });
                break;
            case "IndicatorBrushes":
                this.to(function (ad, ae) { return ad.km = ArrayExtension.getModulus$1(Brush.$, _this.m6, ae); });
                break;
            case "IndicatorThickness":
                this.to(function (ad, ae) { return ad.eo = _this.qj; });
                break;
            case "IndicatorDisplayTypes":
                this.to(function (ad, ae) { return _this.ol.setDisplayType(ad, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, _this.on, ae)); });
                break;
            case "IndicatorPeriod":
                this.to(function (ad, ae) {
                    if (_this.q7 == -2147483648 || !(_this.pp(ad))) {
                        return;
                    }
                    _this.ol.setPeriodOverride(ad, _this.q7);
                });
                break;
            case "IndicatorMultiplier":
                this.to(function (ad, ae) {
                    if (!(_this.pq(ad))) {
                        return;
                    }
                    _this.oq.setMultiplier(ad, _this.qi);
                });
                break;
            case "IndicatorSmoothingPeriod":
                this.to(function (ad, ae) {
                    if (!(_this.pp(ad))) {
                        return;
                    }
                    _this.ol.setSmoothingPeriod(ad, _this.ra);
                });
                break;
            case "IndicatorShortPeriod":
                this.to(function (ad, ae) {
                    if (!(_this.pp(ad))) {
                        return;
                    }
                    _this.ol.setShortPeriod(ad, _this.q8);
                });
                break;
            case "IndicatorLongPeriod":
                this.to(function (ad, ae) {
                    if (!(_this.pp(ad))) {
                        return;
                    }
                    _this.ol.setLongPeriod(ad, _this.q6);
                });
                break;
            case "IndicatorSignalPeriod":
                this.to(function (ad, ae) {
                    if (!(_this.pp(ad))) {
                        return;
                    }
                    _this.ol.setSignalPeriod(ad, _this.q9);
                });
                break;
            case "RangeSelectorOptions":
                var ad = typeCast(FinancialChartRangeSelectorOptionCollection.$, b);
                if (ad != null) {
                    ad.collectionChanged = delegateRemove(ad.collectionChanged, runOn(this, this.ty));
                }
                if (this.nv != null) {
                    var ae = this.nv;
                    ae.collectionChanged = delegateCombine(ae.collectionChanged, runOn(this, this.ty));
                }
                this.ui();
                break;
            case "CustomIndicatorNames":
                var af = typeCast(ObservableCollection$1.$.specialize(String_$type), b);
                if (af != null) {
                    af.collectionChanged = delegateRemove(af.collectionChanged, runOn(this, this.tu));
                }
                if (this.customIndicatorNames != null) {
                    var ag = this.customIndicatorNames;
                    ag.collectionChanged = delegateCombine(ag.collectionChanged, runOn(this, this.tu));
                }
                this.ur();
                break;
            case "Legend":
                if (this.zoomSliderChart != null) {
                    this.zoomSliderChart.ay = null;
                }
                break;
            case "Brushes":
                this.tp(function (ah, ai) {
                    if (_this.pq(ah)) {
                        return;
                    }
                    ah.km = _this.j != null ? ArrayExtension.getModulus$1(Brush.$, _this.j, ai) : null;
                });
                break;
            case "Outlines":
                this.tp(function (ah, ai) {
                    if (_this.pq(ah)) {
                        return;
                    }
                    ah.kp = _this.n != null ? ArrayExtension.getModulus$1(Brush.$, _this.n, ai) : null;
                });
                break;
            case "XAxisLabelVisibility":
                if (this.mw == 0 && this.zoomSliderXAxis != null) {
                    this.lc(this.zoomSliderXAxis, function (ah) { return ah.visibility = 1; });
                }
                this.tm();
                break;
            case "YAxisLabelVisibility":
                if (this.mx != 0 || this.zoomSliderAxis == null) {
                    break;
                }
                this.lc(this.zoomSliderAxis, function (ah) { return ah.visibility = 1; });
                break;
            case "ZoomSliderXAxisMajorStroke":
                this.zoomSliderXAxis.ib = this.u2;
                break;
            case "ZoomSliderXAxisMajorStrokeThickness":
                this.zoomSliderXAxis.d0 = this.qt;
                break;
        }
        var e_17, _c, e_18, _f;
    };
    FinancialChart.prototype.uo = function (a, b, c) {
        if (a != null) {
            if (b != null) {
                a.axes.remove(b);
            }
            a.axes.add(c);
        }
        if (this.aw) {
            this.le(c);
        }
    };
    Object.defineProperty(FinancialChart.prototype, "pz", {
        get: function () {
            return TypeRegistrar.isRegistered("IgxZoomSliderComponent");
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.tu = function (a, b) {
        this.ur();
    };
    FinancialChart.prototype.ps = function (a, b) {
        if (b <= (0)) {
            return false;
        }
        switch (a) {
            case 5: return true;
            case 4:
            case 3: return b >= timeSpanFromDays(365);
            case 2: return b >= timeSpanFromDays(180);
            case 1: return b >= timeSpanFromDays(90);
            case 0: return b >= timeSpanFromDays(30);
        }
        return false;
    };
    FinancialChart.prototype.ui = function () {
        var a = this.nv != null ? this.nv : new FinancialChartRangeSelectorOptionCollection(1, [5, 4, 3, 2, 1, 0]);
        var b = new FinancialChartRangeSelectorOptionCollection(0);
        var c = this.xAxis;
        var d = +(c.actualMaximumValue) - +(c.actualMinimumValue);
        try {
            for (var _a = tslib_1.__values(fromEnum(a)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var e = _b.value;
                if (this.ps(e, d)) {
                    b.add(e);
                }
            }
        }
        catch (e_19_1) { e_19 = { error: e_19_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_19) throw e_19.error; }
        }
        this.nu = b;
        if (this.nx != null) {
            this.nx.v = this.nu;
        }
        var e_19, _c;
    };
    FinancialChart.prototype.ty = function (a, b) {
        this.ui();
    };
    FinancialChart.prototype.t3 = function (a, b) {
        this.of = this.nx.al;
    };
    FinancialChart.prototype.t2 = function (a, b) {
        this.od = this.nx.aj;
    };
    FinancialChart.prototype.tw = function (a, b) {
        this.ur();
    };
    FinancialChart.prototype.tx = function (a, b) {
        this.ut();
    };
    FinancialChart.prototype.t7 = function (a, b) {
        var c = a;
        if (c.bd == null) {
            return;
        }
        if (this.pu) {
            this.up(c.bd);
        }
    };
    FinancialChart.prototype.ua = function (a) {
        a.axes.clear();
        a.series.clear();
        a.gridAreaRectChanged = delegateRemove(a.gridAreaRectChanged, runOn(this, this.tv));
        if (this.volumeChart == null && this.indicatorCharts == null) {
            this.yAxis.d1 = this.volumeAxis.d1 = this.indicatorAxis.d1 = 0;
            this.xAxis.aw.visibility = this.mw;
        }
    };
    FinancialChart.prototype.t8 = function (a) {
        var b = a != this.zoomSliderChart;
        if (b) {
            if (this.dataChart != null) {
                a.my = new Rect(0, this.dataChart.mk.x, a.my.y, this.dataChart.mk.width, a.my.height);
            }
            var c = ((function () {
                var $ret = new SyncSettings();
                $ret.ae = "one";
                $ret.ac = true;
                $ret.ad = false;
                return $ret;
            })());
            SyncManager.d(a, c);
            SyncManager.c(a);
        }
        a.gridAreaRectChanged = delegateCombine(a.gridAreaRectChanged, runOn(this, this.tv));
        this.ew(a);
    };
    FinancialChart.prototype.tm = function () {
        if (this.indicatorCharts != null || this.volumeChart != null) {
            this.lc(this.xAxis, function (a) { return a.visibility = 1; });
        }
        var _loop_1 = function (a) {
            var b = this_1.p6._inner[a];
            var c = a < this_1.p6.count - 1 || this_1.volumeChart != null;
            this_1.lc(b, function (d) { return d.visibility = c ? 1 : 0; });
        };
        var this_1 = this;
        for (var a = 0; a < this.p6.count; a++) {
            _loop_1(a);
        }
    };
    FinancialChart.prototype.um = function (a, b) {
        if (a != null) {
            this.ua(a);
        }
        if (b != null) {
            this.t8(b);
        }
    };
    FinancialChart.prototype.ux = function (a, b) {
        this.um(a, b);
        this.tm();
        if (this.volumeChart != null) {
            if (this.volumeAxis != null) {
                this.volumeChart.axes.add(this.volumeAxis);
                this.volumeChart.axes.add(this.volumeXAxis);
            }
            this.uf();
            this.volumeXAxis.itemsSource = this.xAxis.itemsSource;
        }
        this.uy(a, b);
    };
    FinancialChart.prototype.tz = function (a, b) {
        this.uv();
    };
    FinancialChart.prototype.uv = function () {
        if (this.nx == null || +(this.nx.az) == +(dateMaxValue()) || +(this.nx.ay) == +(dateMinValue()) || this.dataChart == null) {
            return;
        }
        var a = this.xAxis;
        var b = a.getWindowRectForSelection(this.nx.az, this.nx.ay);
        if (b.width == 0 || isNaN_(b.width) || isInfinity(b.width)) {
            return;
        }
        this.pv = true;
        this.dataChart.my = new Rect(0, b.left, this.dataChart.my.top, b.width, this.dataChart.my.height);
        if (this.pe != null) {
            this.pe.t = this.dataChart.mk;
        }
        if (this.pu) {
            this.up(this.dataChart);
        }
        this.pv = false;
    };
    FinancialChart.prototype.t6 = function (a, b) {
        this.ui();
        this.uu(true);
    };
    FinancialChart.prototype.ts = function (a, b) {
        var _this = this;
        if (!this.pv) {
            if (this.pu) {
                this.up(a);
            }
            var c = false;
            var d = this.fn(function () { return _this.uu(true); }, c);
            c = d.p1;
            if (this.pe != null) {
                this.pe.t = this.dataChart.mk;
            }
        }
    };
    FinancialChart.prototype.uq = function (a, b, c, d) {
        if (a == null || b == null) {
            return;
        }
        if (c != -1) {
            this.pv = true;
            a.my = new Rect(0, d, a.mk.top, c, a.mk.height);
            this.pv = false;
        }
        var e = 1.7976931348623157E+308;
        var f = -1.7976931348623157E+308;
        var g = new Rect(0, 0, 0, 1, 1);
        var h = new ScalerParams(0, g, g, this.yAxis.b8, a.mo);
        try {
            for (var _a = tslib_1.__values(fromEnum(a.series)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var i = _b.value;
                h.b = i.d9();
                var j = i.ao();
                var k = j == null || j.c == 1.7976931348623157E+308 || isNaN_(j.c);
                if (k) {
                    continue;
                }
                var l = b.dt(j.c, h);
                var m = b.dt(j.b, h);
                f = Math.max(f, l);
                e = Math.min(e, m);
            }
        }
        catch (e_20_1) { e_20 = { error: e_20_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_20) throw e_20.error; }
        }
        var n = a.mk.width;
        if (c != -1) {
            n = c;
        }
        var o = a.mk.left;
        if (d != -1) {
            o = d;
        }
        if (e == 1.7976931348623157E+308 || f == -1.7976931348623157E+308 || isNaN_(e) || isNaN_(f)) {
            return;
        }
        this.pv = true;
        var p = new Rect(0, o, e, n, f - e);
        a.my = p;
        this.pv = false;
        var e_20, _c;
    };
    FinancialChart.prototype.up = function (a) {
        if (a == null) {
            return;
        }
        if (a == this.dataChart) {
            this.uq(this.dataChart, this.yAxis, -1, -1);
            if (this.volumeChart != null) {
                this.uq(this.volumeChart, this.volumeAxis, this.dataChart.mk.width, this.dataChart.mk.left);
            }
        }
        else if (a == this.volumeChart) {
            this.uq(this.volumeChart, this.volumeAxis, -1, -1);
            this.uq(this.dataChart, this.yAxis, this.volumeChart.mk.width, this.volumeChart.mk.left);
        }
    };
    FinancialChart.prototype.t0 = function (a, b) {
        if (this.pu) {
            this.up(a);
        }
    };
    FinancialChart.prototype.uw = function () {
        if (!this.p0) {
            return;
        }
        if (this.pe != null) {
            this.pe.m();
        }
        if (this.ob == 0) {
            this.zoomSliderChart = null;
        }
        else if (this.zoomSliderChart == null) {
            this.zoomSliderChart = ((function () {
                var $ret = new XamDataChart();
                $ret.name = "ZoomSliderChart";
                return $ret;
            })());
        }
        else {
            this.ug();
        }
    };
    Object.defineProperty(FinancialChart.prototype, "py", {
        get: function () {
            return this.pi;
        },
        set: function (a) {
            var b = this.py;
            if (a != b) {
                this.pi = a;
                this.fj("YAxisIsLogarithmic", b, this.py);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rc", {
        get: function () {
            return this.q4;
        },
        set: function (a) {
            var b = this.rc;
            if (a != b) {
                this.q4 = a;
                this.fj("YAxisLogarithmBase", b, this.rc);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qp", {
        get: function () {
            return this.qc;
        },
        set: function (a) {
            var b = this.qp;
            if (a != b) {
                this.qc = a;
                this.fj("YAxisInterval", b, this.qp);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qr", {
        get: function () {
            return this.qe;
        },
        set: function (a) {
            var b = this.qr;
            if (a != b) {
                this.qe = a;
                this.fj("YAxisMinimumValue", b, this.qr);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qq", {
        get: function () {
            return this.qd;
        },
        set: function (a) {
            var b = this.qq;
            if (a != b) {
                this.qd = a;
                this.fj("YAxisMaximumValue", b, this.qq);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qs", {
        get: function () {
            return this.qf;
        },
        set: function (a) {
            var b = this.qs;
            if (a != b) {
                this.qf = a;
                this.fj("YAxisMinorInterval", b, this.qs);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qo", {
        get: function () {
            return this.yAxis.jw;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qn", {
        get: function () {
            return this.yAxis.jv;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "n4", {
        get: function () {
            return this.n2;
        },
        set: function (a) {
            var b = this.n4;
            if (a != b) {
                this.n2 = a;
                this.fj("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.n4));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "n6", {
        get: function () {
            return this.n5;
        },
        set: function (a) {
            var b = this.n6;
            if (a != b) {
                this.n5 = a;
                this.fj("XAxisMode", enumGetBox(FinancialChartXAxisMode_$type, b), enumGetBox(FinancialChartXAxisMode_$type, this.n6));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "n8", {
        get: function () {
            return this.n7;
        },
        set: function (a) {
            var b = this.n8;
            if (a != b) {
                this.n7 = a;
                this.fj("YAxisMode", enumGetBox(FinancialChartYAxisMode_$type, b), enumGetBox(FinancialChartYAxisMode_$type, this.n8));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "pt", {
        get: function () {
            return this.pf;
        },
        set: function (a) {
            var b = this.pt;
            if (a != b) {
                this.pf = a;
                this.fj("IsToolbarVisible", b, this.pt);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "nz", {
        get: function () {
            return this.ny;
        },
        set: function (a) {
            var b = this.nz;
            if (a != b) {
                this.ny = a;
                this.fj("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.nz));
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_lv = function () {
        return _super.prototype.get_lv.call(this);
    };
    FinancialChart.prototype.set_lv = function (a) {
        _super.prototype.set_lv.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "lv", {
        get: function () {
            return this.get_lv();
        },
        set: function (a) {
            this.set_lv(a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "pu", {
        get: function () {
            return this.pg;
        },
        set: function (a) {
            var b = this.pu;
            if (a != b) {
                this.pg = a;
                this.fj("IsWindowSyncedToVisibleRange", b, this.pu);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "od", {
        get: function () {
            return this.oc;
        },
        set: function (a) {
            var b = this.od;
            if (a != b) {
                this.oc = a;
                this.fj("IndicatorTypes", b, this.od);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "of", {
        get: function () {
            return this.oe;
        },
        set: function (a) {
            var b = this.of;
            if (a != b) {
                this.oe = a;
                this.fj("OverlayTypes", b, this.of);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorCharts", {
        get: function () {
            return this.p2;
        },
        set: function (a) {
            var b = this.indicatorCharts;
            if (a != b) {
                this.p2 = a;
                this.fj("IndicatorCharts", b, this.indicatorCharts);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "px", {
        get: function () {
            return this.ph;
        },
        set: function (a) {
            var b = this.px;
            if (a != b) {
                this.ph = a;
                this.fj("YAxisAbbreviateLargeNumbers", b, this.px);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_by = function () {
        return _super.prototype.get_by.call(this);
    };
    FinancialChart.prototype.set_by = function (a) {
        _super.prototype.set_by.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "by", {
        get: function () {
            return this.get_by();
        },
        set: function (a) {
            this.set_by(a);
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_gr = function () {
        return _super.prototype.get_gr.call(this);
    };
    FinancialChart.prototype.set_gr = function (a) {
        _super.prototype.set_gr.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "gr", {
        get: function () {
            return this.get_gr();
        },
        set: function (a) {
            this.set_gr(a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderChart", {
        get: function () {
            return this.pa;
        },
        set: function (a) {
            var b = this.zoomSliderChart;
            if (a != b) {
                this.pa = a;
                this.fj("ZoomSliderChart", b, this.zoomSliderChart);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderAxis", {
        get: function () {
            return this.ou;
        },
        set: function (a) {
            var b = this.zoomSliderAxis;
            if (a != b) {
                this.ou = a;
                this.fj("ZoomSliderAxis", b, this.zoomSliderAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderXAxis", {
        get: function () {
            return this.nh;
        },
        set: function (a) {
            var b = this.zoomSliderXAxis;
            if (a != b) {
                this.nh = a;
                this.fj("ZoomSliderXAxis", b, this.zoomSliderXAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ob", {
        get: function () {
            return this.n9;
        },
        set: function (a) {
            var b = this.ob;
            if (a != b) {
                this.n9 = a;
                this.fj("ZoomSliderType", enumGetBox(FinancialChartZoomSliderType_$type, b), enumGetBox(FinancialChartZoomSliderType_$type, this.ob));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "m8", {
        get: function () {
            return this.m0;
        },
        set: function (a) {
            var b = this.m8;
            if (a != b) {
                this.m0 = a;
                this.fj("NegativeBrushes", b, this.m8);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "m9", {
        get: function () {
            return this.m1;
        },
        set: function (a) {
            var b = this.m9;
            if (a != b) {
                this.m1 = a;
                this.fj("NegativeOutlines", b, this.m9);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "na", {
        get: function () {
            return this.m2;
        },
        set: function (a) {
            var b = this.na;
            if (a != b) {
                this.m2 = a;
                this.fj("OverlayBrushes", b, this.na);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "nb", {
        get: function () {
            return this.m3;
        },
        set: function (a) {
            var b = this.nb;
            if (a != b) {
                this.m3 = a;
                this.fj("OverlayOutlines", b, this.nb);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "nd", {
        get: function () {
            return this.m5;
        },
        set: function (a) {
            var b = this.nd;
            if (a != b) {
                this.m5 = a;
                this.fj("VolumeOutlines", b, this.nd);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "nc", {
        get: function () {
            return this.m4;
        },
        set: function (a) {
            var b = this.nc;
            if (a != b) {
                this.m4 = a;
                this.fj("VolumeBrushes", b, this.nc);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "m7", {
        get: function () {
            return this.mz;
        },
        set: function (a) {
            var b = this.m7;
            if (a != b) {
                this.mz = a;
                this.fj("IndicatorNegativeBrushes", b, this.m7);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "m6", {
        get: function () {
            return this.my;
        },
        set: function (a) {
            var b = this.m6;
            if (a != b) {
                this.my = a;
                this.fj("IndicatorBrushes", b, this.m6);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qm", {
        get: function () {
            return this.qb;
        },
        set: function (a) {
            var b = this.qm;
            if (a != b) {
                this.qb = a;
                this.fj("VolumeThickness", b, this.qm);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qk", {
        get: function () {
            return this.p9;
        },
        set: function (a) {
            var b = this.qk;
            if (a != b) {
                this.p9 = a;
                this.fj("OverlayThickness", b, this.qk);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qj", {
        get: function () {
            return this.p8;
        },
        set: function (a) {
            var b = this.qj;
            if (a != b) {
                this.p8 = a;
                this.fj("IndicatorThickness", b, this.qj);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "on", {
        get: function () {
            return this.om;
        },
        set: function (a) {
            var b = this.on;
            if (a != b) {
                this.om = a;
                this.fj("IndicatorDisplayTypes", b, this.on);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "q7", {
        get: function () {
            return this.q0;
        },
        set: function (a) {
            var b = this.q7;
            if (a != b) {
                this.q0 = a;
                this.fj("IndicatorPeriod", b, this.q7);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qi", {
        get: function () {
            return this.p7;
        },
        set: function (a) {
            var b = this.qi;
            if (a != b) {
                this.p7 = a;
                this.fj("IndicatorMultiplier", b, this.qi);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ra", {
        get: function () {
            return this.q3;
        },
        set: function (a) {
            var b = this.ra;
            if (a != b) {
                this.q3 = a;
                this.fj("IndicatorSmoothingPeriod", b, this.ra);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "q8", {
        get: function () {
            return this.q1;
        },
        set: function (a) {
            var b = this.q8;
            if (a != b) {
                this.q1 = a;
                this.fj("IndicatorShortPeriod", b, this.q8);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "q6", {
        get: function () {
            return this.qz;
        },
        set: function (a) {
            var b = this.q6;
            if (a != b) {
                this.qz = a;
                this.fj("IndicatorLongPeriod", b, this.q6);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "q9", {
        get: function () {
            return this.q2;
        },
        set: function (a) {
            var b = this.q9;
            if (a != b) {
                this.q2 = a;
                this.fj("IndicatorSignalPeriod", b, this.q9);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "nv", {
        get: function () {
            return this.nt;
        },
        set: function (a) {
            var b = this.nv;
            if (a != b) {
                this.nt = a;
                this.fj("RangeSelectorOptions", b, this.nv);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "customIndicatorNames", {
        get: function () {
            return this.np;
        },
        set: function (a) {
            var b = this.np;
            if (a != b) {
                this.np = a;
                this.fj("CustomIndicatorNames", b, this.customIndicatorNames);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_a3 = function () {
        return _super.prototype.get_a3.call(this);
    };
    FinancialChart.prototype.set_a3 = function (a) {
        _super.prototype.set_a3.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "a3", {
        get: function () {
            return this.get_a3();
        },
        set: function (a) {
            this.set_a3(a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "u2", {
        get: function () {
            return this.u1;
        },
        set: function (a) {
            var b = this.u2;
            if (a != b) {
                this.u1 = a;
                this.fj("ZoomSliderXAxisMajorStroke", b, this.u2);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qt", {
        get: function () {
            return this.qg;
        },
        set: function (a) {
            var b = this.qt;
            if (a != b) {
                this.qg = a;
                this.fj("ZoomSliderXAxisMajorStrokeThickness", b, this.qt);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.rb = 0;
    FinancialChart.$t = markType(FinancialChart, 'FinancialChart', XYChart.$);
    return FinancialChart;
}(XYChart));
export { FinancialChart };
var FinancialChartEnumCollectionPickerTool$2 = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialChartEnumCollectionPickerTool$2, _super);
    function FinancialChartEnumCollectionPickerTool$2($tColl, $tEnum, a, b, c) {
        var _this = _super.call(this, a, b, c) || this;
        _this.$tColl = null;
        _this.$tEnum = null;
        _this.o = null;
        _this.p = null;
        _this.changed = null;
        _this.$tColl = $tColl;
        _this.$tEnum = $tEnum;
        _this.$type = _this.$type.specialize(_this.$tColl, _this.$tEnum);
        _this.o = new FinancialChartEnumCollectionPickerToolView();
        _this.p = new FinancialChartEnumCollectionPickerToolViewModel();
        _this.p.onSelectionChanged = runOn(_this, _this.w);
        return _this;
    }
    FinancialChartEnumCollectionPickerTool$2.prototype.l = function (a) {
        _super.prototype.l.call(this, a);
        this.o.d(this.j, this.d, this.p, this.s());
    };
    FinancialChartEnumCollectionPickerTool$2.prototype.u = function (a) {
    };
    Object.defineProperty(FinancialChartEnumCollectionPickerTool$2.prototype, "n", {
        get: function () {
            var a = Type.createInstance(this.$tColl);
            var d = this.p.selection;
            for (var c = 0; c < d.length; c++) {
                var b = d[c];
                a.add(typeCastObjTo$t(this.$tEnum, EnumUtil.parse(this.$tEnum, b, true)));
            }
            return a;
        },
        set: function (a) {
            var b = this.n;
            if (!FinancialChartToolbar.ar(b, a)) {
                var c = new List$1(String_$type, 0);
                if (a != null) {
                    for (var d = 0; d < a.count; d++) {
                        var e = a._inner[d];
                        c.add(stringToString$1(this.$tEnum, e));
                    }
                }
                this.p.selection = c.toArray();
                this.v("Selection", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartEnumCollectionPickerTool$2.prototype.w = function () {
        if (this.changed != null) {
            this.changed(this, EventArgs.empty);
        }
    };
    FinancialChartEnumCollectionPickerTool$2.prototype.v = function (a, b, c) {
        switch (a) {
            case "Selection":
                this.p.updateUI();
                this.o.g(this.p);
                break;
        }
    };
    FinancialChartEnumCollectionPickerTool$2.prototype.q = function () {
        return this.o.b(this.g);
    };
    FinancialChartEnumCollectionPickerTool$2.$t = markType(FinancialChartEnumCollectionPickerTool$2, 'FinancialChartEnumCollectionPickerTool$2', TemplatedHtmlControl.$);
    return FinancialChartEnumCollectionPickerTool$2;
}(TemplatedHtmlControl));
export { FinancialChartEnumCollectionPickerTool$2 };
var FinancialChartIndicatorPicker = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialChartIndicatorPicker, _super);
    function FinancialChartIndicatorPicker(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = [null];
                    {
                        var e = c[0];
                        _this = _super.call(this, FinancialIndicatorTypeCollection.$, FinancialIndicatorType_$type, "financialChartIndicatorPicker", e, "") || this;
                    }
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    _this = _super.call(this, FinancialIndicatorTypeCollection.$, FinancialIndicatorType_$type, "financialChartIndicatorPicker", c, "") || this;
                }
                break;
        }
        return _this;
    }
    FinancialChartIndicatorPicker.prototype.u = function (a) {
        _super.prototype.u.call(this, a);
        if (this.p.isOpen) {
            for (var b = 0; b < a.length; b++) {
                if (a[b] == "financialChartIndicatorPickerDropDownButton") {
                    return;
                }
            }
            this.p.isOpen = false;
            this.p.updateUI();
        }
    };
    FinancialChartIndicatorPicker.prototype.s = function () {
        return this.d != null ? new SRProvider(this.d).ac : null;
    };
    FinancialChartIndicatorPicker.$t = markType(FinancialChartIndicatorPicker, 'FinancialChartIndicatorPicker', FinancialChartEnumCollectionPickerTool$2.$.specialize(FinancialIndicatorTypeCollection.$, FinancialIndicatorType_$type));
    return FinancialChartIndicatorPicker;
}(FinancialChartEnumCollectionPickerTool$2));
export { FinancialChartIndicatorPicker };
var FinancialChartOverlayPicker = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialChartOverlayPicker, _super);
    function FinancialChartOverlayPicker(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = [null];
                    {
                        var e = c[0];
                        _this = _super.call(this, FinancialOverlayTypeCollection.$, FinancialOverlayType_$type, "financialChartOverlayPicker", e, "") || this;
                    }
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    _this = _super.call(this, FinancialOverlayTypeCollection.$, FinancialOverlayType_$type, "financialChartOverlayPicker", c, "") || this;
                }
                break;
        }
        return _this;
    }
    FinancialChartOverlayPicker.prototype.u = function (a) {
        _super.prototype.u.call(this, a);
        if (this.p.isOpen) {
            for (var b = 0; b < a.length; b++) {
                if (a[b] == "financialChartOverlayPickerDropDownButton") {
                    return;
                }
            }
            this.p.isOpen = false;
            this.p.updateUI();
        }
    };
    FinancialChartOverlayPicker.prototype.s = function () {
        return this.d != null ? new SRProvider(this.d).ad : null;
    };
    FinancialChartOverlayPicker.$t = markType(FinancialChartOverlayPicker, 'FinancialChartOverlayPicker', FinancialChartEnumCollectionPickerTool$2.$.specialize(FinancialOverlayTypeCollection.$, FinancialOverlayType_$type));
    return FinancialChartOverlayPicker;
}(FinancialChartEnumCollectionPickerTool$2));
export { FinancialChartOverlayPicker };
var FinancialChartToolbar = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialChartToolbar, _super);
    function FinancialChartToolbar(a, b) {
        var _this = _super.call(this, "financialChartToolbar", b, "") || this;
        _this.n = null;
        _this.s = null;
        _this.ac = null;
        _this.y = null;
        _this.ag = null;
        _this.o = null;
        _this.q = null;
        _this.x = null;
        _this.av = dateMaxValue();
        _this.au = dateMinValue();
        _this.at = dateMaxValue();
        _this.as = dateMinValue();
        _this.rangeChanged = null;
        _this.chartTypeChanged = null;
        _this.trendLineTypeChanged = null;
        _this.volumeTypeChanged = null;
        _this.indicatorTypesChanged = null;
        _this.overlayTypesChanged = null;
        _this.aa = 0;
        _this.am = 0;
        _this.ae = 0;
        _this.ai = null;
        _this.ak = null;
        _this.u = null;
        _this.ap = false;
        _this.n = a;
        _this.x = new FinancialChartToolbarViewModel();
        _this.t = new FinancialChartRangeSelector(a != null ? a.rn : null);
        _this.ad = new FinancialChartTypePicker(a != null ? a.rk : null);
        _this.z = new FinancialChartTrendLinePicker(1, a != null ? a.rp : null);
        _this.ah = new FinancialChartVolumeTypePicker(a != null ? a.rq : null);
        _this.p = new FinancialChartIndicatorPicker(1, a != null ? a.rl : null);
        _this.r = new FinancialChartOverlayPicker(1, a != null ? a.rm : null);
        return _this;
    }
    FinancialChartToolbar.prototype.bp = function (a) {
        var b = this.d.querySelector(".financialChartRangeSelector");
        this.t.g = b;
        var c = this.d.querySelector(".financialChartChartTypePicker");
        this.ad.g = c;
        var d = this.d.querySelector(".financialChartIndicatorPicker");
        this.p.g = d;
        var e = this.d.querySelector(".financialChartOverlayPicker");
        this.r.g = e;
        var f = this.d.querySelector(".financialChartTrendLineTypePicker");
        this.z.g = f;
        var g = this.d.querySelector(".financialChartVolumeTypePicker");
        this.ah.g = g;
    };
    FinancialChartToolbar.prototype.bx = function (a) {
        this.p.u(a);
        this.r.u(a);
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "t", {
        get: function () {
            return this.s;
        },
        set: function (a) {
            var b = this.t;
            if (a != b) {
                this.s = a;
                this.by("RangeSelector", b, this.t);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ad", {
        get: function () {
            return this.ac;
        },
        set: function (a) {
            var b = this.ad;
            if (a != b) {
                this.ac = a;
                this.by("ChartTypePicker", b, this.ad);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "z", {
        get: function () {
            return this.y;
        },
        set: function (a) {
            var b = this.z;
            if (a != b) {
                this.y = a;
                this.by("TrendLineTypePicker", b, this.z);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ah", {
        get: function () {
            return this.ag;
        },
        set: function (a) {
            var b = this.ah;
            if (a != b) {
                this.ag = a;
                this.by("VolumeTypePicker", b, this.ah);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "p", {
        get: function () {
            return this.o;
        },
        set: function (a) {
            var b = this.p;
            if (a != b) {
                this.o = a;
                this.by("IndicatorPicker", b, this.p);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "r", {
        get: function () {
            return this.q;
        },
        set: function (a) {
            var b = this.r;
            if (a != b) {
                this.q = a;
                this.by("OverlayPicker", b, this.r);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartToolbar.prototype.by = function (a, b, c) {
        switch (a) {
            case "RangeStart":
                if (this.t != null) {
                    this.t.s = this.ax;
                }
                break;
            case "RangeEnd":
                if (this.t != null) {
                    this.t.r = this.aw;
                }
                break;
            case "SelectionStart":
                if (this.t != null) {
                    this.t.u = this.az;
                }
                break;
            case "SelectionEnd":
                if (this.t != null) {
                    this.t.t = this.ay;
                }
                break;
            case "RangeSelector":
                var d = b;
                if (d != null) {
                    d.rangeChanged = delegateRemove(d.rangeChanged, runOn(this, this.bt));
                }
                if (this.t != null) {
                    this.t.s = this.ax;
                    this.t.r = this.aw;
                    this.t.n = this.v;
                    this.t.u = this.az;
                    this.t.t = this.ay;
                    var e = this.t;
                    e.rangeChanged = delegateCombine(e.rangeChanged, runOn(this, this.bt));
                }
                break;
            case "ChartTypePicker":
                var f = b;
                if (f != null) {
                    f.changed = delegateRemove(f.changed, runOn(this, this.bs));
                }
                if (this.ad != null) {
                    this.ad.n = this.ab;
                    var g = this.ad;
                    g.changed = delegateCombine(g.changed, runOn(this, this.bs));
                }
                break;
            case "ChartType":
                if (this.ad != null) {
                    this.ad.n = this.ab;
                }
                break;
            case "TrendLineTypePicker":
                var h = b;
                if (h != null) {
                    h.changed = delegateRemove(h.changed, runOn(this, this.bu));
                }
                if (this.z != null) {
                    this.z.n = this.an;
                    var i = this.z;
                    i.changed = delegateCombine(i.changed, runOn(this, this.bu));
                }
                break;
            case "VolumeType":
                if (this.ah != null) {
                    this.ah.n = this.af;
                }
                break;
            case "VolumeTypePicker":
                var j = b;
                if (j != null) {
                    j.changed = delegateRemove(j.changed, runOn(this, this.bv));
                }
                if (this.ah != null) {
                    this.ah.n = this.af;
                    var k = this.ah;
                    k.changed = delegateCombine(k.changed, runOn(this, this.bv));
                }
                break;
            case "TrendLineType":
                if (this.z != null) {
                    this.z.n = this.an;
                }
                break;
            case "IndicatorPicker":
                var l = b;
                if (l != null) {
                    l.changed = delegateRemove(l.changed, runOn(this, this.bq));
                }
                if (this.p != null) {
                    this.p.n = this.aj;
                    var m = this.p;
                    m.changed = delegateCombine(m.changed, runOn(this, this.bq));
                }
                break;
            case "IndicatorTypes":
                if (this.p != null) {
                    this.p.n = this.aj;
                }
                break;
            case "OverlayPicker":
                var n = b;
                if (n != null) {
                    n.changed = delegateRemove(n.changed, runOn(this, this.br));
                }
                if (this.r != null) {
                    this.r.n = this.al;
                    var o = this.r;
                    o.changed = delegateCombine(o.changed, runOn(this, this.br));
                }
                break;
            case "OverlayTypes":
                if (this.r != null) {
                    this.r.n = this.al;
                }
                break;
            case "RangeSelectorOptions":
                if (this.t != null) {
                    this.t.n = this.v;
                }
                break;
            case "IsToolbarVisible":
                if (this.g == null) {
                    break;
                }
                if (this.aq) {
                    this.g.show();
                }
                else {
                    this.g.hide();
                }
                break;
        }
    };
    FinancialChartToolbar.prototype.br = function (a, b) {
        this.al = this.r.n;
        if (this.overlayTypesChanged != null) {
            this.overlayTypesChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.bq = function (a, b) {
        this.aj = this.p.n;
        if (this.indicatorTypesChanged != null) {
            this.indicatorTypesChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.bs = function (a, b) {
        this.ab = this.ad.n;
        if (this.chartTypeChanged != null) {
            this.chartTypeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.bu = function (a, b) {
        this.an = this.z.n;
        if (this.trendLineTypeChanged != null) {
            this.trendLineTypeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.bv = function (a, b) {
        this.af = this.ah.n;
        if (this.volumeTypeChanged != null) {
            this.volumeTypeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.bt = function (a, b) {
        this.az = this.t.u;
        this.ay = this.t.t;
        if (this.rangeChanged != null) {
            this.rangeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.w = function () {
        var _this = this;
        var a = new FinancialChartToolbarContext();
        a.container = this.d;
        a.vm = this.x;
        a.vm.financialChartChartTypePicker = ((function () {
            var $ret = new FinancialChartChartTypePickerContext();
            $ret.vm = _this.ad.p;
            return $ret;
        })());
        a.vm.financialChartIndicatorPicker = ((function () {
            var $ret = new FinancialChartIndicatorPickerContext();
            $ret.vm = _this.p.p;
            return $ret;
        })());
        a.vm.financialChartOverlayPicker = ((function () {
            var $ret = new FinancialChartOverlayPickerContext();
            $ret.vm = _this.r.p;
            return $ret;
        })());
        a.vm.financialChartRangeSelector = ((function () {
            var $ret = new FinancialChartRangeSelectorContext();
            $ret.vm = _this.t.p;
            return $ret;
        })());
        a.vm.financialChartTrendLineTypePicker = ((function () {
            var $ret = new FinancialChartTrendLinePickerContext();
            $ret.vm = _this.z.p;
            return $ret;
        })());
        a.vm.financialChartVolumeTypePicker = ((function () {
            var $ret = new FinancialChartVolumeTypePickerContext();
            $ret.vm = _this.ah.p;
            return $ret;
        })());
        return a;
    };
    FinancialChartToolbar.prototype.l = function (a) {
        _super.prototype.l.call(this, a);
        if (a == null) {
            return;
        }
        this.bw();
    };
    FinancialChartToolbar.prototype.bw = function () {
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "az", {
        get: function () {
            return this.av;
        },
        set: function (a) {
            var b = this.az;
            if (+a != +b) {
                this.av = a;
                this.by("SelectionStart", b, this.az);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ay", {
        get: function () {
            return this.au;
        },
        set: function (a) {
            var b = this.ay;
            if (+a != +b) {
                this.au = a;
                this.by("SelectionEnd", b, this.ay);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ax", {
        get: function () {
            return this.at;
        },
        set: function (a) {
            var b = this.ax;
            if (+a != +b) {
                this.at = a;
                this.by("RangeStart", b, this.ax);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "aw", {
        get: function () {
            return this.as;
        },
        set: function (a) {
            var b = this.aw;
            if (+a != +b) {
                this.as = a;
                this.by("RangeEnd", b, this.aw);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartToolbar.prototype.bz = function () {
        if (this.t != null) {
            this.t.z();
        }
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "ab", {
        get: function () {
            return this.aa;
        },
        set: function (a) {
            var b = this.ab;
            if (a != b) {
                this.aa = a;
                this.by("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.ab));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "an", {
        get: function () {
            return this.am;
        },
        set: function (a) {
            var b = this.an;
            if (a != b) {
                this.am = a;
                this.by("TrendLineType", enumGetBox(TrendLineType_$type, b), enumGetBox(TrendLineType_$type, this.an));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "af", {
        get: function () {
            return this.ae;
        },
        set: function (a) {
            var b = this.af;
            if (a != b) {
                this.ae = a;
                this.by("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.af));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "aj", {
        get: function () {
            return this.ai;
        },
        set: function (a) {
            var b = this.aj;
            if (!FinancialChartToolbar.ar(b, a)) {
                this.ai = a;
                this.by("IndicatorTypes", b, this.aj);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "al", {
        get: function () {
            return this.ak;
        },
        set: function (a) {
            var b = this.al;
            if (!FinancialChartToolbar.ar(b, a)) {
                this.ak = a;
                this.by("OverlayTypes", b, this.al);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartToolbar.ar = function (a, b) {
        if (a == b) {
            return true;
        }
        if ((a == null && b != null) || (a != null && b == null)) {
            return false;
        }
        if (a.count != b.count) {
            return false;
        }
        try {
            for (var _a = tslib_1.__values(fromEn(a)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var c = _b.value;
                if (!b.contains(c)) {
                    return false;
                }
            }
        }
        catch (e_21_1) { e_21 = { error: e_21_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_21) throw e_21.error; }
        }
        return true;
        var e_21, _c;
    };
    FinancialChartToolbar.prototype.ao = function () {
        var _this = this;
        return ((function () {
            var $ret = new FinancialChartToolbarVisualData();
            $ret.indicatorPicker = _this.p == null ? null : _this.p.q();
            $ret.overlayPicker = _this.r == null ? null : _this.r.q();
            $ret.trendLineTypePicker = _this.z == null ? null : _this.z.q();
            $ret.chartTypePicker = _this.ad == null ? null : _this.ad.q();
            $ret.volumeTypePicker = _this.ah == null ? null : _this.ah.q();
            $ret.rangeSelector = _this.t == null ? null : _this.t.q();
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "v", {
        get: function () {
            return this.u;
        },
        set: function (a) {
            var b = this.v;
            if (a != b) {
                this.u = a;
                this.by("RangeSelectorOptions", b, this.v);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "aq", {
        get: function () {
            return this.ap;
        },
        set: function (a) {
            var b = this.aq;
            if (a != b) {
                this.ap = a;
                this.by("IsToolbarVisible", b, this.aq);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartToolbar.a6 = 0;
    FinancialChartToolbar.$t = markType(FinancialChartToolbar, 'FinancialChartToolbar', TemplatedHtmlControl.$);
    return FinancialChartToolbar;
}(TemplatedHtmlControl));
export { FinancialChartToolbar };
var FinancialChartRangeSelector = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialChartRangeSelector, _super);
    function FinancialChartRangeSelector(a) {
        var _this = _super.call(this, "financialChartRangeSelector", a, "") || this;
        _this.p = null;
        _this.rangeChanged = null;
        _this.o = null;
        _this.o = new FinancialChartRangeSelectorView();
        _this.p = new FinancialChartRangeSelectorViewModel();
        _this.p.onRangeChanged = runOn(_this, _this.y);
        return _this;
    }
    Object.defineProperty(FinancialChartRangeSelector.prototype, "u", {
        get: function () {
            return this.p.selectionStart;
        },
        set: function (a) {
            this.p.selectionStart = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "t", {
        get: function () {
            return this.p.selectionEnd;
        },
        set: function (a) {
            this.p.selectionEnd = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "s", {
        get: function () {
            return this.p.rangeStart;
        },
        set: function (a) {
            this.p.rangeStart = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "r", {
        get: function () {
            return this.p.rangeEnd;
        },
        set: function (a) {
            this.p.rangeEnd = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartRangeSelector.prototype.z = function () {
        if (this.p.onPropertiesChanged()) {
            this.o.e(this.p);
        }
    };
    FinancialChartRangeSelector.prototype.l = function (a) {
        _super.prototype.l.call(this, a);
        this.o.d(this.d, this.p);
    };
    FinancialChartRangeSelector.prototype.y = function () {
        if (this.rangeChanged != null) {
            this.rangeChanged(this, EventArgs.empty);
        }
    };
    FinancialChartRangeSelector.prototype.q = function () {
        return this.o.c(this.g);
    };
    Object.defineProperty(FinancialChartRangeSelector.prototype, "n", {
        get: function () {
            return this.p.options;
        },
        set: function (a) {
            var b = !FinancialChartToolbar.ar(this.p.options, a);
            if (b) {
                this.p.options = a;
                if (this.o != null) {
                    this.o.g(this.n);
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartRangeSelector.w = 0;
    FinancialChartRangeSelector.$t = markType(FinancialChartRangeSelector, 'FinancialChartRangeSelector', TemplatedHtmlControl.$);
    return FinancialChartRangeSelector;
}(TemplatedHtmlControl));
export { FinancialChartRangeSelector };
//# sourceMappingURL=FinancialChart_combined.js.map