/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { EventArgs, Base, Type, markType, typeCast, Point_$type, String_$type, runOn, Number_$type, enumGetBox, fromEnum, toEnum, Delegate_$type } from "igniteui-angular-core/ES5/type";
import { IBucketizer_$type } from "./IBucketizer";
import { ArgumentNullException } from "igniteui-angular-core/ES5/ArgumentNullException";
import { IFastItemColumn$1_$type } from "igniteui-angular-core/ES5/IFastItemColumn$1";
import { Series } from "./Series";
import { Rect } from "igniteui-angular-core/ES5/Rect";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { SeriesView } from "./SeriesView";
import { truncate, intDivide, isInfinity, isNaN_ } from "igniteui-angular-core/ES5/number";
import { IHasCategoryAxis_$type } from "./IHasCategoryAxis";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { Brush } from "igniteui-angular-core/ES5/Brush";
import { DependencyProperty } from "igniteui-angular-core/ES5/DependencyProperty";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionInMode_$type } from "./CategoryTransitionInMode";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode_$type } from "./CategoryMode";
import { List$1 } from "igniteui-angular-core/ES5/List$1";
import { Dictionary$2 } from "igniteui-angular-core/ES5/Dictionary$2";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { IFastItemsSource_$type } from "igniteui-angular-core/ES5/IFastItemsSource";
import { FinancialValueList } from "./FinancialValueList";
import { CategoryXAxis } from "./CategoryXAxis";
import { SafeSortedReadOnlyDoubleCollection } from "./SafeSortedReadOnlyDoubleCollection";
import { SafeReadOnlyDoubleCollection } from "./SafeReadOnlyDoubleCollection";
import { SafeEnumerable } from "./SafeEnumerable";
import { CalculatedColumn } from "./CalculatedColumn";
import { TrendCalculators } from "igniteui-angular-core/ES5/TrendCalculators";
import { ColumnSupportingCalculation } from "./ColumnSupportingCalculation";
import { IDateTimeAxis_$type } from "./IDateTimeAxis";
import { PropertyMetadata } from "igniteui-angular-core/ES5/PropertyMetadata";
import { SupportingCalculation$1 } from "./SupportingCalculation$1";
import { Color } from "igniteui-angular-core/ES5/Color";
import { stringIsNullOrEmpty } from "igniteui-angular-core/ES5/string";
var FinancialEventArgs = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialEventArgs, _super);
    function FinancialEventArgs(a, b, c, d, e) {
        var _this = _super.call(this) || this;
        _this._position = 0;
        _this._count = 0;
        _this._dataSource = null;
        _this._supportingCalculations = null;
        _this._basedOn = null;
        _this.position = a;
        _this.count = b;
        _this.dataSource = c;
        _this.supportingCalculations = d;
        if (c != null) {
            c.series = e;
        }
        return _this;
    }
    Object.defineProperty(FinancialEventArgs.prototype, "position", {
        get: function () {
            return this._position;
        },
        set: function (a) {
            this._position = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialEventArgs.prototype, "count", {
        get: function () {
            return this._count;
        },
        set: function (a) {
            this._count = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialEventArgs.prototype, "dataSource", {
        get: function () {
            return this._dataSource;
        },
        set: function (a) {
            this._dataSource = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialEventArgs.prototype, "supportingCalculations", {
        get: function () {
            return this._supportingCalculations;
        },
        set: function (a) {
            this._supportingCalculations = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialEventArgs.prototype, "basedOn", {
        get: function () {
            return this._basedOn;
        },
        set: function (a) {
            this._basedOn = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialEventArgs.$t = markType(FinancialEventArgs, 'FinancialEventArgs', EventArgs.$);
    return FinancialEventArgs;
}(EventArgs));
export { FinancialEventArgs };
var FinancialBucketCalculator = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialBucketCalculator, _super);
    function FinancialBucketCalculator(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.c = 0;
        _this.d = 0;
        _this.b = 0;
        if (a == null) {
            throw new ArgumentNullException(0, "view");
        }
        _this.a = a;
        _this.c = -1;
        _this.d = _this.d;
        _this.b = 0;
        return _this;
    }
    FinancialBucketCalculator.prototype.getBucket = function (a) {
        return null;
    };
    FinancialBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        return this.getBucket(a);
    };
    FinancialBucketCalculator.prototype.getErrorBucket = function (a, b) {
        return NaN;
    };
    FinancialBucketCalculator.prototype.getBucketInfo = function (a, b, c, d) {
        a = this.c;
        b = this.d;
        c = this.b;
        d = this.a.bu.ek;
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d
        };
    };
    FinancialBucketCalculator.prototype.e = function (a) {
        var b = this.a.bq;
        var c = this.a.bp;
        var d = this.a.bp;
        if (this.a.bu != null) {
            d = this.a.bu.getEffectiveViewport1(this.a);
        }
        if (b.isEmpty || c.isEmpty || this.a.bu.lp == null) {
            this.b = 0;
            return;
        }
        var e = (this.a.bu.lp != null) ? this.a.bu.lp.b8 : false;
        var f = new ScalerParams(0, b, c, e, d);
        var g = this.a.bu.k7(this.a);
        var h = typeCast(ISortingAxis_$type, this.a.bu.lp);
        if (h == null || h.i$b == null) {
            var i = Math.floor(this.a.bu.lp.dw(g.left, f));
            var j = Math.ceil(this.a.bu.lp.dw(g.right, f));
            if (this.a.bu.lp.b8) {
                j = Math.ceil(this.a.bu.lp.dw(g.left, f));
                i = Math.floor(this.a.bu.lp.dw(g.right, f));
            }
            var k = Math.floor((j - i + 1) * a / g.width);
            this.b = truncate(Math.max(1, k));
            this.c = truncate(Math.floor(i / this.b));
            this.d = truncate(Math.ceil(j / this.b));
        }
        else {
            this.c = h.i$e(b, c, d, g);
            this.d = h.i$g(b, c, d, g);
            this.b = 1;
        }
    };
    FinancialBucketCalculator.prototype.cacheValues = function () {
    };
    FinancialBucketCalculator.prototype.unCacheValues = function () {
    };
    FinancialBucketCalculator.$t = markType(FinancialBucketCalculator, 'FinancialBucketCalculator', Base.$, [IBucketizer_$type]);
    return FinancialBucketCalculator;
}(Base));
export { FinancialBucketCalculator };
var FinancialSeries = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialSeries, _super);
    function FinancialSeries() {
        var _this = _super.call(this) || this;
        _this.mg = null;
        _this.mc = null;
        _this.me = null;
        _this.ma = null;
        _this.mj = null;
        _this.mn = false;
        _this.assigningCategoryStyle = null;
        _this.lx = null;
        _this.my = new Dictionary$2(IFastItemColumn$1_$type.specialize(Number_$type), String_$type, 0);
        _this.mz = new Dictionary$2(String_$type, String_$type, 0);
        _this.mm = false;
        _this.l8 = null;
        _this.ls = null;
        _this.lu = null;
        _this.lr = null;
        _this.ov = null;
        _this.l0 = null;
        _this.typical = null;
        _this.typicalBasedOn = null;
        _this.ml = false;
        _this.nb = null;
        _this.m9 = null;
        _this.na = null;
        _this.m8 = null;
        _this.nc = null;
        _this.lt = null;
        _this.lq = null;
        _this.lv = 0;
        _this.lx = new CategorySeriesRenderManager();
        _this.mn = false;
        _this.l0 = new CategoryTransitionSourceFramePreparer();
        _this.lt = new CategoryFrame(3);
        _this.ab = FinancialSeries.$;
        _this.lw = 0;
        return _this;
    }
    FinancialSeries.prototype.ib = function (a) {
        _super.prototype.ib.call(this, a);
        this.l5 = a;
    };
    FinancialSeries.prototype.get_cq = function () {
        return true;
    };
    Object.defineProperty(FinancialSeries.prototype, "cq", {
        get: function () {
            return this.get_cq();
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype.ag = function () {
        return [this.lp, this.l9];
    };
    FinancialSeries.prototype.nm = function () {
        return 2;
    };
    FinancialSeries.prototype.ah = function (a) {
        var b = this.aj(this.lp, this.lr.f, this.nk(this.bi), this.nl(this.bi), this.k5(a), true);
        if (b == null) {
            return null;
        }
        var c = b[0];
        var d = b[1];
        var e = new Array(1);
        var f = new Array(2);
        var g = this.nm();
        f[0] = { $type: Point_$type, x: c[0], y: c[g] };
        f[1] = { $type: Point_$type, x: d[0], y: d[g] };
        e[0] = f;
        return e;
    };
    FinancialSeries.prototype.ai = function (a) {
        var b = this.aj(this.lp, this.lr.f, this.nk(this.bi), this.nl(this.bi), this.k5(a), true);
        if (b == null) {
            return null;
        }
        var c = b[0];
        var d = b[1];
        var e = new Array(1);
        var f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[1] };
        f[1] = { $type: Point_$type, x: d[0], y: d[1] };
        e[0] = f;
        return e;
    };
    FinancialSeries.prototype.kq = function () {
        return this.or;
    };
    FinancialSeries.prototype.hd = function () {
        _super.prototype.hd.call(this);
        this.lp = null;
        this.l9 = null;
    };
    Object.defineProperty(FinancialSeries.prototype, "mh", {
        get: function () {
            return this.mg;
        },
        set: function (a) {
            if (this.mg != a) {
                var b = this.mg;
                this.mg = a;
                this.raisePropertyChanged("OpenColumn", b, this.mg);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialSeries.prototype, "md", {
        get: function () {
            return this.mc;
        },
        set: function (a) {
            if (this.mc != a) {
                var b = this.mc;
                this.mc = a;
                this.raisePropertyChanged("HighColumn", b, this.mc);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialSeries.prototype, "mf", {
        get: function () {
            return this.me;
        },
        set: function (a) {
            if (this.me != a) {
                var b = this.me;
                this.me = a;
                this.raisePropertyChanged("LowColumn", b, this.me);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialSeries.prototype, "mb", {
        get: function () {
            return this.ma;
        },
        set: function (a) {
            if (this.ma != a) {
                var b = this.ma;
                this.ma = a;
                this.raisePropertyChanged("CloseColumn", b, this.ma);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialSeries.prototype, "mk", {
        get: function () {
            return this.mj;
        },
        set: function (a) {
            if (this.mj != a) {
                var b = this.mj;
                this.mj = a;
                this.raisePropertyChanged("VolumeColumn", b, this.mj);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype.mv = function () {
        return (this.assigningCategoryStyle != null && this.mn) || this.ct;
    };
    FinancialSeries.prototype.oe = function (a) {
        if (this.assigningCategoryStyle != null && this.mn) {
            this.assigningCategoryStyle(this, a);
        }
    };
    FinancialSeries.prototype.oc = function (a, b, c, d, e, f) {
        var g = this.b9;
        this.lx.ac(a, b, c, d, e, f, g);
        var h = this.lx.c;
        var i = null;
        var j = this.bz;
        if (g && this.bs != null) {
            i = this.bs.az.getHighlightingInfo(this, j, d, h.m, h.l, false);
            h.b = i;
        }
        h.f = f;
        this.oe(h);
        this.lx.aa(i, f, g);
    };
    FinancialSeries.prototype.nd = function (a) {
        return this.d5(a, this.lp);
    };
    FinancialSeries.prototype.e4 = function (a, b) {
        return this.e5(a, b, this.lp, runOn(this, this.nd), new FinancialValueList(this.mh, this.md, this.mf, this.mb, this.mk));
    };
    FinancialSeries.prototype.e2 = function (a, b) {
        return this.e3(a, b, this.lp, runOn(this, this.nd), new FinancialValueList(this.mh, this.md, this.mf, this.mb, this.mk));
    };
    FinancialSeries.prototype.d1 = function (a, b, c, d, e) {
        if (c == null) {
            return Number.POSITIVE_INFINITY;
        }
        var f = this.lp.jq;
        return this.d2(a, b, this.lp, d, e, f, runOn(this, this.nd));
    };
    FinancialSeries.prototype.getOffsetValue = function () {
        return this.ne(this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi));
    };
    FinancialSeries.prototype.getCategoryWidth = function () {
        return this.lp.getCategorySize(this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi));
    };
    FinancialSeries.prototype.k2 = function (a, b, c) {
        return this.k4(a, b, c, this.ne(this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi)), this.l9, this.lp, null, null, null);
    };
    FinancialSeries.prototype.ee = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.bi);
        var e = this.ne(this.bi.bq, this.bi.bp, d);
        var f = new ScalerParams(0, this.bi.bq, this.bi.bp, this.lp.b8, d);
        return this.eg(new FinancialValueList(this.mh, this.md, this.mf, this.mb, this.mk), a, this.lp, f, e, runOn(this, this.nd), b, c);
    };
    FinancialSeries.prototype.ea = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.bi);
        var e = this.ne(this.bi.bq, this.bi.bp, d);
        var f = new ScalerParams(0, this.bi.bq, this.bi.bp, this.lp.b8, d);
        return this.eg(this.md, a, this.lp, f, e, runOn(this, this.nd), b, c);
    };
    FinancialSeries.prototype.ec = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.bi);
        var e = this.ne(this.bi.bq, this.bi.bp, d);
        var f = new ScalerParams(0, this.bi.bq, this.bi.bp, this.lp.b8, d);
        return this.eg(this.mf, a, this.lp, f, e, runOn(this, this.nd), b, c);
    };
    FinancialSeries.prototype.nf = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.bi);
        var e = this.ne(this.bi.bq, this.bi.bp, d);
        var f = new ScalerParams(0, this.bi.bq, this.bi.bp, this.lp.b8, d);
        return this.eg(this.mb, a, this.lp, f, e, runOn(this, this.nd), b, c);
    };
    FinancialSeries.prototype.ng = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.bi);
        var e = this.ne(this.bi.bq, this.bi.bp, d);
        var f = new ScalerParams(0, this.bi.bq, this.bi.bp, this.lp.b8, d);
        return this.eg(this.mh, a, this.lp, f, e, runOn(this, this.nd), b, c);
    };
    FinancialSeries.prototype.nh = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.bi);
        var e = this.ne(this.bi.bq, this.bi.bp, d);
        var f = new ScalerParams(0, this.bi.bq, this.bi.bp, this.lp.b8, d);
        return this.eg(this.mk, a, this.lp, f, e, runOn(this, this.nd), b, c);
    };
    FinancialSeries.prototype.ky = function (a, b, c) {
        var _this = this;
        return this.k4(a, b, c, this.ne(this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi)), this.l9, this.lp, runOn(this, this.ea), function (d, e) { return _this.e5(d, e, _this.lp, runOn(_this, _this.nd), _this.md); }, function (d, e) { return _this.e3(d, e, _this.lp, runOn(_this, _this.nd), _this.md); });
    };
    FinancialSeries.prototype.k0 = function (a, b, c) {
        var _this = this;
        return this.k4(a, b, c, this.ne(this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi)), this.l9, this.lp, runOn(this, this.ec), function (d, e) { return _this.e5(d, e, _this.lp, runOn(_this, _this.nd), _this.mf); }, function (d, e) { return _this.e3(d, e, _this.lp, runOn(_this, _this.nd), _this.mf); });
    };
    FinancialSeries.prototype.ot = function (a, b, c) {
        var _this = this;
        return this.k4(a, b, c, this.ne(this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi)), this.l9, this.lp, runOn(this, this.ng), function (d, e) { return _this.e5(d, e, _this.lp, runOn(_this, _this.nd), _this.mh); }, function (d, e) { return _this.e3(d, e, _this.lp, runOn(_this, _this.nd), _this.mh); });
    };
    FinancialSeries.prototype.os = function (a, b, c) {
        var _this = this;
        return this.k4(a, b, c, this.ne(this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi)), this.l9, this.lp, runOn(this, this.nf), function (d, e) { return _this.e5(d, e, _this.lp, runOn(_this, _this.nd), _this.mb); }, function (d, e) { return _this.e3(d, e, _this.lp, runOn(_this, _this.nd), _this.mb); });
    };
    FinancialSeries.prototype.ou = function (a, b, c) {
        var _this = this;
        return this.k4(a, b, c, this.ne(this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi)), this.l9, this.lp, runOn(this, this.nh), function (d, e) { return _this.e5(d, e, _this.lp, runOn(_this, _this.nd), _this.mk); }, function (d, e) { return _this.e3(d, e, _this.lp, runOn(_this, _this.nd), _this.mk); });
    };
    FinancialSeries.prototype.hu = function () {
        _super.prototype.hu.call(this);
        if (this.lp != null) {
            this.lp.gz(false);
        }
        if (this.l9 != null) {
            this.l9.gz(false);
        }
    };
    FinancialSeries.prototype.ja = function (a, b) {
        this.l5.bs.e(this.ek);
        this.iv(false);
    };
    FinancialSeries.prototype.i9 = function (a, b) {
        if (this.dj && this.ep < 0.05) {
            this.dk = true;
        }
        this.l5.bs.e(this.ek);
        this.iv(false);
    };
    FinancialSeries.prototype.mi = function (a, b, c) {
        var d = this.bw(b);
        this.my.addItem(d, b);
        this.mz.addItem(b, c);
        return d;
    };
    FinancialSeries.prototype.ob = function (a, b) {
        if (b == null) {
            return;
        }
        a.deregisterColumn(b);
        var c = this.my.item(b);
        this.mz.removeItem(c);
        this.my.removeItem(b);
    };
    FinancialSeries.prototype.ih = function (a, b, c, d) {
        _super.prototype.ih.call(this, a, b, c, d);
        switch (b) {
            case "SyncLink":
                if (this.bn != null && this.bs != null) {
                    this.l5.bs.e(this.ek);
                    this.iv(false);
                }
                break;
            case "SeriesViewer":
                if (c != null && d == null) {
                    if (this.lp != null) {
                        this.lp.bv(this);
                    }
                    if (this.l9 != null) {
                        this.l9.bv(this);
                    }
                }
                if (c == null && d != null) {
                    if (this.lp != null) {
                        this.lp.ch(this);
                    }
                    if (this.l9 != null) {
                        this.l9.ch(this);
                    }
                }
                this.l5.bs.e(this.ek);
                this.iv(false);
                break;
            case "FastItemsSource":
                this.mm = true;
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    this.ob(typeCast(IFastItemsSource_$type, c), this.mh);
                    this.ob(typeCast(IFastItemsSource_$type, c), this.md);
                    this.ob(typeCast(IFastItemsSource_$type, c), this.mf);
                    this.ob(typeCast(IFastItemsSource_$type, c), this.mb);
                    this.ob(typeCast(IFastItemsSource_$type, c), this.mk);
                    this.mh = null;
                    this.md = null;
                    this.mf = null;
                    this.mb = null;
                    this.mk = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    if (this.n2 != null) {
                        this.mh = this.mi(typeCast(IFastItemsSource_$type, d), this.n2, "OpenColumn");
                    }
                    if (this.nt != null) {
                        this.md = this.mi(typeCast(IFastItemsSource_$type, d), this.nt, "HighColumn");
                    }
                    if (this.ny != null) {
                        this.mf = this.mi(typeCast(IFastItemsSource_$type, d), this.ny, "LowColumn");
                    }
                    if (this.nq != null) {
                        this.mb = this.mi(typeCast(IFastItemsSource_$type, d), this.nq, "CloseColumn");
                    }
                    if (this.n6 != null) {
                        this.mk = this.mi(typeCast(IFastItemsSource_$type, d), this.n6, "VolumeColumn");
                    }
                }
                this.mm = false;
                if (this.l9 != null && !this.l9.ck()) {
                    this.l5.bs.e(this.ek);
                    this.iv(false);
                }
                break;
            case FinancialSeries.$$p[6]:
                if (this.bz != null) {
                    this.ob(this.bz, this.mh);
                    this.mh = this.mi(this.bz, this.n2, "OpenColumn");
                }
                break;
            case "OpenColumn":
                if (this.l9 != null && !this.l9.ck() && !this.mm) {
                    this.l5.bs.e(this.ek);
                    this.iv(false);
                }
                break;
            case FinancialSeries.$$p[1]:
                if (this.bz != null) {
                    this.ob(this.bz, this.md);
                    this.md = this.mi(this.bz, this.nt, "HighColumn");
                }
                break;
            case "HighColumn":
                if (this.l9 != null && !this.l9.ck() && !this.mm) {
                    this.l5.bs.e(this.ek);
                    this.iv(false);
                }
                break;
            case FinancialSeries.$$p[4]:
                if (this.bz != null) {
                    this.ob(this.bz, this.mf);
                    this.mf = this.mi(this.bz, this.ny, "LowColumn");
                }
                break;
            case "LowColumn":
                if (this.l9 != null && !this.l9.ck() && !this.mm) {
                    this.l5.bs.e(this.ek);
                    this.iv(false);
                }
                break;
            case FinancialSeries.$$p[0]:
                if (this.bz != null) {
                    this.ob(this.bz, this.mb);
                    this.mb = this.mi(this.bz, this.nq, "CloseColumn");
                }
                break;
            case "CloseColumn":
                if (this.l9 != null && !this.l9.ck() && !this.mm) {
                    this.l5.bs.e(this.ek);
                    this.iv(false);
                }
                break;
            case FinancialSeries.$$p[8]:
                if (this.bz != null) {
                    this.ob(this.bz, this.mk);
                    this.mk = this.mi(this.bz, this.n6, "VolumeColumn");
                }
                break;
            case "VolumeColumn":
                if (this.l9 != null && !this.l9.ck() && !this.mm) {
                    this.l5.bs.e(this.ek);
                    this.iv(false);
                }
                break;
            case FinancialSeries.$$p[9]:
                if (c != null) {
                    c.bv(this);
                }
                if (d != null) {
                    d.ch(this);
                }
                this.l5.bs.e(this.ek);
                this.iv(false);
                this.h2();
                break;
            case FinancialSeries.$$p[10]:
                if (c != null) {
                    c.bv(this);
                }
                if (d != null) {
                    d.ch(this);
                }
                this.l5.bs.e(this.ek);
                if (this.l9 != null) {
                    this.l9.ck();
                }
                {
                    this.iv(false);
                }
                this.h2();
                break;
            case "TransitionProgress":
                this.lu.c(this.ep, this.ls, this.lr);
                if (this.cc(this.bi)) {
                    return;
                }
                if (this.ep == 1) {
                    this.lr.v();
                    this.of(this.lr, this.l5);
                    if (this.dj) {
                        this.dj = false;
                        this.hg();
                        this.bt.r = truncate(this.eh());
                        this.bt.b = this.bu;
                    }
                }
                else {
                    this.of(this.lu, this.l5);
                }
                break;
            case FinancialSeries.$$p[5]:
                this.iv(false);
                break;
            case "IsCustomCategoryStyleAllowed":
                this.mn = this.mq();
                this.iv(false);
                break;
            case "CategoryMode":
                if (this.lp != null) {
                    this.lp.kf(true);
                }
                break;
        }
    };
    FinancialSeries.prototype.mp = function (a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    FinancialSeries.prototype.mo = function (a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.b5) {
            return true;
        }
        return false;
    };
    FinancialSeries.prototype.li = function (a, b, c) {
        if (b < a || a < 0 || a > this.bz.count || b < 0 || b > this.bz.count || c == null) {
            return null;
        }
        var d = new Array((b - a) + 1);
        var e = c.cc;
        var f = null;
        if (e) {
            f = c.i$b;
        }
        for (var g = a; g <= b; g++) {
            var h = g;
            if (e) {
                h = f._inner[h];
            }
            d[g - a] = this.bz.item(g);
        }
        return d;
    };
    FinancialSeries.prototype.nk = function (a) {
        return a.bs.b;
    };
    FinancialSeries.prototype.nl = function (a) {
        return a.bs.c;
    };
    FinancialSeries.prototype.lh = function (a, b) {
        return this.li(a, b, this.l9);
    };
    FinancialSeries.prototype.get_mr = function () {
        return false;
    };
    Object.defineProperty(FinancialSeries.prototype, "mr", {
        get: function () {
            return this.get_mr();
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype.get_cu = function () {
        return true;
    };
    Object.defineProperty(FinancialSeries.prototype, "cu", {
        get: function () {
            return this.get_cu();
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype.at = function (a, b) {
        if (this.mr) {
            var c = this.l7(a, b, this.l8);
            this.l8 = c;
            return c;
        }
        else {
            var d = this.l6(a, b, this.l8);
            this.l8 = d;
            return d;
        }
    };
    FinancialSeries.prototype.nn = function (a) {
        var b = this.lr;
        if (this.ca()) {
            b = this.lu;
        }
        var c = this.bi.bp;
        var d = this.bi.bq;
        var e = this.lp;
        var f = 0;
        if (e.ce) {
            var g = (a.y - d.top) / d.height;
            f = g * c.height + c.top;
        }
        else {
            var h = (a.x - d.left) / d.width;
            f = h * c.width + c.left;
        }
        var i = b.f.count;
        var j = 0;
        for (j = 0; j < i; j++) {
            var k = b.f._inner[j];
            var l = null;
            if (j < i - 1) {
                l = b.f._inner[j + 1];
            }
            if (k[0] <= f && l == null || l[0] >= f) {
                if (l != null) {
                    if (Math.abs(k[0] - f) < Math.abs(l[0] - f)) {
                        return j;
                    }
                    else {
                        return j + 1;
                    }
                }
                else {
                    return j;
                }
            }
        }
        return j;
    };
    FinancialSeries.prototype.l7 = function (a, b, c) {
        var d = this.bz.count;
        var e = this.l5.bs.c;
        var f = this.l5.bs.d;
        var g = this.l5.bs.b;
        var h = this.lp;
        var i = -1;
        var j = -1;
        if (h.cc) {
            var k = this.lr;
            if (this.ca()) {
                k = this.lu;
            }
            var l = this.nn(b);
            i = l;
            j = l;
        }
        else {
            var m = this.ey(b);
            i = truncate(Math.floor((intDivide(m, g)))) * g;
            j = i + (g - 1);
        }
        if (c != null && c.f == i && c.e == j) {
            return c;
        }
        var n = new HighlightingInfo();
        n.b = this;
        n.f = i;
        n.e = j;
        return n;
    };
    FinancialSeries.prototype.l6 = function (a, b, c) {
        var d = new HighlightingInfo();
        d.b = this;
        d.f = 0;
        d.e = this.bz.count - 1;
        if (c != null && c.f == d.f && c.e == d.e) {
            return c;
        }
        return d;
    };
    FinancialSeries.prototype.mq = function () {
        return this.mt;
    };
    FinancialSeries.prototype.d3 = function (a) {
        var b = this.bi.bq;
        var c = this.bi.bp;
        var d = -1;
        if (!b.isEmpty && !c.isEmpty && this.lp != null) {
            var e = this.getEffectiveViewport1(this.bi);
            var f = new ScalerParams(0, b, c, this.lp.b8, e);
            var g = this.k7(this.bi);
            var h = this.lp.dw(g.left, f);
            var i = this.lp.dw(g.right, f);
            var j = (a.x - b.left) / b.width;
            var k = h + (j * (i - h));
            if (this.lp.categoryMode != 0) {
                k -= 0.5;
            }
            d = k;
        }
        return d;
    };
    FinancialSeries.prototype.ey = function (a) {
        return truncate(Math.round(this.d3(a)));
    };
    FinancialSeries.prototype.get_c0 = function () {
        return typeCast(ISortingAxis_$type, this.lp) !== null;
    };
    Object.defineProperty(FinancialSeries.prototype, "c0", {
        get: function () {
            return this.get_c0();
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype.ap = function () {
        return this.lp;
    };
    FinancialSeries.prototype.e0 = function (a) {
        var b = this.bi.bq;
        var c = this.bi.bp;
        var d = this.getEffectiveViewport1(this.bi);
        if (b.isEmpty || c.isEmpty) {
            return -1;
        }
        var e = new Rect(0, 0, 0, 1, 1);
        var f = new ScalerParams(0, b, c, this.lp.b8, d);
        var g = typeCast(ISortingAxis_$type, this.lp);
        var h = this.k7(this.bi);
        var i = h.left;
        var j = h.right;
        var k = this.kx(a).x;
        var l = this.lp.dw(k, f);
        var m = this.lp.dw(i, f);
        var n = this.lp.dw(j, f);
        l = Math.max(m, Math.min(n, l));
        var o = g.i$f(l);
        return o;
    };
    FinancialSeries.prototype.ff = function (a) {
        var b = 0;
        if (typeCast(ISortingAxis_$type, this.lp) !== null) {
            b = this.e0(a);
            if (b == -1) {
                return null;
            }
        }
        else {
            b = this.ey(a);
        }
        return b >= 0 && this.bz != null && b < this.bz.count ? this.bz.item(b) : null;
    };
    FinancialSeries.prototype.ne = function (a, b, c) {
        if (this.lp == null) {
            return 0;
        }
        return this.lp.getOffset(a, b, c, this.e7);
    };
    FinancialSeries.prototype.c9 = function () {
        return this.mu;
    };
    FinancialSeries.prototype.ly = function () {
        return 11;
    };
    FinancialSeries.prototype.bo = function () {
        return 3;
    };
    FinancialSeries.prototype.of = function (a, b) {
        this.k6 = a.aa;
        b.ar();
    };
    Object.defineProperty(FinancialSeries.prototype, "ow", {
        get: function () {
            return this.ov;
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype.od = function (a, b) {
        a.u();
    };
    FinancialSeries.prototype.dt = function (a, b, c) {
        var d = _super.prototype.dt.call(this, a, b, c);
        var e = c;
        if (this.bz == null || this.bz.count == 0 || !c.l() || b.isEmpty || a.isEmpty || this.lp == null || this.l9 == null || e.bs.b < 1 || this.lp.bf == null || this.l9.bf == null || this.l9.jw == this.l9.jv || this.lp.itemsSource == null || this.lp.jq < 1) {
            e.bs.b = 0;
            d = false;
        }
        return d;
    };
    FinancialSeries.prototype.getViewInfo = function (a, b) {
        b = this.bi.bq;
        a = this.bi.bp;
        return {
            p0: a,
            p1: b
        };
    };
    FinancialSeries.prototype.ni = function (a) {
        var b = 0;
        var c = a.bq;
        var d = a.bp;
        var e = this.getEffectiveViewport1(this.bi);
        if (!c.isEmpty && !d.isEmpty && this.l9 != null) {
            var f = new ScalerParams(0, c, d, this.l9.b8, e);
            b = this.l9.dt(this.l9.j6, f);
        }
        return b;
    };
    FinancialSeries.prototype.hg = function () {
        _super.prototype.hg.call(this);
        this.ls.v();
        this.lr.v();
        this.lu.v();
    };
    FinancialSeries.prototype.iw = function (a) {
        var _this = this;
        _super.prototype.iw.call(this, a);
        this.l5.bs.e(this.ek);
        if (this.cc(this.bi)) {
            return;
        }
        if (this.db) {
            if (this.ca()) {
                this.of(this.lu, this.l5);
            }
            else {
                this.of(this.lr, this.l5);
            }
            return;
        }
        if (this.c7(a)) {
            var b = this.ls;
            if (this.ca()) {
                if (this.bt.g) {
                    this.bt.t();
                }
                this.ls = this.lu;
                this.lu = b;
            }
            else {
                this.ls = this.lr;
                this.lr = b;
            }
            this.od(this.lr, this.l5);
            if (this.dl) {
                this.bt.w();
                this.bt.r = truncate(this.ei());
                this.bt.b = this.bv != null ? this.bv : this.bu;
                this.l0.p(this.ls, this.lr, this.isVertical, this.lp, this.l9, this.lz, this.ly(), this.bp, this.bo(), function () { return _this.ni(_this.l5); }, this.l5.bp);
            }
            this.hc();
            this.i3();
            if (this.dl) {
                this.dk = false;
                this.dj = true;
            }
        }
        else {
            this.od(this.lr, this.l5);
            this.of(this.lr, this.l5);
        }
    };
    FinancialSeries.prototype.mw = function (a) {
        try {
            for (var _a = tslib_1.__values(fromEnum(a)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var b = _b.value;
                switch (b) {
                    case "HighColumn":
                        if (this.md == null) {
                            return false;
                        }
                        break;
                    case "LowColumn":
                        if (this.mf == null) {
                            return false;
                        }
                        break;
                    case "OpenColumn":
                        if (this.mh == null) {
                            return false;
                        }
                        break;
                    case "CloseColumn":
                        if (this.mb == null) {
                            return false;
                        }
                        break;
                    case "VolumeColumn":
                        if (this.mk == null) {
                            return false;
                        }
                        break;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return true;
        var e_1, _c;
    };
    Object.defineProperty(FinancialSeries.prototype, "mx", {
        get: function () {
            return this.lp != null && typeCast(ISortingAxis_$type, this.lp) !== null;
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype.ms = function () {
        return this.typical != null;
    };
    FinancialSeries.prototype.oa = function (a) {
        this.typical(this, a);
    };
    Object.defineProperty(FinancialSeries.prototype, "m5", {
        get: function () {
            return this.m2();
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype._m2 = function () {
        var a, b, _a, _b, c, e_2_1, d, e, f, g, h, e_2, _c;
        return tslib_1.__generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    a = false;
                    if (!this.ms()) return [3 /*break*/, 8];
                    b = this.l1(0, this.bz.count);
                    this.oa(new FinancialEventArgs(0, this.bz.count, b, this.l2(b), this));
                    if (!(b.typicalColumn != null)) return [3 /*break*/, 8];
                    a = true;
                    _d.label = 1;
                case 1:
                    _d.trys.push([1, 6, 7, 8]);
                    _a = tslib_1.__values(fromEnum(b.typicalColumn)), _b = _a.next();
                    _d.label = 2;
                case 2:
                    if (!!_b.done) return [3 /*break*/, 5];
                    c = _b.value;
                    return [4 /*yield*/, c];
                case 3:
                    _d.sent();
                    _d.label = 4;
                case 4:
                    _b = _a.next();
                    return [3 /*break*/, 2];
                case 5: return [3 /*break*/, 8];
                case 6:
                    e_2_1 = _d.sent();
                    e_2 = { error: e_2_1 };
                    return [3 /*break*/, 8];
                case 7:
                    try {
                        if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                    }
                    finally { if (e_2) throw e_2.error; }
                    return [7 /*endfinally*/];
                case 8:
                    if (!!a) return [3 /*break*/, 17];
                    if (!(this.mx && this.lp.i$b != null)) return [3 /*break*/, 13];
                    d = this.bz.count;
                    e = this.lp.i$b;
                    f = 0;
                    _d.label = 9;
                case 9:
                    if (!(f < d)) return [3 /*break*/, 12];
                    return [4 /*yield*/, (this.md.item(e.item(f)) + this.mf.item(e.item(f)) + this.mb.item(e.item(f))) / 3];
                case 10:
                    _d.sent();
                    _d.label = 11;
                case 11:
                    ++f;
                    return [3 /*break*/, 9];
                case 12: return [3 /*break*/, 17];
                case 13:
                    g = this.bz.count;
                    h = 0;
                    _d.label = 14;
                case 14:
                    if (!(h < g)) return [3 /*break*/, 17];
                    return [4 /*yield*/, (this.md.item(h) + this.mf.item(h) + this.mb.item(h)) / 3];
                case 15:
                    _d.sent();
                    _d.label = 16;
                case 16:
                    ++h;
                    return [3 /*break*/, 14];
                case 17: return [2 /*return*/];
            }
        });
    };
    FinancialSeries.prototype.m2 = function () {
        var _this = this;
        return toEnum(function () { return _this._m2(); });
    };
    Object.defineProperty(FinancialSeries.prototype, "m4", {
        get: function () {
            return this.m1();
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype._m1 = function () {
        var a, b, c, d, e;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(this.mx && this.lp.i$b != null)) return [3 /*break*/, 7];
                    a = this.md.count;
                    b = this.lp.i$b;
                    if (!(a > 0)) return [3 /*break*/, 2];
                    return [4 /*yield*/, this.nj(this.md.item(b.item(0)) - this.mf.item(b.item(0)))];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2:
                    c = 1;
                    _a.label = 3;
                case 3:
                    if (!(c < a)) return [3 /*break*/, 6];
                    return [4 /*yield*/, Math.max(this.nj(this.md.item(b.item(c)) - this.mf.item(b.item(c))), Math.max(this.nj(Math.abs(this.md.item(b.item(c)) - this.mb.item(b.item(c - 1)))), this.nj(Math.abs(this.mf.item(b.item(c)) - this.mb.item(b.item(c - 1))))))];
                case 4:
                    _a.sent();
                    _a.label = 5;
                case 5:
                    ++c;
                    return [3 /*break*/, 3];
                case 6: return [3 /*break*/, 13];
                case 7:
                    d = this.md.count;
                    if (!(d > 0)) return [3 /*break*/, 9];
                    return [4 /*yield*/, this.nj(this.md.item(0) - this.mf.item(0))];
                case 8:
                    _a.sent();
                    _a.label = 9;
                case 9:
                    e = 1;
                    _a.label = 10;
                case 10:
                    if (!(e < d)) return [3 /*break*/, 13];
                    return [4 /*yield*/, Math.max(this.nj(this.md.item(e) - this.mf.item(e)), Math.max(this.nj(Math.abs(this.md.item(e) - this.mb.item(e - 1))), this.nj(Math.abs(this.mf.item(e) - this.mb.item(e - 1)))))];
                case 11:
                    _a.sent();
                    _a.label = 12;
                case 12:
                    ++e;
                    return [3 /*break*/, 10];
                case 13: return [2 /*return*/];
            }
        });
    };
    FinancialSeries.prototype.m1 = function () {
        var _this = this;
        return toEnum(function () { return _this._m1(); });
    };
    Object.defineProperty(FinancialSeries.prototype, "m3", {
        get: function () {
            return this.m0();
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype._m0 = function () {
        var a, b, c, d, e;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(this.mx && this.lp.i$b != null)) return [3 /*break*/, 7];
                    a = this.mf.count;
                    b = this.lp.i$b;
                    if (!(a > 0)) return [3 /*break*/, 2];
                    return [4 /*yield*/, this.nj(this.mf.item(b.item(0)))];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2:
                    c = 1;
                    _a.label = 3;
                case 3:
                    if (!(c < a)) return [3 /*break*/, 6];
                    return [4 /*yield*/, Math.min(this.nj(this.mf.item(b.item(c))), this.nj(this.mb.item(b.item(c - 1))))];
                case 4:
                    _a.sent();
                    _a.label = 5;
                case 5:
                    c++;
                    return [3 /*break*/, 3];
                case 6: return [3 /*break*/, 13];
                case 7:
                    d = this.mf.count;
                    if (!(d > 0)) return [3 /*break*/, 9];
                    return [4 /*yield*/, this.nj(this.mf.item(0))];
                case 8:
                    _a.sent();
                    _a.label = 9;
                case 9:
                    e = 1;
                    _a.label = 10;
                case 10:
                    if (!(e < d)) return [3 /*break*/, 13];
                    return [4 /*yield*/, Math.min(this.nj(this.mf.item(e)), this.nj(this.mb.item(e - 1)))];
                case 11:
                    _a.sent();
                    _a.label = 12;
                case 12:
                    e++;
                    return [3 /*break*/, 10];
                case 13: return [2 /*return*/];
            }
        });
    };
    FinancialSeries.prototype.m0 = function () {
        var _this = this;
        return toEnum(function () { return _this._m0(); });
    };
    FinancialSeries.prototype.m7 = function (a) {
        if (a == null) {
            return null;
        }
        if (this.mx && this.lp.i$b != null) {
            return new SafeSortedReadOnlyDoubleCollection(0, a, this.lp.i$b);
        }
        return new SafeReadOnlyDoubleCollection(0, a);
    };
    FinancialSeries.prototype.m6 = function () {
        var a = new List$1(String_$type, 0);
        a.add("HighColumn");
        a.add("LowColumn");
        a.add("CloseColumn");
        if (this.typicalBasedOn != null && this.bz != null && !this.ml) {
            this.ml = true;
            var b = this.l1(0, this.bz.count);
            this.ml = false;
            var c = new FinancialEventArgs(0, this.bz.count, b, this.l2(b), this);
            this.typicalBasedOn(this, c);
            if (c.basedOn != null && c.basedOn.count > 0) {
                return c.basedOn;
            }
        }
        return a;
    };
    FinancialSeries.prototype.getOpenColumnAsArray = function () {
        if (this.mh == null) {
            return null;
        }
        if (this.lp != null && typeCast(ISortingAxis_$type, this.lp) !== null) {
            if (this.nb != null) {
                return this.nb.asArray();
            }
            var a = new List$1(Number_$type, 2, this.mh.count);
            var b = this.lp.i$b;
            var c = this.mh.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.nb = a;
            return this.nb.asArray();
        }
        else {
            return this.mh.asArray();
        }
    };
    FinancialSeries.prototype.getHighColumnAsArray = function () {
        if (this.md == null) {
            return null;
        }
        if (this.lp != null && typeCast(ISortingAxis_$type, this.lp) !== null) {
            if (this.m9 != null) {
                return this.m9.asArray();
            }
            var a = new List$1(Number_$type, 2, this.md.count);
            var b = this.lp.i$b;
            var c = this.md.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.m9 = a;
            return this.m9.asArray();
        }
        else {
            return this.md.asArray();
        }
    };
    FinancialSeries.prototype.getLowColumnAsArray = function () {
        if (this.mf == null) {
            return null;
        }
        if (this.lp != null && typeCast(ISortingAxis_$type, this.lp) !== null) {
            if (this.na != null) {
                return this.na.asArray();
            }
            var a = new List$1(Number_$type, 2, this.mf.count);
            var b = this.lp.i$b;
            var c = this.mf.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.na = a;
            return this.na.asArray();
        }
        else {
            return this.mf.asArray();
        }
    };
    FinancialSeries.prototype.getCloseColumnAsArray = function () {
        if (this.mb == null) {
            return null;
        }
        if (this.lp != null && typeCast(ISortingAxis_$type, this.lp) !== null) {
            if (this.m8 != null) {
                return this.m8.asArray();
            }
            var a = new List$1(Number_$type, 2, this.mb.count);
            var b = this.lp.i$b;
            var c = this.mb.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.m8 = a;
            return this.m8.asArray();
        }
        else {
            return this.mb.asArray();
        }
    };
    FinancialSeries.prototype.getVolumeColumnAsArray = function () {
        if (this.mk == null) {
            return null;
        }
        if (this.lp != null && typeCast(ISortingAxis_$type, this.lp) !== null) {
            if (this.nc != null) {
                return this.nc.asArray();
            }
            var a = new List$1(Number_$type, 2, this.mk.count);
            var b = this.lp.i$b;
            var c = this.mk.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.nc = a;
            return this.nc.asArray();
        }
        else {
            return this.mk.asArray();
        }
    };
    FinancialSeries.prototype.hi = function (a, b, c, d) {
        _super.prototype.hi.call(this, a, b, c, d);
        if (this.lp == null || !(typeCast(ISortingAxis_$type, this.lp) !== null)) {
            return;
        }
        var e = this.lp.i$b;
        switch (a) {
            case 1:
                for (var f = b; f < c; f++) {
                    var g = e._inner[f];
                    if (this.nb != null) {
                        this.nb.insert(f, this.mh.item(g));
                    }
                    if (this.m9 != null) {
                        this.m9.insert(f, this.md.item(g));
                    }
                    if (this.na != null) {
                        this.na.insert(f, this.mf.item(g));
                    }
                    if (this.m8 != null) {
                        this.m8.insert(f, this.mb.item(g));
                    }
                    if (this.nc != null) {
                        this.nc.insert(f, this.mk.item(g));
                    }
                }
                break;
            case 0:
                if (this.nb != null) {
                    this.nb.v(b, c);
                }
                if (this.m9 != null) {
                    this.m9.v(b, c);
                }
                if (this.na != null) {
                    this.na.v(b, c);
                }
                if (this.m8 != null) {
                    this.m8.v(b, c);
                }
                if (this.nc != null) {
                    this.nc.v(b, c);
                }
                break;
            case 4:
                if (this.nb != null) {
                    this.nb = new List$1(Number_$type, 0);
                }
                if (this.m9 != null) {
                    this.m9 = new List$1(Number_$type, 0);
                }
                if (this.na != null) {
                    this.na = new List$1(Number_$type, 0);
                }
                if (this.m8 != null) {
                    this.m8 = new List$1(Number_$type, 0);
                }
                if (this.nc != null) {
                    this.nc = new List$1(Number_$type, 0);
                }
                break;
            case 3:
            case 2:
                for (var h = b; h < c; h++) {
                    var i = e._inner[h];
                    if (this.nb != null) {
                        this.nb._inner[h] = this.mh.item(i);
                    }
                    if (this.m9 != null) {
                        this.m9._inner[h] = this.md.item(i);
                    }
                    if (this.na != null) {
                        this.na._inner[h] = this.mf.item(i);
                    }
                    if (this.m8 != null) {
                        this.m8._inner[h] = this.mb.item(i);
                    }
                    if (this.nc != null) {
                        this.nc._inner[h] = this.mk.item(i);
                    }
                }
                break;
        }
    };
    FinancialSeries.prototype.l1 = function (a, b) {
        var _this = this;
        var c = this.m7(this.mh);
        var d = this.m7(this.mb);
        var e = this.m7(this.md);
        var f = this.m7(this.mf);
        var g = this.m7(this.mk);
        var h = ((function () {
            var $ret = new FinancialCalculationDataSource();
            $ret.typicalColumn = new CalculatedColumn(1, new SafeEnumerable(_this.m5), _this.m6());
            $ret.trueRange = new CalculatedColumn(1, new SafeEnumerable(_this.m4), ((function () {
                var $ret = new List$1(String_$type, 0);
                $ret.add("HighColumn");
                $ret.add("LowColumn");
                $ret.add("CloseColumn");
                return $ret;
            })()));
            $ret.trueLow = new CalculatedColumn(1, new SafeEnumerable(_this.m3), ((function () {
                var $ret = new List$1(String_$type, 0);
                $ret.add("LowColumn");
                $ret.add("CloseColumn");
                return $ret;
            })()));
            $ret.openColumn = c;
            $ret.closeColumn = d;
            $ret.highColumn = e;
            $ret.lowColumn = f;
            $ret.volumeColumn = g;
            $ret.calculateFrom = a;
            $ret.calculateCount = b;
            $ret.minimumValue = NaN;
            $ret.maximumValue = NaN;
            $ret.count = _this.bz != null ? _this.bz.count : 0;
            return $ret;
        })());
        return h;
    };
    FinancialSeries.prototype.nj = function (a) {
        if (isInfinity(a) || isNaN_(a)) {
            return 0;
        }
        return a;
    };
    FinancialSeries.prototype.l2 = function (a) {
        var _this = this;
        return ((function () {
            var $ret = new FinancialCalculationSupportingCalculations();
            $ret.a = new ColumnSupportingCalculation(1, TrendCalculators.b, new List$1(String_$type, 0));
            $ret.c = new ColumnSupportingCalculation(1, TrendCalculators.e, new List$1(String_$type, 0));
            $ret.d = new ColumnSupportingCalculation(1, TrendCalculators.f, new List$1(String_$type, 0));
            $ret.b = new ColumnSupportingCalculation(1, TrendCalculators.d, new List$1(String_$type, 0));
            $ret.h = new DataSourceSupportingCalculation(1, function (b) { return TrendCalculators.b(b.volumeColumn, b.shortPeriod); }, ((function () {
                var $ret = new List$1(String_$type, 0);
                $ret.add("VolumeColumn");
                return $ret;
            })()));
            $ret.f = new DataSourceSupportingCalculation(1, function (b) { return TrendCalculators.b(b.volumeColumn, b.longPeriod); }, ((function () {
                var $ret = new List$1(String_$type, 0);
                $ret.add("VolumeColumn");
                return $ret;
            })()));
            $ret.g = new DataSourceSupportingCalculation(1, function (b) { return TrendCalculators.b(b.typicalColumn, b.shortPeriod); }, a.typicalColumn.basedOn);
            $ret.e = new DataSourceSupportingCalculation(1, function (b) { return TrendCalculators.b(b.typicalColumn, b.longPeriod); }, a.typicalColumn.basedOn);
            $ret.k = Series.dw;
            $ret.j = Series.dv;
            $ret.i = runOn(_this, _this.nj);
            return $ret;
        })());
    };
    Object.defineProperty(FinancialSeries.prototype, "categoryAxis", {
        get: function () {
            return this.lp;
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype.ix = function (a, b) {
        _super.prototype.ix.call(this, a, b);
        if (!this.di) {
            this.bi.az(b);
            return;
        }
        var c = typeCast(FinancialSeriesView.$, this.bh);
        this.bi.az(b);
        c.bs.e(this.ek);
        if (this.cc(this.bh)) {
            return;
        }
        if (!this.dc) {
            this.od(this.lt, c);
        }
        this.dc = false;
        this.of(this.lt, c);
        this.di = false;
    };
    FinancialSeries.prototype.iu = function (a, b, c, d, e) {
        _super.prototype.iu.call(this, a, b, c, d, e);
        var f = this.a0.a$h.item(d);
        var g = f;
        g.bs.e(this.ek);
        f.ay(c);
        if (this.cc(g)) {
            return;
        }
        if (this.lq == null) {
            this.lq = new CategoryFrame(3);
        }
        this.lq.u();
        this.od(this.lq, g);
        this.of(this.lq, g);
    };
    FinancialSeries.prototype.am = function (a) {
        if (this.lp == a) {
            return this.l9;
        }
        if (this.l9 == a) {
            return this.lp;
        }
        return null;
    };
    FinancialSeries.prototype.preferredCategoryMode = function (a) {
        var b = typeCast(IDateTimeAxis_$type, this.lp);
        return b != null ? b.preferredCategoryMode(this) : this.lw;
    };
    Object.defineProperty(FinancialSeries.prototype, "lw", {
        get: function () {
            return this.lv;
        },
        set: function (a) {
            var b = this.lw;
            if (a != b) {
                this.lv = a;
                this.raisePropertyChanged("CategoryMode", enumGetBox(CategoryMode_$type, b), enumGetBox(CategoryMode_$type, this.lw));
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype.get_cy = function () {
        return true;
    };
    Object.defineProperty(FinancialSeries.prototype, "cy", {
        get: function () {
            return this.get_cy();
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype.i0 = function (a, b) {
        _super.prototype.i0.call(this, a, b);
        this.or = a;
    };
    FinancialSeries.$t = markType(FinancialSeries, 'FinancialSeries', Series.$, [IHasCategoryAxis_$type, IHasCategoryModePreference_$type]);
    return FinancialSeries;
}(Series));
export { FinancialSeries };
Type.dep(DependencyProperty, PropertyMetadata, FinancialSeries, 'raisePropertyChanged', ['CloseMemberPath:nq:og', [2, null], 'HighMemberPath:nt:oh', [2, null], 'IsCustomCategoryStyleAllowed:mt:oi', [0, false], 'IsTransitionInEnabled:mu:oj', [0, false], 'LowMemberPath:ny:ok', [2, null], 'NegativeBrush:or:ol', [Brush.$, null], 'OpenMemberPath:n2:om', [2, null], 'TransitionInMode:lz:on', [CategoryTransitionInMode_$type, enumGetBox(CategoryTransitionInMode_$type, 0)], 'VolumeMemberPath:n6:oo', [2, null], 'XAxis:lp:op', [CategoryAxisBase.$, null], 'YAxis:l9:oq', [NumericYAxis.$, null]]);
var FinancialCalculationSupportingCalculations = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialCalculationSupportingCalculations, _super);
    function FinancialCalculationSupportingCalculations() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        _this.c = null;
        _this.d = null;
        _this.b = null;
        _this.h = null;
        _this.f = null;
        _this.g = null;
        _this.e = null;
        _this.k = null;
        _this.j = null;
        _this.i = null;
        return _this;
    }
    FinancialCalculationSupportingCalculations.$t = markType(FinancialCalculationSupportingCalculations, 'FinancialCalculationSupportingCalculations');
    return FinancialCalculationSupportingCalculations;
}(Base));
export { FinancialCalculationSupportingCalculations };
var DataSourceSupportingCalculation = /** @class */ (function (_super) {
    tslib_1.__extends(DataSourceSupportingCalculation, _super);
    function DataSourceSupportingCalculation(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    _this = _super.call(this, Delegate_$type, 0, c) || this;
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    _this = _super.call(this, Delegate_$type, 1, c, d) || this;
                }
                break;
        }
        return _this;
    }
    DataSourceSupportingCalculation.$t = markType(DataSourceSupportingCalculation, 'DataSourceSupportingCalculation', SupportingCalculation$1.$.specialize(Delegate_$type));
    return DataSourceSupportingCalculation;
}(SupportingCalculation$1));
export { DataSourceSupportingCalculation };
var FinancialCalculationDataSource = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialCalculationDataSource, _super);
    function FinancialCalculationDataSource() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._openColumn = null;
        _this._closeColumn = null;
        _this._highColumn = null;
        _this._lowColumn = null;
        _this._volumeColumn = null;
        _this._indicatorColumn = null;
        _this._typicalColumn = null;
        _this._trueRange = null;
        _this._trueLow = null;
        _this._period = 0;
        _this._shortPeriod = 0;
        _this._longPeriod = 0;
        _this._count = 0;
        _this._calculateFrom = 0;
        _this._calculateCount = 0;
        _this._multiplier = 0;
        _this._minimumValue = 0;
        _this._maximumValue = 0;
        _this._specifiesRange = false;
        _this._series = null;
        return _this;
    }
    Object.defineProperty(FinancialCalculationDataSource.prototype, "openColumn", {
        get: function () {
            return this._openColumn;
        },
        set: function (a) {
            this._openColumn = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "closeColumn", {
        get: function () {
            return this._closeColumn;
        },
        set: function (a) {
            this._closeColumn = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "highColumn", {
        get: function () {
            return this._highColumn;
        },
        set: function (a) {
            this._highColumn = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "lowColumn", {
        get: function () {
            return this._lowColumn;
        },
        set: function (a) {
            this._lowColumn = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "volumeColumn", {
        get: function () {
            return this._volumeColumn;
        },
        set: function (a) {
            this._volumeColumn = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "indicatorColumn", {
        get: function () {
            return this._indicatorColumn;
        },
        set: function (a) {
            this._indicatorColumn = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "typicalColumn", {
        get: function () {
            return this._typicalColumn;
        },
        set: function (a) {
            this._typicalColumn = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "trueRange", {
        get: function () {
            return this._trueRange;
        },
        set: function (a) {
            this._trueRange = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "trueLow", {
        get: function () {
            return this._trueLow;
        },
        set: function (a) {
            this._trueLow = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "period", {
        get: function () {
            return this._period;
        },
        set: function (a) {
            this._period = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "shortPeriod", {
        get: function () {
            return this._shortPeriod;
        },
        set: function (a) {
            this._shortPeriod = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "longPeriod", {
        get: function () {
            return this._longPeriod;
        },
        set: function (a) {
            this._longPeriod = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "count", {
        get: function () {
            return this._count;
        },
        set: function (a) {
            this._count = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "calculateFrom", {
        get: function () {
            return this._calculateFrom;
        },
        set: function (a) {
            this._calculateFrom = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "calculateCount", {
        get: function () {
            return this._calculateCount;
        },
        set: function (a) {
            this._calculateCount = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "multiplier", {
        get: function () {
            return this._multiplier;
        },
        set: function (a) {
            this._multiplier = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "minimumValue", {
        get: function () {
            return this._minimumValue;
        },
        set: function (a) {
            this._minimumValue = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "maximumValue", {
        get: function () {
            return this._maximumValue;
        },
        set: function (a) {
            this._maximumValue = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "specifiesRange", {
        get: function () {
            return this._specifiesRange;
        },
        set: function (a) {
            this._specifiesRange = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "series", {
        get: function () {
            return this._series;
        },
        set: function (a) {
            this._series = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialCalculationDataSource.$t = markType(FinancialCalculationDataSource, 'FinancialCalculationDataSource');
    return FinancialCalculationDataSource;
}(Base));
export { FinancialCalculationDataSource };
var FinancialSeriesView = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialSeriesView, _super);
    function FinancialSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.bu = null;
        _this.bs = null;
        _this.bw = 0;
        _this.bw = -1;
        _this.bu = a;
        _this.bs = _this.bt();
        return _this;
    }
    FinancialSeriesView.prototype.bv = function (a) {
        if (this.bw != a.t) {
            return true;
        }
        return false;
    };
    FinancialSeriesView.prototype.bx = function (a) {
        this.bw = a.t;
    };
    FinancialSeriesView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        if (!this.n) {
            this.e.bj = 6;
        }
    };
    FinancialSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'>";
        if (this.bu.lp.b5) {
            var b = this.bu.lp;
            a += "<span>${item." + b.dateTimeMemberPath + "}</span><br/>";
        }
        else if (this.bu.lp.e1 != null) {
            a += "<span>${item." + this.bu.lp.e1 + "}</span><br/>";
        }
        a += "<span class='ui-priority-primary'";
        var c = this.e.a0.a$q(this.e);
        if (!stringIsNullOrEmpty(c)) {
            a += " style='color:" + c + "'";
        }
        a += ">" + this.bu.fk + "</span><table><tr><td>" + "Open:</td><td>" + "${item." + this.bu.n2 + "}</td></tr><tr><td>" + "High:</td><td>" + "${item." + this.bu.nt + "}</td></tr><tr><td>" + "Low:</td><td>" + "${item." + this.bu.ny + "}</td></tr><tr><td>" + "Close:</td><td>" + "${item." + this.bu.nq + "}</td></tr>";
        if (!stringIsNullOrEmpty(this.bu.n6)) {
            a += "<tr><td>" + "Volume:</td><td>" + "${item." + this.bu.n6 + "}</td></tr>";
        }
        a += "</table></div>";
        return a;
    };
    FinancialSeriesView.prototype.ac = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.kr = a;
        this.e.el = 5;
        this.e.em = 2;
        this.e.en = 2;
    };
    FinancialSeriesView.$t = markType(FinancialSeriesView, 'FinancialSeriesView', SeriesView.$);
    return FinancialSeriesView;
}(SeriesView));
export { FinancialSeriesView };
/*<BeginStatics Name="Infragistics.Controls.Charts.FinancialSeries" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.FinancialSeries" />*/
//# sourceMappingURL=FinancialEventArgs_combined.js.map