import { IHighlightingManager } from "./IHighlightingManager";
import { List$1 } from "igniteui-angular-core/ES5/List$1";
import { Series } from "./Series";
import { HighlightingInfo } from "./HighlightingInfo";
import { IFastItemsSource } from "igniteui-angular-core/ES5/IFastItemsSource";
import { Axis } from "./Axis";
import { Base, Type } from "igniteui-angular-core/ES5/type";
export declare class HighlightingManager extends Base implements IHighlightingManager {
    constructor();
    private a;
    private c;
    startHighlight(a: HighlightingInfo): void;
    private d;
    private e;
    endHighlight(a: HighlightingInfo): void;
    clear(): void;
    getHighlightingInfo(a: Series, b: IFastItemsSource, c: Axis, d: number, e: number, f: boolean): HighlightingInfo;
    private f;
    private _dirtySeries;
    dirtySeries: List$1<Series>;
    private b;
    tick(a: number): boolean;
    private _inProgress;
    inProgress: boolean;
    private _maxHighlightingProgress;
    maxHighlightingProgress: number;
    private _sumHighlightingProgress;
    sumHighlightingProgress: number;
    private _maxMarkerHighlightingProgress;
    maxMarkerHighlightingProgress: number;
    private _sumMarkerHighlightingProgress;
    sumMarkerHighlightingProgress: number;
    static $t: Type;
}
