import { Path } from "igniteui-angular-core/ES5/Path";
import { TextBlock } from "igniteui-angular-core/ES5/TextBlock";
import { IList$1, Type } from "igniteui-angular-core/ES5/type";
import { Brush } from "igniteui-angular-core/ES5/Brush";
export interface ITrackThumbCalloutVisual {
    readonly calloutBox: Path;
    readonly calloutText: TextBlock;
    readonly allPaths: IList$1<Path>;
    width: number;
    height: number;
    translateX: number;
    translateY: number;
    textTranslateX: number;
    textTranslateY: number;
    isVisible: boolean;
    getCalloutBoxDefaultStroke(): Brush;
    getCalloutBoxDefaultStrokeThickness(): number;
    getCalloutBoxDefaultBrush(): Brush;
    getCalloutTextDefaultBrush(): Brush;
}
export declare let ITrackThumbCalloutVisual_$type: Type;
