/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { DomWrapper_$type, Base, typeCast, runOn, fromEnum, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs } from "igniteui-angular-core/ES5/type";
import { Dictionary$2 } from "igniteui-angular-core/ES5/Dictionary$2";
import { RenderingContext } from "igniteui-angular-core/ES5/RenderingContext";
import { ContentControl } from "igniteui-angular-core/ES5/ContentControl";
import { ILegendContext_$type } from "igniteui-angular-core/ES5/ILegendContext";
import { DataTemplatePassInfo } from "igniteui-angular-core/ES5/DataTemplatePassInfo";
import { DataTemplateMeasureInfo } from "igniteui-angular-core/ES5/DataTemplateMeasureInfo";
import { DataTemplateRenderInfo } from "igniteui-angular-core/ES5/DataTemplateRenderInfo";
import { CanvasViewRenderer } from "igniteui-angular-core/ES5/CanvasViewRenderer";
import { Size } from "igniteui-angular-core/ES5/Size";
import { FontUtil } from "igniteui-angular-core/ES5/FontUtil";
import { LegendItemHelper } from "igniteui-angular-core/ES5/LegendItemHelper";
import { isNaN_ } from "igniteui-angular-core/ES5/number";
import { IChartLegend_$type } from "igniteui-angular-core/ES5/IChartLegend";
import { ObservableCollection$1 } from "igniteui-angular-core/ES5/ObservableCollection$1";
import { UIElement } from "igniteui-angular-core/ES5/UIElement";
import { ILegendSeries_$type } from "igniteui-angular-core/ES5/ILegendSeries";
import { PropertyUpdatedEventArgs } from "igniteui-angular-core/ES5/PropertyUpdatedEventArgs";
import { LegendMouseButtonEventArgs } from "./LegendMouseButtonEventArgs";
import { LegendMouseEventArgs } from "./LegendMouseEventArgs";
import { LegendVisualData } from "./LegendVisualData";
import { LegendItemVisualData } from "./LegendItemVisualData";
import { AppearanceHelper } from "igniteui-angular-core/ES5/AppearanceHelper";
import { stringIsNullOrEmpty } from "igniteui-angular-core/ES5/string";
import { MouseButtonEventArgs } from "igniteui-angular-core/ES5/MouseButtonEventArgs";
import { MouseEventArgs } from "igniteui-angular-core/ES5/MouseEventArgs";
var LegendBaseViewManager = /** @class */ (function (_super) {
    tslib_1.__extends(LegendBaseViewManager, _super);
    function LegendBaseViewManager(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.g = null;
        _this.j = null;
        _this.h = null;
        _this.d = false;
        _this.f = null;
        _this.k = null;
        _this.c = null;
        _this.a = a;
        _this.f = new Dictionary$2(Base.$, DomWrapper_$type, 0);
        _this.n();
        return _this;
    }
    LegendBaseViewManager.prototype.n = function () {
        var _this = this;
        if (this.g == null) {
            this.g = function (a) {
                var b = LegendItemHelper.b;
                if (window.devicePixelRatio != undefined && (isNaN_(b) || window.devicePixelRatio != b)) {
                    LegendItemHelper.b = window.devicePixelRatio;
                    _this.a.ae();
                }
            };
            window.addEventListener("resize", this.g, false);
        }
        this.g(null);
    };
    LegendBaseViewManager.prototype.q = function (a) {
        if (a == null) {
            if (this.g != null) {
                window.removeEventListener("resize", this.g, false);
                this.g = null;
            }
            this.j = null;
            this.h = null;
            return;
        }
        this.h = a;
        this.j = this.h.createElement("table");
        this.j.addClass(this.a.n);
        this.h.append(this.j);
    };
    LegendBaseViewManager.prototype.i = function (a, b) {
        var c = typeCast(ContentControl.$, a);
        var d = this.a.g;
        var e = this.h.createElement("tr");
        e.addClass(this.a.o);
        if (d) {
            e.setStyleProperty("display", "block");
            e.setStyleProperty("float", "left");
            e.setStyleProperty("margin", "0px");
            e.setStyleProperty("margin-right", "8px");
        }
        if (c != null) {
            var f = typeCast(ILegendContext_$type, c.content);
            if (f != null && c.ah != null) {
                var g = new DataTemplatePassInfo();
                g.context = e;
                g.passID = "LegendItem";
                var h = new DataTemplateMeasureInfo();
                h.passInfo = g;
                h.width = NaN;
                h.height = NaN;
                h.data = f;
                h.context = e;
                var i = new DataTemplateRenderInfo();
                i.passInfo = g;
                if (c.ah.measure != null) {
                    c.ah.measure(h);
                }
                i.context = this.h.getSubRenderer(e);
                i.availableWidth = h.width;
                i.availableHeight = h.height;
                i.data = f;
                i.xPosition = 0;
                i.yPosition = 0;
                c.ah.render(i);
                var j = e.findByClass(".ui-legend-item-badge");
                for (var k = 0; k < j.length; k++) {
                    j[k].removeClass("ui-legend-item-badge").addClass(this.a.m);
                }
                j = e.findByClass(".ui-legend-item-text");
                for (var l = 0; l < j.length; l++) {
                    if (d) {
                        j[l].setStyleProperty("white-space", "nowrap");
                    }
                    j[l].removeClass("ui-legend-item-text").addClass(this.a.p);
                }
            }
        }
        return e;
    };
    LegendBaseViewManager.prototype.m = function (a, b) {
        var c = this.i(a, this.j);
        c.listen("mouseup", runOn(this.a, this.a.z));
        c.listen("mousedown", runOn(this.a, this.a.w));
        c.listen("mouseleave", runOn(this.a, this.a.x));
        c.listen("mousemove", runOn(this.a, this.a.y));
        this.f.addItem(a, c);
        if ((this.j.getChildCount() == 0) || (b >= this.j.getChildCount())) {
            this.j.append(c);
        }
        else {
            var d = this.j.getChildAt(b);
            d.before(c);
        }
    };
    LegendBaseViewManager.prototype.s = function (a) {
    };
    LegendBaseViewManager.prototype.t = function (a) {
        var _this = this;
        var b;
        if (((function () { var c = _this.f.tryGetValue(a, b); b = c.p1; return c.ret; })())) {
            b.unlistenAll();
            b.remove();
            this.f.removeItem(a);
        }
    };
    LegendBaseViewManager.prototype.l = function (visual_) {
        try {
            for (var _a = tslib_1.__values(fromEnum(this.f)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var pair_ = _b.value;
                if (pair_.value.getNativeElement() === visual_) {
                    return pair_.key;
                }
                ;
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return null;
        var e_1, _c;
    };
    LegendBaseViewManager.prototype.e = function (a) {
        try {
            for (var _a = tslib_1.__values(fromEnum(this.f.keys)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var b = _b.value;
                var c = typeCast(ContentControl.$, b);
                if (c != null && c.content != null) {
                    var d = typeCast(ILegendContext_$type, c.content);
                    if (d != null && d.itemLabel == a.itemLabel && d.legendLabel == a.legendLabel && d.series == a.series && d.itemBrush == a.itemBrush) {
                        return true;
                    }
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return false;
        var e_2, _c;
    };
    LegendBaseViewManager.prototype.b = function (a) {
        var b = this.h.rootWrapper.width();
        var c = this.h.rootWrapper.height();
        this.j.remove();
        var d = this.h.createElement("div");
        d.setStyleProperty("position", "relative");
        this.k = this.h.createElement("<canvas style=\"position : absolute; top : 0; left : 0\" />");
        this.k.setStyleProperty("position", "absolute");
        this.k.setStyleProperty("top", "0px");
        this.k.setStyleProperty("left", "0px");
        this.h.append(d);
        d.append(this.k);
        this.c = new RenderingContext(new CanvasViewRenderer(), this.h.get2DCanvasContext(this.k));
        this.k.setAttribute("width", b.toString());
        this.k.setAttribute("height", c.toString());
        return this.c;
    };
    LegendBaseViewManager.prototype.x = function () {
        return new Size(1, this.h.rootWrapper.width(), Math.max(10, this.h.rootWrapper.height() - 15));
    };
    LegendBaseViewManager.prototype.u = function (a, b, c, d) {
        var e = a.g();
        e.beginPath();
        e.moveTo(b.aj._inner[0].x, b.aj._inner[0].y);
        for (var f = 1; f < b.aj.count; f++) {
            e.lineTo(b.aj._inner[f].x, b.aj._inner[f].y);
        }
        e.lineTo(b.aj._inner[0].x, b.aj._inner[0].y);
        var g = e.createLinearGradient(d.left, d.top, d.left, d.top + d.height);
        try {
            for (var _a = tslib_1.__values(fromEnum(c.a)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var h = _b.value;
                g.addColorStop(h.a, h.b._fill);
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_3) throw e_3.error; }
        }
        e.fillStyle = g;
        e.fill();
        var e_3, _c;
    };
    LegendBaseViewManager.prototype.o = function () {
    };
    LegendBaseViewManager.prototype.p = function () {
    };
    LegendBaseViewManager.prototype.r = function (a) {
        var b = this.j.getChildCount();
        for (var c = 0; c < b; c++) {
            var d = this.j.getChildAt(c);
            d.setStyleProperty("display", a ? "block" : "");
            d.setStyleProperty("float", a ? "left" : "");
            d.setStyleProperty("margin", a ? "0px" : "");
            d.setStyleProperty("margin-right", a ? "8px" : "");
            d.getChildAt(1).setStyleProperty("white-space", a ? "nowrap" : "");
        }
    };
    LegendBaseViewManager.prototype.v = function (a) {
        this.j.setStyleProperty("color", a);
    };
    LegendBaseViewManager.prototype.w = function (a) {
        var b = FontUtil.getFontInfoFromString(this.h, a);
        this.j.setStyleProperty("font-family", b.n);
        this.j.setStyleProperty("font-size", b.d + "px");
        this.j.setStyleProperty("font-style", b.q);
    };
    LegendBaseViewManager.$t = markType(LegendBaseViewManager, 'LegendBaseViewManager');
    return LegendBaseViewManager;
}(Base));
export { LegendBaseViewManager };
var LegendBase = /** @class */ (function (_super) {
    tslib_1.__extends(LegendBase, _super);
    function LegendBase() {
        var _this = _super.call(this) || this;
        _this.ak = null;
        _this.at = null;
        _this._seriesOwner = null;
        _this._chartOwner = null;
        _this.propertyChanged = null;
        _this.propertyUpdated = null;
        _this.legendItemMouseLeftButtonDown = null;
        _this.legendItemMouseLeftButtonUp = null;
        _this.legendItemMouseEnter = null;
        _this.legendItemMouseLeave = null;
        _this.legendItemMouseMove = null;
        var a = _this.aj();
        _this.a5(a);
        a.ad();
        _this.at = new ObservableCollection$1(UIElement.$, 0);
        return _this;
    }
    LegendBase.prototype.aj = function () {
        return new LegendBaseView(this);
    };
    LegendBase.prototype.a5 = function (a) {
        this.ak = a;
    };
    LegendBase.prototype.addChildInOrder = function (a, b) {
    };
    LegendBase.prototype.az = function (a, b) {
    };
    Object.defineProperty(LegendBase.prototype, "seriesOwner", {
        get: function () {
            return this._seriesOwner;
        },
        set: function (a) {
            this._seriesOwner = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendBase.prototype, "chartOwner", {
        get: function () {
            return this._chartOwner;
        },
        set: function (a) {
            this._chartOwner = a;
        },
        enumerable: true,
        configurable: true
    });
    LegendBase.prototype.get_isItemwise = function () {
        return false;
    };
    Object.defineProperty(LegendBase.prototype, "isItemwise", {
        get: function () {
            return this.get_isItemwise();
        },
        enumerable: true,
        configurable: true
    });
    LegendBase.prototype.get_isScale = function () {
        return false;
    };
    Object.defineProperty(LegendBase.prototype, "isScale", {
        get: function () {
            return this.get_isScale();
        },
        enumerable: true,
        configurable: true
    });
    LegendBase.prototype.clearLegendItemsForSeries = function (a) {
        if (a == null || this.at == null || this.at.count == 0) {
            return;
        }
        var b = new ObservableCollection$1(UIElement.$, 0);
        try {
            for (var _a = tslib_1.__values(fromEnum(this.at)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var c = _b.value;
                var d = typeCast(ContentControl.$, c);
                if (d != null && d.content != null) {
                    var e = typeCast(ILegendContext_$type, d.content);
                    if (e != null && e.series == a) {
                        b.add(c);
                    }
                }
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_4) throw e_4.error; }
        }
        try {
            for (var _d = tslib_1.__values(fromEnum(b)), _e = _d.next(); !_e.done; _e = _d.next()) {
                var f = _e.value;
                this.at.remove(f);
            }
        }
        catch (e_5_1) { e_5 = { error: e_5_1 }; }
        finally {
            try {
                if (_e && !_e.done && (_f = _d.return)) _f.call(_d);
            }
            finally { if (e_5) throw e_5.error; }
        }
        var e_4, _c, e_5, _f;
    };
    LegendBase.prototype.containsChild = function (a) {
        return this.at.contains(a);
    };
    LegendBase.prototype.removeChild = function (a) {
        this.at.remove(a);
    };
    Object.defineProperty(LegendBase.prototype, "ai", {
        get: function () {
            if (this.seriesOwner != null) {
                return this.seriesOwner;
            }
            else {
                return this.chartOwner;
            }
        },
        enumerable: true,
        configurable: true
    });
    LegendBase.prototype.a7 = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    };
    LegendBase.prototype.a2 = function (a) {
        if (this.legendItemMouseLeftButtonDown != null) {
            this.legendItemMouseLeftButtonDown(this, a);
        }
    };
    LegendBase.prototype.a3 = function (a) {
        if (this.legendItemMouseLeftButtonUp != null) {
            this.legendItemMouseLeftButtonUp(this, a);
        }
    };
    LegendBase.prototype.a0 = function (a) {
        if (this.legendItemMouseEnter != null) {
            this.legendItemMouseEnter(this, a);
        }
    };
    LegendBase.prototype.a1 = function (a) {
        if (this.legendItemMouseLeave != null) {
            this.legendItemMouseLeave(this, a);
        }
    };
    LegendBase.prototype.a4 = function (a) {
        if (this.legendItemMouseMove != null) {
            this.legendItemMouseMove(this, a);
        }
    };
    LegendBase.prototype.provideContainer = function (a) {
        this.ak.ac(a);
    };
    Object.defineProperty(LegendBase.prototype, "av", {
        get: function () {
            return this.ak.n;
        },
        set: function (a) {
            this.ak.n = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendBase.prototype, "aw", {
        get: function () {
            return this.ak.o;
        },
        set: function (a) {
            this.ak.o = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendBase.prototype, "au", {
        get: function () {
            return this.ak.m;
        },
        set: function (a) {
            this.ak.m = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendBase.prototype, "ax", {
        get: function () {
            return this.ak.p;
        },
        set: function (a) {
            this.ak.p = a;
        },
        enumerable: true,
        configurable: true
    });
    LegendBase.prototype.ar = function () {
        var a = new LegendVisualData();
        try {
            for (var _a = tslib_1.__values(fromEnum(this.at)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var b = _b.value;
                var c = typeCast(ContentControl.$, b);
                var d = new LegendItemVisualData();
                var e = typeCast(ILegendContext_$type, c.content);
                if (e != null) {
                    if (e.itemLabel != null && !stringIsNullOrEmpty(e.itemLabel.toString())) {
                        d.label = e.itemLabel.toString();
                    }
                    if (e.legendLabel != null && !stringIsNullOrEmpty(e.legendLabel.toString())) {
                        d.label = e.legendLabel.toString();
                    }
                    if (e.actualItemBrush != null) {
                        d.appearance.fill = AppearanceHelper.b(e.actualItemBrush);
                    }
                    else {
                        d.appearance.fill = AppearanceHelper.b(e.itemBrush);
                    }
                }
                a.items.add(d);
            }
        }
        catch (e_6_1) { e_6 = { error: e_6_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_6) throw e_6.error; }
        }
        return a;
        var e_6, _c;
    };
    LegendBase.$t = markType(LegendBase, 'LegendBase', ContentControl.$, [INotifyPropertyChanged_$type, IChartLegend_$type]);
    return LegendBase;
}(ContentControl));
export { LegendBase };
var LegendBaseView = /** @class */ (function (_super) {
    tslib_1.__extends(LegendBaseView, _super);
    function LegendBaseView(a) {
        var _this = _super.call(this) || this;
        _this.b = null;
        _this.a = null;
        _this.n = null;
        _this.o = null;
        _this.m = null;
        _this.p = null;
        _this.h = false;
        _this.e = false;
        _this.k = null;
        _this.l = null;
        _this.a = a;
        _this.b = new LegendBaseViewManager(_this);
        return _this;
    }
    LegendBaseView.prototype.ad = function () {
    };
    LegendBaseView.prototype.get_f = function () {
        return false;
    };
    Object.defineProperty(LegendBaseView.prototype, "f", {
        get: function () {
            return this.get_f();
        },
        enumerable: true,
        configurable: true
    });
    LegendBaseView.prototype.c = function (a) {
        var b;
        var c;
        var d;
        var e = this.v(a, b, c, d);
        b = e.p1;
        c = e.p2;
        d = e.p3;
        var f = new MouseButtonEventArgs();
        var g = new LegendMouseButtonEventArgs(b, c, d, f, a);
        return g;
    };
    LegendBaseView.prototype.d = function (a) {
        var b;
        var c;
        var d;
        var e = this.v(a, b, c, d);
        b = e.p1;
        c = e.p2;
        d = e.p3;
        var f = new MouseEventArgs();
        var g = new LegendMouseEventArgs(b, c, d, f, a);
        return g;
    };
    LegendBaseView.prototype.v = function (a, b, c, d) {
        b = this.a.ai;
        c = null;
        d = null;
        if (a != null) {
            var e = typeCast(ContentControl.$, a);
            if (e != null && e.content != null && typeCast(ILegendContext_$type, e.content) !== null) {
                var f = typeCast(ILegendContext_$type, e.content);
                c = typeCast(ILegendSeries_$type, f.series);
                if (c != null) {
                    b = c.container;
                }
                d = f.item;
            }
        }
        return {
            p1: b,
            p2: c,
            p3: d
        };
    };
    LegendBaseView.prototype.u = function () {
    };
    LegendBaseView.prototype.i = function () {
        return true;
    };
    LegendBaseView.prototype.t = function (a) {
    };
    LegendBaseView.prototype.af = function (a) {
    };
    LegendBaseView.prototype.ac = function (a) {
        this.b.q(a);
    };
    LegendBaseView.prototype.ag = function (a) {
        this.b.t(a);
    };
    LegendBaseView.prototype.s = function (a) {
        var b = this.a.at.indexOf(a);
        this.b.m(a, b);
    };
    LegendBaseView.prototype.aa = function () {
        this.b.o();
    };
    LegendBaseView.prototype.ab = function () {
        this.b.p();
    };
    Object.defineProperty(LegendBaseView.prototype, "g", {
        get: function () {
            return this.e;
        },
        set: function (a) {
            this.e = a;
            this.b.r(this.e);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendBaseView.prototype, "q", {
        get: function () {
            return this.k;
        },
        set: function (a) {
            this.k = a;
            this.b.v(this.k);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendBaseView.prototype, "r", {
        get: function () {
            return this.l;
        },
        set: function (a) {
            this.l = a;
            this.b.w(this.l);
        },
        enumerable: true,
        configurable: true
    });
    LegendBaseView.prototype.ae = function () {
    };
    LegendBaseView.prototype.j = function (e_) {
        return this.b.l(e_);
    };
    LegendBaseView.prototype.y = function (a) {
        if (!this.h) {
            this.a.a0(this.d(this.j(a)));
        }
        this.h = true;
    };
    LegendBaseView.prototype.x = function (a) {
        if (this.h) {
            this.a.a1(this.d(this.j(a)));
        }
        this.h = false;
    };
    LegendBaseView.prototype.w = function (a) {
        this.a.a2(this.c(this.j(a)));
    };
    LegendBaseView.prototype.z = function (a) {
        this.a.a3(this.c(this.j(a)));
    };
    LegendBaseView.$t = markType(LegendBaseView, 'LegendBaseView');
    return LegendBaseView;
}(Base));
export { LegendBaseView };
//# sourceMappingURL=LegendBaseViewManager_combined.js.map