import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IShortPeriodLongPeriod } from "./IShortPeriodLongPeriod";
import { IndicatorCalculationStrategy } from "./IndicatorCalculationStrategy";
import { Type } from "igniteui-angular-core/ES5/type";
import { DependencyProperty } from "igniteui-angular-core/ES5/DependencyProperty";
export declare class PercentagePriceOscillatorIndicator extends StrategyBasedIndicator implements IShortPeriodLongPeriod {
    protected get_pr(): IndicatorCalculationStrategy;
    protected readonly pr: IndicatorCalculationStrategy;
    protected get_p4(): Type;
    protected readonly p4: Type;
    shortPeriod: number;
    static readonly qd: DependencyProperty;
    protected pz(): number;
    longPeriod: number;
    static readonly qc: DependencyProperty;
    protected pw(): number;
    static $t: Type;
}
