import { ContentControl } from "igniteui-angular-core/ES5/ContentControl";
import { INotifyPropertyChanged, Type, Point, PropertyChangedEventArgs, DomRenderer, Base, DomWrapper } from "igniteui-angular-core/ES5/type";
import { SRProvider } from "igniteui-angular-core/ES5/SRProvider";
import { ISeriesVisualDataManager } from "./ISeriesVisualDataManager";
import { Visibility } from "igniteui-angular-core/ES5/Visibility";
import { PointerTooltipPointerLocation } from "./PointerTooltipPointerLocation";
import { PointCollection } from "igniteui-angular-core/ES5/PointCollection";
import { Polygon } from "igniteui-angular-core/ES5/Polygon";
import { Polyline } from "igniteui-angular-core/ES5/Polyline";
import { EventProxy } from "igniteui-angular-core/ES5/EventProxy";
import { PointerTooltipStyle } from "./PointerTooltipStyle";
import { PropertyUpdatedEventArgs } from "igniteui-angular-core/ES5/PropertyUpdatedEventArgs";
import { Size } from "igniteui-angular-core/ES5/Size";
import { RenderingContext } from "igniteui-angular-core/ES5/RenderingContext";
export declare class PointerTooltip extends ContentControl implements INotifyPropertyChanged {
    constructor();
    private aq;
    protected readonly ar: SRProvider;
    private ai;
    readonly aj: ISeriesVisualDataManager;
    am: PointerTooltipView;
    cn: Point;
    a1: number;
    a2: number;
    ct: Visibility;
    al: PointerTooltipPointerLocation;
    cm: Point;
    ck: Point;
    cl: Point;
    ci: Point;
    cj: Point;
    cg: Point;
    ch: Point;
    a0: number;
    az: number;
    ax: number;
    ay: number;
    cp: PointCollection;
    co: PointCollection;
    protected bt(a: string, b: any, c: any): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected br(a: any, b: string, c: any, d: any): void;
    bw: ContentControl;
    cq: Polygon;
    cr: Polyline;
    protected au: boolean;
    bn(): void;
    bq(): void;
    private cf;
    private ak;
    private aw;
    private av;
    private at(a, b);
    cs(a: Size): Size;
    bo(): void;
    bp(): void;
    bu(a: number, b: number): void;
    ao: EventProxy;
    bs(a: DomRenderer): void;
    private as;
    bm(): void;
    bv(): void;
    ap: PointerTooltipStyle;
    a3(): any;
    static $$p: string[];
    static $t: Type;
}
export declare class PointerTooltipView extends Base {
    constructor(a: PointerTooltip);
    private j;
    u(): void;
    private a;
    y(a: Size): Size;
    o: DomWrapper;
    q: DomWrapper;
    p: DomWrapper;
    m: DomWrapper;
    protected l: DomWrapper;
    protected b: RenderingContext;
    protected n: DomWrapper;
    private x;
    private c;
    private i;
    private h;
    w(a: number, b: number): void;
    r(): any;
    private g;
    private e;
    private f;
    d(a: any): boolean;
    s(): void;
    t(): void;
    k: DomRenderer;
    v(a: DomRenderer): void;
    static $t: Type;
}
