/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { FinancialIndicator } from "./FinancialIndicator";
import { String_$type, Number_$type, typeCast, fromEnum, markType } from "igniteui-angular-core/ES5/type";
import { DependencyProperty } from "igniteui-angular-core/ES5/DependencyProperty";
import { PropertyMetadata } from "igniteui-angular-core/ES5/PropertyMetadata";
import { List$1 } from "igniteui-angular-core/ES5/List$1";
import { AxisRange } from "./AxisRange";
import { isNaN_ } from "igniteui-angular-core/ES5/number";
var StrategyBasedIndicator = /** @class */ (function (_super) {
    tslib_1.__extends(StrategyBasedIndicator, _super);
    function StrategyBasedIndicator() {
        var _this = _super.call(this) || this;
        _this.p5();
        return _this;
    }
    StrategyBasedIndicator.prototype.p5 = function () {
        this.pq = this.pr;
        this.ab = this.p4;
    };
    StrategyBasedIndicator.prototype.px = function () {
        return -2147483648;
    };
    StrategyBasedIndicator.prototype.p6 = function (a) {
    };
    StrategyBasedIndicator.prototype.pz = function () {
        return -2147483648;
    };
    StrategyBasedIndicator.prototype.pw = function () {
        return -2147483648;
    };
    StrategyBasedIndicator.qa = function (a, b, c) {
        var d = DependencyProperty.i(c, Number_$type, b, new PropertyMetadata(2, a, function (e, f) { return (typeCast(StrategyBasedIndicator.$, e)).raisePropertyChanged(c, f.oldValue, f.newValue); }));
        StrategyBasedIndicator.pu.add(c);
        return d;
    };
    StrategyBasedIndicator.p9 = function (a, b) {
        return StrategyBasedIndicator.qa(a, b, "Period");
    };
    StrategyBasedIndicator.p7 = function (a, b) {
        return StrategyBasedIndicator.qa(a, b, "LongPeriod");
    };
    StrategyBasedIndicator.qb = function (a, b) {
        return StrategyBasedIndicator.qa(a, b, "ShortPeriod");
    };
    StrategyBasedIndicator.prototype.o3 = function (a, b) {
        var c = this.l1(a, b);
        var d = this.l2(c);
        return this.pq.b(c, d);
    };
    StrategyBasedIndicator.prototype.o0 = function (a, b) {
        var c = this.l1(a, b);
        if (b == 0) {
            return false;
        }
        if (!this.mw(this.o3(a, b))) {
            return false;
        }
        var d = this.l2(c);
        if (this.ox != null) {
            c.minimumValue = this.ox.c;
            c.maximumValue = this.ox.b;
        }
        var e = this.pq.a(c, d);
        for (var f = 0; f < this.o5 && f < c.indicatorColumn.count; f++) {
            c.indicatorColumn.item(f, NaN);
        }
        if (this.l9 != null && this.pt(c)) {
            this.l9.ck();
        }
        return e;
    };
    StrategyBasedIndicator.prototype.pt = function (a) {
        if (!isNaN_(a.minimumValue) && !isNaN_(a.maximumValue) && a.specifiesRange) {
            var b = this.ox;
            this.ox = new AxisRange(a.minimumValue, a.maximumValue);
            return this.ps(b, this.ox);
        }
        var c = 1.7976931348623157E+308;
        var d = -1.7976931348623157E+308;
        try {
            for (var _a = tslib_1.__values(fromEnum(a.indicatorColumn)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var e = _b.value;
                if (!isNaN_(e)) {
                    c = Math.min(c, e);
                    d = Math.max(d, e);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_1) throw e_1.error; }
        }
        var f = this.ox;
        this.ox = new AxisRange(c, d);
        return this.ps(f, this.ox);
        var e_1, _c;
    };
    StrategyBasedIndicator.prototype.ps = function (a, b) {
        if (a == null || b == null) {
            return true;
        }
        if (a.c != b.c) {
            return true;
        }
        if (a.b != b.b) {
            return true;
        }
        return false;
    };
    StrategyBasedIndicator.prototype.py = function (a) {
        if (a == -2147483648) {
            return 0;
        }
        if (a > this.indicatorColumn.count && this.indicatorColumn.count > 0) {
            a = this.indicatorColumn.count - 1;
        }
        if (a < 1) {
            return 1;
        }
        return a;
    };
    StrategyBasedIndicator.prototype.l1 = function (a, b) {
        var c = _super.prototype.l1.call(this, a, b);
        c.indicatorColumn = this.indicatorColumn;
        c.period = this.py(this.px());
        c.shortPeriod = this.py(this.pz());
        c.longPeriod = this.py(this.pw());
        c.multiplier = this.pv();
        return c;
    };
    StrategyBasedIndicator.prototype.pv = function () {
        return 1;
    };
    StrategyBasedIndicator.p8 = function (a, b) {
        var c = DependencyProperty.i("Multiplier", Number_$type, b, new PropertyMetadata(2, a, function (d, e) { return (typeCast(StrategyBasedIndicator.$, d)).raisePropertyChanged("Multiplier", e.oldValue, e.newValue); }));
        StrategyBasedIndicator.pu.add("Multiplier");
        return c;
    };
    StrategyBasedIndicator.prototype.ih = function (a, b, c, d) {
        _super.prototype.ih.call(this, a, b, c, d);
        if (StrategyBasedIndicator.pu.contains(b)) {
            if (this.l9 != null && !this.l9.ck()) {
                this.l5.bs.e(this.ek);
                this.o0(0, this.indicatorColumn.count);
                if (this.oy.b2) {
                    this.oy.b0.g$i();
                }
                this.iv(false);
            }
        }
    };
    StrategyBasedIndicator.pu = new List$1(String_$type, 0);
    StrategyBasedIndicator.$t = markType(StrategyBasedIndicator, 'StrategyBasedIndicator', FinancialIndicator.$);
    return StrategyBasedIndicator;
}(FinancialIndicator));
export { StrategyBasedIndicator };
/*<BeginStatics Name="Infragistics.Controls.Charts.StrategyBasedIndicator" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.StrategyBasedIndicator" />*/
//# sourceMappingURL=StrategyBasedIndicator.js.map