import * as tslib_1 from "tslib";
import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxStrategyBasedIndicatorComponent } from "./igx-strategy-based-indicator-component";
import { IgxFinancialIndicatorComponent } from "./igx-financial-indicator-component";
import { IgxFinancialSeriesComponent } from "./igx-financial-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { OnBalanceVolumeIndicator } from "./OnBalanceVolumeIndicator";
/**
 * Represents a IgxDataChartComponent On Balance Bolume indicator series.
 * Default required members: Close, Volume
*/
export var IgxOnBalanceVolumeIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxOnBalanceVolumeIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxOnBalanceVolumeIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxOnBalanceVolumeIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxOnBalanceVolumeIndicatorComponent; }) }];
var IgxOnBalanceVolumeIndicatorComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxOnBalanceVolumeIndicatorComponent, _super);
    function IgxOnBalanceVolumeIndicatorComponent() {
        return _super.call(this) || this;
    }
    IgxOnBalanceVolumeIndicatorComponent.prototype.createImplementation = function () {
        return new OnBalanceVolumeIndicator();
    };
    Object.defineProperty(IgxOnBalanceVolumeIndicatorComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxOnBalanceVolumeIndicatorComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-on-balance-volume-indicator',
                    template: "",
                    providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxOnBalanceVolumeIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxOnBalanceVolumeIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxOnBalanceVolumeIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxOnBalanceVolumeIndicatorComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxOnBalanceVolumeIndicatorComponent.ctorParameters = function () { return []; };
    return IgxOnBalanceVolumeIndicatorComponent;
}(IgxStrategyBasedIndicatorComponent));
export { IgxOnBalanceVolumeIndicatorComponent };
//# sourceMappingURL=igx-on-balance-volume-indicator-component.js.map