import { DataContext } from "igniteui-angular-core/ES5/igx-data-context";
import { PieSliceDataContext as PieSliceDataContext_internal } from "./PieSliceDataContext";
/**
 * DataContext for a pie slice.
*/
export declare class PieSliceDataContext extends DataContext {
    protected createImplementation(): PieSliceDataContext_internal;
    readonly i: PieSliceDataContext_internal;
    constructor();
    /**
     * Gets or sets the value of this slice as a percentage of the total pie.
    */
    percentValue: number;
    /**
     * Gets or sets whether this slice is an Others slice or not.
    */
    isOthersSlice: boolean;
}
