import { Type } from '@angular/core';
import { NumericScaleMode } from "./NumericScaleMode";
import { IgxNumericAxisBaseComponent } from "./igx-numeric-axis-base-component";
import { IgxAxisComponent } from "./igx-axis-component";
import { StraightNumericAxisBase } from "./StraightNumericAxisBase";
/**
 * Defines a set of basic methods and properties used to create a StraightNumeric axis.
*/
export declare const IgxStraightNumericAxisBaseComponent_PROVIDERS: {
    provide: typeof IgxAxisComponent;
    useExisting: Type<any>;
}[];
export declare abstract class IgxStraightNumericAxisBaseComponent extends IgxNumericAxisBaseComponent {
    readonly i: StraightNumericAxisBase;
    constructor();
    /**
     * Gets or sets the axis scale mode.
    */
    scaleMode: NumericScaleMode;
}
