import * as tslib_1 from "tslib";
import { IgCollection } from "igniteui-angular-core/ES5/IgCollection";
import { markType } from "igniteui-angular-core/ES5/type";
import { SyncableObservableCollection$2 } from "igniteui-angular-core/ES5/SyncableObservableCollection$2";
import { TimeAxisBreak as TimeAxisBreak_internal } from './TimeAxisBreak';
import { TimeAxisBreak as TimeAxisBreak } from './igx-time-axis-break';
var TimeAxisBreakCollection = /** @class */ (function (_super) {
    tslib_1.__extends(TimeAxisBreakCollection, _super);
    function TimeAxisBreakCollection(list) {
        var _this = _super.call(this) || this;
        if (!TimeAxisBreak.$type) {
            TimeAxisBreak.$type = markType(TimeAxisBreak, "TimeAxisBreak");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    TimeAxisBreakCollection.prototype._createInnerColl = function () {
        if (!TimeAxisBreak.$type) {
            TimeAxisBreak.$type = markType(TimeAxisBreak, "TimeAxisBreak");
        }
        var coll = new SyncableObservableCollection$2(TimeAxisBreak.$type, TimeAxisBreak_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new TimeAxisBreak();
                ext._implementation = int;
            }
            return ext;
        };
        return coll;
    };
    return TimeAxisBreakCollection;
}(IgCollection));
export { TimeAxisBreakCollection };
//# sourceMappingURL=igx-time-axis-break-collection.js.map